//
// adapted from https://caps.gsfc.nasa.gov/simpson/software/m66inv_f90.txt
//
// TODO: Do symmetric version
//
#include <math.h>

#if 0
int cmx_inv6_v0(double *a, double *ainv, int*ok_flag__)
{
/* **************************************************************************************** *
 *  m66inv  -  compute the inverse of a 6x6 matrix. 
 *
 *  a       = input 6x6 matrix to be inverted 
 *  ainv    = output 6x6 inverse of matrix a 
 *  ok_flag = (output) .true. if the input matrix could be inverted, 
 *            and .false. if the input matrix is singular. 
 * **************************************************************************************** */

    double cofactor[36]        /* was [6][6] */;
    double det;

    /* Parameter adjustments */
    ainv -= 7;
    a -= 7;

    /* Function Body */
    const double eps = 1e-10;
    const double a11 = a[7];
    const double a12 = a[13];
    const double a13 = a[19];
    const double a14 = a[25];
    const double a15 = a[31];
    const double a16 = a[37];
    const double a21 = a[8];
    const double a22 = a[14];
    const double a23 = a[20];
    const double a24 = a[26];
    const double a25 = a[32];
    const double a26 = a[38];
    const double a31 = a[9];
    const double a32 = a[15];
    const double a33 = a[21];
    const double a34 = a[27];
    const double a35 = a[33];
    const double a36 = a[39];
    const double a41 = a[10];
    const double a42 = a[16];
    const double a43 = a[22];
    const double a44 = a[28];
    const double a45 = a[34];
    const double a46 = a[40];
    const double a51 = a[11];
    const double a52 = a[17];
    const double a53 = a[23];
    const double a54 = a[29];
    const double a55 = a[35];
    const double a56 = a[41];
    const double a61 = a[12];
    const double a62 = a[18];
    const double a63 = a[24];
    const double a64 = a[30];
    const double a65 = a[36];
    const double a66 = a[42];
    det = -(a16 * a25 * a34 * a43 * a52 - a15 * a26 * a34 * a43 * a52 - a16 * 
            a24 * a35 * a43 * a52 + a14 * a26 * a35 * a43 * a52 + a15 * a24 * 
            a36 * a43 * a52 - a14 * a25 * a36 * a43 * a52 - a16 * a25 * a33 * 
            a44 * a52 + a15 * a26 * a33 * a44 * a52 + a16 * a23 * a35 * a44 * 
            a52 - a13 * a26 * a35 * a44 * a52 - a15 * a23 * a36 * a44 * a52 + 
            a13 * a25 * a36 * a44 * a52 + a16 * a24 * a33 * a45 * a52 - a14 * 
            a26 * a33 * a45 * a52 - a16 * a23 * a34 * a45 * a52 + a13 * a26 * 
            a34 * a45 * a52 + a14 * a23 * a36 * a45 * a52 - a13 * a24 * a36 * 
            a45 * a52 - a15 * a24 * a33 * a46 * a52 + a14 * a25 * a33 * a46 * 
            a52 + a15 * a23 * a34 * a46 * a52 - a13 * a25 * a34 * a46 * a52 - 
            a14 * a23 * a35 * a46 * a52 + a13 * a24 * a35 * a46 * a52 - a16 * 
            a25 * a34 * a42 * a53 + a15 * a26 * a34 * a42 * a53 + a16 * a24 * 
            a35 * a42 * a53 - a14 * a26 * a35 * a42 * a53 - a15 * a24 * a36 * 
            a42 * a53 + a14 * a25 * a36 * a42 * a53 + a16 * a25 * a32 * a44 * 
            a53 - a15 * a26 * a32 * a44 * a53 - a16 * a22 * a35 * a44 * a53 + 
            a12 * a26 * a35 * a44 * a53 + a15 * a22 * a36 * a44 * a53 - a12 * 
            a25 * a36 * a44 * a53 - a16 * a24 * a32 * a45 * a53 + a14 * a26 * 
            a32 * a45 * a53 + a16 * a22 * a34 * a45 * a53 - a12 * a26 * a34 * 
            a45 * a53 - a14 * a22 * a36 * a45 * a53 + a12 * a24 * a36 * a45 * 
            a53 + a15 * a24 * a32 * a46 * a53 - a14 * a25 * a32 * a46 * a53 - 
            a15 * a22 * a34 * a46 * a53 + a12 * a25 * a34 * a46 * a53 + a14 * 
            a22 * a35 * a46 * a53 - a12 * a24 * a35 * a46 * a53 + a16 * a25 * 
            a33 * a42 * a54 - a15 * a26 * a33 * a42 * a54 - a16 * a23 * a35 * 
            a42 * a54 + a13 * a26 * a35 * a42 * a54 + a15 * a23 * a36 * a42 * 
            a54 - a13 * a25 * a36 * a42 * a54 - a16 * a25 * a32 * a43 * a54 + 
            a15 * a26 * a32 * a43 * a54 + a16 * a22 * a35 * a43 * a54 - a12 * 
            a26 * a35 * a43 * a54 - a15 * a22 * a36 * a43 * a54 + a12 * a25 * 
            a36 * a43 * a54 + a16 * a23 * a32 * a45 * a54 - a13 * a26 * a32 * 
            a45 * a54 - a16 * a22 * a33 * a45 * a54 + a12 * a26 * a33 * a45 * 
            a54 + a13 * a22 * a36 * a45 * a54 - a12 * a23 * a36 * a45 * a54 - 
            a15 * a23 * a32 * a46 * a54 + a13 * a25 * a32 * a46 * a54 + a15 * 
            a22 * a33 * a46 * a54 - a12 * a25 * a33 * a46 * a54 - a13 * a22 * 
            a35 * a46 * a54 + a12 * a23 * a35 * a46 * a54 - a16 * a24 * a33 * 
            a42 * a55 + a14 * a26 * a33 * a42 * a55 + a16 * a23 * a34 * a42 * 
            a55 - a13 * a26 * a34 * a42 * a55 - a14 * a23 * a36 * a42 * a55 + 
            a13 * a24 * a36 * a42 * a55 + a16 * a24 * a32 * a43 * a55 - a14 * 
            a26 * a32 * a43 * a55 - a16 * a22 * a34 * a43 * a55 + a12 * a26 * 
            a34 * a43 * a55 + a14 * a22 * a36 * a43 * a55 - a12 * a24 * a36 * 
            a43 * a55 - a16 * a23 * a32 * a44 * a55 + a13 * a26 * a32 * a44 * 
            a55 + a16 * a22 * a33 * a44 * a55 - a12 * a26 * a33 * a44 * a55 - 
            a13 * a22 * a36 * a44 * a55 + a12 * a23 * a36 * a44 * a55 + a14 * 
            a23 * a32 * a46 * a55 - a13 * a24 * a32 * a46 * a55 - a14 * a22 * 
            a33 * a46 * a55 + a12 * a24 * a33 * a46 * a55 + a13 * a22 * a34 * 
            a46 * a55 - a12 * a23 * a34 * a46 * a55 + a15 * a24 * a33 * a42 * 
            a56 - a14 * a25 * a33 * a42 * a56 - a15 * a23 * a34 * a42 * a56 + 
            a13 * a25 * a34 * a42 * a56 + a14 * a23 * a35 * a42 * a56 - a13 * 
            a24 * a35 * a42 * a56 - a15 * a24 * a32 * a43 * a56 + a14 * a25 * 
            a32 * a43 * a56 + a15 * a22 * a34 * a43 * a56 - a12 * a25 * a34 * 
            a43 * a56 - a14 * a22 * a35 * a43 * a56 + a12 * a24 * a35 * a43 * 
            a56 + a15 * a23 * a32 * a44 * a56 - a13 * a25 * a32 * a44 * a56 - 
            a15 * a22 * a33 * a44 * a56 + a12 * a25 * a33 * a44 * a56 + a13 * 
            a22 * a35 * a44 * a56 - a12 * a23 * a35 * a44 * a56 - a14 * a23 * 
            a32 * a45 * a56 + a13 * a24 * a32 * a45 * a56 + a14 * a22 * a33 * 
            a45 * a56 - a12 * a24 * a33 * a45 * a56 - a13 * a22 * a34 * a45 * 
            a56 + a12 * a23 * a34 * a45 * a56) * a61 + (a16 * a25 * a34 * a43 
            * a51 - a15 * a26 * a34 * a43 * a51 - a16 * a24 * a35 * a43 * a51 
            + a14 * a26 * a35 * a43 * a51 + a15 * a24 * a36 * a43 * a51 - a14 
            * a25 * a36 * a43 * a51 - a16 * a25 * a33 * a44 * a51 + a15 * a26 
            * a33 * a44 * a51 + a16 * a23 * a35 * a44 * a51 - a13 * a26 * a35 
            * a44 * a51 - a15 * a23 * a36 * a44 * a51 + a13 * a25 * a36 * a44 
            * a51 + a16 * a24 * a33 * a45 * a51 - a14 * a26 * a33 * a45 * a51 
            - a16 * a23 * a34 * a45 * a51 + a13 * a26 * a34 * a45 * a51 + a14 
            * a23 * a36 * a45 * a51 - a13 * a24 * a36 * a45 * a51 - a15 * a24 
            * a33 * a46 * a51 + a14 * a25 * a33 * a46 * a51 + a15 * a23 * a34 
            * a46 * a51 - a13 * a25 * a34 * a46 * a51 - a14 * a23 * a35 * a46 
            * a51 + a13 * a24 * a35 * a46 * a51 - a16 * a25 * a34 * a41 * a53 
            + a15 * a26 * a34 * a41 * a53 + a16 * a24 * a35 * a41 * a53 - a14 
            * a26 * a35 * a41 * a53 - a15 * a24 * a36 * a41 * a53 + a14 * a25 
            * a36 * a41 * a53 + a16 * a25 * a31 * a44 * a53 - a15 * a26 * a31 
            * a44 * a53 - a16 * a21 * a35 * a44 * a53 + a11 * a26 * a35 * a44 
            * a53 + a15 * a21 * a36 * a44 * a53 - a11 * a25 * a36 * a44 * a53 
            - a16 * a24 * a31 * a45 * a53 + a14 * a26 * a31 * a45 * a53 + a16 
            * a21 * a34 * a45 * a53 - a11 * a26 * a34 * a45 * a53 - a14 * a21 
            * a36 * a45 * a53 + a11 * a24 * a36 * a45 * a53 + a15 * a24 * a31 
            * a46 * a53 - a14 * a25 * a31 * a46 * a53 - a15 * a21 * a34 * a46 
            * a53 + a11 * a25 * a34 * a46 * a53 + a14 * a21 * a35 * a46 * a53 
            - a11 * a24 * a35 * a46 * a53 + a16 * a25 * a33 * a41 * a54 - a15 
            * a26 * a33 * a41 * a54 - a16 * a23 * a35 * a41 * a54 + a13 * a26 
            * a35 * a41 * a54 + a15 * a23 * a36 * a41 * a54 - a13 * a25 * a36 
            * a41 * a54 - a16 * a25 * a31 * a43 * a54 + a15 * a26 * a31 * a43 
            * a54 + a16 * a21 * a35 * a43 * a54 - a11 * a26 * a35 * a43 * a54 
            - a15 * a21 * a36 * a43 * a54 + a11 * a25 * a36 * a43 * a54 + a16 
            * a23 * a31 * a45 * a54 - a13 * a26 * a31 * a45 * a54 - a16 * a21 
            * a33 * a45 * a54 + a11 * a26 * a33 * a45 * a54 + a13 * a21 * a36 
            * a45 * a54 - a11 * a23 * a36 * a45 * a54 - a15 * a23 * a31 * a46 
            * a54 + a13 * a25 * a31 * a46 * a54 + a15 * a21 * a33 * a46 * a54 
            - a11 * a25 * a33 * a46 * a54 - a13 * a21 * a35 * a46 * a54 + a11 
            * a23 * a35 * a46 * a54 - a16 * a24 * a33 * a41 * a55 + a14 * a26 
            * a33 * a41 * a55 + a16 * a23 * a34 * a41 * a55 - a13 * a26 * a34 
            * a41 * a55 - a14 * a23 * a36 * a41 * a55 + a13 * a24 * a36 * a41 
            * a55 + a16 * a24 * a31 * a43 * a55 - a14 * a26 * a31 * a43 * a55 
            - a16 * a21 * a34 * a43 * a55 + a11 * a26 * a34 * a43 * a55 + a14 
            * a21 * a36 * a43 * a55 - a11 * a24 * a36 * a43 * a55 - a16 * a23 
            * a31 * a44 * a55 + a13 * a26 * a31 * a44 * a55 + a16 * a21 * a33 
            * a44 * a55 - a11 * a26 * a33 * a44 * a55 - a13 * a21 * a36 * a44 
            * a55 + a11 * a23 * a36 * a44 * a55 + a14 * a23 * a31 * a46 * a55 
            - a13 * a24 * a31 * a46 * a55 - a14 * a21 * a33 * a46 * a55 + a11 
            * a24 * a33 * a46 * a55 + a13 * a21 * a34 * a46 * a55 - a11 * a23 
            * a34 * a46 * a55 + a15 * a24 * a33 * a41 * a56 - a14 * a25 * a33 
            * a41 * a56 - a15 * a23 * a34 * a41 * a56 + a13 * a25 * a34 * a41 
            * a56 + a14 * a23 * a35 * a41 * a56 - a13 * a24 * a35 * a41 * a56 
            - a15 * a24 * a31 * a43 * a56 + a14 * a25 * a31 * a43 * a56 + a15 
            * a21 * a34 * a43 * a56 - a11 * a25 * a34 * a43 * a56 - a14 * a21 
            * a35 * a43 * a56 + a11 * a24 * a35 * a43 * a56 + a15 * a23 * a31 
            * a44 * a56 - a13 * a25 * a31 * a44 * a56 - a15 * a21 * a33 * a44 
            * a56 + a11 * a25 * a33 * a44 * a56 + a13 * a21 * a35 * a44 * a56 
            - a11 * a23 * a35 * a44 * a56 - a14 * a23 * a31 * a45 * a56 + a13 
            * a24 * a31 * a45 * a56 + a14 * a21 * a33 * a45 * a56 - a11 * a24 
            * a33 * a45 * a56 - a13 * a21 * a34 * a45 * a56 + a11 * a23 * a34 
            * a45 * a56) * a62 - (a16 * a25 * a34 * a42 * a51 - a15 * a26 * 
            a34 * a42 * a51 - a16 * a24 * a35 * a42 * a51 + a14 * a26 * a35 * 
            a42 * a51 + a15 * a24 * a36 * a42 * a51 - a14 * a25 * a36 * a42 * 
            a51 - a16 * a25 * a32 * a44 * a51 + a15 * a26 * a32 * a44 * a51 + 
            a16 * a22 * a35 * a44 * a51 - a12 * a26 * a35 * a44 * a51 - a15 * 
            a22 * a36 * a44 * a51 + a12 * a25 * a36 * a44 * a51 + a16 * a24 * 
            a32 * a45 * a51 - a14 * a26 * a32 * a45 * a51 - a16 * a22 * a34 * 
            a45 * a51 + a12 * a26 * a34 * a45 * a51 + a14 * a22 * a36 * a45 * 
            a51 - a12 * a24 * a36 * a45 * a51 - a15 * a24 * a32 * a46 * a51 + 
            a14 * a25 * a32 * a46 * a51 + a15 * a22 * a34 * a46 * a51 - a12 * 
            a25 * a34 * a46 * a51 - a14 * a22 * a35 * a46 * a51 + a12 * a24 * 
            a35 * a46 * a51 - a16 * a25 * a34 * a41 * a52 + a15 * a26 * a34 * 
            a41 * a52 + a16 * a24 * a35 * a41 * a52 - a14 * a26 * a35 * a41 * 
            a52 - a15 * a24 * a36 * a41 * a52 + a14 * a25 * a36 * a41 * a52 + 
            a16 * a25 * a31 * a44 * a52 - a15 * a26 * a31 * a44 * a52 - a16 * 
            a21 * a35 * a44 * a52 + a11 * a26 * a35 * a44 * a52 + a15 * a21 * 
            a36 * a44 * a52 - a11 * a25 * a36 * a44 * a52 - a16 * a24 * a31 * 
            a45 * a52 + a14 * a26 * a31 * a45 * a52 + a16 * a21 * a34 * a45 * 
            a52 - a11 * a26 * a34 * a45 * a52 - a14 * a21 * a36 * a45 * a52 + 
            a11 * a24 * a36 * a45 * a52 + a15 * a24 * a31 * a46 * a52 - a14 * 
            a25 * a31 * a46 * a52 - a15 * a21 * a34 * a46 * a52 + a11 * a25 * 
            a34 * a46 * a52 + a14 * a21 * a35 * a46 * a52 - a11 * a24 * a35 * 
            a46 * a52 + a16 * a25 * a32 * a41 * a54 - a15 * a26 * a32 * a41 * 
            a54 - a16 * a22 * a35 * a41 * a54 + a12 * a26 * a35 * a41 * a54 + 
            a15 * a22 * a36 * a41 * a54 - a12 * a25 * a36 * a41 * a54 - a16 * 
            a25 * a31 * a42 * a54 + a15 * a26 * a31 * a42 * a54 + a16 * a21 * 
            a35 * a42 * a54 - a11 * a26 * a35 * a42 * a54 - a15 * a21 * a36 * 
            a42 * a54 + a11 * a25 * a36 * a42 * a54 + a16 * a22 * a31 * a45 * 
            a54 - a12 * a26 * a31 * a45 * a54 - a16 * a21 * a32 * a45 * a54 + 
            a11 * a26 * a32 * a45 * a54 + a12 * a21 * a36 * a45 * a54 - a11 * 
            a22 * a36 * a45 * a54 - a15 * a22 * a31 * a46 * a54 + a12 * a25 * 
            a31 * a46 * a54 + a15 * a21 * a32 * a46 * a54 - a11 * a25 * a32 * 
            a46 * a54 - a12 * a21 * a35 * a46 * a54 + a11 * a22 * a35 * a46 * 
            a54 - a16 * a24 * a32 * a41 * a55 + a14 * a26 * a32 * a41 * a55 + 
            a16 * a22 * a34 * a41 * a55 - a12 * a26 * a34 * a41 * a55 - a14 * 
            a22 * a36 * a41 * a55 + a12 * a24 * a36 * a41 * a55 + a16 * a24 * 
            a31 * a42 * a55 - a14 * a26 * a31 * a42 * a55 - a16 * a21 * a34 * 
            a42 * a55 + a11 * a26 * a34 * a42 * a55 + a14 * a21 * a36 * a42 * 
            a55 - a11 * a24 * a36 * a42 * a55 - a16 * a22 * a31 * a44 * a55 + 
            a12 * a26 * a31 * a44 * a55 + a16 * a21 * a32 * a44 * a55 - a11 * 
            a26 * a32 * a44 * a55 - a12 * a21 * a36 * a44 * a55 + a11 * a22 * 
            a36 * a44 * a55 + a14 * a22 * a31 * a46 * a55 - a12 * a24 * a31 * 
            a46 * a55 - a14 * a21 * a32 * a46 * a55 + a11 * a24 * a32 * a46 * 
            a55 + a12 * a21 * a34 * a46 * a55 - a11 * a22 * a34 * a46 * a55 + 
            a15 * a24 * a32 * a41 * a56 - a14 * a25 * a32 * a41 * a56 - a15 * 
            a22 * a34 * a41 * a56 + a12 * a25 * a34 * a41 * a56 + a14 * a22 * 
            a35 * a41 * a56 - a12 * a24 * a35 * a41 * a56 - a15 * a24 * a31 * 
            a42 * a56 + a14 * a25 * a31 * a42 * a56 + a15 * a21 * a34 * a42 * 
            a56 - a11 * a25 * a34 * a42 * a56 - a14 * a21 * a35 * a42 * a56 + 
            a11 * a24 * a35 * a42 * a56 + a15 * a22 * a31 * a44 * a56 - a12 * 
            a25 * a31 * a44 * a56 - a15 * a21 * a32 * a44 * a56 + a11 * a25 * 
            a32 * a44 * a56 + a12 * a21 * a35 * a44 * a56 - a11 * a22 * a35 * 
            a44 * a56 - a14 * a22 * a31 * a45 * a56 + a12 * a24 * a31 * a45 * 
            a56 + a14 * a21 * a32 * a45 * a56 - a11 * a24 * a32 * a45 * a56 - 
            a12 * a21 * a34 * a45 * a56 + a11 * a22 * a34 * a45 * a56) * a63 
            + (a16 * a25 * a33 * a42 * a51 - a15 * a26 * a33 * a42 * a51 - 
            a16 * a23 * a35 * a42 * a51 + a13 * a26 * a35 * a42 * a51 + a15 * 
            a23 * a36 * a42 * a51 - a13 * a25 * a36 * a42 * a51 - a16 * a25 * 
            a32 * a43 * a51 + a15 * a26 * a32 * a43 * a51 + a16 * a22 * a35 * 
            a43 * a51 - a12 * a26 * a35 * a43 * a51 - a15 * a22 * a36 * a43 * 
            a51 + a12 * a25 * a36 * a43 * a51 + a16 * a23 * a32 * a45 * a51 - 
            a13 * a26 * a32 * a45 * a51 - a16 * a22 * a33 * a45 * a51 + a12 * 
            a26 * a33 * a45 * a51 + a13 * a22 * a36 * a45 * a51 - a12 * a23 * 
            a36 * a45 * a51 - a15 * a23 * a32 * a46 * a51 + a13 * a25 * a32 * 
            a46 * a51 + a15 * a22 * a33 * a46 * a51 - a12 * a25 * a33 * a46 * 
            a51 - a13 * a22 * a35 * a46 * a51 + a12 * a23 * a35 * a46 * a51 - 
            a16 * a25 * a33 * a41 * a52 + a15 * a26 * a33 * a41 * a52 + a16 * 
            a23 * a35 * a41 * a52 - a13 * a26 * a35 * a41 * a52 - a15 * a23 * 
            a36 * a41 * a52 + a13 * a25 * a36 * a41 * a52 + a16 * a25 * a31 * 
            a43 * a52 - a15 * a26 * a31 * a43 * a52 - a16 * a21 * a35 * a43 * 
            a52 + a11 * a26 * a35 * a43 * a52 + a15 * a21 * a36 * a43 * a52 - 
            a11 * a25 * a36 * a43 * a52 - a16 * a23 * a31 * a45 * a52 + a13 * 
            a26 * a31 * a45 * a52 + a16 * a21 * a33 * a45 * a52 - a11 * a26 * 
            a33 * a45 * a52 - a13 * a21 * a36 * a45 * a52 + a11 * a23 * a36 * 
            a45 * a52 + a15 * a23 * a31 * a46 * a52 - a13 * a25 * a31 * a46 * 
            a52 - a15 * a21 * a33 * a46 * a52 + a11 * a25 * a33 * a46 * a52 + 
            a13 * a21 * a35 * a46 * a52 - a11 * a23 * a35 * a46 * a52 + a16 * 
            a25 * a32 * a41 * a53 - a15 * a26 * a32 * a41 * a53 - a16 * a22 * 
            a35 * a41 * a53 + a12 * a26 * a35 * a41 * a53 + a15 * a22 * a36 * 
            a41 * a53 - a12 * a25 * a36 * a41 * a53 - a16 * a25 * a31 * a42 * 
            a53 + a15 * a26 * a31 * a42 * a53 + a16 * a21 * a35 * a42 * a53 - 
            a11 * a26 * a35 * a42 * a53 - a15 * a21 * a36 * a42 * a53 + a11 * 
            a25 * a36 * a42 * a53 + a16 * a22 * a31 * a45 * a53 - a12 * a26 * 
            a31 * a45 * a53 - a16 * a21 * a32 * a45 * a53 + a11 * a26 * a32 * 
            a45 * a53 + a12 * a21 * a36 * a45 * a53 - a11 * a22 * a36 * a45 * 
            a53 - a15 * a22 * a31 * a46 * a53 + a12 * a25 * a31 * a46 * a53 + 
            a15 * a21 * a32 * a46 * a53 - a11 * a25 * a32 * a46 * a53 - a12 * 
            a21 * a35 * a46 * a53 + a11 * a22 * a35 * a46 * a53 - a16 * a23 * 
            a32 * a41 * a55 + a13 * a26 * a32 * a41 * a55 + a16 * a22 * a33 * 
            a41 * a55 - a12 * a26 * a33 * a41 * a55 - a13 * a22 * a36 * a41 * 
            a55 + a12 * a23 * a36 * a41 * a55 + a16 * a23 * a31 * a42 * a55 - 
            a13 * a26 * a31 * a42 * a55 - a16 * a21 * a33 * a42 * a55 + a11 * 
            a26 * a33 * a42 * a55 + a13 * a21 * a36 * a42 * a55 - a11 * a23 * 
            a36 * a42 * a55 - a16 * a22 * a31 * a43 * a55 + a12 * a26 * a31 * 
            a43 * a55 + a16 * a21 * a32 * a43 * a55 - a11 * a26 * a32 * a43 * 
            a55 - a12 * a21 * a36 * a43 * a55 + a11 * a22 * a36 * a43 * a55 + 
            a13 * a22 * a31 * a46 * a55 - a12 * a23 * a31 * a46 * a55 - a13 * 
            a21 * a32 * a46 * a55 + a11 * a23 * a32 * a46 * a55 + a12 * a21 * 
            a33 * a46 * a55 - a11 * a22 * a33 * a46 * a55 + a15 * a23 * a32 * 
            a41 * a56 - a13 * a25 * a32 * a41 * a56 - a15 * a22 * a33 * a41 * 
            a56 + a12 * a25 * a33 * a41 * a56 + a13 * a22 * a35 * a41 * a56 - 
            a12 * a23 * a35 * a41 * a56 - a15 * a23 * a31 * a42 * a56 + a13 * 
            a25 * a31 * a42 * a56 + a15 * a21 * a33 * a42 * a56 - a11 * a25 * 
            a33 * a42 * a56 - a13 * a21 * a35 * a42 * a56 + a11 * a23 * a35 * 
            a42 * a56 + a15 * a22 * a31 * a43 * a56 - a12 * a25 * a31 * a43 * 
            a56 - a15 * a21 * a32 * a43 * a56 + a11 * a25 * a32 * a43 * a56 + 
            a12 * a21 * a35 * a43 * a56 - a11 * a22 * a35 * a43 * a56 - a13 * 
            a22 * a31 * a45 * a56 + a12 * a23 * a31 * a45 * a56 + a13 * a21 * 
            a32 * a45 * a56 - a11 * a23 * a32 * a45 * a56 - a12 * a21 * a33 * 
            a45 * a56 + a11 * a22 * a33 * a45 * a56) * a64 - (a16 * a24 * a33 
            * a42 * a51 - a14 * a26 * a33 * a42 * a51 - a16 * a23 * a34 * a42 
            * a51 + a13 * a26 * a34 * a42 * a51 + a14 * a23 * a36 * a42 * a51 
            - a13 * a24 * a36 * a42 * a51 - a16 * a24 * a32 * a43 * a51 + a14 
            * a26 * a32 * a43 * a51 + a16 * a22 * a34 * a43 * a51 - a12 * a26 
            * a34 * a43 * a51 - a14 * a22 * a36 * a43 * a51 + a12 * a24 * a36 
            * a43 * a51 + a16 * a23 * a32 * a44 * a51 - a13 * a26 * a32 * a44 
            * a51 - a16 * a22 * a33 * a44 * a51 + a12 * a26 * a33 * a44 * a51 
            + a13 * a22 * a36 * a44 * a51 - a12 * a23 * a36 * a44 * a51 - a14 
            * a23 * a32 * a46 * a51 + a13 * a24 * a32 * a46 * a51 + a14 * a22 
            * a33 * a46 * a51 - a12 * a24 * a33 * a46 * a51 - a13 * a22 * a34 
            * a46 * a51 + a12 * a23 * a34 * a46 * a51 - a16 * a24 * a33 * a41 
            * a52 + a14 * a26 * a33 * a41 * a52 + a16 * a23 * a34 * a41 * a52 
            - a13 * a26 * a34 * a41 * a52 - a14 * a23 * a36 * a41 * a52 + a13 
            * a24 * a36 * a41 * a52 + a16 * a24 * a31 * a43 * a52 - a14 * a26 
            * a31 * a43 * a52 - a16 * a21 * a34 * a43 * a52 + a11 * a26 * a34 
            * a43 * a52 + a14 * a21 * a36 * a43 * a52 - a11 * a24 * a36 * a43 
            * a52 - a16 * a23 * a31 * a44 * a52 + a13 * a26 * a31 * a44 * a52 
            + a16 * a21 * a33 * a44 * a52 - a11 * a26 * a33 * a44 * a52 - a13 
            * a21 * a36 * a44 * a52 + a11 * a23 * a36 * a44 * a52 + a14 * a23 
            * a31 * a46 * a52 - a13 * a24 * a31 * a46 * a52 - a14 * a21 * a33 
            * a46 * a52 + a11 * a24 * a33 * a46 * a52 + a13 * a21 * a34 * a46 
            * a52 - a11 * a23 * a34 * a46 * a52 + a16 * a24 * a32 * a41 * a53 
            - a14 * a26 * a32 * a41 * a53 - a16 * a22 * a34 * a41 * a53 + a12 
            * a26 * a34 * a41 * a53 + a14 * a22 * a36 * a41 * a53 - a12 * a24 
            * a36 * a41 * a53 - a16 * a24 * a31 * a42 * a53 + a14 * a26 * a31 
            * a42 * a53 + a16 * a21 * a34 * a42 * a53 - a11 * a26 * a34 * a42 
            * a53 - a14 * a21 * a36 * a42 * a53 + a11 * a24 * a36 * a42 * a53 
            + a16 * a22 * a31 * a44 * a53 - a12 * a26 * a31 * a44 * a53 - a16 
            * a21 * a32 * a44 * a53 + a11 * a26 * a32 * a44 * a53 + a12 * a21 
            * a36 * a44 * a53 - a11 * a22 * a36 * a44 * a53 - a14 * a22 * a31 
            * a46 * a53 + a12 * a24 * a31 * a46 * a53 + a14 * a21 * a32 * a46 
            * a53 - a11 * a24 * a32 * a46 * a53 - a12 * a21 * a34 * a46 * a53 
            + a11 * a22 * a34 * a46 * a53 - a16 * a23 * a32 * a41 * a54 + a13 
            * a26 * a32 * a41 * a54 + a16 * a22 * a33 * a41 * a54 - a12 * a26 
            * a33 * a41 * a54 - a13 * a22 * a36 * a41 * a54 + a12 * a23 * a36 
            * a41 * a54 + a16 * a23 * a31 * a42 * a54 - a13 * a26 * a31 * a42 
            * a54 - a16 * a21 * a33 * a42 * a54 + a11 * a26 * a33 * a42 * a54 
            + a13 * a21 * a36 * a42 * a54 - a11 * a23 * a36 * a42 * a54 - a16 
            * a22 * a31 * a43 * a54 + a12 * a26 * a31 * a43 * a54 + a16 * a21 
            * a32 * a43 * a54 - a11 * a26 * a32 * a43 * a54 - a12 * a21 * a36 
            * a43 * a54 + a11 * a22 * a36 * a43 * a54 + a13 * a22 * a31 * a46 
            * a54 - a12 * a23 * a31 * a46 * a54 - a13 * a21 * a32 * a46 * a54 
            + a11 * a23 * a32 * a46 * a54 + a12 * a21 * a33 * a46 * a54 - a11 
            * a22 * a33 * a46 * a54 + a14 * a23 * a32 * a41 * a56 - a13 * a24 
            * a32 * a41 * a56 - a14 * a22 * a33 * a41 * a56 + a12 * a24 * a33 
            * a41 * a56 + a13 * a22 * a34 * a41 * a56 - a12 * a23 * a34 * a41 
            * a56 - a14 * a23 * a31 * a42 * a56 + a13 * a24 * a31 * a42 * a56 
            + a14 * a21 * a33 * a42 * a56 - a11 * a24 * a33 * a42 * a56 - a13 
            * a21 * a34 * a42 * a56 + a11 * a23 * a34 * a42 * a56 + a14 * a22 
            * a31 * a43 * a56 - a12 * a24 * a31 * a43 * a56 - a14 * a21 * a32 
            * a43 * a56 + a11 * a24 * a32 * a43 * a56 + a12 * a21 * a34 * a43 
            * a56 - a11 * a22 * a34 * a43 * a56 - a13 * a22 * a31 * a44 * a56 
            + a12 * a23 * a31 * a44 * a56 + a13 * a21 * a32 * a44 * a56 - a11 
            * a23 * a32 * a44 * a56 - a12 * a21 * a33 * a44 * a56 + a11 * a22 
            * a33 * a44 * a56) * a65 + (a15 * a24 * a33 * a42 * a51 - a14 * 
            a25 * a33 * a42 * a51 - a15 * a23 * a34 * a42 * a51 + a13 * a25 * 
            a34 * a42 * a51 + a14 * a23 * a35 * a42 * a51 - a13 * a24 * a35 * 
            a42 * a51 - a15 * a24 * a32 * a43 * a51 + a14 * a25 * a32 * a43 * 
            a51 + a15 * a22 * a34 * a43 * a51 - a12 * a25 * a34 * a43 * a51 - 
            a14 * a22 * a35 * a43 * a51 + a12 * a24 * a35 * a43 * a51 + a15 * 
            a23 * a32 * a44 * a51 - a13 * a25 * a32 * a44 * a51 - a15 * a22 * 
            a33 * a44 * a51 + a12 * a25 * a33 * a44 * a51 + a13 * a22 * a35 * 
            a44 * a51 - a12 * a23 * a35 * a44 * a51 - a14 * a23 * a32 * a45 * 
            a51 + a13 * a24 * a32 * a45 * a51 + a14 * a22 * a33 * a45 * a51 - 
            a12 * a24 * a33 * a45 * a51 - a13 * a22 * a34 * a45 * a51 + a12 * 
            a23 * a34 * a45 * a51 - a15 * a24 * a33 * a41 * a52 + a14 * a25 * 
            a33 * a41 * a52 + a15 * a23 * a34 * a41 * a52 - a13 * a25 * a34 * 
            a41 * a52 - a14 * a23 * a35 * a41 * a52 + a13 * a24 * a35 * a41 * 
            a52 + a15 * a24 * a31 * a43 * a52 - a14 * a25 * a31 * a43 * a52 - 
            a15 * a21 * a34 * a43 * a52 + a11 * a25 * a34 * a43 * a52 + a14 * 
            a21 * a35 * a43 * a52 - a11 * a24 * a35 * a43 * a52 - a15 * a23 * 
            a31 * a44 * a52 + a13 * a25 * a31 * a44 * a52 + a15 * a21 * a33 * 
            a44 * a52 - a11 * a25 * a33 * a44 * a52 - a13 * a21 * a35 * a44 * 
            a52 + a11 * a23 * a35 * a44 * a52 + a14 * a23 * a31 * a45 * a52 - 
            a13 * a24 * a31 * a45 * a52 - a14 * a21 * a33 * a45 * a52 + a11 * 
            a24 * a33 * a45 * a52 + a13 * a21 * a34 * a45 * a52 - a11 * a23 * 
            a34 * a45 * a52 + a15 * a24 * a32 * a41 * a53 - a14 * a25 * a32 * 
            a41 * a53 - a15 * a22 * a34 * a41 * a53 + a12 * a25 * a34 * a41 * 
            a53 + a14 * a22 * a35 * a41 * a53 - a12 * a24 * a35 * a41 * a53 - 
            a15 * a24 * a31 * a42 * a53 + a14 * a25 * a31 * a42 * a53 + a15 * 
            a21 * a34 * a42 * a53 - a11 * a25 * a34 * a42 * a53 - a14 * a21 * 
            a35 * a42 * a53 + a11 * a24 * a35 * a42 * a53 + a15 * a22 * a31 * 
            a44 * a53 - a12 * a25 * a31 * a44 * a53 - a15 * a21 * a32 * a44 * 
            a53 + a11 * a25 * a32 * a44 * a53 + a12 * a21 * a35 * a44 * a53 - 
            a11 * a22 * a35 * a44 * a53 - a14 * a22 * a31 * a45 * a53 + a12 * 
            a24 * a31 * a45 * a53 + a14 * a21 * a32 * a45 * a53 - a11 * a24 * 
            a32 * a45 * a53 - a12 * a21 * a34 * a45 * a53 + a11 * a22 * a34 * 
            a45 * a53 - a15 * a23 * a32 * a41 * a54 + a13 * a25 * a32 * a41 * 
            a54 + a15 * a22 * a33 * a41 * a54 - a12 * a25 * a33 * a41 * a54 - 
            a13 * a22 * a35 * a41 * a54 + a12 * a23 * a35 * a41 * a54 + a15 * 
            a23 * a31 * a42 * a54 - a13 * a25 * a31 * a42 * a54 - a15 * a21 * 
            a33 * a42 * a54 + a11 * a25 * a33 * a42 * a54 + a13 * a21 * a35 * 
            a42 * a54 - a11 * a23 * a35 * a42 * a54 - a15 * a22 * a31 * a43 * 
            a54 + a12 * a25 * a31 * a43 * a54 + a15 * a21 * a32 * a43 * a54 - 
            a11 * a25 * a32 * a43 * a54 - a12 * a21 * a35 * a43 * a54 + a11 * 
            a22 * a35 * a43 * a54 + a13 * a22 * a31 * a45 * a54 - a12 * a23 * 
            a31 * a45 * a54 - a13 * a21 * a32 * a45 * a54 + a11 * a23 * a32 * 
            a45 * a54 + a12 * a21 * a33 * a45 * a54 - a11 * a22 * a33 * a45 * 
            a54 + a14 * a23 * a32 * a41 * a55 - a13 * a24 * a32 * a41 * a55 - 
            a14 * a22 * a33 * a41 * a55 + a12 * a24 * a33 * a41 * a55 + a13 * 
            a22 * a34 * a41 * a55 - a12 * a23 * a34 * a41 * a55 - a14 * a23 * 
            a31 * a42 * a55 + a13 * a24 * a31 * a42 * a55 + a14 * a21 * a33 * 
            a42 * a55 - a11 * a24 * a33 * a42 * a55 - a13 * a21 * a34 * a42 * 
            a55 + a11 * a23 * a34 * a42 * a55 + a14 * a22 * a31 * a43 * a55 - 
            a12 * a24 * a31 * a43 * a55 - a14 * a21 * a32 * a43 * a55 + a11 * 
            a24 * a32 * a43 * a55 + a12 * a21 * a34 * a43 * a55 - a11 * a22 * 
            a34 * a43 * a55 - a13 * a22 * a31 * a44 * a55 + a12 * a23 * a31 * 
            a44 * a55 + a13 * a21 * a32 * a44 * a55 - a11 * a23 * a32 * a44 * 
            a55 - a12 * a21 * a33 * a44 * a55 + a11 * a22 * a33 * a44 * a55) *
             a66;

    if (fabs(det) <= eps) {
/*        ainv = 0.0d0 */
        *ok_flag__ = -1;
        return 0;
    }
    cofactor[0] = a26 * a35 * a44 * a53 * a62 - a25 * a36 * a44 * a53 * a62 - 
            a26 * a34 * a45 * a53 * a62 + a24 * a36 * a45 * a53 * a62 + a25 * 
            a34 * a46 * a53 * a62 - a24 * a35 * a46 * a53 * a62 - a26 * a35 * 
            a43 * a54 * a62 + a25 * a36 * a43 * a54 * a62 + a26 * a33 * a45 * 
            a54 * a62 - a23 * a36 * a45 * a54 * a62 - a25 * a33 * a46 * a54 * 
            a62 + a23 * a35 * a46 * a54 * a62 + a26 * a34 * a43 * a55 * a62 - 
            a24 * a36 * a43 * a55 * a62 - a26 * a33 * a44 * a55 * a62 + a23 * 
            a36 * a44 * a55 * a62 + a24 * a33 * a46 * a55 * a62 - a23 * a34 * 
            a46 * a55 * a62 - a25 * a34 * a43 * a56 * a62 + a24 * a35 * a43 * 
            a56 * a62 + a25 * a33 * a44 * a56 * a62 - a23 * a35 * a44 * a56 * 
            a62 - a24 * a33 * a45 * a56 * a62 + a23 * a34 * a45 * a56 * a62 - 
            a26 * a35 * a44 * a52 * a63 + a25 * a36 * a44 * a52 * a63 + a26 * 
            a34 * a45 * a52 * a63 - a24 * a36 * a45 * a52 * a63 - a25 * a34 * 
            a46 * a52 * a63 + a24 * a35 * a46 * a52 * a63 + a26 * a35 * a42 * 
            a54 * a63 - a25 * a36 * a42 * a54 * a63 - a26 * a32 * a45 * a54 * 
            a63 + a22 * a36 * a45 * a54 * a63 + a25 * a32 * a46 * a54 * a63 - 
            a22 * a35 * a46 * a54 * a63 - a26 * a34 * a42 * a55 * a63 + a24 * 
            a36 * a42 * a55 * a63 + a26 * a32 * a44 * a55 * a63 - a22 * a36 * 
            a44 * a55 * a63 - a24 * a32 * a46 * a55 * a63 + a22 * a34 * a46 * 
            a55 * a63 + a25 * a34 * a42 * a56 * a63 - a24 * a35 * a42 * a56 * 
            a63 - a25 * a32 * a44 * a56 * a63 + a22 * a35 * a44 * a56 * a63 + 
            a24 * a32 * a45 * a56 * a63 - a22 * a34 * a45 * a56 * a63 + a26 * 
            a35 * a43 * a52 * a64 - a25 * a36 * a43 * a52 * a64 - a26 * a33 * 
            a45 * a52 * a64 + a23 * a36 * a45 * a52 * a64 + a25 * a33 * a46 * 
            a52 * a64 - a23 * a35 * a46 * a52 * a64 - a26 * a35 * a42 * a53 * 
            a64 + a25 * a36 * a42 * a53 * a64 + a26 * a32 * a45 * a53 * a64 - 
            a22 * a36 * a45 * a53 * a64 - a25 * a32 * a46 * a53 * a64 + a22 * 
            a35 * a46 * a53 * a64 + a26 * a33 * a42 * a55 * a64 - a23 * a36 * 
            a42 * a55 * a64 - a26 * a32 * a43 * a55 * a64 + a22 * a36 * a43 * 
            a55 * a64 + a23 * a32 * a46 * a55 * a64 - a22 * a33 * a46 * a55 * 
            a64 - a25 * a33 * a42 * a56 * a64 + a23 * a35 * a42 * a56 * a64 + 
            a25 * a32 * a43 * a56 * a64 - a22 * a35 * a43 * a56 * a64 - a23 * 
            a32 * a45 * a56 * a64 + a22 * a33 * a45 * a56 * a64 - a26 * a34 * 
            a43 * a52 * a65 + a24 * a36 * a43 * a52 * a65 + a26 * a33 * a44 * 
            a52 * a65 - a23 * a36 * a44 * a52 * a65 - a24 * a33 * a46 * a52 * 
            a65 + a23 * a34 * a46 * a52 * a65 + a26 * a34 * a42 * a53 * a65 - 
            a24 * a36 * a42 * a53 * a65 - a26 * a32 * a44 * a53 * a65 + a22 * 
            a36 * a44 * a53 * a65 + a24 * a32 * a46 * a53 * a65 - a22 * a34 * 
            a46 * a53 * a65 - a26 * a33 * a42 * a54 * a65 + a23 * a36 * a42 * 
            a54 * a65 + a26 * a32 * a43 * a54 * a65 - a22 * a36 * a43 * a54 * 
            a65 - a23 * a32 * a46 * a54 * a65 + a22 * a33 * a46 * a54 * a65 + 
            a24 * a33 * a42 * a56 * a65 - a23 * a34 * a42 * a56 * a65 - a24 * 
            a32 * a43 * a56 * a65 + a22 * a34 * a43 * a56 * a65 + a23 * a32 * 
            a44 * a56 * a65 - a22 * a33 * a44 * a56 * a65 + a25 * a34 * a43 * 
            a52 * a66 - a24 * a35 * a43 * a52 * a66 - a25 * a33 * a44 * a52 * 
            a66 + a23 * a35 * a44 * a52 * a66 + a24 * a33 * a45 * a52 * a66 - 
            a23 * a34 * a45 * a52 * a66 - a25 * a34 * a42 * a53 * a66 + a24 * 
            a35 * a42 * a53 * a66 + a25 * a32 * a44 * a53 * a66 - a22 * a35 * 
            a44 * a53 * a66 - a24 * a32 * a45 * a53 * a66 + a22 * a34 * a45 * 
            a53 * a66 + a25 * a33 * a42 * a54 * a66 - a23 * a35 * a42 * a54 * 
            a66 - a25 * a32 * a43 * a54 * a66 + a22 * a35 * a43 * a54 * a66 + 
            a23 * a32 * a45 * a54 * a66 - a22 * a33 * a45 * a54 * a66 - a24 * 
            a33 * a42 * a55 * a66 + a23 * a34 * a42 * a55 * a66 + a24 * a32 * 
            a43 * a55 * a66 - a22 * a34 * a43 * a55 * a66 - a23 * a32 * a44 * 
            a55 * a66 + a22 * a33 * a44 * a55 * a66;
    cofactor[1] = -a16 * a35 * a44 * a53 * a62 + a15 * a36 * a44 * a53 * a62 
            + a16 * a34 * a45 * a53 * a62 - a14 * a36 * a45 * a53 * a62 - a15 
            * a34 * a46 * a53 * a62 + a14 * a35 * a46 * a53 * a62 + a16 * a35 
            * a43 * a54 * a62 - a15 * a36 * a43 * a54 * a62 - a16 * a33 * a45 
            * a54 * a62 + a13 * a36 * a45 * a54 * a62 + a15 * a33 * a46 * a54 
            * a62 - a13 * a35 * a46 * a54 * a62 - a16 * a34 * a43 * a55 * a62 
            + a14 * a36 * a43 * a55 * a62 + a16 * a33 * a44 * a55 * a62 - a13 
            * a36 * a44 * a55 * a62 - a14 * a33 * a46 * a55 * a62 + a13 * a34 
            * a46 * a55 * a62 + a15 * a34 * a43 * a56 * a62 - a14 * a35 * a43 
            * a56 * a62 - a15 * a33 * a44 * a56 * a62 + a13 * a35 * a44 * a56 
            * a62 + a14 * a33 * a45 * a56 * a62 - a13 * a34 * a45 * a56 * a62 
            + a16 * a35 * a44 * a52 * a63 - a15 * a36 * a44 * a52 * a63 - a16 
            * a34 * a45 * a52 * a63 + a14 * a36 * a45 * a52 * a63 + a15 * a34 
            * a46 * a52 * a63 - a14 * a35 * a46 * a52 * a63 - a16 * a35 * a42 
            * a54 * a63 + a15 * a36 * a42 * a54 * a63 + a16 * a32 * a45 * a54 
            * a63 - a12 * a36 * a45 * a54 * a63 - a15 * a32 * a46 * a54 * a63 
            + a12 * a35 * a46 * a54 * a63 + a16 * a34 * a42 * a55 * a63 - a14 
            * a36 * a42 * a55 * a63 - a16 * a32 * a44 * a55 * a63 + a12 * a36 
            * a44 * a55 * a63 + a14 * a32 * a46 * a55 * a63 - a12 * a34 * a46 
            * a55 * a63 - a15 * a34 * a42 * a56 * a63 + a14 * a35 * a42 * a56 
            * a63 + a15 * a32 * a44 * a56 * a63 - a12 * a35 * a44 * a56 * a63 
            - a14 * a32 * a45 * a56 * a63 + a12 * a34 * a45 * a56 * a63 - a16 
            * a35 * a43 * a52 * a64 + a15 * a36 * a43 * a52 * a64 + a16 * a33 
            * a45 * a52 * a64 - a13 * a36 * a45 * a52 * a64 - a15 * a33 * a46 
            * a52 * a64 + a13 * a35 * a46 * a52 * a64 + a16 * a35 * a42 * a53 
            * a64 - a15 * a36 * a42 * a53 * a64 - a16 * a32 * a45 * a53 * a64 
            + a12 * a36 * a45 * a53 * a64 + a15 * a32 * a46 * a53 * a64 - a12 
            * a35 * a46 * a53 * a64 - a16 * a33 * a42 * a55 * a64 + a13 * a36 
            * a42 * a55 * a64 + a16 * a32 * a43 * a55 * a64 - a12 * a36 * a43 
            * a55 * a64 - a13 * a32 * a46 * a55 * a64 + a12 * a33 * a46 * a55 
            * a64 + a15 * a33 * a42 * a56 * a64 - a13 * a35 * a42 * a56 * a64 
            - a15 * a32 * a43 * a56 * a64 + a12 * a35 * a43 * a56 * a64 + a13 
            * a32 * a45 * a56 * a64 - a12 * a33 * a45 * a56 * a64 + a16 * a34 
            * a43 * a52 * a65 - a14 * a36 * a43 * a52 * a65 - a16 * a33 * a44 
            * a52 * a65 + a13 * a36 * a44 * a52 * a65 + a14 * a33 * a46 * a52 
            * a65 - a13 * a34 * a46 * a52 * a65 - a16 * a34 * a42 * a53 * a65 
            + a14 * a36 * a42 * a53 * a65 + a16 * a32 * a44 * a53 * a65 - a12 
            * a36 * a44 * a53 * a65 - a14 * a32 * a46 * a53 * a65 + a12 * a34 
            * a46 * a53 * a65 + a16 * a33 * a42 * a54 * a65 - a13 * a36 * a42 
            * a54 * a65 - a16 * a32 * a43 * a54 * a65 + a12 * a36 * a43 * a54 
            * a65 + a13 * a32 * a46 * a54 * a65 - a12 * a33 * a46 * a54 * a65 
            - a14 * a33 * a42 * a56 * a65 + a13 * a34 * a42 * a56 * a65 + a14 
            * a32 * a43 * a56 * a65 - a12 * a34 * a43 * a56 * a65 - a13 * a32 
            * a44 * a56 * a65 + a12 * a33 * a44 * a56 * a65 - a15 * a34 * a43 
            * a52 * a66 + a14 * a35 * a43 * a52 * a66 + a15 * a33 * a44 * a52 
            * a66 - a13 * a35 * a44 * a52 * a66 - a14 * a33 * a45 * a52 * a66 
            + a13 * a34 * a45 * a52 * a66 + a15 * a34 * a42 * a53 * a66 - a14 
            * a35 * a42 * a53 * a66 - a15 * a32 * a44 * a53 * a66 + a12 * a35 
            * a44 * a53 * a66 + a14 * a32 * a45 * a53 * a66 - a12 * a34 * a45 
            * a53 * a66 - a15 * a33 * a42 * a54 * a66 + a13 * a35 * a42 * a54 
            * a66 + a15 * a32 * a43 * a54 * a66 - a12 * a35 * a43 * a54 * a66 
            - a13 * a32 * a45 * a54 * a66 + a12 * a33 * a45 * a54 * a66 + a14 
            * a33 * a42 * a55 * a66 - a13 * a34 * a42 * a55 * a66 - a14 * a32 
            * a43 * a55 * a66 + a12 * a34 * a43 * a55 * a66 + a13 * a32 * a44 
            * a55 * a66 - a12 * a33 * a44 * a55 * a66;
    cofactor[2] = a16 * a25 * a44 * a53 * a62 - a15 * a26 * a44 * a53 * a62 - 
            a16 * a24 * a45 * a53 * a62 + a14 * a26 * a45 * a53 * a62 + a15 * 
            a24 * a46 * a53 * a62 - a14 * a25 * a46 * a53 * a62 - a16 * a25 * 
            a43 * a54 * a62 + a15 * a26 * a43 * a54 * a62 + a16 * a23 * a45 * 
            a54 * a62 - a13 * a26 * a45 * a54 * a62 - a15 * a23 * a46 * a54 * 
            a62 + a13 * a25 * a46 * a54 * a62 + a16 * a24 * a43 * a55 * a62 - 
            a14 * a26 * a43 * a55 * a62 - a16 * a23 * a44 * a55 * a62 + a13 * 
            a26 * a44 * a55 * a62 + a14 * a23 * a46 * a55 * a62 - a13 * a24 * 
            a46 * a55 * a62 - a15 * a24 * a43 * a56 * a62 + a14 * a25 * a43 * 
            a56 * a62 + a15 * a23 * a44 * a56 * a62 - a13 * a25 * a44 * a56 * 
            a62 - a14 * a23 * a45 * a56 * a62 + a13 * a24 * a45 * a56 * a62 - 
            a16 * a25 * a44 * a52 * a63 + a15 * a26 * a44 * a52 * a63 + a16 * 
            a24 * a45 * a52 * a63 - a14 * a26 * a45 * a52 * a63 - a15 * a24 * 
            a46 * a52 * a63 + a14 * a25 * a46 * a52 * a63 + a16 * a25 * a42 * 
            a54 * a63 - a15 * a26 * a42 * a54 * a63 - a16 * a22 * a45 * a54 * 
            a63 + a12 * a26 * a45 * a54 * a63 + a15 * a22 * a46 * a54 * a63 - 
            a12 * a25 * a46 * a54 * a63 - a16 * a24 * a42 * a55 * a63 + a14 * 
            a26 * a42 * a55 * a63 + a16 * a22 * a44 * a55 * a63 - a12 * a26 * 
            a44 * a55 * a63 - a14 * a22 * a46 * a55 * a63 + a12 * a24 * a46 * 
            a55 * a63 + a15 * a24 * a42 * a56 * a63 - a14 * a25 * a42 * a56 * 
            a63 - a15 * a22 * a44 * a56 * a63 + a12 * a25 * a44 * a56 * a63 + 
            a14 * a22 * a45 * a56 * a63 - a12 * a24 * a45 * a56 * a63 + a16 * 
            a25 * a43 * a52 * a64 - a15 * a26 * a43 * a52 * a64 - a16 * a23 * 
            a45 * a52 * a64 + a13 * a26 * a45 * a52 * a64 + a15 * a23 * a46 * 
            a52 * a64 - a13 * a25 * a46 * a52 * a64 - a16 * a25 * a42 * a53 * 
            a64 + a15 * a26 * a42 * a53 * a64 + a16 * a22 * a45 * a53 * a64 - 
            a12 * a26 * a45 * a53 * a64 - a15 * a22 * a46 * a53 * a64 + a12 * 
            a25 * a46 * a53 * a64 + a16 * a23 * a42 * a55 * a64 - a13 * a26 * 
            a42 * a55 * a64 - a16 * a22 * a43 * a55 * a64 + a12 * a26 * a43 * 
            a55 * a64 + a13 * a22 * a46 * a55 * a64 - a12 * a23 * a46 * a55 * 
            a64 - a15 * a23 * a42 * a56 * a64 + a13 * a25 * a42 * a56 * a64 + 
            a15 * a22 * a43 * a56 * a64 - a12 * a25 * a43 * a56 * a64 - a13 * 
            a22 * a45 * a56 * a64 + a12 * a23 * a45 * a56 * a64 - a16 * a24 * 
            a43 * a52 * a65 + a14 * a26 * a43 * a52 * a65 + a16 * a23 * a44 * 
            a52 * a65 - a13 * a26 * a44 * a52 * a65 - a14 * a23 * a46 * a52 * 
            a65 + a13 * a24 * a46 * a52 * a65 + a16 * a24 * a42 * a53 * a65 - 
            a14 * a26 * a42 * a53 * a65 - a16 * a22 * a44 * a53 * a65 + a12 * 
            a26 * a44 * a53 * a65 + a14 * a22 * a46 * a53 * a65 - a12 * a24 * 
            a46 * a53 * a65 - a16 * a23 * a42 * a54 * a65 + a13 * a26 * a42 * 
            a54 * a65 + a16 * a22 * a43 * a54 * a65 - a12 * a26 * a43 * a54 * 
            a65 - a13 * a22 * a46 * a54 * a65 + a12 * a23 * a46 * a54 * a65 + 
            a14 * a23 * a42 * a56 * a65 - a13 * a24 * a42 * a56 * a65 - a14 * 
            a22 * a43 * a56 * a65 + a12 * a24 * a43 * a56 * a65 + a13 * a22 * 
            a44 * a56 * a65 - a12 * a23 * a44 * a56 * a65 + a15 * a24 * a43 * 
            a52 * a66 - a14 * a25 * a43 * a52 * a66 - a15 * a23 * a44 * a52 * 
            a66 + a13 * a25 * a44 * a52 * a66 + a14 * a23 * a45 * a52 * a66 - 
            a13 * a24 * a45 * a52 * a66 - a15 * a24 * a42 * a53 * a66 + a14 * 
            a25 * a42 * a53 * a66 + a15 * a22 * a44 * a53 * a66 - a12 * a25 * 
            a44 * a53 * a66 - a14 * a22 * a45 * a53 * a66 + a12 * a24 * a45 * 
            a53 * a66 + a15 * a23 * a42 * a54 * a66 - a13 * a25 * a42 * a54 * 
            a66 - a15 * a22 * a43 * a54 * a66 + a12 * a25 * a43 * a54 * a66 + 
            a13 * a22 * a45 * a54 * a66 - a12 * a23 * a45 * a54 * a66 - a14 * 
            a23 * a42 * a55 * a66 + a13 * a24 * a42 * a55 * a66 + a14 * a22 * 
            a43 * a55 * a66 - a12 * a24 * a43 * a55 * a66 - a13 * a22 * a44 * 
            a55 * a66 + a12 * a23 * a44 * a55 * a66;
    cofactor[3] = -a16 * a25 * a34 * a53 * a62 + a15 * a26 * a34 * a53 * a62 
            + a16 * a24 * a35 * a53 * a62 - a14 * a26 * a35 * a53 * a62 - a15 
            * a24 * a36 * a53 * a62 + a14 * a25 * a36 * a53 * a62 + a16 * a25 
            * a33 * a54 * a62 - a15 * a26 * a33 * a54 * a62 - a16 * a23 * a35 
            * a54 * a62 + a13 * a26 * a35 * a54 * a62 + a15 * a23 * a36 * a54 
            * a62 - a13 * a25 * a36 * a54 * a62 - a16 * a24 * a33 * a55 * a62 
            + a14 * a26 * a33 * a55 * a62 + a16 * a23 * a34 * a55 * a62 - a13 
            * a26 * a34 * a55 * a62 - a14 * a23 * a36 * a55 * a62 + a13 * a24 
            * a36 * a55 * a62 + a15 * a24 * a33 * a56 * a62 - a14 * a25 * a33 
            * a56 * a62 - a15 * a23 * a34 * a56 * a62 + a13 * a25 * a34 * a56 
            * a62 + a14 * a23 * a35 * a56 * a62 - a13 * a24 * a35 * a56 * a62 
            + a16 * a25 * a34 * a52 * a63 - a15 * a26 * a34 * a52 * a63 - a16 
            * a24 * a35 * a52 * a63 + a14 * a26 * a35 * a52 * a63 + a15 * a24 
            * a36 * a52 * a63 - a14 * a25 * a36 * a52 * a63 - a16 * a25 * a32 
            * a54 * a63 + a15 * a26 * a32 * a54 * a63 + a16 * a22 * a35 * a54 
            * a63 - a12 * a26 * a35 * a54 * a63 - a15 * a22 * a36 * a54 * a63 
            + a12 * a25 * a36 * a54 * a63 + a16 * a24 * a32 * a55 * a63 - a14 
            * a26 * a32 * a55 * a63 - a16 * a22 * a34 * a55 * a63 + a12 * a26 
            * a34 * a55 * a63 + a14 * a22 * a36 * a55 * a63 - a12 * a24 * a36 
            * a55 * a63 - a15 * a24 * a32 * a56 * a63 + a14 * a25 * a32 * a56 
            * a63 + a15 * a22 * a34 * a56 * a63 - a12 * a25 * a34 * a56 * a63 
            - a14 * a22 * a35 * a56 * a63 + a12 * a24 * a35 * a56 * a63 - a16 
            * a25 * a33 * a52 * a64 + a15 * a26 * a33 * a52 * a64 + a16 * a23 
            * a35 * a52 * a64 - a13 * a26 * a35 * a52 * a64 - a15 * a23 * a36 
            * a52 * a64 + a13 * a25 * a36 * a52 * a64 + a16 * a25 * a32 * a53 
            * a64 - a15 * a26 * a32 * a53 * a64 - a16 * a22 * a35 * a53 * a64 
            + a12 * a26 * a35 * a53 * a64 + a15 * a22 * a36 * a53 * a64 - a12 
            * a25 * a36 * a53 * a64 - a16 * a23 * a32 * a55 * a64 + a13 * a26 
            * a32 * a55 * a64 + a16 * a22 * a33 * a55 * a64 - a12 * a26 * a33 
            * a55 * a64 - a13 * a22 * a36 * a55 * a64 + a12 * a23 * a36 * a55 
            * a64 + a15 * a23 * a32 * a56 * a64 - a13 * a25 * a32 * a56 * a64 
            - a15 * a22 * a33 * a56 * a64 + a12 * a25 * a33 * a56 * a64 + a13 
            * a22 * a35 * a56 * a64 - a12 * a23 * a35 * a56 * a64 + a16 * a24 
            * a33 * a52 * a65 - a14 * a26 * a33 * a52 * a65 - a16 * a23 * a34 
            * a52 * a65 + a13 * a26 * a34 * a52 * a65 + a14 * a23 * a36 * a52 
            * a65 - a13 * a24 * a36 * a52 * a65 - a16 * a24 * a32 * a53 * a65 
            + a14 * a26 * a32 * a53 * a65 + a16 * a22 * a34 * a53 * a65 - a12 
            * a26 * a34 * a53 * a65 - a14 * a22 * a36 * a53 * a65 + a12 * a24 
            * a36 * a53 * a65 + a16 * a23 * a32 * a54 * a65 - a13 * a26 * a32 
            * a54 * a65 - a16 * a22 * a33 * a54 * a65 + a12 * a26 * a33 * a54 
            * a65 + a13 * a22 * a36 * a54 * a65 - a12 * a23 * a36 * a54 * a65 
            - a14 * a23 * a32 * a56 * a65 + a13 * a24 * a32 * a56 * a65 + a14 
            * a22 * a33 * a56 * a65 - a12 * a24 * a33 * a56 * a65 - a13 * a22 
            * a34 * a56 * a65 + a12 * a23 * a34 * a56 * a65 - a15 * a24 * a33 
            * a52 * a66 + a14 * a25 * a33 * a52 * a66 + a15 * a23 * a34 * a52 
            * a66 - a13 * a25 * a34 * a52 * a66 - a14 * a23 * a35 * a52 * a66 
            + a13 * a24 * a35 * a52 * a66 + a15 * a24 * a32 * a53 * a66 - a14 
            * a25 * a32 * a53 * a66 - a15 * a22 * a34 * a53 * a66 + a12 * a25 
            * a34 * a53 * a66 + a14 * a22 * a35 * a53 * a66 - a12 * a24 * a35 
            * a53 * a66 - a15 * a23 * a32 * a54 * a66 + a13 * a25 * a32 * a54 
            * a66 + a15 * a22 * a33 * a54 * a66 - a12 * a25 * a33 * a54 * a66 
            - a13 * a22 * a35 * a54 * a66 + a12 * a23 * a35 * a54 * a66 + a14 
            * a23 * a32 * a55 * a66 - a13 * a24 * a32 * a55 * a66 - a14 * a22 
            * a33 * a55 * a66 + a12 * a24 * a33 * a55 * a66 + a13 * a22 * a34 
            * a55 * a66 - a12 * a23 * a34 * a55 * a66;
    cofactor[4] = a16 * a25 * a34 * a43 * a62 - a15 * a26 * a34 * a43 * a62 - 
            a16 * a24 * a35 * a43 * a62 + a14 * a26 * a35 * a43 * a62 + a15 * 
            a24 * a36 * a43 * a62 - a14 * a25 * a36 * a43 * a62 - a16 * a25 * 
            a33 * a44 * a62 + a15 * a26 * a33 * a44 * a62 + a16 * a23 * a35 * 
            a44 * a62 - a13 * a26 * a35 * a44 * a62 - a15 * a23 * a36 * a44 * 
            a62 + a13 * a25 * a36 * a44 * a62 + a16 * a24 * a33 * a45 * a62 - 
            a14 * a26 * a33 * a45 * a62 - a16 * a23 * a34 * a45 * a62 + a13 * 
            a26 * a34 * a45 * a62 + a14 * a23 * a36 * a45 * a62 - a13 * a24 * 
            a36 * a45 * a62 - a15 * a24 * a33 * a46 * a62 + a14 * a25 * a33 * 
            a46 * a62 + a15 * a23 * a34 * a46 * a62 - a13 * a25 * a34 * a46 * 
            a62 - a14 * a23 * a35 * a46 * a62 + a13 * a24 * a35 * a46 * a62 - 
            a16 * a25 * a34 * a42 * a63 + a15 * a26 * a34 * a42 * a63 + a16 * 
            a24 * a35 * a42 * a63 - a14 * a26 * a35 * a42 * a63 - a15 * a24 * 
            a36 * a42 * a63 + a14 * a25 * a36 * a42 * a63 + a16 * a25 * a32 * 
            a44 * a63 - a15 * a26 * a32 * a44 * a63 - a16 * a22 * a35 * a44 * 
            a63 + a12 * a26 * a35 * a44 * a63 + a15 * a22 * a36 * a44 * a63 - 
            a12 * a25 * a36 * a44 * a63 - a16 * a24 * a32 * a45 * a63 + a14 * 
            a26 * a32 * a45 * a63 + a16 * a22 * a34 * a45 * a63 - a12 * a26 * 
            a34 * a45 * a63 - a14 * a22 * a36 * a45 * a63 + a12 * a24 * a36 * 
            a45 * a63 + a15 * a24 * a32 * a46 * a63 - a14 * a25 * a32 * a46 * 
            a63 - a15 * a22 * a34 * a46 * a63 + a12 * a25 * a34 * a46 * a63 + 
            a14 * a22 * a35 * a46 * a63 - a12 * a24 * a35 * a46 * a63 + a16 * 
            a25 * a33 * a42 * a64 - a15 * a26 * a33 * a42 * a64 - a16 * a23 * 
            a35 * a42 * a64 + a13 * a26 * a35 * a42 * a64 + a15 * a23 * a36 * 
            a42 * a64 - a13 * a25 * a36 * a42 * a64 - a16 * a25 * a32 * a43 * 
            a64 + a15 * a26 * a32 * a43 * a64 + a16 * a22 * a35 * a43 * a64 - 
            a12 * a26 * a35 * a43 * a64 - a15 * a22 * a36 * a43 * a64 + a12 * 
            a25 * a36 * a43 * a64 + a16 * a23 * a32 * a45 * a64 - a13 * a26 * 
            a32 * a45 * a64 - a16 * a22 * a33 * a45 * a64 + a12 * a26 * a33 * 
            a45 * a64 + a13 * a22 * a36 * a45 * a64 - a12 * a23 * a36 * a45 * 
            a64 - a15 * a23 * a32 * a46 * a64 + a13 * a25 * a32 * a46 * a64 + 
            a15 * a22 * a33 * a46 * a64 - a12 * a25 * a33 * a46 * a64 - a13 * 
            a22 * a35 * a46 * a64 + a12 * a23 * a35 * a46 * a64 - a16 * a24 * 
            a33 * a42 * a65 + a14 * a26 * a33 * a42 * a65 + a16 * a23 * a34 * 
            a42 * a65 - a13 * a26 * a34 * a42 * a65 - a14 * a23 * a36 * a42 * 
            a65 + a13 * a24 * a36 * a42 * a65 + a16 * a24 * a32 * a43 * a65 - 
            a14 * a26 * a32 * a43 * a65 - a16 * a22 * a34 * a43 * a65 + a12 * 
            a26 * a34 * a43 * a65 + a14 * a22 * a36 * a43 * a65 - a12 * a24 * 
            a36 * a43 * a65 - a16 * a23 * a32 * a44 * a65 + a13 * a26 * a32 * 
            a44 * a65 + a16 * a22 * a33 * a44 * a65 - a12 * a26 * a33 * a44 * 
            a65 - a13 * a22 * a36 * a44 * a65 + a12 * a23 * a36 * a44 * a65 + 
            a14 * a23 * a32 * a46 * a65 - a13 * a24 * a32 * a46 * a65 - a14 * 
            a22 * a33 * a46 * a65 + a12 * a24 * a33 * a46 * a65 + a13 * a22 * 
            a34 * a46 * a65 - a12 * a23 * a34 * a46 * a65 + a15 * a24 * a33 * 
            a42 * a66 - a14 * a25 * a33 * a42 * a66 - a15 * a23 * a34 * a42 * 
            a66 + a13 * a25 * a34 * a42 * a66 + a14 * a23 * a35 * a42 * a66 - 
            a13 * a24 * a35 * a42 * a66 - a15 * a24 * a32 * a43 * a66 + a14 * 
            a25 * a32 * a43 * a66 + a15 * a22 * a34 * a43 * a66 - a12 * a25 * 
            a34 * a43 * a66 - a14 * a22 * a35 * a43 * a66 + a12 * a24 * a35 * 
            a43 * a66 + a15 * a23 * a32 * a44 * a66 - a13 * a25 * a32 * a44 * 
            a66 - a15 * a22 * a33 * a44 * a66 + a12 * a25 * a33 * a44 * a66 + 
            a13 * a22 * a35 * a44 * a66 - a12 * a23 * a35 * a44 * a66 - a14 * 
            a23 * a32 * a45 * a66 + a13 * a24 * a32 * a45 * a66 + a14 * a22 * 
            a33 * a45 * a66 - a12 * a24 * a33 * a45 * a66 - a13 * a22 * a34 * 
            a45 * a66 + a12 * a23 * a34 * a45 * a66;
    cofactor[5] = -a16 * a25 * a34 * a43 * a52 + a15 * a26 * a34 * a43 * a52 
            + a16 * a24 * a35 * a43 * a52 - a14 * a26 * a35 * a43 * a52 - a15 
            * a24 * a36 * a43 * a52 + a14 * a25 * a36 * a43 * a52 + a16 * a25 
            * a33 * a44 * a52 - a15 * a26 * a33 * a44 * a52 - a16 * a23 * a35 
            * a44 * a52 + a13 * a26 * a35 * a44 * a52 + a15 * a23 * a36 * a44 
            * a52 - a13 * a25 * a36 * a44 * a52 - a16 * a24 * a33 * a45 * a52 
            + a14 * a26 * a33 * a45 * a52 + a16 * a23 * a34 * a45 * a52 - a13 
            * a26 * a34 * a45 * a52 - a14 * a23 * a36 * a45 * a52 + a13 * a24 
            * a36 * a45 * a52 + a15 * a24 * a33 * a46 * a52 - a14 * a25 * a33 
            * a46 * a52 - a15 * a23 * a34 * a46 * a52 + a13 * a25 * a34 * a46 
            * a52 + a14 * a23 * a35 * a46 * a52 - a13 * a24 * a35 * a46 * a52 
            + a16 * a25 * a34 * a42 * a53 - a15 * a26 * a34 * a42 * a53 - a16 
            * a24 * a35 * a42 * a53 + a14 * a26 * a35 * a42 * a53 + a15 * a24 
            * a36 * a42 * a53 - a14 * a25 * a36 * a42 * a53 - a16 * a25 * a32 
            * a44 * a53 + a15 * a26 * a32 * a44 * a53 + a16 * a22 * a35 * a44 
            * a53 - a12 * a26 * a35 * a44 * a53 - a15 * a22 * a36 * a44 * a53 
            + a12 * a25 * a36 * a44 * a53 + a16 * a24 * a32 * a45 * a53 - a14 
            * a26 * a32 * a45 * a53 - a16 * a22 * a34 * a45 * a53 + a12 * a26 
            * a34 * a45 * a53 + a14 * a22 * a36 * a45 * a53 - a12 * a24 * a36 
            * a45 * a53 - a15 * a24 * a32 * a46 * a53 + a14 * a25 * a32 * a46 
            * a53 + a15 * a22 * a34 * a46 * a53 - a12 * a25 * a34 * a46 * a53 
            - a14 * a22 * a35 * a46 * a53 + a12 * a24 * a35 * a46 * a53 - a16 
            * a25 * a33 * a42 * a54 + a15 * a26 * a33 * a42 * a54 + a16 * a23 
            * a35 * a42 * a54 - a13 * a26 * a35 * a42 * a54 - a15 * a23 * a36 
            * a42 * a54 + a13 * a25 * a36 * a42 * a54 + a16 * a25 * a32 * a43 
            * a54 - a15 * a26 * a32 * a43 * a54 - a16 * a22 * a35 * a43 * a54 
            + a12 * a26 * a35 * a43 * a54 + a15 * a22 * a36 * a43 * a54 - a12 
            * a25 * a36 * a43 * a54 - a16 * a23 * a32 * a45 * a54 + a13 * a26 
            * a32 * a45 * a54 + a16 * a22 * a33 * a45 * a54 - a12 * a26 * a33 
            * a45 * a54 - a13 * a22 * a36 * a45 * a54 + a12 * a23 * a36 * a45 
            * a54 + a15 * a23 * a32 * a46 * a54 - a13 * a25 * a32 * a46 * a54 
            - a15 * a22 * a33 * a46 * a54 + a12 * a25 * a33 * a46 * a54 + a13 
            * a22 * a35 * a46 * a54 - a12 * a23 * a35 * a46 * a54 + a16 * a24 
            * a33 * a42 * a55 - a14 * a26 * a33 * a42 * a55 - a16 * a23 * a34 
            * a42 * a55 + a13 * a26 * a34 * a42 * a55 + a14 * a23 * a36 * a42 
            * a55 - a13 * a24 * a36 * a42 * a55 - a16 * a24 * a32 * a43 * a55 
            + a14 * a26 * a32 * a43 * a55 + a16 * a22 * a34 * a43 * a55 - a12 
            * a26 * a34 * a43 * a55 - a14 * a22 * a36 * a43 * a55 + a12 * a24 
            * a36 * a43 * a55 + a16 * a23 * a32 * a44 * a55 - a13 * a26 * a32 
            * a44 * a55 - a16 * a22 * a33 * a44 * a55 + a12 * a26 * a33 * a44 
            * a55 + a13 * a22 * a36 * a44 * a55 - a12 * a23 * a36 * a44 * a55 
            - a14 * a23 * a32 * a46 * a55 + a13 * a24 * a32 * a46 * a55 + a14 
            * a22 * a33 * a46 * a55 - a12 * a24 * a33 * a46 * a55 - a13 * a22 
            * a34 * a46 * a55 + a12 * a23 * a34 * a46 * a55 - a15 * a24 * a33 
            * a42 * a56 + a14 * a25 * a33 * a42 * a56 + a15 * a23 * a34 * a42 
            * a56 - a13 * a25 * a34 * a42 * a56 - a14 * a23 * a35 * a42 * a56 
            + a13 * a24 * a35 * a42 * a56 + a15 * a24 * a32 * a43 * a56 - a14 
            * a25 * a32 * a43 * a56 - a15 * a22 * a34 * a43 * a56 + a12 * a25 
            * a34 * a43 * a56 + a14 * a22 * a35 * a43 * a56 - a12 * a24 * a35 
            * a43 * a56 - a15 * a23 * a32 * a44 * a56 + a13 * a25 * a32 * a44 
            * a56 + a15 * a22 * a33 * a44 * a56 - a12 * a25 * a33 * a44 * a56 
            - a13 * a22 * a35 * a44 * a56 + a12 * a23 * a35 * a44 * a56 + a14 
            * a23 * a32 * a45 * a56 - a13 * a24 * a32 * a45 * a56 - a14 * a22 
            * a33 * a45 * a56 + a12 * a24 * a33 * a45 * a56 + a13 * a22 * a34 
            * a45 * a56 - a12 * a23 * a34 * a45 * a56;
    cofactor[6] = -a26 * a35 * a44 * a53 * a61 + a25 * a36 * a44 * a53 * a61 
            + a26 * a34 * a45 * a53 * a61 - a24 * a36 * a45 * a53 * a61 - a25 
            * a34 * a46 * a53 * a61 + a24 * a35 * a46 * a53 * a61 + a26 * a35 
            * a43 * a54 * a61 - a25 * a36 * a43 * a54 * a61 - a26 * a33 * a45 
            * a54 * a61 + a23 * a36 * a45 * a54 * a61 + a25 * a33 * a46 * a54 
            * a61 - a23 * a35 * a46 * a54 * a61 - a26 * a34 * a43 * a55 * a61 
            + a24 * a36 * a43 * a55 * a61 + a26 * a33 * a44 * a55 * a61 - a23 
            * a36 * a44 * a55 * a61 - a24 * a33 * a46 * a55 * a61 + a23 * a34 
            * a46 * a55 * a61 + a25 * a34 * a43 * a56 * a61 - a24 * a35 * a43 
            * a56 * a61 - a25 * a33 * a44 * a56 * a61 + a23 * a35 * a44 * a56 
            * a61 + a24 * a33 * a45 * a56 * a61 - a23 * a34 * a45 * a56 * a61 
            + a26 * a35 * a44 * a51 * a63 - a25 * a36 * a44 * a51 * a63 - a26 
            * a34 * a45 * a51 * a63 + a24 * a36 * a45 * a51 * a63 + a25 * a34 
            * a46 * a51 * a63 - a24 * a35 * a46 * a51 * a63 - a26 * a35 * a41 
            * a54 * a63 + a25 * a36 * a41 * a54 * a63 + a26 * a31 * a45 * a54 
            * a63 - a21 * a36 * a45 * a54 * a63 - a25 * a31 * a46 * a54 * a63 
            + a21 * a35 * a46 * a54 * a63 + a26 * a34 * a41 * a55 * a63 - a24 
            * a36 * a41 * a55 * a63 - a26 * a31 * a44 * a55 * a63 + a21 * a36 
            * a44 * a55 * a63 + a24 * a31 * a46 * a55 * a63 - a21 * a34 * a46 
            * a55 * a63 - a25 * a34 * a41 * a56 * a63 + a24 * a35 * a41 * a56 
            * a63 + a25 * a31 * a44 * a56 * a63 - a21 * a35 * a44 * a56 * a63 
            - a24 * a31 * a45 * a56 * a63 + a21 * a34 * a45 * a56 * a63 - a26 
            * a35 * a43 * a51 * a64 + a25 * a36 * a43 * a51 * a64 + a26 * a33 
            * a45 * a51 * a64 - a23 * a36 * a45 * a51 * a64 - a25 * a33 * a46 
            * a51 * a64 + a23 * a35 * a46 * a51 * a64 + a26 * a35 * a41 * a53 
            * a64 - a25 * a36 * a41 * a53 * a64 - a26 * a31 * a45 * a53 * a64 
            + a21 * a36 * a45 * a53 * a64 + a25 * a31 * a46 * a53 * a64 - a21 
            * a35 * a46 * a53 * a64 - a26 * a33 * a41 * a55 * a64 + a23 * a36 
            * a41 * a55 * a64 + a26 * a31 * a43 * a55 * a64 - a21 * a36 * a43 
            * a55 * a64 - a23 * a31 * a46 * a55 * a64 + a21 * a33 * a46 * a55 
            * a64 + a25 * a33 * a41 * a56 * a64 - a23 * a35 * a41 * a56 * a64 
            - a25 * a31 * a43 * a56 * a64 + a21 * a35 * a43 * a56 * a64 + a23 
            * a31 * a45 * a56 * a64 - a21 * a33 * a45 * a56 * a64 + a26 * a34 
            * a43 * a51 * a65 - a24 * a36 * a43 * a51 * a65 - a26 * a33 * a44 
            * a51 * a65 + a23 * a36 * a44 * a51 * a65 + a24 * a33 * a46 * a51 
            * a65 - a23 * a34 * a46 * a51 * a65 - a26 * a34 * a41 * a53 * a65 
            + a24 * a36 * a41 * a53 * a65 + a26 * a31 * a44 * a53 * a65 - a21 
            * a36 * a44 * a53 * a65 - a24 * a31 * a46 * a53 * a65 + a21 * a34 
            * a46 * a53 * a65 + a26 * a33 * a41 * a54 * a65 - a23 * a36 * a41 
            * a54 * a65 - a26 * a31 * a43 * a54 * a65 + a21 * a36 * a43 * a54 
            * a65 + a23 * a31 * a46 * a54 * a65 - a21 * a33 * a46 * a54 * a65 
            - a24 * a33 * a41 * a56 * a65 + a23 * a34 * a41 * a56 * a65 + a24 
            * a31 * a43 * a56 * a65 - a21 * a34 * a43 * a56 * a65 - a23 * a31 
            * a44 * a56 * a65 + a21 * a33 * a44 * a56 * a65 - a25 * a34 * a43 
            * a51 * a66 + a24 * a35 * a43 * a51 * a66 + a25 * a33 * a44 * a51 
            * a66 - a23 * a35 * a44 * a51 * a66 - a24 * a33 * a45 * a51 * a66 
            + a23 * a34 * a45 * a51 * a66 + a25 * a34 * a41 * a53 * a66 - a24 
            * a35 * a41 * a53 * a66 - a25 * a31 * a44 * a53 * a66 + a21 * a35 
            * a44 * a53 * a66 + a24 * a31 * a45 * a53 * a66 - a21 * a34 * a45 
            * a53 * a66 - a25 * a33 * a41 * a54 * a66 + a23 * a35 * a41 * a54 
            * a66 + a25 * a31 * a43 * a54 * a66 - a21 * a35 * a43 * a54 * a66 
            - a23 * a31 * a45 * a54 * a66 + a21 * a33 * a45 * a54 * a66 + a24 
            * a33 * a41 * a55 * a66 - a23 * a34 * a41 * a55 * a66 - a24 * a31 
            * a43 * a55 * a66 + a21 * a34 * a43 * a55 * a66 + a23 * a31 * a44 
            * a55 * a66 - a21 * a33 * a44 * a55 * a66;
    cofactor[7] = a16 * a35 * a44 * a53 * a61 - a15 * a36 * a44 * a53 * a61 - 
            a16 * a34 * a45 * a53 * a61 + a14 * a36 * a45 * a53 * a61 + a15 * 
            a34 * a46 * a53 * a61 - a14 * a35 * a46 * a53 * a61 - a16 * a35 * 
            a43 * a54 * a61 + a15 * a36 * a43 * a54 * a61 + a16 * a33 * a45 * 
            a54 * a61 - a13 * a36 * a45 * a54 * a61 - a15 * a33 * a46 * a54 * 
            a61 + a13 * a35 * a46 * a54 * a61 + a16 * a34 * a43 * a55 * a61 - 
            a14 * a36 * a43 * a55 * a61 - a16 * a33 * a44 * a55 * a61 + a13 * 
            a36 * a44 * a55 * a61 + a14 * a33 * a46 * a55 * a61 - a13 * a34 * 
            a46 * a55 * a61 - a15 * a34 * a43 * a56 * a61 + a14 * a35 * a43 * 
            a56 * a61 + a15 * a33 * a44 * a56 * a61 - a13 * a35 * a44 * a56 * 
            a61 - a14 * a33 * a45 * a56 * a61 + a13 * a34 * a45 * a56 * a61 - 
            a16 * a35 * a44 * a51 * a63 + a15 * a36 * a44 * a51 * a63 + a16 * 
            a34 * a45 * a51 * a63 - a14 * a36 * a45 * a51 * a63 - a15 * a34 * 
            a46 * a51 * a63 + a14 * a35 * a46 * a51 * a63 + a16 * a35 * a41 * 
            a54 * a63 - a15 * a36 * a41 * a54 * a63 - a16 * a31 * a45 * a54 * 
            a63 + a11 * a36 * a45 * a54 * a63 + a15 * a31 * a46 * a54 * a63 - 
            a11 * a35 * a46 * a54 * a63 - a16 * a34 * a41 * a55 * a63 + a14 * 
            a36 * a41 * a55 * a63 + a16 * a31 * a44 * a55 * a63 - a11 * a36 * 
            a44 * a55 * a63 - a14 * a31 * a46 * a55 * a63 + a11 * a34 * a46 * 
            a55 * a63 + a15 * a34 * a41 * a56 * a63 - a14 * a35 * a41 * a56 * 
            a63 - a15 * a31 * a44 * a56 * a63 + a11 * a35 * a44 * a56 * a63 + 
            a14 * a31 * a45 * a56 * a63 - a11 * a34 * a45 * a56 * a63 + a16 * 
            a35 * a43 * a51 * a64 - a15 * a36 * a43 * a51 * a64 - a16 * a33 * 
            a45 * a51 * a64 + a13 * a36 * a45 * a51 * a64 + a15 * a33 * a46 * 
            a51 * a64 - a13 * a35 * a46 * a51 * a64 - a16 * a35 * a41 * a53 * 
            a64 + a15 * a36 * a41 * a53 * a64 + a16 * a31 * a45 * a53 * a64 - 
            a11 * a36 * a45 * a53 * a64 - a15 * a31 * a46 * a53 * a64 + a11 * 
            a35 * a46 * a53 * a64 + a16 * a33 * a41 * a55 * a64 - a13 * a36 * 
            a41 * a55 * a64 - a16 * a31 * a43 * a55 * a64 + a11 * a36 * a43 * 
            a55 * a64 + a13 * a31 * a46 * a55 * a64 - a11 * a33 * a46 * a55 * 
            a64 - a15 * a33 * a41 * a56 * a64 + a13 * a35 * a41 * a56 * a64 + 
            a15 * a31 * a43 * a56 * a64 - a11 * a35 * a43 * a56 * a64 - a13 * 
            a31 * a45 * a56 * a64 + a11 * a33 * a45 * a56 * a64 - a16 * a34 * 
            a43 * a51 * a65 + a14 * a36 * a43 * a51 * a65 + a16 * a33 * a44 * 
            a51 * a65 - a13 * a36 * a44 * a51 * a65 - a14 * a33 * a46 * a51 * 
            a65 + a13 * a34 * a46 * a51 * a65 + a16 * a34 * a41 * a53 * a65 - 
            a14 * a36 * a41 * a53 * a65 - a16 * a31 * a44 * a53 * a65 + a11 * 
            a36 * a44 * a53 * a65 + a14 * a31 * a46 * a53 * a65 - a11 * a34 * 
            a46 * a53 * a65 - a16 * a33 * a41 * a54 * a65 + a13 * a36 * a41 * 
            a54 * a65 + a16 * a31 * a43 * a54 * a65 - a11 * a36 * a43 * a54 * 
            a65 - a13 * a31 * a46 * a54 * a65 + a11 * a33 * a46 * a54 * a65 + 
            a14 * a33 * a41 * a56 * a65 - a13 * a34 * a41 * a56 * a65 - a14 * 
            a31 * a43 * a56 * a65 + a11 * a34 * a43 * a56 * a65 + a13 * a31 * 
            a44 * a56 * a65 - a11 * a33 * a44 * a56 * a65 + a15 * a34 * a43 * 
            a51 * a66 - a14 * a35 * a43 * a51 * a66 - a15 * a33 * a44 * a51 * 
            a66 + a13 * a35 * a44 * a51 * a66 + a14 * a33 * a45 * a51 * a66 - 
            a13 * a34 * a45 * a51 * a66 - a15 * a34 * a41 * a53 * a66 + a14 * 
            a35 * a41 * a53 * a66 + a15 * a31 * a44 * a53 * a66 - a11 * a35 * 
            a44 * a53 * a66 - a14 * a31 * a45 * a53 * a66 + a11 * a34 * a45 * 
            a53 * a66 + a15 * a33 * a41 * a54 * a66 - a13 * a35 * a41 * a54 * 
            a66 - a15 * a31 * a43 * a54 * a66 + a11 * a35 * a43 * a54 * a66 + 
            a13 * a31 * a45 * a54 * a66 - a11 * a33 * a45 * a54 * a66 - a14 * 
            a33 * a41 * a55 * a66 + a13 * a34 * a41 * a55 * a66 + a14 * a31 * 
            a43 * a55 * a66 - a11 * a34 * a43 * a55 * a66 - a13 * a31 * a44 * 
            a55 * a66 + a11 * a33 * a44 * a55 * a66;
    cofactor[8] = -a16 * a25 * a44 * a53 * a61 + a15 * a26 * a44 * a53 * a61 
            + a16 * a24 * a45 * a53 * a61 - a14 * a26 * a45 * a53 * a61 - a15 
            * a24 * a46 * a53 * a61 + a14 * a25 * a46 * a53 * a61 + a16 * a25 
            * a43 * a54 * a61 - a15 * a26 * a43 * a54 * a61 - a16 * a23 * a45 
            * a54 * a61 + a13 * a26 * a45 * a54 * a61 + a15 * a23 * a46 * a54 
            * a61 - a13 * a25 * a46 * a54 * a61 - a16 * a24 * a43 * a55 * a61 
            + a14 * a26 * a43 * a55 * a61 + a16 * a23 * a44 * a55 * a61 - a13 
            * a26 * a44 * a55 * a61 - a14 * a23 * a46 * a55 * a61 + a13 * a24 
            * a46 * a55 * a61 + a15 * a24 * a43 * a56 * a61 - a14 * a25 * a43 
            * a56 * a61 - a15 * a23 * a44 * a56 * a61 + a13 * a25 * a44 * a56 
            * a61 + a14 * a23 * a45 * a56 * a61 - a13 * a24 * a45 * a56 * a61 
            + a16 * a25 * a44 * a51 * a63 - a15 * a26 * a44 * a51 * a63 - a16 
            * a24 * a45 * a51 * a63 + a14 * a26 * a45 * a51 * a63 + a15 * a24 
            * a46 * a51 * a63 - a14 * a25 * a46 * a51 * a63 - a16 * a25 * a41 
            * a54 * a63 + a15 * a26 * a41 * a54 * a63 + a16 * a21 * a45 * a54 
            * a63 - a11 * a26 * a45 * a54 * a63 - a15 * a21 * a46 * a54 * a63 
            + a11 * a25 * a46 * a54 * a63 + a16 * a24 * a41 * a55 * a63 - a14 
            * a26 * a41 * a55 * a63 - a16 * a21 * a44 * a55 * a63 + a11 * a26 
            * a44 * a55 * a63 + a14 * a21 * a46 * a55 * a63 - a11 * a24 * a46 
            * a55 * a63 - a15 * a24 * a41 * a56 * a63 + a14 * a25 * a41 * a56 
            * a63 + a15 * a21 * a44 * a56 * a63 - a11 * a25 * a44 * a56 * a63 
            - a14 * a21 * a45 * a56 * a63 + a11 * a24 * a45 * a56 * a63 - a16 
            * a25 * a43 * a51 * a64 + a15 * a26 * a43 * a51 * a64 + a16 * a23 
            * a45 * a51 * a64 - a13 * a26 * a45 * a51 * a64 - a15 * a23 * a46 
            * a51 * a64 + a13 * a25 * a46 * a51 * a64 + a16 * a25 * a41 * a53 
            * a64 - a15 * a26 * a41 * a53 * a64 - a16 * a21 * a45 * a53 * a64 
            + a11 * a26 * a45 * a53 * a64 + a15 * a21 * a46 * a53 * a64 - a11 
            * a25 * a46 * a53 * a64 - a16 * a23 * a41 * a55 * a64 + a13 * a26 
            * a41 * a55 * a64 + a16 * a21 * a43 * a55 * a64 - a11 * a26 * a43 
            * a55 * a64 - a13 * a21 * a46 * a55 * a64 + a11 * a23 * a46 * a55 
            * a64 + a15 * a23 * a41 * a56 * a64 - a13 * a25 * a41 * a56 * a64 
            - a15 * a21 * a43 * a56 * a64 + a11 * a25 * a43 * a56 * a64 + a13 
            * a21 * a45 * a56 * a64 - a11 * a23 * a45 * a56 * a64 + a16 * a24 
            * a43 * a51 * a65 - a14 * a26 * a43 * a51 * a65 - a16 * a23 * a44 
            * a51 * a65 + a13 * a26 * a44 * a51 * a65 + a14 * a23 * a46 * a51 
            * a65 - a13 * a24 * a46 * a51 * a65 - a16 * a24 * a41 * a53 * a65 
            + a14 * a26 * a41 * a53 * a65 + a16 * a21 * a44 * a53 * a65 - a11 
            * a26 * a44 * a53 * a65 - a14 * a21 * a46 * a53 * a65 + a11 * a24 
            * a46 * a53 * a65 + a16 * a23 * a41 * a54 * a65 - a13 * a26 * a41 
            * a54 * a65 - a16 * a21 * a43 * a54 * a65 + a11 * a26 * a43 * a54 
            * a65 + a13 * a21 * a46 * a54 * a65 - a11 * a23 * a46 * a54 * a65 
            - a14 * a23 * a41 * a56 * a65 + a13 * a24 * a41 * a56 * a65 + a14 
            * a21 * a43 * a56 * a65 - a11 * a24 * a43 * a56 * a65 - a13 * a21 
            * a44 * a56 * a65 + a11 * a23 * a44 * a56 * a65 - a15 * a24 * a43 
            * a51 * a66 + a14 * a25 * a43 * a51 * a66 + a15 * a23 * a44 * a51 
            * a66 - a13 * a25 * a44 * a51 * a66 - a14 * a23 * a45 * a51 * a66 
            + a13 * a24 * a45 * a51 * a66 + a15 * a24 * a41 * a53 * a66 - a14 
            * a25 * a41 * a53 * a66 - a15 * a21 * a44 * a53 * a66 + a11 * a25 
            * a44 * a53 * a66 + a14 * a21 * a45 * a53 * a66 - a11 * a24 * a45 
            * a53 * a66 - a15 * a23 * a41 * a54 * a66 + a13 * a25 * a41 * a54 
            * a66 + a15 * a21 * a43 * a54 * a66 - a11 * a25 * a43 * a54 * a66 
            - a13 * a21 * a45 * a54 * a66 + a11 * a23 * a45 * a54 * a66 + a14 
            * a23 * a41 * a55 * a66 - a13 * a24 * a41 * a55 * a66 - a14 * a21 
            * a43 * a55 * a66 + a11 * a24 * a43 * a55 * a66 + a13 * a21 * a44 
            * a55 * a66 - a11 * a23 * a44 * a55 * a66;
    cofactor[9] = a16 * a25 * a34 * a53 * a61 - a15 * a26 * a34 * a53 * a61 - 
            a16 * a24 * a35 * a53 * a61 + a14 * a26 * a35 * a53 * a61 + a15 * 
            a24 * a36 * a53 * a61 - a14 * a25 * a36 * a53 * a61 - a16 * a25 * 
            a33 * a54 * a61 + a15 * a26 * a33 * a54 * a61 + a16 * a23 * a35 * 
            a54 * a61 - a13 * a26 * a35 * a54 * a61 - a15 * a23 * a36 * a54 * 
            a61 + a13 * a25 * a36 * a54 * a61 + a16 * a24 * a33 * a55 * a61 - 
            a14 * a26 * a33 * a55 * a61 - a16 * a23 * a34 * a55 * a61 + a13 * 
            a26 * a34 * a55 * a61 + a14 * a23 * a36 * a55 * a61 - a13 * a24 * 
            a36 * a55 * a61 - a15 * a24 * a33 * a56 * a61 + a14 * a25 * a33 * 
            a56 * a61 + a15 * a23 * a34 * a56 * a61 - a13 * a25 * a34 * a56 * 
            a61 - a14 * a23 * a35 * a56 * a61 + a13 * a24 * a35 * a56 * a61 - 
            a16 * a25 * a34 * a51 * a63 + a15 * a26 * a34 * a51 * a63 + a16 * 
            a24 * a35 * a51 * a63 - a14 * a26 * a35 * a51 * a63 - a15 * a24 * 
            a36 * a51 * a63 + a14 * a25 * a36 * a51 * a63 + a16 * a25 * a31 * 
            a54 * a63 - a15 * a26 * a31 * a54 * a63 - a16 * a21 * a35 * a54 * 
            a63 + a11 * a26 * a35 * a54 * a63 + a15 * a21 * a36 * a54 * a63 - 
            a11 * a25 * a36 * a54 * a63 - a16 * a24 * a31 * a55 * a63 + a14 * 
            a26 * a31 * a55 * a63 + a16 * a21 * a34 * a55 * a63 - a11 * a26 * 
            a34 * a55 * a63 - a14 * a21 * a36 * a55 * a63 + a11 * a24 * a36 * 
            a55 * a63 + a15 * a24 * a31 * a56 * a63 - a14 * a25 * a31 * a56 * 
            a63 - a15 * a21 * a34 * a56 * a63 + a11 * a25 * a34 * a56 * a63 + 
            a14 * a21 * a35 * a56 * a63 - a11 * a24 * a35 * a56 * a63 + a16 * 
            a25 * a33 * a51 * a64 - a15 * a26 * a33 * a51 * a64 - a16 * a23 * 
            a35 * a51 * a64 + a13 * a26 * a35 * a51 * a64 + a15 * a23 * a36 * 
            a51 * a64 - a13 * a25 * a36 * a51 * a64 - a16 * a25 * a31 * a53 * 
            a64 + a15 * a26 * a31 * a53 * a64 + a16 * a21 * a35 * a53 * a64 - 
            a11 * a26 * a35 * a53 * a64 - a15 * a21 * a36 * a53 * a64 + a11 * 
            a25 * a36 * a53 * a64 + a16 * a23 * a31 * a55 * a64 - a13 * a26 * 
            a31 * a55 * a64 - a16 * a21 * a33 * a55 * a64 + a11 * a26 * a33 * 
            a55 * a64 + a13 * a21 * a36 * a55 * a64 - a11 * a23 * a36 * a55 * 
            a64 - a15 * a23 * a31 * a56 * a64 + a13 * a25 * a31 * a56 * a64 + 
            a15 * a21 * a33 * a56 * a64 - a11 * a25 * a33 * a56 * a64 - a13 * 
            a21 * a35 * a56 * a64 + a11 * a23 * a35 * a56 * a64 - a16 * a24 * 
            a33 * a51 * a65 + a14 * a26 * a33 * a51 * a65 + a16 * a23 * a34 * 
            a51 * a65 - a13 * a26 * a34 * a51 * a65 - a14 * a23 * a36 * a51 * 
            a65 + a13 * a24 * a36 * a51 * a65 + a16 * a24 * a31 * a53 * a65 - 
            a14 * a26 * a31 * a53 * a65 - a16 * a21 * a34 * a53 * a65 + a11 * 
            a26 * a34 * a53 * a65 + a14 * a21 * a36 * a53 * a65 - a11 * a24 * 
            a36 * a53 * a65 - a16 * a23 * a31 * a54 * a65 + a13 * a26 * a31 * 
            a54 * a65 + a16 * a21 * a33 * a54 * a65 - a11 * a26 * a33 * a54 * 
            a65 - a13 * a21 * a36 * a54 * a65 + a11 * a23 * a36 * a54 * a65 + 
            a14 * a23 * a31 * a56 * a65 - a13 * a24 * a31 * a56 * a65 - a14 * 
            a21 * a33 * a56 * a65 + a11 * a24 * a33 * a56 * a65 + a13 * a21 * 
            a34 * a56 * a65 - a11 * a23 * a34 * a56 * a65 + a15 * a24 * a33 * 
            a51 * a66 - a14 * a25 * a33 * a51 * a66 - a15 * a23 * a34 * a51 * 
            a66 + a13 * a25 * a34 * a51 * a66 + a14 * a23 * a35 * a51 * a66 - 
            a13 * a24 * a35 * a51 * a66 - a15 * a24 * a31 * a53 * a66 + a14 * 
            a25 * a31 * a53 * a66 + a15 * a21 * a34 * a53 * a66 - a11 * a25 * 
            a34 * a53 * a66 - a14 * a21 * a35 * a53 * a66 + a11 * a24 * a35 * 
            a53 * a66 + a15 * a23 * a31 * a54 * a66 - a13 * a25 * a31 * a54 * 
            a66 - a15 * a21 * a33 * a54 * a66 + a11 * a25 * a33 * a54 * a66 + 
            a13 * a21 * a35 * a54 * a66 - a11 * a23 * a35 * a54 * a66 - a14 * 
            a23 * a31 * a55 * a66 + a13 * a24 * a31 * a55 * a66 + a14 * a21 * 
            a33 * a55 * a66 - a11 * a24 * a33 * a55 * a66 - a13 * a21 * a34 * 
            a55 * a66 + a11 * a23 * a34 * a55 * a66;
    cofactor[10] = -a16 * a25 * a34 * a43 * a61 + a15 * a26 * a34 * a43 * a61 
            + a16 * a24 * a35 * a43 * a61 - a14 * a26 * a35 * a43 * a61 - a15 
            * a24 * a36 * a43 * a61 + a14 * a25 * a36 * a43 * a61 + a16 * a25 
            * a33 * a44 * a61 - a15 * a26 * a33 * a44 * a61 - a16 * a23 * a35 
            * a44 * a61 + a13 * a26 * a35 * a44 * a61 + a15 * a23 * a36 * a44 
            * a61 - a13 * a25 * a36 * a44 * a61 - a16 * a24 * a33 * a45 * a61 
            + a14 * a26 * a33 * a45 * a61 + a16 * a23 * a34 * a45 * a61 - a13 
            * a26 * a34 * a45 * a61 - a14 * a23 * a36 * a45 * a61 + a13 * a24 
            * a36 * a45 * a61 + a15 * a24 * a33 * a46 * a61 - a14 * a25 * a33 
            * a46 * a61 - a15 * a23 * a34 * a46 * a61 + a13 * a25 * a34 * a46 
            * a61 + a14 * a23 * a35 * a46 * a61 - a13 * a24 * a35 * a46 * a61 
            + a16 * a25 * a34 * a41 * a63 - a15 * a26 * a34 * a41 * a63 - a16 
            * a24 * a35 * a41 * a63 + a14 * a26 * a35 * a41 * a63 + a15 * a24 
            * a36 * a41 * a63 - a14 * a25 * a36 * a41 * a63 - a16 * a25 * a31 
            * a44 * a63 + a15 * a26 * a31 * a44 * a63 + a16 * a21 * a35 * a44 
            * a63 - a11 * a26 * a35 * a44 * a63 - a15 * a21 * a36 * a44 * a63 
            + a11 * a25 * a36 * a44 * a63 + a16 * a24 * a31 * a45 * a63 - a14 
            * a26 * a31 * a45 * a63 - a16 * a21 * a34 * a45 * a63 + a11 * a26 
            * a34 * a45 * a63 + a14 * a21 * a36 * a45 * a63 - a11 * a24 * a36 
            * a45 * a63 - a15 * a24 * a31 * a46 * a63 + a14 * a25 * a31 * a46 
            * a63 + a15 * a21 * a34 * a46 * a63 - a11 * a25 * a34 * a46 * a63 
            - a14 * a21 * a35 * a46 * a63 + a11 * a24 * a35 * a46 * a63 - a16 
            * a25 * a33 * a41 * a64 + a15 * a26 * a33 * a41 * a64 + a16 * a23 
            * a35 * a41 * a64 - a13 * a26 * a35 * a41 * a64 - a15 * a23 * a36 
            * a41 * a64 + a13 * a25 * a36 * a41 * a64 + a16 * a25 * a31 * a43 
            * a64 - a15 * a26 * a31 * a43 * a64 - a16 * a21 * a35 * a43 * a64 
            + a11 * a26 * a35 * a43 * a64 + a15 * a21 * a36 * a43 * a64 - a11 
            * a25 * a36 * a43 * a64 - a16 * a23 * a31 * a45 * a64 + a13 * a26 
            * a31 * a45 * a64 + a16 * a21 * a33 * a45 * a64 - a11 * a26 * a33 
            * a45 * a64 - a13 * a21 * a36 * a45 * a64 + a11 * a23 * a36 * a45 
            * a64 + a15 * a23 * a31 * a46 * a64 - a13 * a25 * a31 * a46 * a64 
            - a15 * a21 * a33 * a46 * a64 + a11 * a25 * a33 * a46 * a64 + a13 
            * a21 * a35 * a46 * a64 - a11 * a23 * a35 * a46 * a64 + a16 * a24 
            * a33 * a41 * a65 - a14 * a26 * a33 * a41 * a65 - a16 * a23 * a34 
            * a41 * a65 + a13 * a26 * a34 * a41 * a65 + a14 * a23 * a36 * a41 
            * a65 - a13 * a24 * a36 * a41 * a65 - a16 * a24 * a31 * a43 * a65 
            + a14 * a26 * a31 * a43 * a65 + a16 * a21 * a34 * a43 * a65 - a11 
            * a26 * a34 * a43 * a65 - a14 * a21 * a36 * a43 * a65 + a11 * a24 
            * a36 * a43 * a65 + a16 * a23 * a31 * a44 * a65 - a13 * a26 * a31 
            * a44 * a65 - a16 * a21 * a33 * a44 * a65 + a11 * a26 * a33 * a44 
            * a65 + a13 * a21 * a36 * a44 * a65 - a11 * a23 * a36 * a44 * a65 
            - a14 * a23 * a31 * a46 * a65 + a13 * a24 * a31 * a46 * a65 + a14 
            * a21 * a33 * a46 * a65 - a11 * a24 * a33 * a46 * a65 - a13 * a21 
            * a34 * a46 * a65 + a11 * a23 * a34 * a46 * a65 - a15 * a24 * a33 
            * a41 * a66 + a14 * a25 * a33 * a41 * a66 + a15 * a23 * a34 * a41 
            * a66 - a13 * a25 * a34 * a41 * a66 - a14 * a23 * a35 * a41 * a66 
            + a13 * a24 * a35 * a41 * a66 + a15 * a24 * a31 * a43 * a66 - a14 
            * a25 * a31 * a43 * a66 - a15 * a21 * a34 * a43 * a66 + a11 * a25 
            * a34 * a43 * a66 + a14 * a21 * a35 * a43 * a66 - a11 * a24 * a35 
            * a43 * a66 - a15 * a23 * a31 * a44 * a66 + a13 * a25 * a31 * a44 
            * a66 + a15 * a21 * a33 * a44 * a66 - a11 * a25 * a33 * a44 * a66 
            - a13 * a21 * a35 * a44 * a66 + a11 * a23 * a35 * a44 * a66 + a14 
            * a23 * a31 * a45 * a66 - a13 * a24 * a31 * a45 * a66 - a14 * a21 
            * a33 * a45 * a66 + a11 * a24 * a33 * a45 * a66 + a13 * a21 * a34 
            * a45 * a66 - a11 * a23 * a34 * a45 * a66;
    cofactor[11] = a16 * a25 * a34 * a43 * a51 - a15 * a26 * a34 * a43 * a51 
            - a16 * a24 * a35 * a43 * a51 + a14 * a26 * a35 * a43 * a51 + a15 
            * a24 * a36 * a43 * a51 - a14 * a25 * a36 * a43 * a51 - a16 * a25 
            * a33 * a44 * a51 + a15 * a26 * a33 * a44 * a51 + a16 * a23 * a35 
            * a44 * a51 - a13 * a26 * a35 * a44 * a51 - a15 * a23 * a36 * a44 
            * a51 + a13 * a25 * a36 * a44 * a51 + a16 * a24 * a33 * a45 * a51 
            - a14 * a26 * a33 * a45 * a51 - a16 * a23 * a34 * a45 * a51 + a13 
            * a26 * a34 * a45 * a51 + a14 * a23 * a36 * a45 * a51 - a13 * a24 
            * a36 * a45 * a51 - a15 * a24 * a33 * a46 * a51 + a14 * a25 * a33 
            * a46 * a51 + a15 * a23 * a34 * a46 * a51 - a13 * a25 * a34 * a46 
            * a51 - a14 * a23 * a35 * a46 * a51 + a13 * a24 * a35 * a46 * a51 
            - a16 * a25 * a34 * a41 * a53 + a15 * a26 * a34 * a41 * a53 + a16 
            * a24 * a35 * a41 * a53 - a14 * a26 * a35 * a41 * a53 - a15 * a24 
            * a36 * a41 * a53 + a14 * a25 * a36 * a41 * a53 + a16 * a25 * a31 
            * a44 * a53 - a15 * a26 * a31 * a44 * a53 - a16 * a21 * a35 * a44 
            * a53 + a11 * a26 * a35 * a44 * a53 + a15 * a21 * a36 * a44 * a53 
            - a11 * a25 * a36 * a44 * a53 - a16 * a24 * a31 * a45 * a53 + a14 
            * a26 * a31 * a45 * a53 + a16 * a21 * a34 * a45 * a53 - a11 * a26 
            * a34 * a45 * a53 - a14 * a21 * a36 * a45 * a53 + a11 * a24 * a36 
            * a45 * a53 + a15 * a24 * a31 * a46 * a53 - a14 * a25 * a31 * a46 
            * a53 - a15 * a21 * a34 * a46 * a53 + a11 * a25 * a34 * a46 * a53 
            + a14 * a21 * a35 * a46 * a53 - a11 * a24 * a35 * a46 * a53 + a16 
            * a25 * a33 * a41 * a54 - a15 * a26 * a33 * a41 * a54 - a16 * a23 
            * a35 * a41 * a54 + a13 * a26 * a35 * a41 * a54 + a15 * a23 * a36 
            * a41 * a54 - a13 * a25 * a36 * a41 * a54 - a16 * a25 * a31 * a43 
            * a54 + a15 * a26 * a31 * a43 * a54 + a16 * a21 * a35 * a43 * a54 
            - a11 * a26 * a35 * a43 * a54 - a15 * a21 * a36 * a43 * a54 + a11 
            * a25 * a36 * a43 * a54 + a16 * a23 * a31 * a45 * a54 - a13 * a26 
            * a31 * a45 * a54 - a16 * a21 * a33 * a45 * a54 + a11 * a26 * a33 
            * a45 * a54 + a13 * a21 * a36 * a45 * a54 - a11 * a23 * a36 * a45 
            * a54 - a15 * a23 * a31 * a46 * a54 + a13 * a25 * a31 * a46 * a54 
            + a15 * a21 * a33 * a46 * a54 - a11 * a25 * a33 * a46 * a54 - a13 
            * a21 * a35 * a46 * a54 + a11 * a23 * a35 * a46 * a54 - a16 * a24 
            * a33 * a41 * a55 + a14 * a26 * a33 * a41 * a55 + a16 * a23 * a34 
            * a41 * a55 - a13 * a26 * a34 * a41 * a55 - a14 * a23 * a36 * a41 
            * a55 + a13 * a24 * a36 * a41 * a55 + a16 * a24 * a31 * a43 * a55 
            - a14 * a26 * a31 * a43 * a55 - a16 * a21 * a34 * a43 * a55 + a11 
            * a26 * a34 * a43 * a55 + a14 * a21 * a36 * a43 * a55 - a11 * a24 
            * a36 * a43 * a55 - a16 * a23 * a31 * a44 * a55 + a13 * a26 * a31 
            * a44 * a55 + a16 * a21 * a33 * a44 * a55 - a11 * a26 * a33 * a44 
            * a55 - a13 * a21 * a36 * a44 * a55 + a11 * a23 * a36 * a44 * a55 
            + a14 * a23 * a31 * a46 * a55 - a13 * a24 * a31 * a46 * a55 - a14 
            * a21 * a33 * a46 * a55 + a11 * a24 * a33 * a46 * a55 + a13 * a21 
            * a34 * a46 * a55 - a11 * a23 * a34 * a46 * a55 + a15 * a24 * a33 
            * a41 * a56 - a14 * a25 * a33 * a41 * a56 - a15 * a23 * a34 * a41 
            * a56 + a13 * a25 * a34 * a41 * a56 + a14 * a23 * a35 * a41 * a56 
            - a13 * a24 * a35 * a41 * a56 - a15 * a24 * a31 * a43 * a56 + a14 
            * a25 * a31 * a43 * a56 + a15 * a21 * a34 * a43 * a56 - a11 * a25 
            * a34 * a43 * a56 - a14 * a21 * a35 * a43 * a56 + a11 * a24 * a35 
            * a43 * a56 + a15 * a23 * a31 * a44 * a56 - a13 * a25 * a31 * a44 
            * a56 - a15 * a21 * a33 * a44 * a56 + a11 * a25 * a33 * a44 * a56 
            + a13 * a21 * a35 * a44 * a56 - a11 * a23 * a35 * a44 * a56 - a14 
            * a23 * a31 * a45 * a56 + a13 * a24 * a31 * a45 * a56 + a14 * a21 
            * a33 * a45 * a56 - a11 * a24 * a33 * a45 * a56 - a13 * a21 * a34 
            * a45 * a56 + a11 * a23 * a34 * a45 * a56;
    cofactor[12] = a26 * a35 * a44 * a52 * a61 - a25 * a36 * a44 * a52 * a61 
            - a26 * a34 * a45 * a52 * a61 + a24 * a36 * a45 * a52 * a61 + a25 
            * a34 * a46 * a52 * a61 - a24 * a35 * a46 * a52 * a61 - a26 * a35 
            * a42 * a54 * a61 + a25 * a36 * a42 * a54 * a61 + a26 * a32 * a45 
            * a54 * a61 - a22 * a36 * a45 * a54 * a61 - a25 * a32 * a46 * a54 
            * a61 + a22 * a35 * a46 * a54 * a61 + a26 * a34 * a42 * a55 * a61 
            - a24 * a36 * a42 * a55 * a61 - a26 * a32 * a44 * a55 * a61 + a22 
            * a36 * a44 * a55 * a61 + a24 * a32 * a46 * a55 * a61 - a22 * a34 
            * a46 * a55 * a61 - a25 * a34 * a42 * a56 * a61 + a24 * a35 * a42 
            * a56 * a61 + a25 * a32 * a44 * a56 * a61 - a22 * a35 * a44 * a56 
            * a61 - a24 * a32 * a45 * a56 * a61 + a22 * a34 * a45 * a56 * a61 
            - a26 * a35 * a44 * a51 * a62 + a25 * a36 * a44 * a51 * a62 + a26 
            * a34 * a45 * a51 * a62 - a24 * a36 * a45 * a51 * a62 - a25 * a34 
            * a46 * a51 * a62 + a24 * a35 * a46 * a51 * a62 + a26 * a35 * a41 
            * a54 * a62 - a25 * a36 * a41 * a54 * a62 - a26 * a31 * a45 * a54 
            * a62 + a21 * a36 * a45 * a54 * a62 + a25 * a31 * a46 * a54 * a62 
            - a21 * a35 * a46 * a54 * a62 - a26 * a34 * a41 * a55 * a62 + a24 
            * a36 * a41 * a55 * a62 + a26 * a31 * a44 * a55 * a62 - a21 * a36 
            * a44 * a55 * a62 - a24 * a31 * a46 * a55 * a62 + a21 * a34 * a46 
            * a55 * a62 + a25 * a34 * a41 * a56 * a62 - a24 * a35 * a41 * a56 
            * a62 - a25 * a31 * a44 * a56 * a62 + a21 * a35 * a44 * a56 * a62 
            + a24 * a31 * a45 * a56 * a62 - a21 * a34 * a45 * a56 * a62 + a26 
            * a35 * a42 * a51 * a64 - a25 * a36 * a42 * a51 * a64 - a26 * a32 
            * a45 * a51 * a64 + a22 * a36 * a45 * a51 * a64 + a25 * a32 * a46 
            * a51 * a64 - a22 * a35 * a46 * a51 * a64 - a26 * a35 * a41 * a52 
            * a64 + a25 * a36 * a41 * a52 * a64 + a26 * a31 * a45 * a52 * a64 
            - a21 * a36 * a45 * a52 * a64 - a25 * a31 * a46 * a52 * a64 + a21 
            * a35 * a46 * a52 * a64 + a26 * a32 * a41 * a55 * a64 - a22 * a36 
            * a41 * a55 * a64 - a26 * a31 * a42 * a55 * a64 + a21 * a36 * a42 
            * a55 * a64 + a22 * a31 * a46 * a55 * a64 - a21 * a32 * a46 * a55 
            * a64 - a25 * a32 * a41 * a56 * a64 + a22 * a35 * a41 * a56 * a64 
            + a25 * a31 * a42 * a56 * a64 - a21 * a35 * a42 * a56 * a64 - a22 
            * a31 * a45 * a56 * a64 + a21 * a32 * a45 * a56 * a64 - a26 * a34 
            * a42 * a51 * a65 + a24 * a36 * a42 * a51 * a65 + a26 * a32 * a44 
            * a51 * a65 - a22 * a36 * a44 * a51 * a65 - a24 * a32 * a46 * a51 
            * a65 + a22 * a34 * a46 * a51 * a65 + a26 * a34 * a41 * a52 * a65 
            - a24 * a36 * a41 * a52 * a65 - a26 * a31 * a44 * a52 * a65 + a21 
            * a36 * a44 * a52 * a65 + a24 * a31 * a46 * a52 * a65 - a21 * a34 
            * a46 * a52 * a65 - a26 * a32 * a41 * a54 * a65 + a22 * a36 * a41 
            * a54 * a65 + a26 * a31 * a42 * a54 * a65 - a21 * a36 * a42 * a54 
            * a65 - a22 * a31 * a46 * a54 * a65 + a21 * a32 * a46 * a54 * a65 
            + a24 * a32 * a41 * a56 * a65 - a22 * a34 * a41 * a56 * a65 - a24 
            * a31 * a42 * a56 * a65 + a21 * a34 * a42 * a56 * a65 + a22 * a31 
            * a44 * a56 * a65 - a21 * a32 * a44 * a56 * a65 + a25 * a34 * a42 
            * a51 * a66 - a24 * a35 * a42 * a51 * a66 - a25 * a32 * a44 * a51 
            * a66 + a22 * a35 * a44 * a51 * a66 + a24 * a32 * a45 * a51 * a66 
            - a22 * a34 * a45 * a51 * a66 - a25 * a34 * a41 * a52 * a66 + a24 
            * a35 * a41 * a52 * a66 + a25 * a31 * a44 * a52 * a66 - a21 * a35 
            * a44 * a52 * a66 - a24 * a31 * a45 * a52 * a66 + a21 * a34 * a45 
            * a52 * a66 + a25 * a32 * a41 * a54 * a66 - a22 * a35 * a41 * a54 
            * a66 - a25 * a31 * a42 * a54 * a66 + a21 * a35 * a42 * a54 * a66 
            + a22 * a31 * a45 * a54 * a66 - a21 * a32 * a45 * a54 * a66 - a24 
            * a32 * a41 * a55 * a66 + a22 * a34 * a41 * a55 * a66 + a24 * a31 
            * a42 * a55 * a66 - a21 * a34 * a42 * a55 * a66 - a22 * a31 * a44 
            * a55 * a66 + a21 * a32 * a44 * a55 * a66;
    cofactor[13] = -a16 * a35 * a44 * a52 * a61 + a15 * a36 * a44 * a52 * a61 
            + a16 * a34 * a45 * a52 * a61 - a14 * a36 * a45 * a52 * a61 - a15 
            * a34 * a46 * a52 * a61 + a14 * a35 * a46 * a52 * a61 + a16 * a35 
            * a42 * a54 * a61 - a15 * a36 * a42 * a54 * a61 - a16 * a32 * a45 
            * a54 * a61 + a12 * a36 * a45 * a54 * a61 + a15 * a32 * a46 * a54 
            * a61 - a12 * a35 * a46 * a54 * a61 - a16 * a34 * a42 * a55 * a61 
            + a14 * a36 * a42 * a55 * a61 + a16 * a32 * a44 * a55 * a61 - a12 
            * a36 * a44 * a55 * a61 - a14 * a32 * a46 * a55 * a61 + a12 * a34 
            * a46 * a55 * a61 + a15 * a34 * a42 * a56 * a61 - a14 * a35 * a42 
            * a56 * a61 - a15 * a32 * a44 * a56 * a61 + a12 * a35 * a44 * a56 
            * a61 + a14 * a32 * a45 * a56 * a61 - a12 * a34 * a45 * a56 * a61 
            + a16 * a35 * a44 * a51 * a62 - a15 * a36 * a44 * a51 * a62 - a16 
            * a34 * a45 * a51 * a62 + a14 * a36 * a45 * a51 * a62 + a15 * a34 
            * a46 * a51 * a62 - a14 * a35 * a46 * a51 * a62 - a16 * a35 * a41 
            * a54 * a62 + a15 * a36 * a41 * a54 * a62 + a16 * a31 * a45 * a54 
            * a62 - a11 * a36 * a45 * a54 * a62 - a15 * a31 * a46 * a54 * a62 
            + a11 * a35 * a46 * a54 * a62 + a16 * a34 * a41 * a55 * a62 - a14 
            * a36 * a41 * a55 * a62 - a16 * a31 * a44 * a55 * a62 + a11 * a36 
            * a44 * a55 * a62 + a14 * a31 * a46 * a55 * a62 - a11 * a34 * a46 
            * a55 * a62 - a15 * a34 * a41 * a56 * a62 + a14 * a35 * a41 * a56 
            * a62 + a15 * a31 * a44 * a56 * a62 - a11 * a35 * a44 * a56 * a62 
            - a14 * a31 * a45 * a56 * a62 + a11 * a34 * a45 * a56 * a62 - a16 
            * a35 * a42 * a51 * a64 + a15 * a36 * a42 * a51 * a64 + a16 * a32 
            * a45 * a51 * a64 - a12 * a36 * a45 * a51 * a64 - a15 * a32 * a46 
            * a51 * a64 + a12 * a35 * a46 * a51 * a64 + a16 * a35 * a41 * a52 
            * a64 - a15 * a36 * a41 * a52 * a64 - a16 * a31 * a45 * a52 * a64 
            + a11 * a36 * a45 * a52 * a64 + a15 * a31 * a46 * a52 * a64 - a11 
            * a35 * a46 * a52 * a64 - a16 * a32 * a41 * a55 * a64 + a12 * a36 
            * a41 * a55 * a64 + a16 * a31 * a42 * a55 * a64 - a11 * a36 * a42 
            * a55 * a64 - a12 * a31 * a46 * a55 * a64 + a11 * a32 * a46 * a55 
            * a64 + a15 * a32 * a41 * a56 * a64 - a12 * a35 * a41 * a56 * a64 
            - a15 * a31 * a42 * a56 * a64 + a11 * a35 * a42 * a56 * a64 + a12 
            * a31 * a45 * a56 * a64 - a11 * a32 * a45 * a56 * a64 + a16 * a34 
            * a42 * a51 * a65 - a14 * a36 * a42 * a51 * a65 - a16 * a32 * a44 
            * a51 * a65 + a12 * a36 * a44 * a51 * a65 + a14 * a32 * a46 * a51 
            * a65 - a12 * a34 * a46 * a51 * a65 - a16 * a34 * a41 * a52 * a65 
            + a14 * a36 * a41 * a52 * a65 + a16 * a31 * a44 * a52 * a65 - a11 
            * a36 * a44 * a52 * a65 - a14 * a31 * a46 * a52 * a65 + a11 * a34 
            * a46 * a52 * a65 + a16 * a32 * a41 * a54 * a65 - a12 * a36 * a41 
            * a54 * a65 - a16 * a31 * a42 * a54 * a65 + a11 * a36 * a42 * a54 
            * a65 + a12 * a31 * a46 * a54 * a65 - a11 * a32 * a46 * a54 * a65 
            - a14 * a32 * a41 * a56 * a65 + a12 * a34 * a41 * a56 * a65 + a14 
            * a31 * a42 * a56 * a65 - a11 * a34 * a42 * a56 * a65 - a12 * a31 
            * a44 * a56 * a65 + a11 * a32 * a44 * a56 * a65 - a15 * a34 * a42 
            * a51 * a66 + a14 * a35 * a42 * a51 * a66 + a15 * a32 * a44 * a51 
            * a66 - a12 * a35 * a44 * a51 * a66 - a14 * a32 * a45 * a51 * a66 
            + a12 * a34 * a45 * a51 * a66 + a15 * a34 * a41 * a52 * a66 - a14 
            * a35 * a41 * a52 * a66 - a15 * a31 * a44 * a52 * a66 + a11 * a35 
            * a44 * a52 * a66 + a14 * a31 * a45 * a52 * a66 - a11 * a34 * a45 
            * a52 * a66 - a15 * a32 * a41 * a54 * a66 + a12 * a35 * a41 * a54 
            * a66 + a15 * a31 * a42 * a54 * a66 - a11 * a35 * a42 * a54 * a66 
            - a12 * a31 * a45 * a54 * a66 + a11 * a32 * a45 * a54 * a66 + a14 
            * a32 * a41 * a55 * a66 - a12 * a34 * a41 * a55 * a66 - a14 * a31 
            * a42 * a55 * a66 + a11 * a34 * a42 * a55 * a66 + a12 * a31 * a44 
            * a55 * a66 - a11 * a32 * a44 * a55 * a66;
    cofactor[14] = a16 * a25 * a44 * a52 * a61 - a15 * a26 * a44 * a52 * a61 
            - a16 * a24 * a45 * a52 * a61 + a14 * a26 * a45 * a52 * a61 + a15 
            * a24 * a46 * a52 * a61 - a14 * a25 * a46 * a52 * a61 - a16 * a25 
            * a42 * a54 * a61 + a15 * a26 * a42 * a54 * a61 + a16 * a22 * a45 
            * a54 * a61 - a12 * a26 * a45 * a54 * a61 - a15 * a22 * a46 * a54 
            * a61 + a12 * a25 * a46 * a54 * a61 + a16 * a24 * a42 * a55 * a61 
            - a14 * a26 * a42 * a55 * a61 - a16 * a22 * a44 * a55 * a61 + a12 
            * a26 * a44 * a55 * a61 + a14 * a22 * a46 * a55 * a61 - a12 * a24 
            * a46 * a55 * a61 - a15 * a24 * a42 * a56 * a61 + a14 * a25 * a42 
            * a56 * a61 + a15 * a22 * a44 * a56 * a61 - a12 * a25 * a44 * a56 
            * a61 - a14 * a22 * a45 * a56 * a61 + a12 * a24 * a45 * a56 * a61 
            - a16 * a25 * a44 * a51 * a62 + a15 * a26 * a44 * a51 * a62 + a16 
            * a24 * a45 * a51 * a62 - a14 * a26 * a45 * a51 * a62 - a15 * a24 
            * a46 * a51 * a62 + a14 * a25 * a46 * a51 * a62 + a16 * a25 * a41 
            * a54 * a62 - a15 * a26 * a41 * a54 * a62 - a16 * a21 * a45 * a54 
            * a62 + a11 * a26 * a45 * a54 * a62 + a15 * a21 * a46 * a54 * a62 
            - a11 * a25 * a46 * a54 * a62 - a16 * a24 * a41 * a55 * a62 + a14 
            * a26 * a41 * a55 * a62 + a16 * a21 * a44 * a55 * a62 - a11 * a26 
            * a44 * a55 * a62 - a14 * a21 * a46 * a55 * a62 + a11 * a24 * a46 
            * a55 * a62 + a15 * a24 * a41 * a56 * a62 - a14 * a25 * a41 * a56 
            * a62 - a15 * a21 * a44 * a56 * a62 + a11 * a25 * a44 * a56 * a62 
            + a14 * a21 * a45 * a56 * a62 - a11 * a24 * a45 * a56 * a62 + a16 
            * a25 * a42 * a51 * a64 - a15 * a26 * a42 * a51 * a64 - a16 * a22 
            * a45 * a51 * a64 + a12 * a26 * a45 * a51 * a64 + a15 * a22 * a46 
            * a51 * a64 - a12 * a25 * a46 * a51 * a64 - a16 * a25 * a41 * a52 
            * a64 + a15 * a26 * a41 * a52 * a64 + a16 * a21 * a45 * a52 * a64 
            - a11 * a26 * a45 * a52 * a64 - a15 * a21 * a46 * a52 * a64 + a11 
            * a25 * a46 * a52 * a64 + a16 * a22 * a41 * a55 * a64 - a12 * a26 
            * a41 * a55 * a64 - a16 * a21 * a42 * a55 * a64 + a11 * a26 * a42 
            * a55 * a64 + a12 * a21 * a46 * a55 * a64 - a11 * a22 * a46 * a55 
            * a64 - a15 * a22 * a41 * a56 * a64 + a12 * a25 * a41 * a56 * a64 
            + a15 * a21 * a42 * a56 * a64 - a11 * a25 * a42 * a56 * a64 - a12 
            * a21 * a45 * a56 * a64 + a11 * a22 * a45 * a56 * a64 - a16 * a24 
            * a42 * a51 * a65 + a14 * a26 * a42 * a51 * a65 + a16 * a22 * a44 
            * a51 * a65 - a12 * a26 * a44 * a51 * a65 - a14 * a22 * a46 * a51 
            * a65 + a12 * a24 * a46 * a51 * a65 + a16 * a24 * a41 * a52 * a65 
            - a14 * a26 * a41 * a52 * a65 - a16 * a21 * a44 * a52 * a65 + a11 
            * a26 * a44 * a52 * a65 + a14 * a21 * a46 * a52 * a65 - a11 * a24 
            * a46 * a52 * a65 - a16 * a22 * a41 * a54 * a65 + a12 * a26 * a41 
            * a54 * a65 + a16 * a21 * a42 * a54 * a65 - a11 * a26 * a42 * a54 
            * a65 - a12 * a21 * a46 * a54 * a65 + a11 * a22 * a46 * a54 * a65 
            + a14 * a22 * a41 * a56 * a65 - a12 * a24 * a41 * a56 * a65 - a14 
            * a21 * a42 * a56 * a65 + a11 * a24 * a42 * a56 * a65 + a12 * a21 
            * a44 * a56 * a65 - a11 * a22 * a44 * a56 * a65 + a15 * a24 * a42 
            * a51 * a66 - a14 * a25 * a42 * a51 * a66 - a15 * a22 * a44 * a51 
            * a66 + a12 * a25 * a44 * a51 * a66 + a14 * a22 * a45 * a51 * a66 
            - a12 * a24 * a45 * a51 * a66 - a15 * a24 * a41 * a52 * a66 + a14 
            * a25 * a41 * a52 * a66 + a15 * a21 * a44 * a52 * a66 - a11 * a25 
            * a44 * a52 * a66 - a14 * a21 * a45 * a52 * a66 + a11 * a24 * a45 
            * a52 * a66 + a15 * a22 * a41 * a54 * a66 - a12 * a25 * a41 * a54 
            * a66 - a15 * a21 * a42 * a54 * a66 + a11 * a25 * a42 * a54 * a66 
            + a12 * a21 * a45 * a54 * a66 - a11 * a22 * a45 * a54 * a66 - a14 
            * a22 * a41 * a55 * a66 + a12 * a24 * a41 * a55 * a66 + a14 * a21 
            * a42 * a55 * a66 - a11 * a24 * a42 * a55 * a66 - a12 * a21 * a44 
            * a55 * a66 + a11 * a22 * a44 * a55 * a66;
    cofactor[15] = -a16 * a25 * a34 * a52 * a61 + a15 * a26 * a34 * a52 * a61 
            + a16 * a24 * a35 * a52 * a61 - a14 * a26 * a35 * a52 * a61 - a15 
            * a24 * a36 * a52 * a61 + a14 * a25 * a36 * a52 * a61 + a16 * a25 
            * a32 * a54 * a61 - a15 * a26 * a32 * a54 * a61 - a16 * a22 * a35 
            * a54 * a61 + a12 * a26 * a35 * a54 * a61 + a15 * a22 * a36 * a54 
            * a61 - a12 * a25 * a36 * a54 * a61 - a16 * a24 * a32 * a55 * a61 
            + a14 * a26 * a32 * a55 * a61 + a16 * a22 * a34 * a55 * a61 - a12 
            * a26 * a34 * a55 * a61 - a14 * a22 * a36 * a55 * a61 + a12 * a24 
            * a36 * a55 * a61 + a15 * a24 * a32 * a56 * a61 - a14 * a25 * a32 
            * a56 * a61 - a15 * a22 * a34 * a56 * a61 + a12 * a25 * a34 * a56 
            * a61 + a14 * a22 * a35 * a56 * a61 - a12 * a24 * a35 * a56 * a61 
            + a16 * a25 * a34 * a51 * a62 - a15 * a26 * a34 * a51 * a62 - a16 
            * a24 * a35 * a51 * a62 + a14 * a26 * a35 * a51 * a62 + a15 * a24 
            * a36 * a51 * a62 - a14 * a25 * a36 * a51 * a62 - a16 * a25 * a31 
            * a54 * a62 + a15 * a26 * a31 * a54 * a62 + a16 * a21 * a35 * a54 
            * a62 - a11 * a26 * a35 * a54 * a62 - a15 * a21 * a36 * a54 * a62 
            + a11 * a25 * a36 * a54 * a62 + a16 * a24 * a31 * a55 * a62 - a14 
            * a26 * a31 * a55 * a62 - a16 * a21 * a34 * a55 * a62 + a11 * a26 
            * a34 * a55 * a62 + a14 * a21 * a36 * a55 * a62 - a11 * a24 * a36 
            * a55 * a62 - a15 * a24 * a31 * a56 * a62 + a14 * a25 * a31 * a56 
            * a62 + a15 * a21 * a34 * a56 * a62 - a11 * a25 * a34 * a56 * a62 
            - a14 * a21 * a35 * a56 * a62 + a11 * a24 * a35 * a56 * a62 - a16 
            * a25 * a32 * a51 * a64 + a15 * a26 * a32 * a51 * a64 + a16 * a22 
            * a35 * a51 * a64 - a12 * a26 * a35 * a51 * a64 - a15 * a22 * a36 
            * a51 * a64 + a12 * a25 * a36 * a51 * a64 + a16 * a25 * a31 * a52 
            * a64 - a15 * a26 * a31 * a52 * a64 - a16 * a21 * a35 * a52 * a64 
            + a11 * a26 * a35 * a52 * a64 + a15 * a21 * a36 * a52 * a64 - a11 
            * a25 * a36 * a52 * a64 - a16 * a22 * a31 * a55 * a64 + a12 * a26 
            * a31 * a55 * a64 + a16 * a21 * a32 * a55 * a64 - a11 * a26 * a32 
            * a55 * a64 - a12 * a21 * a36 * a55 * a64 + a11 * a22 * a36 * a55 
            * a64 + a15 * a22 * a31 * a56 * a64 - a12 * a25 * a31 * a56 * a64 
            - a15 * a21 * a32 * a56 * a64 + a11 * a25 * a32 * a56 * a64 + a12 
            * a21 * a35 * a56 * a64 - a11 * a22 * a35 * a56 * a64 + a16 * a24 
            * a32 * a51 * a65 - a14 * a26 * a32 * a51 * a65 - a16 * a22 * a34 
            * a51 * a65 + a12 * a26 * a34 * a51 * a65 + a14 * a22 * a36 * a51 
            * a65 - a12 * a24 * a36 * a51 * a65 - a16 * a24 * a31 * a52 * a65 
            + a14 * a26 * a31 * a52 * a65 + a16 * a21 * a34 * a52 * a65 - a11 
            * a26 * a34 * a52 * a65 - a14 * a21 * a36 * a52 * a65 + a11 * a24 
            * a36 * a52 * a65 + a16 * a22 * a31 * a54 * a65 - a12 * a26 * a31 
            * a54 * a65 - a16 * a21 * a32 * a54 * a65 + a11 * a26 * a32 * a54 
            * a65 + a12 * a21 * a36 * a54 * a65 - a11 * a22 * a36 * a54 * a65 
            - a14 * a22 * a31 * a56 * a65 + a12 * a24 * a31 * a56 * a65 + a14 
            * a21 * a32 * a56 * a65 - a11 * a24 * a32 * a56 * a65 - a12 * a21 
            * a34 * a56 * a65 + a11 * a22 * a34 * a56 * a65 - a15 * a24 * a32 
            * a51 * a66 + a14 * a25 * a32 * a51 * a66 + a15 * a22 * a34 * a51 
            * a66 - a12 * a25 * a34 * a51 * a66 - a14 * a22 * a35 * a51 * a66 
            + a12 * a24 * a35 * a51 * a66 + a15 * a24 * a31 * a52 * a66 - a14 
            * a25 * a31 * a52 * a66 - a15 * a21 * a34 * a52 * a66 + a11 * a25 
            * a34 * a52 * a66 + a14 * a21 * a35 * a52 * a66 - a11 * a24 * a35 
            * a52 * a66 - a15 * a22 * a31 * a54 * a66 + a12 * a25 * a31 * a54 
            * a66 + a15 * a21 * a32 * a54 * a66 - a11 * a25 * a32 * a54 * a66 
            - a12 * a21 * a35 * a54 * a66 + a11 * a22 * a35 * a54 * a66 + a14 
            * a22 * a31 * a55 * a66 - a12 * a24 * a31 * a55 * a66 - a14 * a21 
            * a32 * a55 * a66 + a11 * a24 * a32 * a55 * a66 + a12 * a21 * a34 
            * a55 * a66 - a11 * a22 * a34 * a55 * a66;
    cofactor[16] = a16 * a25 * a34 * a42 * a61 - a15 * a26 * a34 * a42 * a61 
            - a16 * a24 * a35 * a42 * a61 + a14 * a26 * a35 * a42 * a61 + a15 
            * a24 * a36 * a42 * a61 - a14 * a25 * a36 * a42 * a61 - a16 * a25 
            * a32 * a44 * a61 + a15 * a26 * a32 * a44 * a61 + a16 * a22 * a35 
            * a44 * a61 - a12 * a26 * a35 * a44 * a61 - a15 * a22 * a36 * a44 
            * a61 + a12 * a25 * a36 * a44 * a61 + a16 * a24 * a32 * a45 * a61 
            - a14 * a26 * a32 * a45 * a61 - a16 * a22 * a34 * a45 * a61 + a12 
            * a26 * a34 * a45 * a61 + a14 * a22 * a36 * a45 * a61 - a12 * a24 
            * a36 * a45 * a61 - a15 * a24 * a32 * a46 * a61 + a14 * a25 * a32 
            * a46 * a61 + a15 * a22 * a34 * a46 * a61 - a12 * a25 * a34 * a46 
            * a61 - a14 * a22 * a35 * a46 * a61 + a12 * a24 * a35 * a46 * a61 
            - a16 * a25 * a34 * a41 * a62 + a15 * a26 * a34 * a41 * a62 + a16 
            * a24 * a35 * a41 * a62 - a14 * a26 * a35 * a41 * a62 - a15 * a24 
            * a36 * a41 * a62 + a14 * a25 * a36 * a41 * a62 + a16 * a25 * a31 
            * a44 * a62 - a15 * a26 * a31 * a44 * a62 - a16 * a21 * a35 * a44 
            * a62 + a11 * a26 * a35 * a44 * a62 + a15 * a21 * a36 * a44 * a62 
            - a11 * a25 * a36 * a44 * a62 - a16 * a24 * a31 * a45 * a62 + a14 
            * a26 * a31 * a45 * a62 + a16 * a21 * a34 * a45 * a62 - a11 * a26 
            * a34 * a45 * a62 - a14 * a21 * a36 * a45 * a62 + a11 * a24 * a36 
            * a45 * a62 + a15 * a24 * a31 * a46 * a62 - a14 * a25 * a31 * a46 
            * a62 - a15 * a21 * a34 * a46 * a62 + a11 * a25 * a34 * a46 * a62 
            + a14 * a21 * a35 * a46 * a62 - a11 * a24 * a35 * a46 * a62 + a16 
            * a25 * a32 * a41 * a64 - a15 * a26 * a32 * a41 * a64 - a16 * a22 
            * a35 * a41 * a64 + a12 * a26 * a35 * a41 * a64 + a15 * a22 * a36 
            * a41 * a64 - a12 * a25 * a36 * a41 * a64 - a16 * a25 * a31 * a42 
            * a64 + a15 * a26 * a31 * a42 * a64 + a16 * a21 * a35 * a42 * a64 
            - a11 * a26 * a35 * a42 * a64 - a15 * a21 * a36 * a42 * a64 + a11 
            * a25 * a36 * a42 * a64 + a16 * a22 * a31 * a45 * a64 - a12 * a26 
            * a31 * a45 * a64 - a16 * a21 * a32 * a45 * a64 + a11 * a26 * a32 
            * a45 * a64 + a12 * a21 * a36 * a45 * a64 - a11 * a22 * a36 * a45 
            * a64 - a15 * a22 * a31 * a46 * a64 + a12 * a25 * a31 * a46 * a64 
            + a15 * a21 * a32 * a46 * a64 - a11 * a25 * a32 * a46 * a64 - a12 
            * a21 * a35 * a46 * a64 + a11 * a22 * a35 * a46 * a64 - a16 * a24 
            * a32 * a41 * a65 + a14 * a26 * a32 * a41 * a65 + a16 * a22 * a34 
            * a41 * a65 - a12 * a26 * a34 * a41 * a65 - a14 * a22 * a36 * a41 
            * a65 + a12 * a24 * a36 * a41 * a65 + a16 * a24 * a31 * a42 * a65 
            - a14 * a26 * a31 * a42 * a65 - a16 * a21 * a34 * a42 * a65 + a11 
            * a26 * a34 * a42 * a65 + a14 * a21 * a36 * a42 * a65 - a11 * a24 
            * a36 * a42 * a65 - a16 * a22 * a31 * a44 * a65 + a12 * a26 * a31 
            * a44 * a65 + a16 * a21 * a32 * a44 * a65 - a11 * a26 * a32 * a44 
            * a65 - a12 * a21 * a36 * a44 * a65 + a11 * a22 * a36 * a44 * a65 
            + a14 * a22 * a31 * a46 * a65 - a12 * a24 * a31 * a46 * a65 - a14 
            * a21 * a32 * a46 * a65 + a11 * a24 * a32 * a46 * a65 + a12 * a21 
            * a34 * a46 * a65 - a11 * a22 * a34 * a46 * a65 + a15 * a24 * a32 
            * a41 * a66 - a14 * a25 * a32 * a41 * a66 - a15 * a22 * a34 * a41 
            * a66 + a12 * a25 * a34 * a41 * a66 + a14 * a22 * a35 * a41 * a66 
            - a12 * a24 * a35 * a41 * a66 - a15 * a24 * a31 * a42 * a66 + a14 
            * a25 * a31 * a42 * a66 + a15 * a21 * a34 * a42 * a66 - a11 * a25 
            * a34 * a42 * a66 - a14 * a21 * a35 * a42 * a66 + a11 * a24 * a35 
            * a42 * a66 + a15 * a22 * a31 * a44 * a66 - a12 * a25 * a31 * a44 
            * a66 - a15 * a21 * a32 * a44 * a66 + a11 * a25 * a32 * a44 * a66 
            + a12 * a21 * a35 * a44 * a66 - a11 * a22 * a35 * a44 * a66 - a14 
            * a22 * a31 * a45 * a66 + a12 * a24 * a31 * a45 * a66 + a14 * a21 
            * a32 * a45 * a66 - a11 * a24 * a32 * a45 * a66 - a12 * a21 * a34 
            * a45 * a66 + a11 * a22 * a34 * a45 * a66;
    cofactor[17] = -a16 * a25 * a34 * a42 * a51 + a15 * a26 * a34 * a42 * a51 
            + a16 * a24 * a35 * a42 * a51 - a14 * a26 * a35 * a42 * a51 - a15 
            * a24 * a36 * a42 * a51 + a14 * a25 * a36 * a42 * a51 + a16 * a25 
            * a32 * a44 * a51 - a15 * a26 * a32 * a44 * a51 - a16 * a22 * a35 
            * a44 * a51 + a12 * a26 * a35 * a44 * a51 + a15 * a22 * a36 * a44 
            * a51 - a12 * a25 * a36 * a44 * a51 - a16 * a24 * a32 * a45 * a51 
            + a14 * a26 * a32 * a45 * a51 + a16 * a22 * a34 * a45 * a51 - a12 
            * a26 * a34 * a45 * a51 - a14 * a22 * a36 * a45 * a51 + a12 * a24 
            * a36 * a45 * a51 + a15 * a24 * a32 * a46 * a51 - a14 * a25 * a32 
            * a46 * a51 - a15 * a22 * a34 * a46 * a51 + a12 * a25 * a34 * a46 
            * a51 + a14 * a22 * a35 * a46 * a51 - a12 * a24 * a35 * a46 * a51 
            + a16 * a25 * a34 * a41 * a52 - a15 * a26 * a34 * a41 * a52 - a16 
            * a24 * a35 * a41 * a52 + a14 * a26 * a35 * a41 * a52 + a15 * a24 
            * a36 * a41 * a52 - a14 * a25 * a36 * a41 * a52 - a16 * a25 * a31 
            * a44 * a52 + a15 * a26 * a31 * a44 * a52 + a16 * a21 * a35 * a44 
            * a52 - a11 * a26 * a35 * a44 * a52 - a15 * a21 * a36 * a44 * a52 
            + a11 * a25 * a36 * a44 * a52 + a16 * a24 * a31 * a45 * a52 - a14 
            * a26 * a31 * a45 * a52 - a16 * a21 * a34 * a45 * a52 + a11 * a26 
            * a34 * a45 * a52 + a14 * a21 * a36 * a45 * a52 - a11 * a24 * a36 
            * a45 * a52 - a15 * a24 * a31 * a46 * a52 + a14 * a25 * a31 * a46 
            * a52 + a15 * a21 * a34 * a46 * a52 - a11 * a25 * a34 * a46 * a52 
            - a14 * a21 * a35 * a46 * a52 + a11 * a24 * a35 * a46 * a52 - a16 
            * a25 * a32 * a41 * a54 + a15 * a26 * a32 * a41 * a54 + a16 * a22 
            * a35 * a41 * a54 - a12 * a26 * a35 * a41 * a54 - a15 * a22 * a36 
            * a41 * a54 + a12 * a25 * a36 * a41 * a54 + a16 * a25 * a31 * a42 
            * a54 - a15 * a26 * a31 * a42 * a54 - a16 * a21 * a35 * a42 * a54 
            + a11 * a26 * a35 * a42 * a54 + a15 * a21 * a36 * a42 * a54 - a11 
            * a25 * a36 * a42 * a54 - a16 * a22 * a31 * a45 * a54 + a12 * a26 
            * a31 * a45 * a54 + a16 * a21 * a32 * a45 * a54 - a11 * a26 * a32 
            * a45 * a54 - a12 * a21 * a36 * a45 * a54 + a11 * a22 * a36 * a45 
            * a54 + a15 * a22 * a31 * a46 * a54 - a12 * a25 * a31 * a46 * a54 
            - a15 * a21 * a32 * a46 * a54 + a11 * a25 * a32 * a46 * a54 + a12 
            * a21 * a35 * a46 * a54 - a11 * a22 * a35 * a46 * a54 + a16 * a24 
            * a32 * a41 * a55 - a14 * a26 * a32 * a41 * a55 - a16 * a22 * a34 
            * a41 * a55 + a12 * a26 * a34 * a41 * a55 + a14 * a22 * a36 * a41 
            * a55 - a12 * a24 * a36 * a41 * a55 - a16 * a24 * a31 * a42 * a55 
            + a14 * a26 * a31 * a42 * a55 + a16 * a21 * a34 * a42 * a55 - a11 
            * a26 * a34 * a42 * a55 - a14 * a21 * a36 * a42 * a55 + a11 * a24 
            * a36 * a42 * a55 + a16 * a22 * a31 * a44 * a55 - a12 * a26 * a31 
            * a44 * a55 - a16 * a21 * a32 * a44 * a55 + a11 * a26 * a32 * a44 
            * a55 + a12 * a21 * a36 * a44 * a55 - a11 * a22 * a36 * a44 * a55 
            - a14 * a22 * a31 * a46 * a55 + a12 * a24 * a31 * a46 * a55 + a14 
            * a21 * a32 * a46 * a55 - a11 * a24 * a32 * a46 * a55 - a12 * a21 
            * a34 * a46 * a55 + a11 * a22 * a34 * a46 * a55 - a15 * a24 * a32 
            * a41 * a56 + a14 * a25 * a32 * a41 * a56 + a15 * a22 * a34 * a41 
            * a56 - a12 * a25 * a34 * a41 * a56 - a14 * a22 * a35 * a41 * a56 
            + a12 * a24 * a35 * a41 * a56 + a15 * a24 * a31 * a42 * a56 - a14 
            * a25 * a31 * a42 * a56 - a15 * a21 * a34 * a42 * a56 + a11 * a25 
            * a34 * a42 * a56 + a14 * a21 * a35 * a42 * a56 - a11 * a24 * a35 
            * a42 * a56 - a15 * a22 * a31 * a44 * a56 + a12 * a25 * a31 * a44 
            * a56 + a15 * a21 * a32 * a44 * a56 - a11 * a25 * a32 * a44 * a56 
            - a12 * a21 * a35 * a44 * a56 + a11 * a22 * a35 * a44 * a56 + a14 
            * a22 * a31 * a45 * a56 - a12 * a24 * a31 * a45 * a56 - a14 * a21 
            * a32 * a45 * a56 + a11 * a24 * a32 * a45 * a56 + a12 * a21 * a34 
            * a45 * a56 - a11 * a22 * a34 * a45 * a56;
    cofactor[18] = -a26 * a35 * a43 * a52 * a61 + a25 * a36 * a43 * a52 * a61 
            + a26 * a33 * a45 * a52 * a61 - a23 * a36 * a45 * a52 * a61 - a25 
            * a33 * a46 * a52 * a61 + a23 * a35 * a46 * a52 * a61 + a26 * a35 
            * a42 * a53 * a61 - a25 * a36 * a42 * a53 * a61 - a26 * a32 * a45 
            * a53 * a61 + a22 * a36 * a45 * a53 * a61 + a25 * a32 * a46 * a53 
            * a61 - a22 * a35 * a46 * a53 * a61 - a26 * a33 * a42 * a55 * a61 
            + a23 * a36 * a42 * a55 * a61 + a26 * a32 * a43 * a55 * a61 - a22 
            * a36 * a43 * a55 * a61 - a23 * a32 * a46 * a55 * a61 + a22 * a33 
            * a46 * a55 * a61 + a25 * a33 * a42 * a56 * a61 - a23 * a35 * a42 
            * a56 * a61 - a25 * a32 * a43 * a56 * a61 + a22 * a35 * a43 * a56 
            * a61 + a23 * a32 * a45 * a56 * a61 - a22 * a33 * a45 * a56 * a61 
            + a26 * a35 * a43 * a51 * a62 - a25 * a36 * a43 * a51 * a62 - a26 
            * a33 * a45 * a51 * a62 + a23 * a36 * a45 * a51 * a62 + a25 * a33 
            * a46 * a51 * a62 - a23 * a35 * a46 * a51 * a62 - a26 * a35 * a41 
            * a53 * a62 + a25 * a36 * a41 * a53 * a62 + a26 * a31 * a45 * a53 
            * a62 - a21 * a36 * a45 * a53 * a62 - a25 * a31 * a46 * a53 * a62 
            + a21 * a35 * a46 * a53 * a62 + a26 * a33 * a41 * a55 * a62 - a23 
            * a36 * a41 * a55 * a62 - a26 * a31 * a43 * a55 * a62 + a21 * a36 
            * a43 * a55 * a62 + a23 * a31 * a46 * a55 * a62 - a21 * a33 * a46 
            * a55 * a62 - a25 * a33 * a41 * a56 * a62 + a23 * a35 * a41 * a56 
            * a62 + a25 * a31 * a43 * a56 * a62 - a21 * a35 * a43 * a56 * a62 
            - a23 * a31 * a45 * a56 * a62 + a21 * a33 * a45 * a56 * a62 - a26 
            * a35 * a42 * a51 * a63 + a25 * a36 * a42 * a51 * a63 + a26 * a32 
            * a45 * a51 * a63 - a22 * a36 * a45 * a51 * a63 - a25 * a32 * a46 
            * a51 * a63 + a22 * a35 * a46 * a51 * a63 + a26 * a35 * a41 * a52 
            * a63 - a25 * a36 * a41 * a52 * a63 - a26 * a31 * a45 * a52 * a63 
            + a21 * a36 * a45 * a52 * a63 + a25 * a31 * a46 * a52 * a63 - a21 
            * a35 * a46 * a52 * a63 - a26 * a32 * a41 * a55 * a63 + a22 * a36 
            * a41 * a55 * a63 + a26 * a31 * a42 * a55 * a63 - a21 * a36 * a42 
            * a55 * a63 - a22 * a31 * a46 * a55 * a63 + a21 * a32 * a46 * a55 
            * a63 + a25 * a32 * a41 * a56 * a63 - a22 * a35 * a41 * a56 * a63 
            - a25 * a31 * a42 * a56 * a63 + a21 * a35 * a42 * a56 * a63 + a22 
            * a31 * a45 * a56 * a63 - a21 * a32 * a45 * a56 * a63 + a26 * a33 
            * a42 * a51 * a65 - a23 * a36 * a42 * a51 * a65 - a26 * a32 * a43 
            * a51 * a65 + a22 * a36 * a43 * a51 * a65 + a23 * a32 * a46 * a51 
            * a65 - a22 * a33 * a46 * a51 * a65 - a26 * a33 * a41 * a52 * a65 
            + a23 * a36 * a41 * a52 * a65 + a26 * a31 * a43 * a52 * a65 - a21 
            * a36 * a43 * a52 * a65 - a23 * a31 * a46 * a52 * a65 + a21 * a33 
            * a46 * a52 * a65 + a26 * a32 * a41 * a53 * a65 - a22 * a36 * a41 
            * a53 * a65 - a26 * a31 * a42 * a53 * a65 + a21 * a36 * a42 * a53 
            * a65 + a22 * a31 * a46 * a53 * a65 - a21 * a32 * a46 * a53 * a65 
            - a23 * a32 * a41 * a56 * a65 + a22 * a33 * a41 * a56 * a65 + a23 
            * a31 * a42 * a56 * a65 - a21 * a33 * a42 * a56 * a65 - a22 * a31 
            * a43 * a56 * a65 + a21 * a32 * a43 * a56 * a65 - a25 * a33 * a42 
            * a51 * a66 + a23 * a35 * a42 * a51 * a66 + a25 * a32 * a43 * a51 
            * a66 - a22 * a35 * a43 * a51 * a66 - a23 * a32 * a45 * a51 * a66 
            + a22 * a33 * a45 * a51 * a66 + a25 * a33 * a41 * a52 * a66 - a23 
            * a35 * a41 * a52 * a66 - a25 * a31 * a43 * a52 * a66 + a21 * a35 
            * a43 * a52 * a66 + a23 * a31 * a45 * a52 * a66 - a21 * a33 * a45 
            * a52 * a66 - a25 * a32 * a41 * a53 * a66 + a22 * a35 * a41 * a53 
            * a66 + a25 * a31 * a42 * a53 * a66 - a21 * a35 * a42 * a53 * a66 
            - a22 * a31 * a45 * a53 * a66 + a21 * a32 * a45 * a53 * a66 + a23 
            * a32 * a41 * a55 * a66 - a22 * a33 * a41 * a55 * a66 - a23 * a31 
            * a42 * a55 * a66 + a21 * a33 * a42 * a55 * a66 + a22 * a31 * a43 
            * a55 * a66 - a21 * a32 * a43 * a55 * a66;
    cofactor[19] = a16 * a35 * a43 * a52 * a61 - a15 * a36 * a43 * a52 * a61 
            - a16 * a33 * a45 * a52 * a61 + a13 * a36 * a45 * a52 * a61 + a15 
            * a33 * a46 * a52 * a61 - a13 * a35 * a46 * a52 * a61 - a16 * a35 
            * a42 * a53 * a61 + a15 * a36 * a42 * a53 * a61 + a16 * a32 * a45 
            * a53 * a61 - a12 * a36 * a45 * a53 * a61 - a15 * a32 * a46 * a53 
            * a61 + a12 * a35 * a46 * a53 * a61 + a16 * a33 * a42 * a55 * a61 
            - a13 * a36 * a42 * a55 * a61 - a16 * a32 * a43 * a55 * a61 + a12 
            * a36 * a43 * a55 * a61 + a13 * a32 * a46 * a55 * a61 - a12 * a33 
            * a46 * a55 * a61 - a15 * a33 * a42 * a56 * a61 + a13 * a35 * a42 
            * a56 * a61 + a15 * a32 * a43 * a56 * a61 - a12 * a35 * a43 * a56 
            * a61 - a13 * a32 * a45 * a56 * a61 + a12 * a33 * a45 * a56 * a61 
            - a16 * a35 * a43 * a51 * a62 + a15 * a36 * a43 * a51 * a62 + a16 
            * a33 * a45 * a51 * a62 - a13 * a36 * a45 * a51 * a62 - a15 * a33 
            * a46 * a51 * a62 + a13 * a35 * a46 * a51 * a62 + a16 * a35 * a41 
            * a53 * a62 - a15 * a36 * a41 * a53 * a62 - a16 * a31 * a45 * a53 
            * a62 + a11 * a36 * a45 * a53 * a62 + a15 * a31 * a46 * a53 * a62 
            - a11 * a35 * a46 * a53 * a62 - a16 * a33 * a41 * a55 * a62 + a13 
            * a36 * a41 * a55 * a62 + a16 * a31 * a43 * a55 * a62 - a11 * a36 
            * a43 * a55 * a62 - a13 * a31 * a46 * a55 * a62 + a11 * a33 * a46 
            * a55 * a62 + a15 * a33 * a41 * a56 * a62 - a13 * a35 * a41 * a56 
            * a62 - a15 * a31 * a43 * a56 * a62 + a11 * a35 * a43 * a56 * a62 
            + a13 * a31 * a45 * a56 * a62 - a11 * a33 * a45 * a56 * a62 + a16 
            * a35 * a42 * a51 * a63 - a15 * a36 * a42 * a51 * a63 - a16 * a32 
            * a45 * a51 * a63 + a12 * a36 * a45 * a51 * a63 + a15 * a32 * a46 
            * a51 * a63 - a12 * a35 * a46 * a51 * a63 - a16 * a35 * a41 * a52 
            * a63 + a15 * a36 * a41 * a52 * a63 + a16 * a31 * a45 * a52 * a63 
            - a11 * a36 * a45 * a52 * a63 - a15 * a31 * a46 * a52 * a63 + a11 
            * a35 * a46 * a52 * a63 + a16 * a32 * a41 * a55 * a63 - a12 * a36 
            * a41 * a55 * a63 - a16 * a31 * a42 * a55 * a63 + a11 * a36 * a42 
            * a55 * a63 + a12 * a31 * a46 * a55 * a63 - a11 * a32 * a46 * a55 
            * a63 - a15 * a32 * a41 * a56 * a63 + a12 * a35 * a41 * a56 * a63 
            + a15 * a31 * a42 * a56 * a63 - a11 * a35 * a42 * a56 * a63 - a12 
            * a31 * a45 * a56 * a63 + a11 * a32 * a45 * a56 * a63 - a16 * a33 
            * a42 * a51 * a65 + a13 * a36 * a42 * a51 * a65 + a16 * a32 * a43 
            * a51 * a65 - a12 * a36 * a43 * a51 * a65 - a13 * a32 * a46 * a51 
            * a65 + a12 * a33 * a46 * a51 * a65 + a16 * a33 * a41 * a52 * a65 
            - a13 * a36 * a41 * a52 * a65 - a16 * a31 * a43 * a52 * a65 + a11 
            * a36 * a43 * a52 * a65 + a13 * a31 * a46 * a52 * a65 - a11 * a33 
            * a46 * a52 * a65 - a16 * a32 * a41 * a53 * a65 + a12 * a36 * a41 
            * a53 * a65 + a16 * a31 * a42 * a53 * a65 - a11 * a36 * a42 * a53 
            * a65 - a12 * a31 * a46 * a53 * a65 + a11 * a32 * a46 * a53 * a65 
            + a13 * a32 * a41 * a56 * a65 - a12 * a33 * a41 * a56 * a65 - a13 
            * a31 * a42 * a56 * a65 + a11 * a33 * a42 * a56 * a65 + a12 * a31 
            * a43 * a56 * a65 - a11 * a32 * a43 * a56 * a65 + a15 * a33 * a42 
            * a51 * a66 - a13 * a35 * a42 * a51 * a66 - a15 * a32 * a43 * a51 
            * a66 + a12 * a35 * a43 * a51 * a66 + a13 * a32 * a45 * a51 * a66 
            - a12 * a33 * a45 * a51 * a66 - a15 * a33 * a41 * a52 * a66 + a13 
            * a35 * a41 * a52 * a66 + a15 * a31 * a43 * a52 * a66 - a11 * a35 
            * a43 * a52 * a66 - a13 * a31 * a45 * a52 * a66 + a11 * a33 * a45 
            * a52 * a66 + a15 * a32 * a41 * a53 * a66 - a12 * a35 * a41 * a53 
            * a66 - a15 * a31 * a42 * a53 * a66 + a11 * a35 * a42 * a53 * a66 
            + a12 * a31 * a45 * a53 * a66 - a11 * a32 * a45 * a53 * a66 - a13 
            * a32 * a41 * a55 * a66 + a12 * a33 * a41 * a55 * a66 + a13 * a31 
            * a42 * a55 * a66 - a11 * a33 * a42 * a55 * a66 - a12 * a31 * a43 
            * a55 * a66 + a11 * a32 * a43 * a55 * a66;
    cofactor[20] = -a16 * a25 * a43 * a52 * a61 + a15 * a26 * a43 * a52 * a61 
            + a16 * a23 * a45 * a52 * a61 - a13 * a26 * a45 * a52 * a61 - a15 
            * a23 * a46 * a52 * a61 + a13 * a25 * a46 * a52 * a61 + a16 * a25 
            * a42 * a53 * a61 - a15 * a26 * a42 * a53 * a61 - a16 * a22 * a45 
            * a53 * a61 + a12 * a26 * a45 * a53 * a61 + a15 * a22 * a46 * a53 
            * a61 - a12 * a25 * a46 * a53 * a61 - a16 * a23 * a42 * a55 * a61 
            + a13 * a26 * a42 * a55 * a61 + a16 * a22 * a43 * a55 * a61 - a12 
            * a26 * a43 * a55 * a61 - a13 * a22 * a46 * a55 * a61 + a12 * a23 
            * a46 * a55 * a61 + a15 * a23 * a42 * a56 * a61 - a13 * a25 * a42 
            * a56 * a61 - a15 * a22 * a43 * a56 * a61 + a12 * a25 * a43 * a56 
            * a61 + a13 * a22 * a45 * a56 * a61 - a12 * a23 * a45 * a56 * a61 
            + a16 * a25 * a43 * a51 * a62 - a15 * a26 * a43 * a51 * a62 - a16 
            * a23 * a45 * a51 * a62 + a13 * a26 * a45 * a51 * a62 + a15 * a23 
            * a46 * a51 * a62 - a13 * a25 * a46 * a51 * a62 - a16 * a25 * a41 
            * a53 * a62 + a15 * a26 * a41 * a53 * a62 + a16 * a21 * a45 * a53 
            * a62 - a11 * a26 * a45 * a53 * a62 - a15 * a21 * a46 * a53 * a62 
            + a11 * a25 * a46 * a53 * a62 + a16 * a23 * a41 * a55 * a62 - a13 
            * a26 * a41 * a55 * a62 - a16 * a21 * a43 * a55 * a62 + a11 * a26 
            * a43 * a55 * a62 + a13 * a21 * a46 * a55 * a62 - a11 * a23 * a46 
            * a55 * a62 - a15 * a23 * a41 * a56 * a62 + a13 * a25 * a41 * a56 
            * a62 + a15 * a21 * a43 * a56 * a62 - a11 * a25 * a43 * a56 * a62 
            - a13 * a21 * a45 * a56 * a62 + a11 * a23 * a45 * a56 * a62 - a16 
            * a25 * a42 * a51 * a63 + a15 * a26 * a42 * a51 * a63 + a16 * a22 
            * a45 * a51 * a63 - a12 * a26 * a45 * a51 * a63 - a15 * a22 * a46 
            * a51 * a63 + a12 * a25 * a46 * a51 * a63 + a16 * a25 * a41 * a52 
            * a63 - a15 * a26 * a41 * a52 * a63 - a16 * a21 * a45 * a52 * a63 
            + a11 * a26 * a45 * a52 * a63 + a15 * a21 * a46 * a52 * a63 - a11 
            * a25 * a46 * a52 * a63 - a16 * a22 * a41 * a55 * a63 + a12 * a26 
            * a41 * a55 * a63 + a16 * a21 * a42 * a55 * a63 - a11 * a26 * a42 
            * a55 * a63 - a12 * a21 * a46 * a55 * a63 + a11 * a22 * a46 * a55 
            * a63 + a15 * a22 * a41 * a56 * a63 - a12 * a25 * a41 * a56 * a63 
            - a15 * a21 * a42 * a56 * a63 + a11 * a25 * a42 * a56 * a63 + a12 
            * a21 * a45 * a56 * a63 - a11 * a22 * a45 * a56 * a63 + a16 * a23 
            * a42 * a51 * a65 - a13 * a26 * a42 * a51 * a65 - a16 * a22 * a43 
            * a51 * a65 + a12 * a26 * a43 * a51 * a65 + a13 * a22 * a46 * a51 
            * a65 - a12 * a23 * a46 * a51 * a65 - a16 * a23 * a41 * a52 * a65 
            + a13 * a26 * a41 * a52 * a65 + a16 * a21 * a43 * a52 * a65 - a11 
            * a26 * a43 * a52 * a65 - a13 * a21 * a46 * a52 * a65 + a11 * a23 
            * a46 * a52 * a65 + a16 * a22 * a41 * a53 * a65 - a12 * a26 * a41 
            * a53 * a65 - a16 * a21 * a42 * a53 * a65 + a11 * a26 * a42 * a53 
            * a65 + a12 * a21 * a46 * a53 * a65 - a11 * a22 * a46 * a53 * a65 
            - a13 * a22 * a41 * a56 * a65 + a12 * a23 * a41 * a56 * a65 + a13 
            * a21 * a42 * a56 * a65 - a11 * a23 * a42 * a56 * a65 - a12 * a21 
            * a43 * a56 * a65 + a11 * a22 * a43 * a56 * a65 - a15 * a23 * a42 
            * a51 * a66 + a13 * a25 * a42 * a51 * a66 + a15 * a22 * a43 * a51 
            * a66 - a12 * a25 * a43 * a51 * a66 - a13 * a22 * a45 * a51 * a66 
            + a12 * a23 * a45 * a51 * a66 + a15 * a23 * a41 * a52 * a66 - a13 
            * a25 * a41 * a52 * a66 - a15 * a21 * a43 * a52 * a66 + a11 * a25 
            * a43 * a52 * a66 + a13 * a21 * a45 * a52 * a66 - a11 * a23 * a45 
            * a52 * a66 - a15 * a22 * a41 * a53 * a66 + a12 * a25 * a41 * a53 
            * a66 + a15 * a21 * a42 * a53 * a66 - a11 * a25 * a42 * a53 * a66 
            - a12 * a21 * a45 * a53 * a66 + a11 * a22 * a45 * a53 * a66 + a13 
            * a22 * a41 * a55 * a66 - a12 * a23 * a41 * a55 * a66 - a13 * a21 
            * a42 * a55 * a66 + a11 * a23 * a42 * a55 * a66 + a12 * a21 * a43 
            * a55 * a66 - a11 * a22 * a43 * a55 * a66;
    cofactor[21] = a16 * a25 * a33 * a52 * a61 - a15 * a26 * a33 * a52 * a61 
            - a16 * a23 * a35 * a52 * a61 + a13 * a26 * a35 * a52 * a61 + a15 
            * a23 * a36 * a52 * a61 - a13 * a25 * a36 * a52 * a61 - a16 * a25 
            * a32 * a53 * a61 + a15 * a26 * a32 * a53 * a61 + a16 * a22 * a35 
            * a53 * a61 - a12 * a26 * a35 * a53 * a61 - a15 * a22 * a36 * a53 
            * a61 + a12 * a25 * a36 * a53 * a61 + a16 * a23 * a32 * a55 * a61 
            - a13 * a26 * a32 * a55 * a61 - a16 * a22 * a33 * a55 * a61 + a12 
            * a26 * a33 * a55 * a61 + a13 * a22 * a36 * a55 * a61 - a12 * a23 
            * a36 * a55 * a61 - a15 * a23 * a32 * a56 * a61 + a13 * a25 * a32 
            * a56 * a61 + a15 * a22 * a33 * a56 * a61 - a12 * a25 * a33 * a56 
            * a61 - a13 * a22 * a35 * a56 * a61 + a12 * a23 * a35 * a56 * a61 
            - a16 * a25 * a33 * a51 * a62 + a15 * a26 * a33 * a51 * a62 + a16 
            * a23 * a35 * a51 * a62 - a13 * a26 * a35 * a51 * a62 - a15 * a23 
            * a36 * a51 * a62 + a13 * a25 * a36 * a51 * a62 + a16 * a25 * a31 
            * a53 * a62 - a15 * a26 * a31 * a53 * a62 - a16 * a21 * a35 * a53 
            * a62 + a11 * a26 * a35 * a53 * a62 + a15 * a21 * a36 * a53 * a62 
            - a11 * a25 * a36 * a53 * a62 - a16 * a23 * a31 * a55 * a62 + a13 
            * a26 * a31 * a55 * a62 + a16 * a21 * a33 * a55 * a62 - a11 * a26 
            * a33 * a55 * a62 - a13 * a21 * a36 * a55 * a62 + a11 * a23 * a36 
            * a55 * a62 + a15 * a23 * a31 * a56 * a62 - a13 * a25 * a31 * a56 
            * a62 - a15 * a21 * a33 * a56 * a62 + a11 * a25 * a33 * a56 * a62 
            + a13 * a21 * a35 * a56 * a62 - a11 * a23 * a35 * a56 * a62 + a16 
            * a25 * a32 * a51 * a63 - a15 * a26 * a32 * a51 * a63 - a16 * a22 
            * a35 * a51 * a63 + a12 * a26 * a35 * a51 * a63 + a15 * a22 * a36 
            * a51 * a63 - a12 * a25 * a36 * a51 * a63 - a16 * a25 * a31 * a52 
            * a63 + a15 * a26 * a31 * a52 * a63 + a16 * a21 * a35 * a52 * a63 
            - a11 * a26 * a35 * a52 * a63 - a15 * a21 * a36 * a52 * a63 + a11 
            * a25 * a36 * a52 * a63 + a16 * a22 * a31 * a55 * a63 - a12 * a26 
            * a31 * a55 * a63 - a16 * a21 * a32 * a55 * a63 + a11 * a26 * a32 
            * a55 * a63 + a12 * a21 * a36 * a55 * a63 - a11 * a22 * a36 * a55 
            * a63 - a15 * a22 * a31 * a56 * a63 + a12 * a25 * a31 * a56 * a63 
            + a15 * a21 * a32 * a56 * a63 - a11 * a25 * a32 * a56 * a63 - a12 
            * a21 * a35 * a56 * a63 + a11 * a22 * a35 * a56 * a63 - a16 * a23 
            * a32 * a51 * a65 + a13 * a26 * a32 * a51 * a65 + a16 * a22 * a33 
            * a51 * a65 - a12 * a26 * a33 * a51 * a65 - a13 * a22 * a36 * a51 
            * a65 + a12 * a23 * a36 * a51 * a65 + a16 * a23 * a31 * a52 * a65 
            - a13 * a26 * a31 * a52 * a65 - a16 * a21 * a33 * a52 * a65 + a11 
            * a26 * a33 * a52 * a65 + a13 * a21 * a36 * a52 * a65 - a11 * a23 
            * a36 * a52 * a65 - a16 * a22 * a31 * a53 * a65 + a12 * a26 * a31 
            * a53 * a65 + a16 * a21 * a32 * a53 * a65 - a11 * a26 * a32 * a53 
            * a65 - a12 * a21 * a36 * a53 * a65 + a11 * a22 * a36 * a53 * a65 
            + a13 * a22 * a31 * a56 * a65 - a12 * a23 * a31 * a56 * a65 - a13 
            * a21 * a32 * a56 * a65 + a11 * a23 * a32 * a56 * a65 + a12 * a21 
            * a33 * a56 * a65 - a11 * a22 * a33 * a56 * a65 + a15 * a23 * a32 
            * a51 * a66 - a13 * a25 * a32 * a51 * a66 - a15 * a22 * a33 * a51 
            * a66 + a12 * a25 * a33 * a51 * a66 + a13 * a22 * a35 * a51 * a66 
            - a12 * a23 * a35 * a51 * a66 - a15 * a23 * a31 * a52 * a66 + a13 
            * a25 * a31 * a52 * a66 + a15 * a21 * a33 * a52 * a66 - a11 * a25 
            * a33 * a52 * a66 - a13 * a21 * a35 * a52 * a66 + a11 * a23 * a35 
            * a52 * a66 + a15 * a22 * a31 * a53 * a66 - a12 * a25 * a31 * a53 
            * a66 - a15 * a21 * a32 * a53 * a66 + a11 * a25 * a32 * a53 * a66 
            + a12 * a21 * a35 * a53 * a66 - a11 * a22 * a35 * a53 * a66 - a13 
            * a22 * a31 * a55 * a66 + a12 * a23 * a31 * a55 * a66 + a13 * a21 
            * a32 * a55 * a66 - a11 * a23 * a32 * a55 * a66 - a12 * a21 * a33 
            * a55 * a66 + a11 * a22 * a33 * a55 * a66;
    cofactor[22] = -a16 * a25 * a33 * a42 * a61 + a15 * a26 * a33 * a42 * a61 
            + a16 * a23 * a35 * a42 * a61 - a13 * a26 * a35 * a42 * a61 - a15 
            * a23 * a36 * a42 * a61 + a13 * a25 * a36 * a42 * a61 + a16 * a25 
            * a32 * a43 * a61 - a15 * a26 * a32 * a43 * a61 - a16 * a22 * a35 
            * a43 * a61 + a12 * a26 * a35 * a43 * a61 + a15 * a22 * a36 * a43 
            * a61 - a12 * a25 * a36 * a43 * a61 - a16 * a23 * a32 * a45 * a61 
            + a13 * a26 * a32 * a45 * a61 + a16 * a22 * a33 * a45 * a61 - a12 
            * a26 * a33 * a45 * a61 - a13 * a22 * a36 * a45 * a61 + a12 * a23 
            * a36 * a45 * a61 + a15 * a23 * a32 * a46 * a61 - a13 * a25 * a32 
            * a46 * a61 - a15 * a22 * a33 * a46 * a61 + a12 * a25 * a33 * a46 
            * a61 + a13 * a22 * a35 * a46 * a61 - a12 * a23 * a35 * a46 * a61 
            + a16 * a25 * a33 * a41 * a62 - a15 * a26 * a33 * a41 * a62 - a16 
            * a23 * a35 * a41 * a62 + a13 * a26 * a35 * a41 * a62 + a15 * a23 
            * a36 * a41 * a62 - a13 * a25 * a36 * a41 * a62 - a16 * a25 * a31 
            * a43 * a62 + a15 * a26 * a31 * a43 * a62 + a16 * a21 * a35 * a43 
            * a62 - a11 * a26 * a35 * a43 * a62 - a15 * a21 * a36 * a43 * a62 
            + a11 * a25 * a36 * a43 * a62 + a16 * a23 * a31 * a45 * a62 - a13 
            * a26 * a31 * a45 * a62 - a16 * a21 * a33 * a45 * a62 + a11 * a26 
            * a33 * a45 * a62 + a13 * a21 * a36 * a45 * a62 - a11 * a23 * a36 
            * a45 * a62 - a15 * a23 * a31 * a46 * a62 + a13 * a25 * a31 * a46 
            * a62 + a15 * a21 * a33 * a46 * a62 - a11 * a25 * a33 * a46 * a62 
            - a13 * a21 * a35 * a46 * a62 + a11 * a23 * a35 * a46 * a62 - a16 
            * a25 * a32 * a41 * a63 + a15 * a26 * a32 * a41 * a63 + a16 * a22 
            * a35 * a41 * a63 - a12 * a26 * a35 * a41 * a63 - a15 * a22 * a36 
            * a41 * a63 + a12 * a25 * a36 * a41 * a63 + a16 * a25 * a31 * a42 
            * a63 - a15 * a26 * a31 * a42 * a63 - a16 * a21 * a35 * a42 * a63 
            + a11 * a26 * a35 * a42 * a63 + a15 * a21 * a36 * a42 * a63 - a11 
            * a25 * a36 * a42 * a63 - a16 * a22 * a31 * a45 * a63 + a12 * a26 
            * a31 * a45 * a63 + a16 * a21 * a32 * a45 * a63 - a11 * a26 * a32 
            * a45 * a63 - a12 * a21 * a36 * a45 * a63 + a11 * a22 * a36 * a45 
            * a63 + a15 * a22 * a31 * a46 * a63 - a12 * a25 * a31 * a46 * a63 
            - a15 * a21 * a32 * a46 * a63 + a11 * a25 * a32 * a46 * a63 + a12 
            * a21 * a35 * a46 * a63 - a11 * a22 * a35 * a46 * a63 + a16 * a23 
            * a32 * a41 * a65 - a13 * a26 * a32 * a41 * a65 - a16 * a22 * a33 
            * a41 * a65 + a12 * a26 * a33 * a41 * a65 + a13 * a22 * a36 * a41 
            * a65 - a12 * a23 * a36 * a41 * a65 - a16 * a23 * a31 * a42 * a65 
            + a13 * a26 * a31 * a42 * a65 + a16 * a21 * a33 * a42 * a65 - a11 
            * a26 * a33 * a42 * a65 - a13 * a21 * a36 * a42 * a65 + a11 * a23 
            * a36 * a42 * a65 + a16 * a22 * a31 * a43 * a65 - a12 * a26 * a31 
            * a43 * a65 - a16 * a21 * a32 * a43 * a65 + a11 * a26 * a32 * a43 
            * a65 + a12 * a21 * a36 * a43 * a65 - a11 * a22 * a36 * a43 * a65 
            - a13 * a22 * a31 * a46 * a65 + a12 * a23 * a31 * a46 * a65 + a13 
            * a21 * a32 * a46 * a65 - a11 * a23 * a32 * a46 * a65 - a12 * a21 
            * a33 * a46 * a65 + a11 * a22 * a33 * a46 * a65 - a15 * a23 * a32 
            * a41 * a66 + a13 * a25 * a32 * a41 * a66 + a15 * a22 * a33 * a41 
            * a66 - a12 * a25 * a33 * a41 * a66 - a13 * a22 * a35 * a41 * a66 
            + a12 * a23 * a35 * a41 * a66 + a15 * a23 * a31 * a42 * a66 - a13 
            * a25 * a31 * a42 * a66 - a15 * a21 * a33 * a42 * a66 + a11 * a25 
            * a33 * a42 * a66 + a13 * a21 * a35 * a42 * a66 - a11 * a23 * a35 
            * a42 * a66 - a15 * a22 * a31 * a43 * a66 + a12 * a25 * a31 * a43 
            * a66 + a15 * a21 * a32 * a43 * a66 - a11 * a25 * a32 * a43 * a66 
            - a12 * a21 * a35 * a43 * a66 + a11 * a22 * a35 * a43 * a66 + a13 
            * a22 * a31 * a45 * a66 - a12 * a23 * a31 * a45 * a66 - a13 * a21 
            * a32 * a45 * a66 + a11 * a23 * a32 * a45 * a66 + a12 * a21 * a33 
            * a45 * a66 - a11 * a22 * a33 * a45 * a66;
    cofactor[23] = a16 * a25 * a33 * a42 * a51 - a15 * a26 * a33 * a42 * a51 
            - a16 * a23 * a35 * a42 * a51 + a13 * a26 * a35 * a42 * a51 + a15 
            * a23 * a36 * a42 * a51 - a13 * a25 * a36 * a42 * a51 - a16 * a25 
            * a32 * a43 * a51 + a15 * a26 * a32 * a43 * a51 + a16 * a22 * a35 
            * a43 * a51 - a12 * a26 * a35 * a43 * a51 - a15 * a22 * a36 * a43 
            * a51 + a12 * a25 * a36 * a43 * a51 + a16 * a23 * a32 * a45 * a51 
            - a13 * a26 * a32 * a45 * a51 - a16 * a22 * a33 * a45 * a51 + a12 
            * a26 * a33 * a45 * a51 + a13 * a22 * a36 * a45 * a51 - a12 * a23 
            * a36 * a45 * a51 - a15 * a23 * a32 * a46 * a51 + a13 * a25 * a32 
            * a46 * a51 + a15 * a22 * a33 * a46 * a51 - a12 * a25 * a33 * a46 
            * a51 - a13 * a22 * a35 * a46 * a51 + a12 * a23 * a35 * a46 * a51 
            - a16 * a25 * a33 * a41 * a52 + a15 * a26 * a33 * a41 * a52 + a16 
            * a23 * a35 * a41 * a52 - a13 * a26 * a35 * a41 * a52 - a15 * a23 
            * a36 * a41 * a52 + a13 * a25 * a36 * a41 * a52 + a16 * a25 * a31 
            * a43 * a52 - a15 * a26 * a31 * a43 * a52 - a16 * a21 * a35 * a43 
            * a52 + a11 * a26 * a35 * a43 * a52 + a15 * a21 * a36 * a43 * a52 
            - a11 * a25 * a36 * a43 * a52 - a16 * a23 * a31 * a45 * a52 + a13 
            * a26 * a31 * a45 * a52 + a16 * a21 * a33 * a45 * a52 - a11 * a26 
            * a33 * a45 * a52 - a13 * a21 * a36 * a45 * a52 + a11 * a23 * a36 
            * a45 * a52 + a15 * a23 * a31 * a46 * a52 - a13 * a25 * a31 * a46 
            * a52 - a15 * a21 * a33 * a46 * a52 + a11 * a25 * a33 * a46 * a52 
            + a13 * a21 * a35 * a46 * a52 - a11 * a23 * a35 * a46 * a52 + a16 
            * a25 * a32 * a41 * a53 - a15 * a26 * a32 * a41 * a53 - a16 * a22 
            * a35 * a41 * a53 + a12 * a26 * a35 * a41 * a53 + a15 * a22 * a36 
            * a41 * a53 - a12 * a25 * a36 * a41 * a53 - a16 * a25 * a31 * a42 
            * a53 + a15 * a26 * a31 * a42 * a53 + a16 * a21 * a35 * a42 * a53 
            - a11 * a26 * a35 * a42 * a53 - a15 * a21 * a36 * a42 * a53 + a11 
            * a25 * a36 * a42 * a53 + a16 * a22 * a31 * a45 * a53 - a12 * a26 
            * a31 * a45 * a53 - a16 * a21 * a32 * a45 * a53 + a11 * a26 * a32 
            * a45 * a53 + a12 * a21 * a36 * a45 * a53 - a11 * a22 * a36 * a45 
            * a53 - a15 * a22 * a31 * a46 * a53 + a12 * a25 * a31 * a46 * a53 
            + a15 * a21 * a32 * a46 * a53 - a11 * a25 * a32 * a46 * a53 - a12 
            * a21 * a35 * a46 * a53 + a11 * a22 * a35 * a46 * a53 - a16 * a23 
            * a32 * a41 * a55 + a13 * a26 * a32 * a41 * a55 + a16 * a22 * a33 
            * a41 * a55 - a12 * a26 * a33 * a41 * a55 - a13 * a22 * a36 * a41 
            * a55 + a12 * a23 * a36 * a41 * a55 + a16 * a23 * a31 * a42 * a55 
            - a13 * a26 * a31 * a42 * a55 - a16 * a21 * a33 * a42 * a55 + a11 
            * a26 * a33 * a42 * a55 + a13 * a21 * a36 * a42 * a55 - a11 * a23 
            * a36 * a42 * a55 - a16 * a22 * a31 * a43 * a55 + a12 * a26 * a31 
            * a43 * a55 + a16 * a21 * a32 * a43 * a55 - a11 * a26 * a32 * a43 
            * a55 - a12 * a21 * a36 * a43 * a55 + a11 * a22 * a36 * a43 * a55 
            + a13 * a22 * a31 * a46 * a55 - a12 * a23 * a31 * a46 * a55 - a13 
            * a21 * a32 * a46 * a55 + a11 * a23 * a32 * a46 * a55 + a12 * a21 
            * a33 * a46 * a55 - a11 * a22 * a33 * a46 * a55 + a15 * a23 * a32 
            * a41 * a56 - a13 * a25 * a32 * a41 * a56 - a15 * a22 * a33 * a41 
            * a56 + a12 * a25 * a33 * a41 * a56 + a13 * a22 * a35 * a41 * a56 
            - a12 * a23 * a35 * a41 * a56 - a15 * a23 * a31 * a42 * a56 + a13 
            * a25 * a31 * a42 * a56 + a15 * a21 * a33 * a42 * a56 - a11 * a25 
            * a33 * a42 * a56 - a13 * a21 * a35 * a42 * a56 + a11 * a23 * a35 
            * a42 * a56 + a15 * a22 * a31 * a43 * a56 - a12 * a25 * a31 * a43 
            * a56 - a15 * a21 * a32 * a43 * a56 + a11 * a25 * a32 * a43 * a56 
            + a12 * a21 * a35 * a43 * a56 - a11 * a22 * a35 * a43 * a56 - a13 
            * a22 * a31 * a45 * a56 + a12 * a23 * a31 * a45 * a56 + a13 * a21 
            * a32 * a45 * a56 - a11 * a23 * a32 * a45 * a56 - a12 * a21 * a33 
            * a45 * a56 + a11 * a22 * a33 * a45 * a56;
    cofactor[24] = a26 * a34 * a43 * a52 * a61 - a24 * a36 * a43 * a52 * a61 
            - a26 * a33 * a44 * a52 * a61 + a23 * a36 * a44 * a52 * a61 + a24 
            * a33 * a46 * a52 * a61 - a23 * a34 * a46 * a52 * a61 - a26 * a34 
            * a42 * a53 * a61 + a24 * a36 * a42 * a53 * a61 + a26 * a32 * a44 
            * a53 * a61 - a22 * a36 * a44 * a53 * a61 - a24 * a32 * a46 * a53 
            * a61 + a22 * a34 * a46 * a53 * a61 + a26 * a33 * a42 * a54 * a61 
            - a23 * a36 * a42 * a54 * a61 - a26 * a32 * a43 * a54 * a61 + a22 
            * a36 * a43 * a54 * a61 + a23 * a32 * a46 * a54 * a61 - a22 * a33 
            * a46 * a54 * a61 - a24 * a33 * a42 * a56 * a61 + a23 * a34 * a42 
            * a56 * a61 + a24 * a32 * a43 * a56 * a61 - a22 * a34 * a43 * a56 
            * a61 - a23 * a32 * a44 * a56 * a61 + a22 * a33 * a44 * a56 * a61 
            - a26 * a34 * a43 * a51 * a62 + a24 * a36 * a43 * a51 * a62 + a26 
            * a33 * a44 * a51 * a62 - a23 * a36 * a44 * a51 * a62 - a24 * a33 
            * a46 * a51 * a62 + a23 * a34 * a46 * a51 * a62 + a26 * a34 * a41 
            * a53 * a62 - a24 * a36 * a41 * a53 * a62 - a26 * a31 * a44 * a53 
            * a62 + a21 * a36 * a44 * a53 * a62 + a24 * a31 * a46 * a53 * a62 
            - a21 * a34 * a46 * a53 * a62 - a26 * a33 * a41 * a54 * a62 + a23 
            * a36 * a41 * a54 * a62 + a26 * a31 * a43 * a54 * a62 - a21 * a36 
            * a43 * a54 * a62 - a23 * a31 * a46 * a54 * a62 + a21 * a33 * a46 
            * a54 * a62 + a24 * a33 * a41 * a56 * a62 - a23 * a34 * a41 * a56 
            * a62 - a24 * a31 * a43 * a56 * a62 + a21 * a34 * a43 * a56 * a62 
            + a23 * a31 * a44 * a56 * a62 - a21 * a33 * a44 * a56 * a62 + a26 
            * a34 * a42 * a51 * a63 - a24 * a36 * a42 * a51 * a63 - a26 * a32 
            * a44 * a51 * a63 + a22 * a36 * a44 * a51 * a63 + a24 * a32 * a46 
            * a51 * a63 - a22 * a34 * a46 * a51 * a63 - a26 * a34 * a41 * a52 
            * a63 + a24 * a36 * a41 * a52 * a63 + a26 * a31 * a44 * a52 * a63 
            - a21 * a36 * a44 * a52 * a63 - a24 * a31 * a46 * a52 * a63 + a21 
            * a34 * a46 * a52 * a63 + a26 * a32 * a41 * a54 * a63 - a22 * a36 
            * a41 * a54 * a63 - a26 * a31 * a42 * a54 * a63 + a21 * a36 * a42 
            * a54 * a63 + a22 * a31 * a46 * a54 * a63 - a21 * a32 * a46 * a54 
            * a63 - a24 * a32 * a41 * a56 * a63 + a22 * a34 * a41 * a56 * a63 
            + a24 * a31 * a42 * a56 * a63 - a21 * a34 * a42 * a56 * a63 - a22 
            * a31 * a44 * a56 * a63 + a21 * a32 * a44 * a56 * a63 - a26 * a33 
            * a42 * a51 * a64 + a23 * a36 * a42 * a51 * a64 + a26 * a32 * a43 
            * a51 * a64 - a22 * a36 * a43 * a51 * a64 - a23 * a32 * a46 * a51 
            * a64 + a22 * a33 * a46 * a51 * a64 + a26 * a33 * a41 * a52 * a64 
            - a23 * a36 * a41 * a52 * a64 - a26 * a31 * a43 * a52 * a64 + a21 
            * a36 * a43 * a52 * a64 + a23 * a31 * a46 * a52 * a64 - a21 * a33 
            * a46 * a52 * a64 - a26 * a32 * a41 * a53 * a64 + a22 * a36 * a41 
            * a53 * a64 + a26 * a31 * a42 * a53 * a64 - a21 * a36 * a42 * a53 
            * a64 - a22 * a31 * a46 * a53 * a64 + a21 * a32 * a46 * a53 * a64 
            + a23 * a32 * a41 * a56 * a64 - a22 * a33 * a41 * a56 * a64 - a23 
            * a31 * a42 * a56 * a64 + a21 * a33 * a42 * a56 * a64 + a22 * a31 
            * a43 * a56 * a64 - a21 * a32 * a43 * a56 * a64 + a24 * a33 * a42 
            * a51 * a66 - a23 * a34 * a42 * a51 * a66 - a24 * a32 * a43 * a51 
            * a66 + a22 * a34 * a43 * a51 * a66 + a23 * a32 * a44 * a51 * a66 
            - a22 * a33 * a44 * a51 * a66 - a24 * a33 * a41 * a52 * a66 + a23 
            * a34 * a41 * a52 * a66 + a24 * a31 * a43 * a52 * a66 - a21 * a34 
            * a43 * a52 * a66 - a23 * a31 * a44 * a52 * a66 + a21 * a33 * a44 
            * a52 * a66 + a24 * a32 * a41 * a53 * a66 - a22 * a34 * a41 * a53 
            * a66 - a24 * a31 * a42 * a53 * a66 + a21 * a34 * a42 * a53 * a66 
            + a22 * a31 * a44 * a53 * a66 - a21 * a32 * a44 * a53 * a66 - a23 
            * a32 * a41 * a54 * a66 + a22 * a33 * a41 * a54 * a66 + a23 * a31 
            * a42 * a54 * a66 - a21 * a33 * a42 * a54 * a66 - a22 * a31 * a43 
            * a54 * a66 + a21 * a32 * a43 * a54 * a66;
    cofactor[25] = -a16 * a34 * a43 * a52 * a61 + a14 * a36 * a43 * a52 * a61 
            + a16 * a33 * a44 * a52 * a61 - a13 * a36 * a44 * a52 * a61 - a14 
            * a33 * a46 * a52 * a61 + a13 * a34 * a46 * a52 * a61 + a16 * a34 
            * a42 * a53 * a61 - a14 * a36 * a42 * a53 * a61 - a16 * a32 * a44 
            * a53 * a61 + a12 * a36 * a44 * a53 * a61 + a14 * a32 * a46 * a53 
            * a61 - a12 * a34 * a46 * a53 * a61 - a16 * a33 * a42 * a54 * a61 
            + a13 * a36 * a42 * a54 * a61 + a16 * a32 * a43 * a54 * a61 - a12 
            * a36 * a43 * a54 * a61 - a13 * a32 * a46 * a54 * a61 + a12 * a33 
            * a46 * a54 * a61 + a14 * a33 * a42 * a56 * a61 - a13 * a34 * a42 
            * a56 * a61 - a14 * a32 * a43 * a56 * a61 + a12 * a34 * a43 * a56 
            * a61 + a13 * a32 * a44 * a56 * a61 - a12 * a33 * a44 * a56 * a61 
            + a16 * a34 * a43 * a51 * a62 - a14 * a36 * a43 * a51 * a62 - a16 
            * a33 * a44 * a51 * a62 + a13 * a36 * a44 * a51 * a62 + a14 * a33 
            * a46 * a51 * a62 - a13 * a34 * a46 * a51 * a62 - a16 * a34 * a41 
            * a53 * a62 + a14 * a36 * a41 * a53 * a62 + a16 * a31 * a44 * a53 
            * a62 - a11 * a36 * a44 * a53 * a62 - a14 * a31 * a46 * a53 * a62 
            + a11 * a34 * a46 * a53 * a62 + a16 * a33 * a41 * a54 * a62 - a13 
            * a36 * a41 * a54 * a62 - a16 * a31 * a43 * a54 * a62 + a11 * a36 
            * a43 * a54 * a62 + a13 * a31 * a46 * a54 * a62 - a11 * a33 * a46 
            * a54 * a62 - a14 * a33 * a41 * a56 * a62 + a13 * a34 * a41 * a56 
            * a62 + a14 * a31 * a43 * a56 * a62 - a11 * a34 * a43 * a56 * a62 
            - a13 * a31 * a44 * a56 * a62 + a11 * a33 * a44 * a56 * a62 - a16 
            * a34 * a42 * a51 * a63 + a14 * a36 * a42 * a51 * a63 + a16 * a32 
            * a44 * a51 * a63 - a12 * a36 * a44 * a51 * a63 - a14 * a32 * a46 
            * a51 * a63 + a12 * a34 * a46 * a51 * a63 + a16 * a34 * a41 * a52 
            * a63 - a14 * a36 * a41 * a52 * a63 - a16 * a31 * a44 * a52 * a63 
            + a11 * a36 * a44 * a52 * a63 + a14 * a31 * a46 * a52 * a63 - a11 
            * a34 * a46 * a52 * a63 - a16 * a32 * a41 * a54 * a63 + a12 * a36 
            * a41 * a54 * a63 + a16 * a31 * a42 * a54 * a63 - a11 * a36 * a42 
            * a54 * a63 - a12 * a31 * a46 * a54 * a63 + a11 * a32 * a46 * a54 
            * a63 + a14 * a32 * a41 * a56 * a63 - a12 * a34 * a41 * a56 * a63 
            - a14 * a31 * a42 * a56 * a63 + a11 * a34 * a42 * a56 * a63 + a12 
            * a31 * a44 * a56 * a63 - a11 * a32 * a44 * a56 * a63 + a16 * a33 
            * a42 * a51 * a64 - a13 * a36 * a42 * a51 * a64 - a16 * a32 * a43 
            * a51 * a64 + a12 * a36 * a43 * a51 * a64 + a13 * a32 * a46 * a51 
            * a64 - a12 * a33 * a46 * a51 * a64 - a16 * a33 * a41 * a52 * a64 
            + a13 * a36 * a41 * a52 * a64 + a16 * a31 * a43 * a52 * a64 - a11 
            * a36 * a43 * a52 * a64 - a13 * a31 * a46 * a52 * a64 + a11 * a33 
            * a46 * a52 * a64 + a16 * a32 * a41 * a53 * a64 - a12 * a36 * a41 
            * a53 * a64 - a16 * a31 * a42 * a53 * a64 + a11 * a36 * a42 * a53 
            * a64 + a12 * a31 * a46 * a53 * a64 - a11 * a32 * a46 * a53 * a64 
            - a13 * a32 * a41 * a56 * a64 + a12 * a33 * a41 * a56 * a64 + a13 
            * a31 * a42 * a56 * a64 - a11 * a33 * a42 * a56 * a64 - a12 * a31 
            * a43 * a56 * a64 + a11 * a32 * a43 * a56 * a64 - a14 * a33 * a42 
            * a51 * a66 + a13 * a34 * a42 * a51 * a66 + a14 * a32 * a43 * a51 
            * a66 - a12 * a34 * a43 * a51 * a66 - a13 * a32 * a44 * a51 * a66 
            + a12 * a33 * a44 * a51 * a66 + a14 * a33 * a41 * a52 * a66 - a13 
            * a34 * a41 * a52 * a66 - a14 * a31 * a43 * a52 * a66 + a11 * a34 
            * a43 * a52 * a66 + a13 * a31 * a44 * a52 * a66 - a11 * a33 * a44 
            * a52 * a66 - a14 * a32 * a41 * a53 * a66 + a12 * a34 * a41 * a53 
            * a66 + a14 * a31 * a42 * a53 * a66 - a11 * a34 * a42 * a53 * a66 
            - a12 * a31 * a44 * a53 * a66 + a11 * a32 * a44 * a53 * a66 + a13 
            * a32 * a41 * a54 * a66 - a12 * a33 * a41 * a54 * a66 - a13 * a31 
            * a42 * a54 * a66 + a11 * a33 * a42 * a54 * a66 + a12 * a31 * a43 
            * a54 * a66 - a11 * a32 * a43 * a54 * a66;
    cofactor[26] = a16 * a24 * a43 * a52 * a61 - a14 * a26 * a43 * a52 * a61 
            - a16 * a23 * a44 * a52 * a61 + a13 * a26 * a44 * a52 * a61 + a14 
            * a23 * a46 * a52 * a61 - a13 * a24 * a46 * a52 * a61 - a16 * a24 
            * a42 * a53 * a61 + a14 * a26 * a42 * a53 * a61 + a16 * a22 * a44 
            * a53 * a61 - a12 * a26 * a44 * a53 * a61 - a14 * a22 * a46 * a53 
            * a61 + a12 * a24 * a46 * a53 * a61 + a16 * a23 * a42 * a54 * a61 
            - a13 * a26 * a42 * a54 * a61 - a16 * a22 * a43 * a54 * a61 + a12 
            * a26 * a43 * a54 * a61 + a13 * a22 * a46 * a54 * a61 - a12 * a23 
            * a46 * a54 * a61 - a14 * a23 * a42 * a56 * a61 + a13 * a24 * a42 
            * a56 * a61 + a14 * a22 * a43 * a56 * a61 - a12 * a24 * a43 * a56 
            * a61 - a13 * a22 * a44 * a56 * a61 + a12 * a23 * a44 * a56 * a61 
            - a16 * a24 * a43 * a51 * a62 + a14 * a26 * a43 * a51 * a62 + a16 
            * a23 * a44 * a51 * a62 - a13 * a26 * a44 * a51 * a62 - a14 * a23 
            * a46 * a51 * a62 + a13 * a24 * a46 * a51 * a62 + a16 * a24 * a41 
            * a53 * a62 - a14 * a26 * a41 * a53 * a62 - a16 * a21 * a44 * a53 
            * a62 + a11 * a26 * a44 * a53 * a62 + a14 * a21 * a46 * a53 * a62 
            - a11 * a24 * a46 * a53 * a62 - a16 * a23 * a41 * a54 * a62 + a13 
            * a26 * a41 * a54 * a62 + a16 * a21 * a43 * a54 * a62 - a11 * a26 
            * a43 * a54 * a62 - a13 * a21 * a46 * a54 * a62 + a11 * a23 * a46 
            * a54 * a62 + a14 * a23 * a41 * a56 * a62 - a13 * a24 * a41 * a56 
            * a62 - a14 * a21 * a43 * a56 * a62 + a11 * a24 * a43 * a56 * a62 
            + a13 * a21 * a44 * a56 * a62 - a11 * a23 * a44 * a56 * a62 + a16 
            * a24 * a42 * a51 * a63 - a14 * a26 * a42 * a51 * a63 - a16 * a22 
            * a44 * a51 * a63 + a12 * a26 * a44 * a51 * a63 + a14 * a22 * a46 
            * a51 * a63 - a12 * a24 * a46 * a51 * a63 - a16 * a24 * a41 * a52 
            * a63 + a14 * a26 * a41 * a52 * a63 + a16 * a21 * a44 * a52 * a63 
            - a11 * a26 * a44 * a52 * a63 - a14 * a21 * a46 * a52 * a63 + a11 
            * a24 * a46 * a52 * a63 + a16 * a22 * a41 * a54 * a63 - a12 * a26 
            * a41 * a54 * a63 - a16 * a21 * a42 * a54 * a63 + a11 * a26 * a42 
            * a54 * a63 + a12 * a21 * a46 * a54 * a63 - a11 * a22 * a46 * a54 
            * a63 - a14 * a22 * a41 * a56 * a63 + a12 * a24 * a41 * a56 * a63 
            + a14 * a21 * a42 * a56 * a63 - a11 * a24 * a42 * a56 * a63 - a12 
            * a21 * a44 * a56 * a63 + a11 * a22 * a44 * a56 * a63 - a16 * a23 
            * a42 * a51 * a64 + a13 * a26 * a42 * a51 * a64 + a16 * a22 * a43 
            * a51 * a64 - a12 * a26 * a43 * a51 * a64 - a13 * a22 * a46 * a51 
            * a64 + a12 * a23 * a46 * a51 * a64 + a16 * a23 * a41 * a52 * a64 
            - a13 * a26 * a41 * a52 * a64 - a16 * a21 * a43 * a52 * a64 + a11 
            * a26 * a43 * a52 * a64 + a13 * a21 * a46 * a52 * a64 - a11 * a23 
            * a46 * a52 * a64 - a16 * a22 * a41 * a53 * a64 + a12 * a26 * a41 
            * a53 * a64 + a16 * a21 * a42 * a53 * a64 - a11 * a26 * a42 * a53 
            * a64 - a12 * a21 * a46 * a53 * a64 + a11 * a22 * a46 * a53 * a64 
            + a13 * a22 * a41 * a56 * a64 - a12 * a23 * a41 * a56 * a64 - a13 
            * a21 * a42 * a56 * a64 + a11 * a23 * a42 * a56 * a64 + a12 * a21 
            * a43 * a56 * a64 - a11 * a22 * a43 * a56 * a64 + a14 * a23 * a42 
            * a51 * a66 - a13 * a24 * a42 * a51 * a66 - a14 * a22 * a43 * a51 
            * a66 + a12 * a24 * a43 * a51 * a66 + a13 * a22 * a44 * a51 * a66 
            - a12 * a23 * a44 * a51 * a66 - a14 * a23 * a41 * a52 * a66 + a13 
            * a24 * a41 * a52 * a66 + a14 * a21 * a43 * a52 * a66 - a11 * a24 
            * a43 * a52 * a66 - a13 * a21 * a44 * a52 * a66 + a11 * a23 * a44 
            * a52 * a66 + a14 * a22 * a41 * a53 * a66 - a12 * a24 * a41 * a53 
            * a66 - a14 * a21 * a42 * a53 * a66 + a11 * a24 * a42 * a53 * a66 
            + a12 * a21 * a44 * a53 * a66 - a11 * a22 * a44 * a53 * a66 - a13 
            * a22 * a41 * a54 * a66 + a12 * a23 * a41 * a54 * a66 + a13 * a21 
            * a42 * a54 * a66 - a11 * a23 * a42 * a54 * a66 - a12 * a21 * a43 
            * a54 * a66 + a11 * a22 * a43 * a54 * a66;
    cofactor[27] = -a16 * a24 * a33 * a52 * a61 + a14 * a26 * a33 * a52 * a61 
            + a16 * a23 * a34 * a52 * a61 - a13 * a26 * a34 * a52 * a61 - a14 
            * a23 * a36 * a52 * a61 + a13 * a24 * a36 * a52 * a61 + a16 * a24 
            * a32 * a53 * a61 - a14 * a26 * a32 * a53 * a61 - a16 * a22 * a34 
            * a53 * a61 + a12 * a26 * a34 * a53 * a61 + a14 * a22 * a36 * a53 
            * a61 - a12 * a24 * a36 * a53 * a61 - a16 * a23 * a32 * a54 * a61 
            + a13 * a26 * a32 * a54 * a61 + a16 * a22 * a33 * a54 * a61 - a12 
            * a26 * a33 * a54 * a61 - a13 * a22 * a36 * a54 * a61 + a12 * a23 
            * a36 * a54 * a61 + a14 * a23 * a32 * a56 * a61 - a13 * a24 * a32 
            * a56 * a61 - a14 * a22 * a33 * a56 * a61 + a12 * a24 * a33 * a56 
            * a61 + a13 * a22 * a34 * a56 * a61 - a12 * a23 * a34 * a56 * a61 
            + a16 * a24 * a33 * a51 * a62 - a14 * a26 * a33 * a51 * a62 - a16 
            * a23 * a34 * a51 * a62 + a13 * a26 * a34 * a51 * a62 + a14 * a23 
            * a36 * a51 * a62 - a13 * a24 * a36 * a51 * a62 - a16 * a24 * a31 
            * a53 * a62 + a14 * a26 * a31 * a53 * a62 + a16 * a21 * a34 * a53 
            * a62 - a11 * a26 * a34 * a53 * a62 - a14 * a21 * a36 * a53 * a62 
            + a11 * a24 * a36 * a53 * a62 + a16 * a23 * a31 * a54 * a62 - a13 
            * a26 * a31 * a54 * a62 - a16 * a21 * a33 * a54 * a62 + a11 * a26 
            * a33 * a54 * a62 + a13 * a21 * a36 * a54 * a62 - a11 * a23 * a36 
            * a54 * a62 - a14 * a23 * a31 * a56 * a62 + a13 * a24 * a31 * a56 
            * a62 + a14 * a21 * a33 * a56 * a62 - a11 * a24 * a33 * a56 * a62 
            - a13 * a21 * a34 * a56 * a62 + a11 * a23 * a34 * a56 * a62 - a16 
            * a24 * a32 * a51 * a63 + a14 * a26 * a32 * a51 * a63 + a16 * a22 
            * a34 * a51 * a63 - a12 * a26 * a34 * a51 * a63 - a14 * a22 * a36 
            * a51 * a63 + a12 * a24 * a36 * a51 * a63 + a16 * a24 * a31 * a52 
            * a63 - a14 * a26 * a31 * a52 * a63 - a16 * a21 * a34 * a52 * a63 
            + a11 * a26 * a34 * a52 * a63 + a14 * a21 * a36 * a52 * a63 - a11 
            * a24 * a36 * a52 * a63 - a16 * a22 * a31 * a54 * a63 + a12 * a26 
            * a31 * a54 * a63 + a16 * a21 * a32 * a54 * a63 - a11 * a26 * a32 
            * a54 * a63 - a12 * a21 * a36 * a54 * a63 + a11 * a22 * a36 * a54 
            * a63 + a14 * a22 * a31 * a56 * a63 - a12 * a24 * a31 * a56 * a63 
            - a14 * a21 * a32 * a56 * a63 + a11 * a24 * a32 * a56 * a63 + a12 
            * a21 * a34 * a56 * a63 - a11 * a22 * a34 * a56 * a63 + a16 * a23 
            * a32 * a51 * a64 - a13 * a26 * a32 * a51 * a64 - a16 * a22 * a33 
            * a51 * a64 + a12 * a26 * a33 * a51 * a64 + a13 * a22 * a36 * a51 
            * a64 - a12 * a23 * a36 * a51 * a64 - a16 * a23 * a31 * a52 * a64 
            + a13 * a26 * a31 * a52 * a64 + a16 * a21 * a33 * a52 * a64 - a11 
            * a26 * a33 * a52 * a64 - a13 * a21 * a36 * a52 * a64 + a11 * a23 
            * a36 * a52 * a64 + a16 * a22 * a31 * a53 * a64 - a12 * a26 * a31 
            * a53 * a64 - a16 * a21 * a32 * a53 * a64 + a11 * a26 * a32 * a53 
            * a64 + a12 * a21 * a36 * a53 * a64 - a11 * a22 * a36 * a53 * a64 
            - a13 * a22 * a31 * a56 * a64 + a12 * a23 * a31 * a56 * a64 + a13 
            * a21 * a32 * a56 * a64 - a11 * a23 * a32 * a56 * a64 - a12 * a21 
            * a33 * a56 * a64 + a11 * a22 * a33 * a56 * a64 - a14 * a23 * a32 
            * a51 * a66 + a13 * a24 * a32 * a51 * a66 + a14 * a22 * a33 * a51 
            * a66 - a12 * a24 * a33 * a51 * a66 - a13 * a22 * a34 * a51 * a66 
            + a12 * a23 * a34 * a51 * a66 + a14 * a23 * a31 * a52 * a66 - a13 
            * a24 * a31 * a52 * a66 - a14 * a21 * a33 * a52 * a66 + a11 * a24 
            * a33 * a52 * a66 + a13 * a21 * a34 * a52 * a66 - a11 * a23 * a34 
            * a52 * a66 - a14 * a22 * a31 * a53 * a66 + a12 * a24 * a31 * a53 
            * a66 + a14 * a21 * a32 * a53 * a66 - a11 * a24 * a32 * a53 * a66 
            - a12 * a21 * a34 * a53 * a66 + a11 * a22 * a34 * a53 * a66 + a13 
            * a22 * a31 * a54 * a66 - a12 * a23 * a31 * a54 * a66 - a13 * a21 
            * a32 * a54 * a66 + a11 * a23 * a32 * a54 * a66 + a12 * a21 * a33 
            * a54 * a66 - a11 * a22 * a33 * a54 * a66;
    cofactor[28] = a16 * a24 * a33 * a42 * a61 - a14 * a26 * a33 * a42 * a61 
            - a16 * a23 * a34 * a42 * a61 + a13 * a26 * a34 * a42 * a61 + a14 
            * a23 * a36 * a42 * a61 - a13 * a24 * a36 * a42 * a61 - a16 * a24 
            * a32 * a43 * a61 + a14 * a26 * a32 * a43 * a61 + a16 * a22 * a34 
            * a43 * a61 - a12 * a26 * a34 * a43 * a61 - a14 * a22 * a36 * a43 
            * a61 + a12 * a24 * a36 * a43 * a61 + a16 * a23 * a32 * a44 * a61 
            - a13 * a26 * a32 * a44 * a61 - a16 * a22 * a33 * a44 * a61 + a12 
            * a26 * a33 * a44 * a61 + a13 * a22 * a36 * a44 * a61 - a12 * a23 
            * a36 * a44 * a61 - a14 * a23 * a32 * a46 * a61 + a13 * a24 * a32 
            * a46 * a61 + a14 * a22 * a33 * a46 * a61 - a12 * a24 * a33 * a46 
            * a61 - a13 * a22 * a34 * a46 * a61 + a12 * a23 * a34 * a46 * a61 
            - a16 * a24 * a33 * a41 * a62 + a14 * a26 * a33 * a41 * a62 + a16 
            * a23 * a34 * a41 * a62 - a13 * a26 * a34 * a41 * a62 - a14 * a23 
            * a36 * a41 * a62 + a13 * a24 * a36 * a41 * a62 + a16 * a24 * a31 
            * a43 * a62 - a14 * a26 * a31 * a43 * a62 - a16 * a21 * a34 * a43 
            * a62 + a11 * a26 * a34 * a43 * a62 + a14 * a21 * a36 * a43 * a62 
            - a11 * a24 * a36 * a43 * a62 - a16 * a23 * a31 * a44 * a62 + a13 
            * a26 * a31 * a44 * a62 + a16 * a21 * a33 * a44 * a62 - a11 * a26 
            * a33 * a44 * a62 - a13 * a21 * a36 * a44 * a62 + a11 * a23 * a36 
            * a44 * a62 + a14 * a23 * a31 * a46 * a62 - a13 * a24 * a31 * a46 
            * a62 - a14 * a21 * a33 * a46 * a62 + a11 * a24 * a33 * a46 * a62 
            + a13 * a21 * a34 * a46 * a62 - a11 * a23 * a34 * a46 * a62 + a16 
            * a24 * a32 * a41 * a63 - a14 * a26 * a32 * a41 * a63 - a16 * a22 
            * a34 * a41 * a63 + a12 * a26 * a34 * a41 * a63 + a14 * a22 * a36 
            * a41 * a63 - a12 * a24 * a36 * a41 * a63 - a16 * a24 * a31 * a42 
            * a63 + a14 * a26 * a31 * a42 * a63 + a16 * a21 * a34 * a42 * a63 
            - a11 * a26 * a34 * a42 * a63 - a14 * a21 * a36 * a42 * a63 + a11 
            * a24 * a36 * a42 * a63 + a16 * a22 * a31 * a44 * a63 - a12 * a26 
            * a31 * a44 * a63 - a16 * a21 * a32 * a44 * a63 + a11 * a26 * a32 
            * a44 * a63 + a12 * a21 * a36 * a44 * a63 - a11 * a22 * a36 * a44 
            * a63 - a14 * a22 * a31 * a46 * a63 + a12 * a24 * a31 * a46 * a63 
            + a14 * a21 * a32 * a46 * a63 - a11 * a24 * a32 * a46 * a63 - a12 
            * a21 * a34 * a46 * a63 + a11 * a22 * a34 * a46 * a63 - a16 * a23 
            * a32 * a41 * a64 + a13 * a26 * a32 * a41 * a64 + a16 * a22 * a33 
            * a41 * a64 - a12 * a26 * a33 * a41 * a64 - a13 * a22 * a36 * a41 
            * a64 + a12 * a23 * a36 * a41 * a64 + a16 * a23 * a31 * a42 * a64 
            - a13 * a26 * a31 * a42 * a64 - a16 * a21 * a33 * a42 * a64 + a11 
            * a26 * a33 * a42 * a64 + a13 * a21 * a36 * a42 * a64 - a11 * a23 
            * a36 * a42 * a64 - a16 * a22 * a31 * a43 * a64 + a12 * a26 * a31 
            * a43 * a64 + a16 * a21 * a32 * a43 * a64 - a11 * a26 * a32 * a43 
            * a64 - a12 * a21 * a36 * a43 * a64 + a11 * a22 * a36 * a43 * a64 
            + a13 * a22 * a31 * a46 * a64 - a12 * a23 * a31 * a46 * a64 - a13 
            * a21 * a32 * a46 * a64 + a11 * a23 * a32 * a46 * a64 + a12 * a21 
            * a33 * a46 * a64 - a11 * a22 * a33 * a46 * a64 + a14 * a23 * a32 
            * a41 * a66 - a13 * a24 * a32 * a41 * a66 - a14 * a22 * a33 * a41 
            * a66 + a12 * a24 * a33 * a41 * a66 + a13 * a22 * a34 * a41 * a66 
            - a12 * a23 * a34 * a41 * a66 - a14 * a23 * a31 * a42 * a66 + a13 
            * a24 * a31 * a42 * a66 + a14 * a21 * a33 * a42 * a66 - a11 * a24 
            * a33 * a42 * a66 - a13 * a21 * a34 * a42 * a66 + a11 * a23 * a34 
            * a42 * a66 + a14 * a22 * a31 * a43 * a66 - a12 * a24 * a31 * a43 
            * a66 - a14 * a21 * a32 * a43 * a66 + a11 * a24 * a32 * a43 * a66 
            + a12 * a21 * a34 * a43 * a66 - a11 * a22 * a34 * a43 * a66 - a13 
            * a22 * a31 * a44 * a66 + a12 * a23 * a31 * a44 * a66 + a13 * a21 
            * a32 * a44 * a66 - a11 * a23 * a32 * a44 * a66 - a12 * a21 * a33 
            * a44 * a66 + a11 * a22 * a33 * a44 * a66;
    cofactor[29] = -a16 * a24 * a33 * a42 * a51 + a14 * a26 * a33 * a42 * a51 
            + a16 * a23 * a34 * a42 * a51 - a13 * a26 * a34 * a42 * a51 - a14 
            * a23 * a36 * a42 * a51 + a13 * a24 * a36 * a42 * a51 + a16 * a24 
            * a32 * a43 * a51 - a14 * a26 * a32 * a43 * a51 - a16 * a22 * a34 
            * a43 * a51 + a12 * a26 * a34 * a43 * a51 + a14 * a22 * a36 * a43 
            * a51 - a12 * a24 * a36 * a43 * a51 - a16 * a23 * a32 * a44 * a51 
            + a13 * a26 * a32 * a44 * a51 + a16 * a22 * a33 * a44 * a51 - a12 
            * a26 * a33 * a44 * a51 - a13 * a22 * a36 * a44 * a51 + a12 * a23 
            * a36 * a44 * a51 + a14 * a23 * a32 * a46 * a51 - a13 * a24 * a32 
            * a46 * a51 - a14 * a22 * a33 * a46 * a51 + a12 * a24 * a33 * a46 
            * a51 + a13 * a22 * a34 * a46 * a51 - a12 * a23 * a34 * a46 * a51 
            + a16 * a24 * a33 * a41 * a52 - a14 * a26 * a33 * a41 * a52 - a16 
            * a23 * a34 * a41 * a52 + a13 * a26 * a34 * a41 * a52 + a14 * a23 
            * a36 * a41 * a52 - a13 * a24 * a36 * a41 * a52 - a16 * a24 * a31 
            * a43 * a52 + a14 * a26 * a31 * a43 * a52 + a16 * a21 * a34 * a43 
            * a52 - a11 * a26 * a34 * a43 * a52 - a14 * a21 * a36 * a43 * a52 
            + a11 * a24 * a36 * a43 * a52 + a16 * a23 * a31 * a44 * a52 - a13 
            * a26 * a31 * a44 * a52 - a16 * a21 * a33 * a44 * a52 + a11 * a26 
            * a33 * a44 * a52 + a13 * a21 * a36 * a44 * a52 - a11 * a23 * a36 
            * a44 * a52 - a14 * a23 * a31 * a46 * a52 + a13 * a24 * a31 * a46 
            * a52 + a14 * a21 * a33 * a46 * a52 - a11 * a24 * a33 * a46 * a52 
            - a13 * a21 * a34 * a46 * a52 + a11 * a23 * a34 * a46 * a52 - a16 
            * a24 * a32 * a41 * a53 + a14 * a26 * a32 * a41 * a53 + a16 * a22 
            * a34 * a41 * a53 - a12 * a26 * a34 * a41 * a53 - a14 * a22 * a36 
            * a41 * a53 + a12 * a24 * a36 * a41 * a53 + a16 * a24 * a31 * a42 
            * a53 - a14 * a26 * a31 * a42 * a53 - a16 * a21 * a34 * a42 * a53 
            + a11 * a26 * a34 * a42 * a53 + a14 * a21 * a36 * a42 * a53 - a11 
            * a24 * a36 * a42 * a53 - a16 * a22 * a31 * a44 * a53 + a12 * a26 
            * a31 * a44 * a53 + a16 * a21 * a32 * a44 * a53 - a11 * a26 * a32 
            * a44 * a53 - a12 * a21 * a36 * a44 * a53 + a11 * a22 * a36 * a44 
            * a53 + a14 * a22 * a31 * a46 * a53 - a12 * a24 * a31 * a46 * a53 
            - a14 * a21 * a32 * a46 * a53 + a11 * a24 * a32 * a46 * a53 + a12 
            * a21 * a34 * a46 * a53 - a11 * a22 * a34 * a46 * a53 + a16 * a23 
            * a32 * a41 * a54 - a13 * a26 * a32 * a41 * a54 - a16 * a22 * a33 
            * a41 * a54 + a12 * a26 * a33 * a41 * a54 + a13 * a22 * a36 * a41 
            * a54 - a12 * a23 * a36 * a41 * a54 - a16 * a23 * a31 * a42 * a54 
            + a13 * a26 * a31 * a42 * a54 + a16 * a21 * a33 * a42 * a54 - a11 
            * a26 * a33 * a42 * a54 - a13 * a21 * a36 * a42 * a54 + a11 * a23 
            * a36 * a42 * a54 + a16 * a22 * a31 * a43 * a54 - a12 * a26 * a31 
            * a43 * a54 - a16 * a21 * a32 * a43 * a54 + a11 * a26 * a32 * a43 
            * a54 + a12 * a21 * a36 * a43 * a54 - a11 * a22 * a36 * a43 * a54 
            - a13 * a22 * a31 * a46 * a54 + a12 * a23 * a31 * a46 * a54 + a13 
            * a21 * a32 * a46 * a54 - a11 * a23 * a32 * a46 * a54 - a12 * a21 
            * a33 * a46 * a54 + a11 * a22 * a33 * a46 * a54 - a14 * a23 * a32 
            * a41 * a56 + a13 * a24 * a32 * a41 * a56 + a14 * a22 * a33 * a41 
            * a56 - a12 * a24 * a33 * a41 * a56 - a13 * a22 * a34 * a41 * a56 
            + a12 * a23 * a34 * a41 * a56 + a14 * a23 * a31 * a42 * a56 - a13 
            * a24 * a31 * a42 * a56 - a14 * a21 * a33 * a42 * a56 + a11 * a24 
            * a33 * a42 * a56 + a13 * a21 * a34 * a42 * a56 - a11 * a23 * a34 
            * a42 * a56 - a14 * a22 * a31 * a43 * a56 + a12 * a24 * a31 * a43 
            * a56 + a14 * a21 * a32 * a43 * a56 - a11 * a24 * a32 * a43 * a56 
            - a12 * a21 * a34 * a43 * a56 + a11 * a22 * a34 * a43 * a56 + a13 
            * a22 * a31 * a44 * a56 - a12 * a23 * a31 * a44 * a56 - a13 * a21 
            * a32 * a44 * a56 + a11 * a23 * a32 * a44 * a56 + a12 * a21 * a33 
            * a44 * a56 - a11 * a22 * a33 * a44 * a56;
    cofactor[30] = -a25 * a34 * a43 * a52 * a61 + a24 * a35 * a43 * a52 * a61 
            + a25 * a33 * a44 * a52 * a61 - a23 * a35 * a44 * a52 * a61 - a24 
            * a33 * a45 * a52 * a61 + a23 * a34 * a45 * a52 * a61 + a25 * a34 
            * a42 * a53 * a61 - a24 * a35 * a42 * a53 * a61 - a25 * a32 * a44 
            * a53 * a61 + a22 * a35 * a44 * a53 * a61 + a24 * a32 * a45 * a53 
            * a61 - a22 * a34 * a45 * a53 * a61 - a25 * a33 * a42 * a54 * a61 
            + a23 * a35 * a42 * a54 * a61 + a25 * a32 * a43 * a54 * a61 - a22 
            * a35 * a43 * a54 * a61 - a23 * a32 * a45 * a54 * a61 + a22 * a33 
            * a45 * a54 * a61 + a24 * a33 * a42 * a55 * a61 - a23 * a34 * a42 
            * a55 * a61 - a24 * a32 * a43 * a55 * a61 + a22 * a34 * a43 * a55 
            * a61 + a23 * a32 * a44 * a55 * a61 - a22 * a33 * a44 * a55 * a61 
            + a25 * a34 * a43 * a51 * a62 - a24 * a35 * a43 * a51 * a62 - a25 
            * a33 * a44 * a51 * a62 + a23 * a35 * a44 * a51 * a62 + a24 * a33 
            * a45 * a51 * a62 - a23 * a34 * a45 * a51 * a62 - a25 * a34 * a41 
            * a53 * a62 + a24 * a35 * a41 * a53 * a62 + a25 * a31 * a44 * a53 
            * a62 - a21 * a35 * a44 * a53 * a62 - a24 * a31 * a45 * a53 * a62 
            + a21 * a34 * a45 * a53 * a62 + a25 * a33 * a41 * a54 * a62 - a23 
            * a35 * a41 * a54 * a62 - a25 * a31 * a43 * a54 * a62 + a21 * a35 
            * a43 * a54 * a62 + a23 * a31 * a45 * a54 * a62 - a21 * a33 * a45 
            * a54 * a62 - a24 * a33 * a41 * a55 * a62 + a23 * a34 * a41 * a55 
            * a62 + a24 * a31 * a43 * a55 * a62 - a21 * a34 * a43 * a55 * a62 
            - a23 * a31 * a44 * a55 * a62 + a21 * a33 * a44 * a55 * a62 - a25 
            * a34 * a42 * a51 * a63 + a24 * a35 * a42 * a51 * a63 + a25 * a32 
            * a44 * a51 * a63 - a22 * a35 * a44 * a51 * a63 - a24 * a32 * a45 
            * a51 * a63 + a22 * a34 * a45 * a51 * a63 + a25 * a34 * a41 * a52 
            * a63 - a24 * a35 * a41 * a52 * a63 - a25 * a31 * a44 * a52 * a63 
            + a21 * a35 * a44 * a52 * a63 + a24 * a31 * a45 * a52 * a63 - a21 
            * a34 * a45 * a52 * a63 - a25 * a32 * a41 * a54 * a63 + a22 * a35 
            * a41 * a54 * a63 + a25 * a31 * a42 * a54 * a63 - a21 * a35 * a42 
            * a54 * a63 - a22 * a31 * a45 * a54 * a63 + a21 * a32 * a45 * a54 
            * a63 + a24 * a32 * a41 * a55 * a63 - a22 * a34 * a41 * a55 * a63 
            - a24 * a31 * a42 * a55 * a63 + a21 * a34 * a42 * a55 * a63 + a22 
            * a31 * a44 * a55 * a63 - a21 * a32 * a44 * a55 * a63 + a25 * a33 
            * a42 * a51 * a64 - a23 * a35 * a42 * a51 * a64 - a25 * a32 * a43 
            * a51 * a64 + a22 * a35 * a43 * a51 * a64 + a23 * a32 * a45 * a51 
            * a64 - a22 * a33 * a45 * a51 * a64 - a25 * a33 * a41 * a52 * a64 
            + a23 * a35 * a41 * a52 * a64 + a25 * a31 * a43 * a52 * a64 - a21 
            * a35 * a43 * a52 * a64 - a23 * a31 * a45 * a52 * a64 + a21 * a33 
            * a45 * a52 * a64 + a25 * a32 * a41 * a53 * a64 - a22 * a35 * a41 
            * a53 * a64 - a25 * a31 * a42 * a53 * a64 + a21 * a35 * a42 * a53 
            * a64 + a22 * a31 * a45 * a53 * a64 - a21 * a32 * a45 * a53 * a64 
            - a23 * a32 * a41 * a55 * a64 + a22 * a33 * a41 * a55 * a64 + a23 
            * a31 * a42 * a55 * a64 - a21 * a33 * a42 * a55 * a64 - a22 * a31 
            * a43 * a55 * a64 + a21 * a32 * a43 * a55 * a64 - a24 * a33 * a42 
            * a51 * a65 + a23 * a34 * a42 * a51 * a65 + a24 * a32 * a43 * a51 
            * a65 - a22 * a34 * a43 * a51 * a65 - a23 * a32 * a44 * a51 * a65 
            + a22 * a33 * a44 * a51 * a65 + a24 * a33 * a41 * a52 * a65 - a23 
            * a34 * a41 * a52 * a65 - a24 * a31 * a43 * a52 * a65 + a21 * a34 
            * a43 * a52 * a65 + a23 * a31 * a44 * a52 * a65 - a21 * a33 * a44 
            * a52 * a65 - a24 * a32 * a41 * a53 * a65 + a22 * a34 * a41 * a53 
            * a65 + a24 * a31 * a42 * a53 * a65 - a21 * a34 * a42 * a53 * a65 
            - a22 * a31 * a44 * a53 * a65 + a21 * a32 * a44 * a53 * a65 + a23 
            * a32 * a41 * a54 * a65 - a22 * a33 * a41 * a54 * a65 - a23 * a31 
            * a42 * a54 * a65 + a21 * a33 * a42 * a54 * a65 + a22 * a31 * a43 
            * a54 * a65 - a21 * a32 * a43 * a54 * a65;
    cofactor[31] = a15 * a34 * a43 * a52 * a61 - a14 * a35 * a43 * a52 * a61 
            - a15 * a33 * a44 * a52 * a61 + a13 * a35 * a44 * a52 * a61 + a14 
            * a33 * a45 * a52 * a61 - a13 * a34 * a45 * a52 * a61 - a15 * a34 
            * a42 * a53 * a61 + a14 * a35 * a42 * a53 * a61 + a15 * a32 * a44 
            * a53 * a61 - a12 * a35 * a44 * a53 * a61 - a14 * a32 * a45 * a53 
            * a61 + a12 * a34 * a45 * a53 * a61 + a15 * a33 * a42 * a54 * a61 
            - a13 * a35 * a42 * a54 * a61 - a15 * a32 * a43 * a54 * a61 + a12 
            * a35 * a43 * a54 * a61 + a13 * a32 * a45 * a54 * a61 - a12 * a33 
            * a45 * a54 * a61 - a14 * a33 * a42 * a55 * a61 + a13 * a34 * a42 
            * a55 * a61 + a14 * a32 * a43 * a55 * a61 - a12 * a34 * a43 * a55 
            * a61 - a13 * a32 * a44 * a55 * a61 + a12 * a33 * a44 * a55 * a61 
            - a15 * a34 * a43 * a51 * a62 + a14 * a35 * a43 * a51 * a62 + a15 
            * a33 * a44 * a51 * a62 - a13 * a35 * a44 * a51 * a62 - a14 * a33 
            * a45 * a51 * a62 + a13 * a34 * a45 * a51 * a62 + a15 * a34 * a41 
            * a53 * a62 - a14 * a35 * a41 * a53 * a62 - a15 * a31 * a44 * a53 
            * a62 + a11 * a35 * a44 * a53 * a62 + a14 * a31 * a45 * a53 * a62 
            - a11 * a34 * a45 * a53 * a62 - a15 * a33 * a41 * a54 * a62 + a13 
            * a35 * a41 * a54 * a62 + a15 * a31 * a43 * a54 * a62 - a11 * a35 
            * a43 * a54 * a62 - a13 * a31 * a45 * a54 * a62 + a11 * a33 * a45 
            * a54 * a62 + a14 * a33 * a41 * a55 * a62 - a13 * a34 * a41 * a55 
            * a62 - a14 * a31 * a43 * a55 * a62 + a11 * a34 * a43 * a55 * a62 
            + a13 * a31 * a44 * a55 * a62 - a11 * a33 * a44 * a55 * a62 + a15 
            * a34 * a42 * a51 * a63 - a14 * a35 * a42 * a51 * a63 - a15 * a32 
            * a44 * a51 * a63 + a12 * a35 * a44 * a51 * a63 + a14 * a32 * a45 
            * a51 * a63 - a12 * a34 * a45 * a51 * a63 - a15 * a34 * a41 * a52 
            * a63 + a14 * a35 * a41 * a52 * a63 + a15 * a31 * a44 * a52 * a63 
            - a11 * a35 * a44 * a52 * a63 - a14 * a31 * a45 * a52 * a63 + a11 
            * a34 * a45 * a52 * a63 + a15 * a32 * a41 * a54 * a63 - a12 * a35 
            * a41 * a54 * a63 - a15 * a31 * a42 * a54 * a63 + a11 * a35 * a42 
            * a54 * a63 + a12 * a31 * a45 * a54 * a63 - a11 * a32 * a45 * a54 
            * a63 - a14 * a32 * a41 * a55 * a63 + a12 * a34 * a41 * a55 * a63 
            + a14 * a31 * a42 * a55 * a63 - a11 * a34 * a42 * a55 * a63 - a12 
            * a31 * a44 * a55 * a63 + a11 * a32 * a44 * a55 * a63 - a15 * a33 
            * a42 * a51 * a64 + a13 * a35 * a42 * a51 * a64 + a15 * a32 * a43 
            * a51 * a64 - a12 * a35 * a43 * a51 * a64 - a13 * a32 * a45 * a51 
            * a64 + a12 * a33 * a45 * a51 * a64 + a15 * a33 * a41 * a52 * a64 
            - a13 * a35 * a41 * a52 * a64 - a15 * a31 * a43 * a52 * a64 + a11 
            * a35 * a43 * a52 * a64 + a13 * a31 * a45 * a52 * a64 - a11 * a33 
            * a45 * a52 * a64 - a15 * a32 * a41 * a53 * a64 + a12 * a35 * a41 
            * a53 * a64 + a15 * a31 * a42 * a53 * a64 - a11 * a35 * a42 * a53 
            * a64 - a12 * a31 * a45 * a53 * a64 + a11 * a32 * a45 * a53 * a64 
            + a13 * a32 * a41 * a55 * a64 - a12 * a33 * a41 * a55 * a64 - a13 
            * a31 * a42 * a55 * a64 + a11 * a33 * a42 * a55 * a64 + a12 * a31 
            * a43 * a55 * a64 - a11 * a32 * a43 * a55 * a64 + a14 * a33 * a42 
            * a51 * a65 - a13 * a34 * a42 * a51 * a65 - a14 * a32 * a43 * a51 
            * a65 + a12 * a34 * a43 * a51 * a65 + a13 * a32 * a44 * a51 * a65 
            - a12 * a33 * a44 * a51 * a65 - a14 * a33 * a41 * a52 * a65 + a13 
            * a34 * a41 * a52 * a65 + a14 * a31 * a43 * a52 * a65 - a11 * a34 
            * a43 * a52 * a65 - a13 * a31 * a44 * a52 * a65 + a11 * a33 * a44 
            * a52 * a65 + a14 * a32 * a41 * a53 * a65 - a12 * a34 * a41 * a53 
            * a65 - a14 * a31 * a42 * a53 * a65 + a11 * a34 * a42 * a53 * a65 
            + a12 * a31 * a44 * a53 * a65 - a11 * a32 * a44 * a53 * a65 - a13 
            * a32 * a41 * a54 * a65 + a12 * a33 * a41 * a54 * a65 + a13 * a31 
            * a42 * a54 * a65 - a11 * a33 * a42 * a54 * a65 - a12 * a31 * a43 
            * a54 * a65 + a11 * a32 * a43 * a54 * a65;
    cofactor[32] = -a15 * a24 * a43 * a52 * a61 + a14 * a25 * a43 * a52 * a61 
            + a15 * a23 * a44 * a52 * a61 - a13 * a25 * a44 * a52 * a61 - a14 
            * a23 * a45 * a52 * a61 + a13 * a24 * a45 * a52 * a61 + a15 * a24 
            * a42 * a53 * a61 - a14 * a25 * a42 * a53 * a61 - a15 * a22 * a44 
            * a53 * a61 + a12 * a25 * a44 * a53 * a61 + a14 * a22 * a45 * a53 
            * a61 - a12 * a24 * a45 * a53 * a61 - a15 * a23 * a42 * a54 * a61 
            + a13 * a25 * a42 * a54 * a61 + a15 * a22 * a43 * a54 * a61 - a12 
            * a25 * a43 * a54 * a61 - a13 * a22 * a45 * a54 * a61 + a12 * a23 
            * a45 * a54 * a61 + a14 * a23 * a42 * a55 * a61 - a13 * a24 * a42 
            * a55 * a61 - a14 * a22 * a43 * a55 * a61 + a12 * a24 * a43 * a55 
            * a61 + a13 * a22 * a44 * a55 * a61 - a12 * a23 * a44 * a55 * a61 
            + a15 * a24 * a43 * a51 * a62 - a14 * a25 * a43 * a51 * a62 - a15 
            * a23 * a44 * a51 * a62 + a13 * a25 * a44 * a51 * a62 + a14 * a23 
            * a45 * a51 * a62 - a13 * a24 * a45 * a51 * a62 - a15 * a24 * a41 
            * a53 * a62 + a14 * a25 * a41 * a53 * a62 + a15 * a21 * a44 * a53 
            * a62 - a11 * a25 * a44 * a53 * a62 - a14 * a21 * a45 * a53 * a62 
            + a11 * a24 * a45 * a53 * a62 + a15 * a23 * a41 * a54 * a62 - a13 
            * a25 * a41 * a54 * a62 - a15 * a21 * a43 * a54 * a62 + a11 * a25 
            * a43 * a54 * a62 + a13 * a21 * a45 * a54 * a62 - a11 * a23 * a45 
            * a54 * a62 - a14 * a23 * a41 * a55 * a62 + a13 * a24 * a41 * a55 
            * a62 + a14 * a21 * a43 * a55 * a62 - a11 * a24 * a43 * a55 * a62 
            - a13 * a21 * a44 * a55 * a62 + a11 * a23 * a44 * a55 * a62 - a15 
            * a24 * a42 * a51 * a63 + a14 * a25 * a42 * a51 * a63 + a15 * a22 
            * a44 * a51 * a63 - a12 * a25 * a44 * a51 * a63 - a14 * a22 * a45 
            * a51 * a63 + a12 * a24 * a45 * a51 * a63 + a15 * a24 * a41 * a52 
            * a63 - a14 * a25 * a41 * a52 * a63 - a15 * a21 * a44 * a52 * a63 
            + a11 * a25 * a44 * a52 * a63 + a14 * a21 * a45 * a52 * a63 - a11 
            * a24 * a45 * a52 * a63 - a15 * a22 * a41 * a54 * a63 + a12 * a25 
            * a41 * a54 * a63 + a15 * a21 * a42 * a54 * a63 - a11 * a25 * a42 
            * a54 * a63 - a12 * a21 * a45 * a54 * a63 + a11 * a22 * a45 * a54 
            * a63 + a14 * a22 * a41 * a55 * a63 - a12 * a24 * a41 * a55 * a63 
            - a14 * a21 * a42 * a55 * a63 + a11 * a24 * a42 * a55 * a63 + a12 
            * a21 * a44 * a55 * a63 - a11 * a22 * a44 * a55 * a63 + a15 * a23 
            * a42 * a51 * a64 - a13 * a25 * a42 * a51 * a64 - a15 * a22 * a43 
            * a51 * a64 + a12 * a25 * a43 * a51 * a64 + a13 * a22 * a45 * a51 
            * a64 - a12 * a23 * a45 * a51 * a64 - a15 * a23 * a41 * a52 * a64 
            + a13 * a25 * a41 * a52 * a64 + a15 * a21 * a43 * a52 * a64 - a11 
            * a25 * a43 * a52 * a64 - a13 * a21 * a45 * a52 * a64 + a11 * a23 
            * a45 * a52 * a64 + a15 * a22 * a41 * a53 * a64 - a12 * a25 * a41 
            * a53 * a64 - a15 * a21 * a42 * a53 * a64 + a11 * a25 * a42 * a53 
            * a64 + a12 * a21 * a45 * a53 * a64 - a11 * a22 * a45 * a53 * a64 
            - a13 * a22 * a41 * a55 * a64 + a12 * a23 * a41 * a55 * a64 + a13 
            * a21 * a42 * a55 * a64 - a11 * a23 * a42 * a55 * a64 - a12 * a21 
            * a43 * a55 * a64 + a11 * a22 * a43 * a55 * a64 - a14 * a23 * a42 
            * a51 * a65 + a13 * a24 * a42 * a51 * a65 + a14 * a22 * a43 * a51 
            * a65 - a12 * a24 * a43 * a51 * a65 - a13 * a22 * a44 * a51 * a65 
            + a12 * a23 * a44 * a51 * a65 + a14 * a23 * a41 * a52 * a65 - a13 
            * a24 * a41 * a52 * a65 - a14 * a21 * a43 * a52 * a65 + a11 * a24 
            * a43 * a52 * a65 + a13 * a21 * a44 * a52 * a65 - a11 * a23 * a44 
            * a52 * a65 - a14 * a22 * a41 * a53 * a65 + a12 * a24 * a41 * a53 
            * a65 + a14 * a21 * a42 * a53 * a65 - a11 * a24 * a42 * a53 * a65 
            - a12 * a21 * a44 * a53 * a65 + a11 * a22 * a44 * a53 * a65 + a13 
            * a22 * a41 * a54 * a65 - a12 * a23 * a41 * a54 * a65 - a13 * a21 
            * a42 * a54 * a65 + a11 * a23 * a42 * a54 * a65 + a12 * a21 * a43 
            * a54 * a65 - a11 * a22 * a43 * a54 * a65;
    cofactor[33] = a15 * a24 * a33 * a52 * a61 - a14 * a25 * a33 * a52 * a61 
            - a15 * a23 * a34 * a52 * a61 + a13 * a25 * a34 * a52 * a61 + a14 
            * a23 * a35 * a52 * a61 - a13 * a24 * a35 * a52 * a61 - a15 * a24 
            * a32 * a53 * a61 + a14 * a25 * a32 * a53 * a61 + a15 * a22 * a34 
            * a53 * a61 - a12 * a25 * a34 * a53 * a61 - a14 * a22 * a35 * a53 
            * a61 + a12 * a24 * a35 * a53 * a61 + a15 * a23 * a32 * a54 * a61 
            - a13 * a25 * a32 * a54 * a61 - a15 * a22 * a33 * a54 * a61 + a12 
            * a25 * a33 * a54 * a61 + a13 * a22 * a35 * a54 * a61 - a12 * a23 
            * a35 * a54 * a61 - a14 * a23 * a32 * a55 * a61 + a13 * a24 * a32 
            * a55 * a61 + a14 * a22 * a33 * a55 * a61 - a12 * a24 * a33 * a55 
            * a61 - a13 * a22 * a34 * a55 * a61 + a12 * a23 * a34 * a55 * a61 
            - a15 * a24 * a33 * a51 * a62 + a14 * a25 * a33 * a51 * a62 + a15 
            * a23 * a34 * a51 * a62 - a13 * a25 * a34 * a51 * a62 - a14 * a23 
            * a35 * a51 * a62 + a13 * a24 * a35 * a51 * a62 + a15 * a24 * a31 
            * a53 * a62 - a14 * a25 * a31 * a53 * a62 - a15 * a21 * a34 * a53 
            * a62 + a11 * a25 * a34 * a53 * a62 + a14 * a21 * a35 * a53 * a62 
            - a11 * a24 * a35 * a53 * a62 - a15 * a23 * a31 * a54 * a62 + a13 
            * a25 * a31 * a54 * a62 + a15 * a21 * a33 * a54 * a62 - a11 * a25 
            * a33 * a54 * a62 - a13 * a21 * a35 * a54 * a62 + a11 * a23 * a35 
            * a54 * a62 + a14 * a23 * a31 * a55 * a62 - a13 * a24 * a31 * a55 
            * a62 - a14 * a21 * a33 * a55 * a62 + a11 * a24 * a33 * a55 * a62 
            + a13 * a21 * a34 * a55 * a62 - a11 * a23 * a34 * a55 * a62 + a15 
            * a24 * a32 * a51 * a63 - a14 * a25 * a32 * a51 * a63 - a15 * a22 
            * a34 * a51 * a63 + a12 * a25 * a34 * a51 * a63 + a14 * a22 * a35 
            * a51 * a63 - a12 * a24 * a35 * a51 * a63 - a15 * a24 * a31 * a52 
            * a63 + a14 * a25 * a31 * a52 * a63 + a15 * a21 * a34 * a52 * a63 
            - a11 * a25 * a34 * a52 * a63 - a14 * a21 * a35 * a52 * a63 + a11 
            * a24 * a35 * a52 * a63 + a15 * a22 * a31 * a54 * a63 - a12 * a25 
            * a31 * a54 * a63 - a15 * a21 * a32 * a54 * a63 + a11 * a25 * a32 
            * a54 * a63 + a12 * a21 * a35 * a54 * a63 - a11 * a22 * a35 * a54 
            * a63 - a14 * a22 * a31 * a55 * a63 + a12 * a24 * a31 * a55 * a63 
            + a14 * a21 * a32 * a55 * a63 - a11 * a24 * a32 * a55 * a63 - a12 
            * a21 * a34 * a55 * a63 + a11 * a22 * a34 * a55 * a63 - a15 * a23 
            * a32 * a51 * a64 + a13 * a25 * a32 * a51 * a64 + a15 * a22 * a33 
            * a51 * a64 - a12 * a25 * a33 * a51 * a64 - a13 * a22 * a35 * a51 
            * a64 + a12 * a23 * a35 * a51 * a64 + a15 * a23 * a31 * a52 * a64 
            - a13 * a25 * a31 * a52 * a64 - a15 * a21 * a33 * a52 * a64 + a11 
            * a25 * a33 * a52 * a64 + a13 * a21 * a35 * a52 * a64 - a11 * a23 
            * a35 * a52 * a64 - a15 * a22 * a31 * a53 * a64 + a12 * a25 * a31 
            * a53 * a64 + a15 * a21 * a32 * a53 * a64 - a11 * a25 * a32 * a53 
            * a64 - a12 * a21 * a35 * a53 * a64 + a11 * a22 * a35 * a53 * a64 
            + a13 * a22 * a31 * a55 * a64 - a12 * a23 * a31 * a55 * a64 - a13 
            * a21 * a32 * a55 * a64 + a11 * a23 * a32 * a55 * a64 + a12 * a21 
            * a33 * a55 * a64 - a11 * a22 * a33 * a55 * a64 + a14 * a23 * a32 
            * a51 * a65 - a13 * a24 * a32 * a51 * a65 - a14 * a22 * a33 * a51 
            * a65 + a12 * a24 * a33 * a51 * a65 + a13 * a22 * a34 * a51 * a65 
            - a12 * a23 * a34 * a51 * a65 - a14 * a23 * a31 * a52 * a65 + a13 
            * a24 * a31 * a52 * a65 + a14 * a21 * a33 * a52 * a65 - a11 * a24 
            * a33 * a52 * a65 - a13 * a21 * a34 * a52 * a65 + a11 * a23 * a34 
            * a52 * a65 + a14 * a22 * a31 * a53 * a65 - a12 * a24 * a31 * a53 
            * a65 - a14 * a21 * a32 * a53 * a65 + a11 * a24 * a32 * a53 * a65 
            + a12 * a21 * a34 * a53 * a65 - a11 * a22 * a34 * a53 * a65 - a13 
            * a22 * a31 * a54 * a65 + a12 * a23 * a31 * a54 * a65 + a13 * a21 
            * a32 * a54 * a65 - a11 * a23 * a32 * a54 * a65 - a12 * a21 * a33 
            * a54 * a65 + a11 * a22 * a33 * a54 * a65;
    cofactor[34] = -a15 * a24 * a33 * a42 * a61 + a14 * a25 * a33 * a42 * a61 
            + a15 * a23 * a34 * a42 * a61 - a13 * a25 * a34 * a42 * a61 - a14 
            * a23 * a35 * a42 * a61 + a13 * a24 * a35 * a42 * a61 + a15 * a24 
            * a32 * a43 * a61 - a14 * a25 * a32 * a43 * a61 - a15 * a22 * a34 
            * a43 * a61 + a12 * a25 * a34 * a43 * a61 + a14 * a22 * a35 * a43 
            * a61 - a12 * a24 * a35 * a43 * a61 - a15 * a23 * a32 * a44 * a61 
            + a13 * a25 * a32 * a44 * a61 + a15 * a22 * a33 * a44 * a61 - a12 
            * a25 * a33 * a44 * a61 - a13 * a22 * a35 * a44 * a61 + a12 * a23 
            * a35 * a44 * a61 + a14 * a23 * a32 * a45 * a61 - a13 * a24 * a32 
            * a45 * a61 - a14 * a22 * a33 * a45 * a61 + a12 * a24 * a33 * a45 
            * a61 + a13 * a22 * a34 * a45 * a61 - a12 * a23 * a34 * a45 * a61 
            + a15 * a24 * a33 * a41 * a62 - a14 * a25 * a33 * a41 * a62 - a15 
            * a23 * a34 * a41 * a62 + a13 * a25 * a34 * a41 * a62 + a14 * a23 
            * a35 * a41 * a62 - a13 * a24 * a35 * a41 * a62 - a15 * a24 * a31 
            * a43 * a62 + a14 * a25 * a31 * a43 * a62 + a15 * a21 * a34 * a43 
            * a62 - a11 * a25 * a34 * a43 * a62 - a14 * a21 * a35 * a43 * a62 
            + a11 * a24 * a35 * a43 * a62 + a15 * a23 * a31 * a44 * a62 - a13 
            * a25 * a31 * a44 * a62 - a15 * a21 * a33 * a44 * a62 + a11 * a25 
            * a33 * a44 * a62 + a13 * a21 * a35 * a44 * a62 - a11 * a23 * a35 
            * a44 * a62 - a14 * a23 * a31 * a45 * a62 + a13 * a24 * a31 * a45 
            * a62 + a14 * a21 * a33 * a45 * a62 - a11 * a24 * a33 * a45 * a62 
            - a13 * a21 * a34 * a45 * a62 + a11 * a23 * a34 * a45 * a62 - a15 
            * a24 * a32 * a41 * a63 + a14 * a25 * a32 * a41 * a63 + a15 * a22 
            * a34 * a41 * a63 - a12 * a25 * a34 * a41 * a63 - a14 * a22 * a35 
            * a41 * a63 + a12 * a24 * a35 * a41 * a63 + a15 * a24 * a31 * a42 
            * a63 - a14 * a25 * a31 * a42 * a63 - a15 * a21 * a34 * a42 * a63 
            + a11 * a25 * a34 * a42 * a63 + a14 * a21 * a35 * a42 * a63 - a11 
            * a24 * a35 * a42 * a63 - a15 * a22 * a31 * a44 * a63 + a12 * a25 
            * a31 * a44 * a63 + a15 * a21 * a32 * a44 * a63 - a11 * a25 * a32 
            * a44 * a63 - a12 * a21 * a35 * a44 * a63 + a11 * a22 * a35 * a44 
            * a63 + a14 * a22 * a31 * a45 * a63 - a12 * a24 * a31 * a45 * a63 
            - a14 * a21 * a32 * a45 * a63 + a11 * a24 * a32 * a45 * a63 + a12 
            * a21 * a34 * a45 * a63 - a11 * a22 * a34 * a45 * a63 + a15 * a23 
            * a32 * a41 * a64 - a13 * a25 * a32 * a41 * a64 - a15 * a22 * a33 
            * a41 * a64 + a12 * a25 * a33 * a41 * a64 + a13 * a22 * a35 * a41 
            * a64 - a12 * a23 * a35 * a41 * a64 - a15 * a23 * a31 * a42 * a64 
            + a13 * a25 * a31 * a42 * a64 + a15 * a21 * a33 * a42 * a64 - a11 
            * a25 * a33 * a42 * a64 - a13 * a21 * a35 * a42 * a64 + a11 * a23 
            * a35 * a42 * a64 + a15 * a22 * a31 * a43 * a64 - a12 * a25 * a31 
            * a43 * a64 - a15 * a21 * a32 * a43 * a64 + a11 * a25 * a32 * a43 
            * a64 + a12 * a21 * a35 * a43 * a64 - a11 * a22 * a35 * a43 * a64 
            - a13 * a22 * a31 * a45 * a64 + a12 * a23 * a31 * a45 * a64 + a13 
            * a21 * a32 * a45 * a64 - a11 * a23 * a32 * a45 * a64 - a12 * a21 
            * a33 * a45 * a64 + a11 * a22 * a33 * a45 * a64 - a14 * a23 * a32 
            * a41 * a65 + a13 * a24 * a32 * a41 * a65 + a14 * a22 * a33 * a41 
            * a65 - a12 * a24 * a33 * a41 * a65 - a13 * a22 * a34 * a41 * a65 
            + a12 * a23 * a34 * a41 * a65 + a14 * a23 * a31 * a42 * a65 - a13 
            * a24 * a31 * a42 * a65 - a14 * a21 * a33 * a42 * a65 + a11 * a24 
            * a33 * a42 * a65 + a13 * a21 * a34 * a42 * a65 - a11 * a23 * a34 
            * a42 * a65 - a14 * a22 * a31 * a43 * a65 + a12 * a24 * a31 * a43 
            * a65 + a14 * a21 * a32 * a43 * a65 - a11 * a24 * a32 * a43 * a65 
            - a12 * a21 * a34 * a43 * a65 + a11 * a22 * a34 * a43 * a65 + a13 
            * a22 * a31 * a44 * a65 - a12 * a23 * a31 * a44 * a65 - a13 * a21 
            * a32 * a44 * a65 + a11 * a23 * a32 * a44 * a65 + a12 * a21 * a33 
            * a44 * a65 - a11 * a22 * a33 * a44 * a65;
    cofactor[35] = a15 * a24 * a33 * a42 * a51 - a14 * a25 * a33 * a42 * a51 
            - a15 * a23 * a34 * a42 * a51 + a13 * a25 * a34 * a42 * a51 + a14 
            * a23 * a35 * a42 * a51 - a13 * a24 * a35 * a42 * a51 - a15 * a24 
            * a32 * a43 * a51 + a14 * a25 * a32 * a43 * a51 + a15 * a22 * a34 
            * a43 * a51 - a12 * a25 * a34 * a43 * a51 - a14 * a22 * a35 * a43 
            * a51 + a12 * a24 * a35 * a43 * a51 + a15 * a23 * a32 * a44 * a51 
            - a13 * a25 * a32 * a44 * a51 - a15 * a22 * a33 * a44 * a51 + a12 
            * a25 * a33 * a44 * a51 + a13 * a22 * a35 * a44 * a51 - a12 * a23 
            * a35 * a44 * a51 - a14 * a23 * a32 * a45 * a51 + a13 * a24 * a32 
            * a45 * a51 + a14 * a22 * a33 * a45 * a51 - a12 * a24 * a33 * a45 
            * a51 - a13 * a22 * a34 * a45 * a51 + a12 * a23 * a34 * a45 * a51 
            - a15 * a24 * a33 * a41 * a52 + a14 * a25 * a33 * a41 * a52 + a15 
            * a23 * a34 * a41 * a52 - a13 * a25 * a34 * a41 * a52 - a14 * a23 
            * a35 * a41 * a52 + a13 * a24 * a35 * a41 * a52 + a15 * a24 * a31 
            * a43 * a52 - a14 * a25 * a31 * a43 * a52 - a15 * a21 * a34 * a43 
            * a52 + a11 * a25 * a34 * a43 * a52 + a14 * a21 * a35 * a43 * a52 
            - a11 * a24 * a35 * a43 * a52 - a15 * a23 * a31 * a44 * a52 + a13 
            * a25 * a31 * a44 * a52 + a15 * a21 * a33 * a44 * a52 - a11 * a25 
            * a33 * a44 * a52 - a13 * a21 * a35 * a44 * a52 + a11 * a23 * a35 
            * a44 * a52 + a14 * a23 * a31 * a45 * a52 - a13 * a24 * a31 * a45 
            * a52 - a14 * a21 * a33 * a45 * a52 + a11 * a24 * a33 * a45 * a52 
            + a13 * a21 * a34 * a45 * a52 - a11 * a23 * a34 * a45 * a52 + a15 
            * a24 * a32 * a41 * a53 - a14 * a25 * a32 * a41 * a53 - a15 * a22 
            * a34 * a41 * a53 + a12 * a25 * a34 * a41 * a53 + a14 * a22 * a35 
            * a41 * a53 - a12 * a24 * a35 * a41 * a53 - a15 * a24 * a31 * a42 
            * a53 + a14 * a25 * a31 * a42 * a53 + a15 * a21 * a34 * a42 * a53 
            - a11 * a25 * a34 * a42 * a53 - a14 * a21 * a35 * a42 * a53 + a11 
            * a24 * a35 * a42 * a53 + a15 * a22 * a31 * a44 * a53 - a12 * a25 
            * a31 * a44 * a53 - a15 * a21 * a32 * a44 * a53 + a11 * a25 * a32 
            * a44 * a53 + a12 * a21 * a35 * a44 * a53 - a11 * a22 * a35 * a44 
            * a53 - a14 * a22 * a31 * a45 * a53 + a12 * a24 * a31 * a45 * a53 
            + a14 * a21 * a32 * a45 * a53 - a11 * a24 * a32 * a45 * a53 - a12 
            * a21 * a34 * a45 * a53 + a11 * a22 * a34 * a45 * a53 - a15 * a23 
            * a32 * a41 * a54 + a13 * a25 * a32 * a41 * a54 + a15 * a22 * a33 
            * a41 * a54 - a12 * a25 * a33 * a41 * a54 - a13 * a22 * a35 * a41 
            * a54 + a12 * a23 * a35 * a41 * a54 + a15 * a23 * a31 * a42 * a54 
            - a13 * a25 * a31 * a42 * a54 - a15 * a21 * a33 * a42 * a54 + a11 
            * a25 * a33 * a42 * a54 + a13 * a21 * a35 * a42 * a54 - a11 * a23 
            * a35 * a42 * a54 - a15 * a22 * a31 * a43 * a54 + a12 * a25 * a31 
            * a43 * a54 + a15 * a21 * a32 * a43 * a54 - a11 * a25 * a32 * a43 
            * a54 - a12 * a21 * a35 * a43 * a54 + a11 * a22 * a35 * a43 * a54 
            + a13 * a22 * a31 * a45 * a54 - a12 * a23 * a31 * a45 * a54 - a13 
            * a21 * a32 * a45 * a54 + a11 * a23 * a32 * a45 * a54 + a12 * a21 
            * a33 * a45 * a54 - a11 * a22 * a33 * a45 * a54 + a14 * a23 * a32 
            * a41 * a55 - a13 * a24 * a32 * a41 * a55 - a14 * a22 * a33 * a41 
            * a55 + a12 * a24 * a33 * a41 * a55 + a13 * a22 * a34 * a41 * a55 
            - a12 * a23 * a34 * a41 * a55 - a14 * a23 * a31 * a42 * a55 + a13 
            * a24 * a31 * a42 * a55 + a14 * a21 * a33 * a42 * a55 - a11 * a24 
            * a33 * a42 * a55 - a13 * a21 * a34 * a42 * a55 + a11 * a23 * a34 
            * a42 * a55 + a14 * a22 * a31 * a43 * a55 - a12 * a24 * a31 * a43 
            * a55 - a14 * a21 * a32 * a43 * a55 + a11 * a24 * a32 * a43 * a55 
            + a12 * a21 * a34 * a43 * a55 - a11 * a22 * a34 * a43 * a55 - a13 
            * a22 * a31 * a44 * a55 + a12 * a23 * a31 * a44 * a55 + a13 * a21 
            * a32 * a44 * a55 - a11 * a23 * a32 * a44 * a55 - a12 * a21 * a33 
            * a44 * a55 + a11 * a22 * a33 * a44 * a55;

    for (int i = 1; i <= 6; ++i) {
        for (int j = 1; j <= 6; ++j) {
            ainv[j + i * 6] = cofactor[i + j * 6 - 7] / det;
        }
    }
/*     ainv = transpose(cofactor) ! / det */
    *ok_flag__ = 0;
    return 0;
}

int cmx_inv6_v1(const double const a[6][6], double *ainv, int*ok_flag__)
{
    double cofactor[36]        /* was [6][6] */;

    /* Parameter adjustments */
    ainv -= 7;
//  a -= 7;

    /* Function Body */
    const double eps = 1e-10;
    const double
    det = -(a[1-1][6-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][2-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][2-1]
            - a[1-1][6-1]*
            a[2-1][4-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][2-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][2-1]
            + a[1-1][5-1]*a[2-1][4-1]*
            a[3-1][6-1]*a[4-1][3-1]*a[5-1][2-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][2-1]
            - a[1-1][6-1]*a[2-1][5-1]*a[3-1][3-1]*
            a[4-1][4-1]*a[5-1][2-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][2-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][4-1]*
            a[5-1][2-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][2-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][2-1]
            + 
            a[1-1][3-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][2-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][2-1]
            - a[1-1][4-1]*
            a[2-1][6-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][2-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][2-1]
            + a[1-1][3-1]*a[2-1][6-1]*
            a[3-1][4-1]*a[4-1][5-1]*a[5-1][2-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][2-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[3-1][6-1]*
            a[4-1][5-1]*a[5-1][2-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][2-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][6-1]*
            a[5-1][2-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][2-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][2-1]
            - 
            a[1-1][4-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][2-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][2-1]
            - a[1-1][6-1]*
            a[2-1][5-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][3-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][3-1]
            + a[1-1][6-1]*a[2-1][4-1]*
            a[3-1][5-1]*a[4-1][2-1]*a[5-1][3-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][3-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][6-1]*
            a[4-1][2-1]*a[5-1][3-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][3-1]
            + a[1-1][6-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][4-1]*
            a[5-1][3-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][3-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][3-1]
            + 
            a[1-1][2-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][3-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][3-1]
            - a[1-1][2-1]*
            a[2-1][5-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][3-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][3-1]
            + a[1-1][4-1]*a[2-1][6-1]*
            a[3-1][2-1]*a[4-1][5-1]*a[5-1][3-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][3-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][4-1]*
            a[4-1][5-1]*a[5-1][3-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][3-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][5-1]*
            a[5-1][3-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][3-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][3-1]
            - 
            a[1-1][5-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][3-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][3-1]
            + a[1-1][4-1]*
            a[2-1][2-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][3-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][3-1]
            + a[1-1][6-1]*a[2-1][5-1]*
            a[3-1][3-1]*a[4-1][2-1]*a[5-1][4-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][4-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][5-1]*
            a[4-1][2-1]*a[5-1][4-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][4-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][2-1]*
            a[5-1][4-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][4-1]
            - a[1-1][6-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][4-1]
            + 
            a[1-1][5-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][4-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][4-1]
            - a[1-1][2-1]*
            a[2-1][6-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][4-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][4-1]
            + a[1-1][2-1]*a[2-1][5-1]*
            a[3-1][6-1]*a[4-1][3-1]*a[5-1][4-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][4-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][2-1]*
            a[4-1][5-1]*a[5-1][4-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][4-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][5-1]*
            a[5-1][4-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][4-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][4-1]
            - 
            a[1-1][5-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][4-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][4-1]
            + a[1-1][5-1]*
            a[2-1][2-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][4-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][4-1]
            - a[1-1][3-1]*a[2-1][2-1]*
            a[3-1][5-1]*a[4-1][6-1]*a[5-1][4-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][4-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[3-1][3-1]*
            a[4-1][2-1]*a[5-1][5-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][5-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][2-1]*
            a[5-1][5-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][5-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][5-1]
            + 
            a[1-1][3-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][5-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][5-1]
            - a[1-1][4-1]*
            a[2-1][6-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][5-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][5-1]
            + a[1-1][2-1]*a[2-1][6-1]*
            a[3-1][4-1]*a[4-1][3-1]*a[5-1][5-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][5-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][6-1]*
            a[4-1][3-1]*a[5-1][5-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][5-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][4-1]*
            a[5-1][5-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][5-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][5-1]
            - 
            a[1-1][3-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][5-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][5-1]
            + a[1-1][4-1]*
            a[2-1][3-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][5-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][5-1]
            - a[1-1][4-1]*a[2-1][2-1]*
            a[3-1][3-1]*a[4-1][6-1]*a[5-1][5-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][5-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][4-1]*
            a[4-1][6-1]*a[5-1][5-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][5-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][2-1]*
            a[5-1][6-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][6-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][6-1]
            + 
            a[1-1][3-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][6-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][6-1]
            - a[1-1][3-1]*
            a[2-1][4-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][6-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][6-1]
            + a[1-1][4-1]*a[2-1][5-1]*
            a[3-1][2-1]*a[4-1][3-1]*a[5-1][6-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][6-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][4-1]*
            a[4-1][3-1]*a[5-1][6-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][6-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][3-1]*
            a[5-1][6-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][6-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][6-1]
            - 
            a[1-1][5-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][6-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][6-1]
            + a[1-1][3-1]*
            a[2-1][2-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][6-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][6-1]
            - a[1-1][4-1]*a[2-1][3-1]*
            a[3-1][2-1]*a[4-1][5-1]*a[5-1][6-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][6-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][3-1]*
            a[4-1][5-1]*a[5-1][6-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][6-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][5-1]*
            a[5-1][6-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][6-1])*a[6-1][1-1]
            + (a[1-1][6-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][1-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][1-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][1-1] 
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][1-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][1-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][1-1]
            - a[1-1][6-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][1-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][1-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][1-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][1-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][1-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][1-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][1-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][1-1] 
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][1-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][1-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][1-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][1-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][1-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][1-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][1-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][1-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][1-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][1-1]
            - a[1-1][6-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][3-1] 
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][3-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][3-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][3-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][3-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][3-1]
            + a[1-1][6-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][3-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][3-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][3-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][3-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][3-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][3-1] 
            - a[1-1][6-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][3-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][3-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][3-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][3-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][3-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][3-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][3-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][3-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][3-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][3-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][3-1] 
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][3-1]
            + a[1-1][6-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][4-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][4-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][4-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][4-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][4-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][4-1]
            - a[1-1][6-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][4-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][4-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][4-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][4-1] 
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][4-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][4-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][4-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][4-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][4-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][4-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][4-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][4-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][4-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][4-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][4-1] 
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][4-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][4-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][4-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][5-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][5-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][5-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][5-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][5-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][5-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][5-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][5-1] 
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][5-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][5-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][5-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][5-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][5-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][5-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][5-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][5-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][5-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][5-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][5-1] 
            - a[1-1][3-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][5-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][5-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][5-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][5-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][5-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][6-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][6-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][6-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][6-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][6-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][6-1] 
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][6-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][6-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][6-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][6-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][6-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][6-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][6-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][6-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][6-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][6-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][6-1] 
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][6-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][6-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][6-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][6-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][6-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][6-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][6-1])*a[6-1][2-1]
            - (a[1-1][6-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][1-1]
            - a[1-1][5-1]*a[2-1][6-1]*
            a[3-1][4-1]*a[4-1][2-1]*a[5-1][1-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][1-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][5-1]*
            a[4-1][2-1]*a[5-1][1-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][1-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][2-1]*
            a[5-1][1-1]
            - a[1-1][6-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][1-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][1-1]
            + 
            a[1-1][6-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][1-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][1-1]
            - a[1-1][5-1]*
            a[2-1][2-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][1-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][1-1]
            + a[1-1][6-1]*a[2-1][4-1]*
            a[3-1][2-1]*a[4-1][5-1]*a[5-1][1-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][1-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][4-1]*
            a[4-1][5-1]*a[5-1][1-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][1-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][5-1]*
            a[5-1][1-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][1-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][1-1]
            + 
            a[1-1][4-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][1-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][1-1]
            - a[1-1][2-1]*
            a[2-1][5-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][1-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][1-1]
            + a[1-1][2-1]*a[2-1][4-1]*
            a[3-1][5-1]*a[4-1][6-1]*a[5-1][1-1]
            - a[1-1][6-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][2-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][4-1]*
            a[4-1][1-1]*a[5-1][2-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][2-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][1-1]*
            a[5-1][2-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][2-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][2-1]
            + 
            a[1-1][6-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][2-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][2-1]
            - a[1-1][6-1]*
            a[2-1][1-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][2-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][2-1]
            + a[1-1][5-1]*a[2-1][1-1]*
            a[3-1][6-1]*a[4-1][4-1]*a[5-1][2-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][2-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[3-1][1-1]*
            a[4-1][5-1]*a[5-1][2-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][2-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][5-1]*
            a[5-1][2-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][2-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][2-1]
            + 
            a[1-1][1-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][2-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][2-1]
            - a[1-1][4-1]*
            a[2-1][5-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][2-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][2-1]
            + a[1-1][1-1]*a[2-1][5-1]*
            a[3-1][4-1]*a[4-1][6-1]*a[5-1][2-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][2-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][5-1]*
            a[4-1][6-1]*a[5-1][2-1]
            + a[1-1][6-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][4-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][1-1]*
            a[5-1][4-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][4-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][4-1]
            + 
            a[1-1][5-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][4-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][4-1]
            - a[1-1][6-1]*
            a[2-1][5-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][4-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][4-1]
            + a[1-1][6-1]*a[2-1][1-1]*
            a[3-1][5-1]*a[4-1][2-1]*a[5-1][4-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][4-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][6-1]*
            a[4-1][2-1]*a[5-1][4-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][4-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][5-1]*
            a[5-1][4-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][4-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][4-1]
            + 
            a[1-1][1-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][4-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][4-1]
            - a[1-1][1-1]*
            a[2-1][2-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][4-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][4-1]
            + a[1-1][2-1]*a[2-1][5-1]*
            a[3-1][1-1]*a[4-1][6-1]*a[5-1][4-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][4-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][2-1]*
            a[4-1][6-1]*a[5-1][4-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][4-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][6-1]*
            a[5-1][4-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][5-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][5-1]
            + 
            a[1-1][6-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][5-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][5-1]
            - a[1-1][4-1]*
            a[2-1][2-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][5-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][5-1]
            + a[1-1][6-1]*a[2-1][4-1]*
            a[3-1][1-1]*a[4-1][2-1]*a[5-1][5-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][5-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][4-1]*
            a[4-1][2-1]*a[5-1][5-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][5-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][2-1]*
            a[5-1][5-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][5-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][5-1]
            + 
            a[1-1][2-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][5-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][5-1]
            - a[1-1][1-1]*
            a[2-1][6-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][5-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][5-1]
            + a[1-1][1-1]*a[2-1][2-1]*
            a[3-1][6-1]*a[4-1][4-1]*a[5-1][5-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][5-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][1-1]*
            a[4-1][6-1]*a[5-1][5-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][5-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][6-1]*
            a[5-1][5-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][5-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][5-1]
            + 
            a[1-1][5-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][6-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][6-1]
            - a[1-1][5-1]*
            a[2-1][2-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][6-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][6-1]
            + a[1-1][4-1]*a[2-1][2-1]*
            a[3-1][5-1]*a[4-1][1-1]*a[5-1][6-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][6-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][1-1]*
            a[4-1][2-1]*a[5-1][6-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][6-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][2-1]*
            a[5-1][6-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][6-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][6-1]
            + 
            a[1-1][1-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][6-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][6-1]
            - a[1-1][2-1]*
            a[2-1][5-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][6-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][6-1]
            + a[1-1][1-1]*a[2-1][5-1]*
            a[3-1][2-1]*a[4-1][4-1]*a[5-1][6-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][6-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][5-1]*
            a[4-1][4-1]*a[5-1][6-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][6-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][5-1]*
            a[5-1][6-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][6-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][6-1]
            - 
            a[1-1][2-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][6-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][6-1])*a[6-1][3-1] 
            + (a[1-1][6-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][1-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][1-1]
            - 
            a[1-1][6-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][1-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][1-1]
            + a[1-1][5-1]*
            a[2-1][3-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][1-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][1-1]
            - a[1-1][6-1]*a[2-1][5-1]*
            a[3-1][2-1]*a[4-1][3-1]*a[5-1][1-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][1-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][5-1]*
            a[4-1][3-1]*a[5-1][1-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][1-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][3-1]*
            a[5-1][1-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][1-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][1-1]
            - 
            a[1-1][3-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][1-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][1-1]
            + a[1-1][2-1]*
            a[2-1][6-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][1-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][1-1]
            - a[1-1][2-1]*a[2-1][3-1]*
            a[3-1][6-1]*a[4-1][5-1]*a[5-1][1-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][1-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][2-1]*
            a[4-1][6-1]*a[5-1][1-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][1-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][6-1]*
            a[5-1][1-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][1-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][1-1]
            - 
            a[1-1][6-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][2-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][2-1]
            + a[1-1][6-1]*
            a[2-1][3-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][2-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][2-1]
            - a[1-1][5-1]*a[2-1][3-1]*
            a[3-1][6-1]*a[4-1][1-1]*a[5-1][2-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][2-1]
            + a[1-1][6-1]*a[2-1][5-1]*a[3-1][1-1]*
            a[4-1][3-1]*a[5-1][2-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][2-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][3-1]*
            a[5-1][2-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][2-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][2-1]
            - 
            a[1-1][1-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][2-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][2-1]
            + a[1-1][3-1]*
            a[2-1][6-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][2-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][2-1]
            - a[1-1][1-1]*a[2-1][6-1]*
            a[3-1][3-1]*a[4-1][5-1]*a[5-1][2-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][2-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][6-1]*
            a[4-1][5-1]*a[5-1][2-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][2-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][6-1]*
            a[5-1][2-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][2-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][2-1]
            + 
            a[1-1][3-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][2-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][2-1]
            + a[1-1][6-1]*
            a[2-1][5-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][3-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][3-1]
            - a[1-1][6-1]*a[2-1][2-1]*
            a[3-1][5-1]*a[4-1][1-1]*a[5-1][3-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][3-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][6-1]*
            a[4-1][1-1]*a[5-1][3-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][3-1]
            - a[1-1][6-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][2-1]*
            a[5-1][3-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][3-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][3-1]
            - 
            a[1-1][1-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][3-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][3-1]
            + a[1-1][1-1]*
            a[2-1][5-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][3-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][3-1]
            - a[1-1][2-1]*a[2-1][6-1]*
            a[3-1][1-1]*a[4-1][5-1]*a[5-1][3-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][3-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][2-1]*
            a[4-1][5-1]*a[5-1][3-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][3-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][5-1]*
            a[5-1][3-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][3-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][3-1]
            + 
            a[1-1][5-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][3-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][3-1]
            - a[1-1][2-1]*
            a[2-1][1-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][3-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][3-1]
            - a[1-1][6-1]*a[2-1][3-1]*
            a[3-1][2-1]*a[4-1][1-1]*a[5-1][5-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][5-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][3-1]*
            a[4-1][1-1]*a[5-1][5-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][5-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][1-1]*
            a[5-1][5-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][5-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][5-1]
            - 
            a[1-1][3-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][5-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][5-1]
            + a[1-1][1-1]*
            a[2-1][6-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][5-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][5-1]
            - a[1-1][1-1]*a[2-1][3-1]*
            a[3-1][6-1]*a[4-1][2-1]*a[5-1][5-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][5-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][1-1]*
            a[4-1][3-1]*a[5-1][5-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][5-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][3-1]*
            a[5-1][5-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][5-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][5-1]
            + 
            a[1-1][3-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][5-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][5-1]
            - a[1-1][3-1]*
            a[2-1][1-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][5-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][5-1]
            + a[1-1][2-1]*a[2-1][1-1]*
            a[3-1][3-1]*a[4-1][6-1]*a[5-1][5-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][5-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][2-1]*
            a[4-1][1-1]*a[5-1][6-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][6-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][1-1]*
            a[5-1][6-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][6-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][6-1]
            - 
            a[1-1][2-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][6-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][6-1]
            + a[1-1][3-1]*
            a[2-1][5-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][6-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][6-1]
            - a[1-1][1-1]*a[2-1][5-1]*
            a[3-1][3-1]*a[4-1][2-1]*a[5-1][6-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][6-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][5-1]*
            a[4-1][2-1]*a[5-1][6-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][6-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][3-1]*
            a[5-1][6-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][6-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][6-1]
            + 
            a[1-1][2-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][6-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][6-1]
            - a[1-1][3-1]*
            a[2-1][2-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][6-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][6-1]
            + a[1-1][3-1]*a[2-1][1-1]*
            a[3-1][2-1]*a[4-1][5-1]*a[5-1][6-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][6-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][3-1]*
            a[4-1][5-1]*a[5-1][6-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][6-1])*a[6-1][4-1]
            - (a[1-1][6-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][1-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][1-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][1-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][1-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][1-1] 
            - a[1-1][3-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][1-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][1-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][1-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][1-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][1-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][1-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][1-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][1-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][1-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][1-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][1-1] 
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][1-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][1-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][1-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][1-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][1-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][1-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][1-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][1-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][2-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][2-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][2-1] 
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][2-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][2-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][2-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][2-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][2-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][2-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][2-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][2-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][2-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][2-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][2-1] 
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][2-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][2-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][2-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][2-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][2-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][2-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][2-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][2-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][2-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][2-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][3-1] 
            - a[1-1][4-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][3-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][3-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][3-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][3-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][3-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][3-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][3-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][3-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][3-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][3-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][3-1] 
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][3-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][3-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][3-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][3-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][3-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][3-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][3-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][3-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][3-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][3-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][3-1] 
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][3-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][4-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][4-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][4-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][4-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][4-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][4-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][4-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][4-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][4-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][4-1] 
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][4-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][4-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][4-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][4-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][4-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][4-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][4-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][4-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][4-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][4-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][4-1] 
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][4-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][4-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][4-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][6-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][6-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][6-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][6-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][6-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][6-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][6-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][6-1] 
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][6-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][6-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][6-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][6-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][6-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][6-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][6-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][6-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][6-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][6-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][6-1] 
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][6-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][6-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][6-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][6-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][6-1])*a[6-1][5-1]
            + (a[1-1][5-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][1-1]
            - a[1-1][4-1]*
            a[2-1][5-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][1-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][1-1]
            + a[1-1][3-1]*a[2-1][5-1]*
            a[3-1][4-1]*a[4-1][2-1]*a[5-1][1-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][1-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[3-1][5-1]*
            a[4-1][2-1]*a[5-1][1-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][1-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][3-1]*
            a[5-1][1-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][1-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][1-1]
            - 
            a[1-1][4-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][1-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][1-1]
            + a[1-1][5-1]*
            a[2-1][3-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][1-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][1-1]
            - a[1-1][5-1]*a[2-1][2-1]*
            a[3-1][3-1]*a[4-1][4-1]*a[5-1][1-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][1-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][5-1]*
            a[4-1][4-1]*a[5-1][1-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][1-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][5-1]*
            a[5-1][1-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][1-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][1-1]
            - 
            a[1-1][2-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][1-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][1-1]
            + a[1-1][2-1]*
            a[2-1][3-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][1-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][2-1]
            + a[1-1][4-1]*a[2-1][5-1]*
            a[3-1][3-1]*a[4-1][1-1]*a[5-1][2-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][2-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][4-1]*
            a[4-1][1-1]*a[5-1][2-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][2-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][1-1]*
            a[5-1][2-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][2-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][2-1]
            - 
            a[1-1][5-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][2-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][2-1]
            + a[1-1][4-1]*
            a[2-1][1-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][2-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][2-1]
            - a[1-1][5-1]*a[2-1][3-1]*
            a[3-1][1-1]*a[4-1][4-1]*a[5-1][2-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][2-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][3-1]*
            a[4-1][4-1]*a[5-1][2-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][2-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][4-1]*
            a[5-1][2-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][2-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][2-1]
            - 
            a[1-1][3-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][2-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][2-1]
            + a[1-1][1-1]*
            a[2-1][4-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][2-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][2-1]
            - a[1-1][1-1]*a[2-1][3-1]*
            a[3-1][4-1]*a[4-1][5-1]*a[5-1][2-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][3-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][2-1]*
            a[4-1][1-1]*a[5-1][3-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][3-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][1-1]*
            a[5-1][3-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][3-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][3-1]
            - 
            a[1-1][5-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][3-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][3-1]
            + a[1-1][5-1]*
            a[2-1][1-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][3-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][3-1]
            - a[1-1][4-1]*a[2-1][1-1]*
            a[3-1][5-1]*a[4-1][2-1]*a[5-1][3-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][3-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][1-1]*
            a[4-1][4-1]*a[5-1][3-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][3-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][4-1]*
            a[5-1][3-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][3-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][3-1]
            - 
            a[1-1][1-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][3-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][3-1]
            + a[1-1][2-1]*
            a[2-1][4-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][3-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][3-1]
            - a[1-1][1-1]*a[2-1][4-1]*
            a[3-1][2-1]*a[4-1][5-1]*a[5-1][3-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][3-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][4-1]*
            a[4-1][5-1]*a[5-1][3-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][4-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][1-1]*
            a[5-1][4-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][4-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][4-1]
            - 
            a[1-1][3-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][4-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][4-1]
            + a[1-1][5-1]*
            a[2-1][3-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][4-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][4-1]
            - a[1-1][5-1]*a[2-1][1-1]*
            a[3-1][3-1]*a[4-1][2-1]*a[5-1][4-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][4-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][5-1]*
            a[4-1][2-1]*a[5-1][4-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][4-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][3-1]*
            a[5-1][4-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][4-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][4-1]
            - 
            a[1-1][1-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][4-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][4-1]
            + a[1-1][1-1]*
            a[2-1][2-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][4-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][4-1]
            - a[1-1][2-1]*a[2-1][3-1]*
            a[3-1][1-1]*a[4-1][5-1]*a[5-1][4-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][4-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][2-1]*
            a[4-1][5-1]*a[5-1][4-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][4-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][5-1]*
            a[5-1][4-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][5-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][5-1]
            - 
            a[1-1][4-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][5-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][5-1]
            + a[1-1][3-1]*
            a[2-1][2-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][5-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][5-1]
            - a[1-1][4-1]*a[2-1][3-1]*
            a[3-1][1-1]*a[4-1][2-1]*a[5-1][5-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][5-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][3-1]*
            a[4-1][2-1]*a[5-1][5-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][5-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][2-1]*
            a[5-1][5-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][5-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][5-1]
            - 
            a[1-1][2-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][5-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][5-1]
            + a[1-1][1-1]*
            a[2-1][4-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][5-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][5-1]
            - a[1-1][1-1]*a[2-1][2-1]*
            a[3-1][4-1]*a[4-1][3-1]*a[5-1][5-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][5-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][1-1]*
            a[4-1][4-1]*a[5-1][5-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][5-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][4-1]*
            a[5-1][5-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][5-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][5-1]) *
             a[6-1][6-1];

    if (fabs(det) <= eps) {
      *ok_flag__ = -1;
      return 0;
    }
    cofactor[0] = a[2-1][6-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][2-1]
            - a[2-1][5-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][2-1]
            - 
            a[2-1][6-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][2-1]
            + a[2-1][4-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][2-1]
            + a[2-1][5-1]*
            a[3-1][4-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][2-1]
            - a[2-1][4-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][2-1]
            - a[2-1][6-1]*a[3-1][5-1]*
            a[4-1][3-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[2-1][5-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[2-1][6-1]*a[3-1][3-1]*a[4-1][5-1]*
            a[5-1][4-1]*a[6-1][2-1]
            - a[2-1][3-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[2-1][5-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][4-1]*
            a[6-1][2-1]
            + a[2-1][3-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[2-1][6-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][2-1]
            - 
            a[2-1][4-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[2-1][6-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[2-1][3-1]*
            a[3-1][6-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[2-1][4-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[2-1][3-1]*a[3-1][4-1]*
            a[4-1][6-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[2-1][5-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][2-1]
            + a[2-1][4-1]*a[3-1][5-1]*a[4-1][3-1]*
            a[5-1][6-1]*a[6-1][2-1]
            + a[2-1][5-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][2-1]
            - a[2-1][3-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][6-1]*
            a[6-1][2-1]
            - a[2-1][4-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][2-1]
            + a[2-1][3-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][2-1]
            - 
            a[2-1][6-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][3-1]
            + a[2-1][5-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][3-1]
            + a[2-1][6-1]*
            a[3-1][4-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][3-1]
            - a[2-1][4-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][3-1]
            - a[2-1][5-1]*a[3-1][4-1]*
            a[4-1][6-1]*a[5-1][2-1]*a[6-1][3-1]
            + a[2-1][4-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][3-1]
            + a[2-1][6-1]*a[3-1][5-1]*a[4-1][2-1]*
            a[5-1][4-1]*a[6-1][3-1]
            - a[2-1][5-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][3-1]
            - a[2-1][6-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][4-1]*
            a[6-1][3-1]
            + a[2-1][2-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][3-1]
            + a[2-1][5-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][3-1]
            - 
            a[2-1][2-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][3-1]
            - a[2-1][6-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][3-1]
            + a[2-1][4-1]*
            a[3-1][6-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][3-1]
            + a[2-1][6-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[2-1][2-1]*a[3-1][6-1]*
            a[4-1][4-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[2-1][4-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][3-1]
            + a[2-1][2-1]*a[3-1][4-1]*a[4-1][6-1]*
            a[5-1][5-1]*a[6-1][3-1]
            + a[2-1][5-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][3-1]
            - a[2-1][4-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][6-1]*
            a[6-1][3-1]
            - a[2-1][5-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][3-1]
            + a[2-1][2-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][3-1]
            + 
            a[2-1][4-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][3-1]
            - a[2-1][2-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][3-1]
            + a[2-1][6-1]*
            a[3-1][5-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][4-1]
            - a[2-1][5-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][4-1]
            - a[2-1][6-1]*a[3-1][3-1]*
            a[4-1][5-1]*a[5-1][2-1]*a[6-1][4-1]
            + a[2-1][3-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][4-1]
            + a[2-1][5-1]*a[3-1][3-1]*a[4-1][6-1]*
            a[5-1][2-1]*a[6-1][4-1]
            - a[2-1][3-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][4-1]
            - a[2-1][6-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][3-1]*
            a[6-1][4-1]
            + a[2-1][5-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][4-1]
            + a[2-1][6-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][4-1]
            - 
            a[2-1][2-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][4-1]
            - a[2-1][5-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][4-1]
            + a[2-1][2-1]*
            a[3-1][5-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][4-1]
            + a[2-1][6-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[2-1][3-1]*a[3-1][6-1]*
            a[4-1][2-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[2-1][6-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[2-1][2-1]*a[3-1][6-1]*a[4-1][3-1]*
            a[5-1][5-1]*a[6-1][4-1]
            + a[2-1][3-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[2-1][2-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][5-1]*
            a[6-1][4-1]
            - a[2-1][5-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][4-1]
            + a[2-1][3-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][4-1]
            + 
            a[2-1][5-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][4-1]
            - a[2-1][2-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][4-1]
            - a[2-1][3-1]*
            a[3-1][2-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][4-1]
            + a[2-1][2-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][4-1]
            - a[2-1][6-1]*a[3-1][4-1]*
            a[4-1][3-1]*a[5-1][2-1]*a[6-1][5-1]
            + a[2-1][4-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][5-1]
            + a[2-1][6-1]*a[3-1][3-1]*a[4-1][4-1]*
            a[5-1][2-1]*a[6-1][5-1]
            - a[2-1][3-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][5-1]
            - a[2-1][4-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][2-1]*
            a[6-1][5-1]
            + a[2-1][3-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][5-1]
            + a[2-1][6-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][5-1]
            - 
            a[2-1][4-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][5-1]
            - a[2-1][6-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][5-1]
            + a[2-1][2-1]*
            a[3-1][6-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][5-1]
            + a[2-1][4-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][5-1]
            - a[2-1][2-1]*a[3-1][4-1]*
            a[4-1][6-1]*a[5-1][3-1]*a[6-1][5-1]
            - a[2-1][6-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][5-1]
            + a[2-1][3-1]*a[3-1][6-1]*a[4-1][2-1]*
            a[5-1][4-1]*a[6-1][5-1]
            + a[2-1][6-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][5-1]
            - a[2-1][2-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][4-1]*
            a[6-1][5-1]
            - a[2-1][3-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][5-1]
            + a[2-1][2-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][5-1]
            + 
            a[2-1][4-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[2-1][3-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[2-1][4-1]*
            a[3-1][2-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[2-1][2-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[2-1][3-1]*a[3-1][2-1]*
            a[4-1][4-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[2-1][2-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[2-1][5-1]*a[3-1][4-1]*a[4-1][3-1]*
            a[5-1][2-1]*a[6-1][6-1]
            - a[2-1][4-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[2-1][5-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][2-1]*
            a[6-1][6-1]
            + a[2-1][3-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[2-1][4-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][6-1]
            - 
            a[2-1][3-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[2-1][5-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][6-1]
            + a[2-1][4-1]*
            a[3-1][5-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][6-1]
            + a[2-1][5-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[2-1][2-1]*a[3-1][5-1]*
            a[4-1][4-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[2-1][4-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][6-1]
            + a[2-1][2-1]*a[3-1][4-1]*a[4-1][5-1]*
            a[5-1][3-1]*a[6-1][6-1]
            + a[2-1][5-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][6-1]
            - a[2-1][3-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][4-1]*
            a[6-1][6-1]
            - a[2-1][5-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][6-1]
            + a[2-1][2-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][6-1]
            + 
            a[2-1][3-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][6-1]
            - a[2-1][2-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][6-1]
            - a[2-1][4-1]*
            a[3-1][3-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][6-1]
            + a[2-1][3-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][6-1]
            + a[2-1][4-1]*a[3-1][2-1]*
            a[4-1][3-1]*a[5-1][5-1]*a[6-1][6-1]
            - a[2-1][2-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][6-1]
            - a[2-1][3-1]*a[3-1][2-1]*a[4-1][4-1]*
            a[5-1][5-1]*a[6-1][6-1]
            + a[2-1][2-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][6-1];
    cofactor[1] = -a[1-1][6-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][2-1] 
            + a[1-1][6-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][2-1]
            - a[1-1][4-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[1-1][3-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[1-1][3-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][2-1] 
            + a[1-1][4-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[1-1][3-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[1-1][4-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[1-1][3-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][2-1]
            - a[1-1][4-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][2-1]
            + a[1-1][3-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][2-1]
            - a[1-1][3-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][2-1] 
            + a[1-1][6-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][3-1]
            - a[1-1][5-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][3-1]
            + a[1-1][4-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][3-1]
            - a[1-1][4-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][3-1]
            + a[1-1][6-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][3-1]
            - a[1-1][5-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][3-1] 
            + a[1-1][2-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][3-1]
            + a[1-1][6-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[1-1][4-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][3-1]
            + a[1-1][4-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[1-1][5-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][3-1]
            + a[1-1][4-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][3-1] 
            - a[1-1][4-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][4-1]
            + a[1-1][5-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][4-1]
            - a[1-1][3-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][4-1]
            - a[1-1][5-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][4-1]
            + a[1-1][3-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][4-1]
            - a[1-1][5-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][4-1] 
            + a[1-1][2-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][4-1]
            + a[1-1][5-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[1-1][3-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[1-1][3-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[1-1][5-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][4-1]
            - a[1-1][3-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][4-1] 
            - a[1-1][5-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][4-1]
            + a[1-1][3-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][5-1]
            - a[1-1][4-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][5-1]
            - a[1-1][6-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][5-1]
            + a[1-1][3-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][5-1]
            + a[1-1][4-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][5-1]
            - a[1-1][3-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][5-1]
            - a[1-1][6-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][5-1] 
            + a[1-1][4-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][5-1]
            + a[1-1][6-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][5-1]
            - a[1-1][4-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][5-1]
            + a[1-1][2-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][5-1]
            + a[1-1][6-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][5-1]
            - a[1-1][3-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][5-1]
            - a[1-1][6-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][5-1]
            + a[1-1][2-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][5-1]
            + a[1-1][3-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][5-1] 
            - a[1-1][4-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[1-1][3-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[1-1][4-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[1-1][3-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[1-1][2-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[1-1][5-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[1-1][4-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[1-1][5-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[1-1][3-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[1-1][4-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][6-1] 
            + a[1-1][3-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[1-1][5-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[1-1][4-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[1-1][5-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][6-1]
            + a[1-1][2-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][6-1]
            + a[1-1][4-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[1-1][2-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[1-1][5-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][6-1]
            + a[1-1][3-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][6-1]
            + a[1-1][5-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][6-1]
            - a[1-1][2-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][6-1] 
            - a[1-1][3-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][6-1]
            + a[1-1][2-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][6-1]
            + a[1-1][4-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][6-1]
            - a[1-1][3-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][6-1]
            - a[1-1][4-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][6-1]
            + a[1-1][2-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][6-1]
            + a[1-1][3-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][6-1]
            - a[1-1][2-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][6-1];
    cofactor[2] = a[1-1][6-1]*a[2-1][5-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][2-1]
            - 
            a[1-1][6-1]*a[2-1][4-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][2-1]
            + a[1-1][5-1]*
            a[2-1][4-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][2-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[2-1][5-1]*
            a[4-1][3-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[4-1][5-1]*
            a[5-1][4-1]*a[6-1][2-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[4-1][6-1]*a[5-1][4-1]*
            a[6-1][2-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][2-1]
            - 
            a[1-1][4-1]*a[2-1][6-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[1-1][3-1]*
            a[2-1][6-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[1-1][3-1]*a[2-1][4-1]*
            a[4-1][6-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[4-1][3-1]*
            a[5-1][6-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][2-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[4-1][4-1]*a[5-1][6-1]*
            a[6-1][2-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][2-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][2-1]
            - 
            a[1-1][6-1]*a[2-1][5-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][3-1]
            + a[1-1][6-1]*
            a[2-1][4-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][3-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][3-1]
            - a[1-1][5-1]*a[2-1][4-1]*
            a[4-1][6-1]*a[5-1][2-1]*a[6-1][3-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][3-1]
            + a[1-1][6-1]*a[2-1][5-1]*a[4-1][2-1]*
            a[5-1][4-1]*a[6-1][3-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[4-1][5-1]*a[5-1][4-1]*
            a[6-1][3-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][3-1]
            - 
            a[1-1][2-1]*a[2-1][5-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][3-1]
            + a[1-1][4-1]*
            a[2-1][6-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][3-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[2-1][6-1]*
            a[4-1][4-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[4-1][6-1]*
            a[5-1][5-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][3-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[4-1][2-1]*a[5-1][6-1]*
            a[6-1][3-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][3-1]
            + 
            a[1-1][4-1]*a[2-1][2-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][3-1]
            + a[1-1][6-1]*
            a[2-1][5-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][4-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[2-1][3-1]*
            a[4-1][5-1]*a[5-1][2-1]*a[6-1][4-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][4-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[4-1][6-1]*
            a[5-1][2-1]*a[6-1][4-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[2-1][5-1]*a[4-1][2-1]*a[5-1][3-1]*
            a[6-1][4-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][4-1]
            - 
            a[1-1][2-1]*a[2-1][6-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][4-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][4-1]
            + a[1-1][2-1]*
            a[2-1][5-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[1-1][3-1]*a[2-1][6-1]*
            a[4-1][2-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[4-1][3-1]*
            a[5-1][5-1]*a[6-1][4-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[4-1][6-1]*a[5-1][5-1]*
            a[6-1][4-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][4-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][4-1]
            + 
            a[1-1][5-1]*a[2-1][2-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][4-1]
            - a[1-1][3-1]*
            a[2-1][2-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[2-1][4-1]*
            a[4-1][3-1]*a[5-1][2-1]*a[6-1][5-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][5-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[4-1][4-1]*
            a[5-1][2-1]*a[6-1][5-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][5-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[4-1][6-1]*a[5-1][2-1]*
            a[6-1][5-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][5-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][5-1]
            - 
            a[1-1][4-1]*a[2-1][6-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][5-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][5-1]
            + a[1-1][2-1]*
            a[2-1][6-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][5-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[2-1][4-1]*
            a[4-1][6-1]*a[5-1][3-1]*a[6-1][5-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][5-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[4-1][2-1]*
            a[5-1][4-1]*a[6-1][5-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[4-1][3-1]*a[5-1][4-1]*
            a[6-1][5-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][5-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][5-1]
            + 
            a[1-1][4-1]*a[2-1][3-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[1-1][4-1]*
            a[2-1][2-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[1-1][3-1]*a[2-1][2-1]*
            a[4-1][4-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[4-1][3-1]*
            a[5-1][2-1]*a[6-1][6-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[4-1][4-1]*a[5-1][2-1]*
            a[6-1][6-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][6-1]
            - 
            a[1-1][3-1]*a[2-1][4-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][6-1]
            + a[1-1][4-1]*
            a[2-1][5-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][6-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[1-1][2-1]*a[2-1][5-1]*
            a[4-1][4-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][6-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[4-1][5-1]*
            a[5-1][3-1]*a[6-1][6-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][6-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[4-1][2-1]*a[5-1][4-1]*
            a[6-1][6-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][6-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][6-1]
            + 
            a[1-1][3-1]*a[2-1][2-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][6-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][6-1]
            - a[1-1][4-1]*
            a[2-1][3-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][6-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][6-1]
            + a[1-1][4-1]*a[2-1][2-1]*
            a[4-1][3-1]*a[5-1][5-1]*a[6-1][6-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][6-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[4-1][4-1]*
            a[5-1][5-1]*a[6-1][6-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][6-1];
    cofactor[3] = -a[1-1][6-1]*a[2-1][5-1]*a[3-1][4-1]*a[5-1][3-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][4-1]*a[5-1][3-1]*a[6-1][2-1] 
            + a[1-1][6-1]*a[2-1][4-1]*a[3-1][5-1]*a[5-1][3-1]*a[6-1][2-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[3-1][5-1]*a[5-1][3-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][6-1]*a[5-1][3-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][6-1]*a[5-1][3-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[2-1][5-1]*a[3-1][3-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][3-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][5-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][5-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][6-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][6-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[3-1][3-1]*a[5-1][5-1]*a[6-1][2-1] 
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][3-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][4-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][4-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][6-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][6-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[3-1][3-1]*a[5-1][6-1]*a[6-1][2-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][3-1]*a[5-1][6-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][4-1]*a[5-1][6-1]*a[6-1][2-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][4-1]*a[5-1][6-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][5-1]*a[5-1][6-1]*a[6-1][2-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[3-1][5-1]*a[5-1][6-1]*a[6-1][2-1] 
            + a[1-1][6-1]*a[2-1][5-1]*a[3-1][4-1]*a[5-1][2-1]*a[6-1][3-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][4-1]*a[5-1][2-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[3-1][5-1]*a[5-1][2-1]*a[6-1][3-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][5-1]*a[5-1][2-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[3-1][6-1]*a[5-1][2-1]*a[6-1][3-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][6-1]*a[5-1][2-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[2-1][5-1]*a[3-1][2-1]*a[5-1][4-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][2-1]*a[5-1][4-1]*a[6-1][3-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][5-1]*a[5-1][4-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][5-1]*a[5-1][4-1]*a[6-1][3-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][6-1]*a[5-1][4-1]*a[6-1][3-1] 
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][6-1]*a[5-1][4-1]*a[6-1][3-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[3-1][2-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[3-1][2-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][4-1]*a[5-1][5-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][4-1]*a[5-1][5-1]*a[6-1][3-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][6-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][6-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][2-1]*a[5-1][6-1]*a[6-1][3-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][2-1]*a[5-1][6-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][4-1]*a[5-1][6-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][4-1]*a[5-1][6-1]*a[6-1][3-1] 
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][5-1]*a[5-1][6-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][5-1]*a[5-1][6-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[2-1][5-1]*a[3-1][3-1]*a[5-1][2-1]*a[6-1][4-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][3-1]*a[5-1][2-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][5-1]*a[5-1][2-1]*a[6-1][4-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][5-1]*a[5-1][2-1]*a[6-1][4-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][6-1]*a[5-1][2-1]*a[6-1][4-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][6-1]*a[5-1][2-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[2-1][5-1]*a[3-1][2-1]*a[5-1][3-1]*a[6-1][4-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][2-1]*a[5-1][3-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][5-1]*a[5-1][3-1]*a[6-1][4-1] 
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][5-1]*a[5-1][3-1]*a[6-1][4-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][6-1]*a[5-1][3-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][6-1]*a[5-1][3-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][2-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][2-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][3-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][3-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][6-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][6-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][2-1]*a[5-1][6-1]*a[6-1][4-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][2-1]*a[5-1][6-1]*a[6-1][4-1] 
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][3-1]*a[5-1][6-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][3-1]*a[5-1][6-1]*a[6-1][4-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][5-1]*a[5-1][6-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][5-1]*a[5-1][6-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[3-1][3-1]*a[5-1][2-1]*a[6-1][5-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[3-1][3-1]*a[5-1][2-1]*a[6-1][5-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][4-1]*a[5-1][2-1]*a[6-1][5-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][4-1]*a[5-1][2-1]*a[6-1][5-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][6-1]*a[5-1][2-1]*a[6-1][5-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[3-1][6-1]*a[5-1][2-1]*a[6-1][5-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[3-1][2-1]*a[5-1][3-1]*a[6-1][5-1] 
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][2-1]*a[5-1][3-1]*a[6-1][5-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][4-1]*a[5-1][3-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][4-1]*a[5-1][3-1]*a[6-1][5-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][6-1]*a[5-1][3-1]*a[6-1][5-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][6-1]*a[5-1][3-1]*a[6-1][5-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][2-1]*a[5-1][4-1]*a[6-1][5-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][2-1]*a[5-1][4-1]*a[6-1][5-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][3-1]*a[5-1][4-1]*a[6-1][5-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][3-1]*a[5-1][4-1]*a[6-1][5-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][6-1]*a[5-1][4-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][6-1]*a[5-1][4-1]*a[6-1][5-1] 
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][2-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][2-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][3-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][3-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][4-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][4-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][3-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][3-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][4-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][4-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][5-1]*a[5-1][2-1]*a[6-1][6-1] 
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][5-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[3-1][2-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][2-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][4-1]*a[5-1][3-1]*a[6-1][6-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][4-1]*a[5-1][3-1]*a[6-1][6-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][5-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][5-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][2-1]*a[5-1][4-1]*a[6-1][6-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][2-1]*a[5-1][4-1]*a[6-1][6-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][3-1]*a[5-1][4-1]*a[6-1][6-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][3-1]*a[5-1][4-1]*a[6-1][6-1] 
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][5-1]*a[5-1][4-1]*a[6-1][6-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][5-1]*a[5-1][4-1]*a[6-1][6-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][2-1]*a[5-1][5-1]*a[6-1][6-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[3-1][2-1]*a[5-1][5-1]*a[6-1][6-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][3-1]*a[5-1][5-1]*a[6-1][6-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][3-1]*a[5-1][5-1]*a[6-1][6-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][4-1]*a[5-1][5-1]*a[6-1][6-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][4-1]*a[5-1][5-1]*a[6-1][6-1];
    cofactor[4] = a[1-1][6-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][3-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][3-1]*a[6-1][2-1]
            - 
            a[1-1][6-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][3-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][3-1]*a[6-1][2-1]
            + a[1-1][5-1]*
            a[2-1][4-1]*a[3-1][6-1]*a[4-1][3-1]*a[6-1][2-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][3-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[2-1][5-1]*
            a[3-1][3-1]*a[4-1][4-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][4-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][5-1]*
            a[4-1][4-1]*a[6-1][2-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][4-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][4-1]*
            a[6-1][2-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][4-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][5-1]*a[6-1][2-1]
            - 
            a[1-1][4-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][5-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][5-1]*a[6-1][2-1]
            + a[1-1][3-1]*
            a[2-1][6-1]*a[3-1][4-1]*a[4-1][5-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][5-1]*a[6-1][2-1]
            - a[1-1][3-1]*a[2-1][4-1]*
            a[3-1][6-1]*a[4-1][5-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][6-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][3-1]*
            a[4-1][6-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][6-1]*a[6-1][2-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][6-1]*
            a[6-1][2-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][6-1]*a[6-1][2-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][6-1]*a[6-1][2-1]
            - 
            a[1-1][6-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][2-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][2-1]*a[6-1][3-1]
            + a[1-1][6-1]*
            a[2-1][4-1]*a[3-1][5-1]*a[4-1][2-1]*a[6-1][3-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][2-1]*a[6-1][3-1]
            - a[1-1][5-1]*a[2-1][4-1]*
            a[3-1][6-1]*a[4-1][2-1]*a[6-1][3-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][2-1]*a[6-1][3-1]
            + a[1-1][6-1]*a[2-1][5-1]*a[3-1][2-1]*
            a[4-1][4-1]*a[6-1][3-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][4-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][4-1]*
            a[6-1][3-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][4-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][4-1]*a[6-1][3-1]
            - 
            a[1-1][2-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][4-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][5-1]*a[6-1][3-1]
            + a[1-1][4-1]*
            a[2-1][6-1]*a[3-1][2-1]*a[4-1][5-1]*a[6-1][3-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][5-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[2-1][6-1]*
            a[3-1][4-1]*a[4-1][5-1]*a[6-1][3-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][5-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][6-1]*
            a[4-1][5-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][6-1]*a[6-1][3-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][6-1]*
            a[6-1][3-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][6-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][6-1]*a[6-1][3-1]
            + 
            a[1-1][4-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][6-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][6-1]*a[6-1][3-1]
            + a[1-1][6-1]*
            a[2-1][5-1]*a[3-1][3-1]*a[4-1][2-1]*a[6-1][4-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][2-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[2-1][3-1]*
            a[3-1][5-1]*a[4-1][2-1]*a[6-1][4-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][2-1]*a[6-1][4-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][6-1]*
            a[4-1][2-1]*a[6-1][4-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][2-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][3-1]*
            a[6-1][4-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][3-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][3-1]*a[6-1][4-1]
            - 
            a[1-1][2-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][3-1]*a[6-1][4-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][3-1]*a[6-1][4-1]
            + a[1-1][2-1]*
            a[2-1][5-1]*a[3-1][6-1]*a[4-1][3-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][5-1]*a[6-1][4-1]
            - a[1-1][3-1]*a[2-1][6-1]*
            a[3-1][2-1]*a[4-1][5-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][5-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][3-1]*
            a[4-1][5-1]*a[6-1][4-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][5-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][5-1]*
            a[6-1][4-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][6-1]*a[6-1][4-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][6-1]*a[6-1][4-1]
            + 
            a[1-1][5-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][6-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][6-1]*a[6-1][4-1]
            - a[1-1][3-1]*
            a[2-1][2-1]*a[3-1][5-1]*a[4-1][6-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][6-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[2-1][4-1]*
            a[3-1][3-1]*a[4-1][2-1]*a[6-1][5-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][2-1]*a[6-1][5-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][4-1]*
            a[4-1][2-1]*a[6-1][5-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][2-1]*a[6-1][5-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][2-1]*
            a[6-1][5-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][2-1]*a[6-1][5-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][3-1]*a[6-1][5-1]
            - 
            a[1-1][4-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][3-1]*a[6-1][5-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][3-1]*a[6-1][5-1]
            + a[1-1][2-1]*
            a[2-1][6-1]*a[3-1][4-1]*a[4-1][3-1]*a[6-1][5-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][3-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[2-1][4-1]*
            a[3-1][6-1]*a[4-1][3-1]*a[6-1][5-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][4-1]*a[6-1][5-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][2-1]*
            a[4-1][4-1]*a[6-1][5-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][4-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][4-1]*
            a[6-1][5-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][4-1]*a[6-1][5-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][4-1]*a[6-1][5-1]
            + 
            a[1-1][4-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][6-1]*a[6-1][5-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][6-1]*a[6-1][5-1]
            - a[1-1][4-1]*
            a[2-1][2-1]*a[3-1][3-1]*a[4-1][6-1]*a[6-1][5-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][6-1]*a[6-1][5-1]
            + a[1-1][3-1]*a[2-1][2-1]*
            a[3-1][4-1]*a[4-1][6-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][6-1]*a[6-1][5-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[3-1][3-1]*
            a[4-1][2-1]*a[6-1][6-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][2-1]*a[6-1][6-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][2-1]*
            a[6-1][6-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][2-1]*a[6-1][6-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][2-1]*a[6-1][6-1]
            - 
            a[1-1][3-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][2-1]*a[6-1][6-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][3-1]*a[6-1][6-1]
            + a[1-1][4-1]*
            a[2-1][5-1]*a[3-1][2-1]*a[4-1][3-1]*a[6-1][6-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][3-1]*a[6-1][6-1]
            - a[1-1][2-1]*a[2-1][5-1]*
            a[3-1][4-1]*a[4-1][3-1]*a[6-1][6-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][3-1]*a[6-1][6-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][5-1]*
            a[4-1][3-1]*a[6-1][6-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][4-1]*a[6-1][6-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][4-1]*
            a[6-1][6-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][4-1]*a[6-1][6-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][4-1]*a[6-1][6-1]
            + 
            a[1-1][3-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][4-1]*a[6-1][6-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][4-1]*a[6-1][6-1]
            - a[1-1][4-1]*
            a[2-1][3-1]*a[3-1][2-1]*a[4-1][5-1]*a[6-1][6-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][5-1]*a[6-1][6-1]
            + a[1-1][4-1]*a[2-1][2-1]*
            a[3-1][3-1]*a[4-1][5-1]*a[6-1][6-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][5-1]*a[6-1][6-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][4-1]*
            a[4-1][5-1]*a[6-1][6-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][5-1]*a[6-1][6-1];
    cofactor[5] = -a[1-1][6-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][2-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][2-1] 
            + a[1-1][6-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][2-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][2-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][2-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][2-1]
            + a[1-1][6-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][2-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][2-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][2-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][2-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][2-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][2-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][2-1] 
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][2-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][2-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][2-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][2-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][2-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][2-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][2-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][2-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][2-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][2-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][2-1] 
            + a[1-1][6-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][3-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][3-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][3-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][3-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][3-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][3-1]
            - a[1-1][6-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][3-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][3-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][3-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][3-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][3-1] 
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][3-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][3-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][3-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][3-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][3-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][3-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][3-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][3-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][3-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][3-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][3-1] 
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][3-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][3-1]
            - a[1-1][6-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][4-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][4-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][4-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][4-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][4-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][4-1]
            + a[1-1][6-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][4-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][4-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][4-1] 
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][4-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][4-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][4-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][4-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][4-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][4-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][4-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][4-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][4-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][4-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][4-1] 
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][4-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][4-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][4-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][4-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][5-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][5-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][5-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][5-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][5-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][5-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][5-1] 
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][5-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][5-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][5-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][5-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][5-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][5-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][5-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][5-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][5-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][5-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][5-1] 
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][5-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][5-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][5-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][5-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][5-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][5-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][6-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][6-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][6-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][6-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][6-1] 
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][6-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][6-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][6-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][6-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][6-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][6-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][6-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][6-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][6-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][6-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][6-1] 
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][6-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][6-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][6-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][6-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][6-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][6-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][6-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][6-1];
    cofactor[6] = -a[2-1][6-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[2-1][5-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][1-1] 
            + a[2-1][6-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[2-1][4-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[2-1][5-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[2-1][4-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[2-1][6-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][1-1]
            - a[2-1][5-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][1-1]
            - a[2-1][6-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][1-1]
            + a[2-1][3-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][1-1]
            + a[2-1][5-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][1-1]
            - a[2-1][3-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][1-1]
            - a[2-1][6-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][1-1] 
            + a[2-1][4-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][1-1]
            + a[2-1][6-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][1-1]
            - a[2-1][3-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][1-1]
            - a[2-1][4-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][1-1]
            + a[2-1][3-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][1-1]
            + a[2-1][5-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][1-1]
            - a[2-1][4-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][1-1]
            - a[2-1][5-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][1-1]
            + a[2-1][3-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][1-1]
            + a[2-1][4-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][1-1]
            - a[2-1][3-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][1-1] 
            + a[2-1][6-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[2-1][5-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[2-1][6-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[2-1][4-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[2-1][5-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[2-1][4-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[2-1][6-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][3-1]
            + a[2-1][5-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][3-1]
            + a[2-1][6-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][3-1]
            - a[2-1][1-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][3-1]
            - a[2-1][5-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][3-1] 
            + a[2-1][1-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][3-1]
            + a[2-1][6-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[2-1][4-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[2-1][6-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][3-1]
            + a[2-1][1-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][3-1]
            + a[2-1][4-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[2-1][1-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[2-1][5-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][3-1]
            + a[2-1][4-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][3-1]
            + a[2-1][5-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][3-1]
            - a[2-1][1-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][3-1] 
            - a[2-1][4-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][3-1]
            + a[2-1][1-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][3-1]
            - a[2-1][6-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[2-1][5-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[2-1][6-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[2-1][3-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[2-1][5-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[2-1][3-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[2-1][6-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][4-1]
            - a[2-1][5-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][4-1]
            - a[2-1][6-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][4-1] 
            + a[2-1][1-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][4-1]
            + a[2-1][5-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][4-1]
            - a[2-1][1-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][4-1]
            - a[2-1][6-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[2-1][3-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[2-1][6-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[2-1][1-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[2-1][3-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[2-1][1-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[2-1][5-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][4-1]
            - a[2-1][3-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][4-1] 
            - a[2-1][5-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][4-1]
            + a[2-1][1-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][4-1]
            + a[2-1][3-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][4-1]
            - a[2-1][1-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][4-1]
            + a[2-1][6-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[2-1][4-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[2-1][6-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[2-1][3-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[2-1][4-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[2-1][3-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[2-1][6-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][5-1] 
            + a[2-1][4-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][5-1]
            + a[2-1][6-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][5-1]
            - a[2-1][1-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][5-1]
            - a[2-1][4-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][5-1]
            + a[2-1][1-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][5-1]
            + a[2-1][6-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][5-1]
            - a[2-1][3-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][5-1]
            - a[2-1][6-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][5-1]
            + a[2-1][1-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][5-1]
            + a[2-1][3-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][5-1]
            - a[2-1][1-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][5-1] 
            - a[2-1][4-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[2-1][3-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[2-1][4-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[2-1][1-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[2-1][3-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[2-1][1-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[2-1][5-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][6-1]
            + a[2-1][4-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][6-1]
            + a[2-1][5-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][6-1]
            - a[2-1][3-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][6-1]
            - a[2-1][4-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][6-1] 
            + a[2-1][3-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][6-1]
            + a[2-1][5-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[2-1][4-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[2-1][5-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][6-1]
            + a[2-1][1-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][6-1]
            + a[2-1][4-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[2-1][1-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[2-1][5-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][6-1]
            + a[2-1][3-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][6-1]
            + a[2-1][5-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][6-1]
            - a[2-1][1-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][6-1] 
            - a[2-1][3-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][6-1]
            + a[2-1][1-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][6-1]
            + a[2-1][4-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][6-1]
            - a[2-1][3-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][6-1]
            - a[2-1][4-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][6-1]
            + a[2-1][1-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][6-1]
            + a[2-1][3-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][6-1]
            - a[2-1][1-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][6-1];
    cofactor[7] = a[1-1][6-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][1-1]
            - 
            a[1-1][6-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[1-1][5-1]*
            a[3-1][4-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[1-1][4-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[1-1][6-1]*a[3-1][5-1]*
            a[4-1][3-1]*a[5-1][4-1]*a[6-1][1-1]
            + a[1-1][5-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][1-1]
            + a[1-1][6-1]*a[3-1][3-1]*a[4-1][5-1]*
            a[5-1][4-1]*a[6-1][1-1]
            - a[1-1][3-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][4-1]*
            a[6-1][1-1]
            + a[1-1][3-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][1-1]
            + a[1-1][6-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][1-1]
            - 
            a[1-1][4-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][1-1]
            - a[1-1][6-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][1-1]
            + a[1-1][3-1]*
            a[3-1][6-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][1-1]
            - a[1-1][3-1]*a[3-1][4-1]*
            a[4-1][6-1]*a[5-1][5-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[3-1][5-1]*a[4-1][3-1]*
            a[5-1][6-1]*a[6-1][1-1]
            + a[1-1][5-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][1-1]
            - a[1-1][3-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][6-1]*
            a[6-1][1-1]
            - a[1-1][4-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][1-1]
            + a[1-1][3-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][1-1]
            - 
            a[1-1][6-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[1-1][6-1]*
            a[3-1][4-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[1-1][4-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[1-1][5-1]*a[3-1][4-1]*
            a[4-1][6-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[1-1][4-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[1-1][6-1]*a[3-1][5-1]*a[4-1][1-1]*
            a[5-1][4-1]*a[6-1][3-1]
            - a[1-1][5-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][4-1]*
            a[6-1][3-1]
            + a[1-1][1-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][3-1]
            - 
            a[1-1][1-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][3-1]
            + a[1-1][4-1]*
            a[3-1][6-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][3-1]
            + a[1-1][6-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[1-1][1-1]*a[3-1][6-1]*
            a[4-1][4-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[1-1][4-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][3-1]
            + a[1-1][1-1]*a[3-1][4-1]*a[4-1][6-1]*
            a[5-1][5-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][3-1]
            - a[1-1][4-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][6-1]*
            a[6-1][3-1]
            - a[1-1][5-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][3-1]
            + a[1-1][1-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][3-1]
            + 
            a[1-1][4-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][3-1]
            - a[1-1][1-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][3-1]
            + a[1-1][6-1]*
            a[3-1][5-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[1-1][5-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[3-1][3-1]*
            a[4-1][5-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[1-1][3-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[1-1][5-1]*a[3-1][3-1]*a[4-1][6-1]*
            a[5-1][1-1]*a[6-1][4-1]
            - a[1-1][3-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][3-1]*
            a[6-1][4-1]
            + a[1-1][5-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][4-1]
            - 
            a[1-1][1-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][4-1]
            - a[1-1][5-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][4-1]
            + a[1-1][1-1]*
            a[3-1][5-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[1-1][3-1]*a[3-1][6-1]*
            a[4-1][1-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[1-1][1-1]*a[3-1][6-1]*a[4-1][3-1]*
            a[5-1][5-1]*a[6-1][4-1]
            + a[1-1][3-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][5-1]*
            a[6-1][4-1]
            - a[1-1][5-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][4-1]
            + a[1-1][3-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][4-1]
            + 
            a[1-1][5-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][4-1]
            - a[1-1][3-1]*
            a[3-1][1-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][4-1]
            + a[1-1][1-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[3-1][4-1]*
            a[4-1][3-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[1-1][4-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[1-1][6-1]*a[3-1][3-1]*a[4-1][4-1]*
            a[5-1][1-1]*a[6-1][5-1]
            - a[1-1][3-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[1-1][4-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][1-1]*
            a[6-1][5-1]
            + a[1-1][3-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[1-1][6-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][5-1]
            - 
            a[1-1][4-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][5-1]
            - a[1-1][6-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][5-1]
            + a[1-1][1-1]*
            a[3-1][6-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][5-1]
            + a[1-1][4-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[3-1][4-1]*
            a[4-1][6-1]*a[5-1][3-1]*a[6-1][5-1]
            - a[1-1][6-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][5-1]
            + a[1-1][3-1]*a[3-1][6-1]*a[4-1][1-1]*
            a[5-1][4-1]*a[6-1][5-1]
            + a[1-1][6-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][4-1]*
            a[6-1][5-1]
            - a[1-1][3-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][5-1]
            + 
            a[1-1][4-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[1-1][3-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[1-1][4-1]*
            a[3-1][1-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[1-1][3-1]*a[3-1][1-1]*
            a[4-1][4-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[1-1][5-1]*a[3-1][4-1]*a[4-1][3-1]*
            a[5-1][1-1]*a[6-1][6-1]
            - a[1-1][4-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][6-1]
            - a[1-1][5-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][1-1]*
            a[6-1][6-1]
            + a[1-1][3-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][6-1]
            + a[1-1][4-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][6-1]
            - 
            a[1-1][3-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][6-1]
            - a[1-1][5-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][6-1]
            + a[1-1][4-1]*
            a[3-1][5-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][6-1]
            + a[1-1][5-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[3-1][5-1]*
            a[4-1][4-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[1-1][4-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[3-1][4-1]*a[4-1][5-1]*
            a[5-1][3-1]*a[6-1][6-1]
            + a[1-1][5-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][6-1]
            - a[1-1][3-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][4-1]*
            a[6-1][6-1]
            - a[1-1][5-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][6-1]
            + 
            a[1-1][3-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][6-1]
            - a[1-1][4-1]*
            a[3-1][3-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][6-1]
            + a[1-1][3-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][6-1]
            + a[1-1][4-1]*a[3-1][1-1]*
            a[4-1][3-1]*a[5-1][5-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][6-1]
            - a[1-1][3-1]*a[3-1][1-1]*a[4-1][4-1]*
            a[5-1][5-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][6-1];
    cofactor[8] = -a[1-1][6-1]*a[2-1][5-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][1-1] 
            + a[1-1][6-1]*a[2-1][4-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[1-1][6-1]*a[2-1][5-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][1-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][1-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][1-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][1-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][1-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][1-1] 
            + a[1-1][4-1]*a[2-1][6-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][1-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][1-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][1-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][1-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][1-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][1-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][1-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][1-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][1-1] 
            + a[1-1][6-1]*a[2-1][5-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[2-1][5-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][3-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][3-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][3-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][3-1] 
            + a[1-1][1-1]*a[2-1][5-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][3-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][3-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][3-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][3-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][3-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][3-1] 
            - a[1-1][4-1]*a[2-1][1-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][3-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[2-1][5-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[2-1][5-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][4-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][4-1] 
            + a[1-1][1-1]*a[2-1][6-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][4-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][4-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][4-1] 
            - a[1-1][5-1]*a[2-1][1-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][4-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][4-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][5-1] 
            + a[1-1][4-1]*a[2-1][6-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][5-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][5-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][5-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][5-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][5-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][5-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][5-1] 
            - a[1-1][4-1]*a[2-1][3-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][6-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][6-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][6-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][6-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][6-1] 
            + a[1-1][3-1]*a[2-1][4-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][6-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][6-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][6-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][6-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][6-1] 
            - a[1-1][3-1]*a[2-1][1-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][6-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][6-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][6-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][6-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][6-1];
    cofactor[9] = a[1-1][6-1]*a[2-1][5-1]*a[3-1][4-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][4-1]*a[5-1][3-1]*a[6-1][1-1]
            - 
            a[1-1][6-1]*a[2-1][4-1]*a[3-1][5-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][5-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[1-1][5-1]*
            a[2-1][4-1]*a[3-1][6-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][6-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[1-1][6-1]*a[2-1][5-1]*
            a[3-1][3-1]*a[5-1][4-1]*a[6-1][1-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][3-1]*a[5-1][4-1]*a[6-1][1-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][5-1]*
            a[5-1][4-1]*a[6-1][1-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][5-1]*a[5-1][4-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][6-1]*a[5-1][4-1]*
            a[6-1][1-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][6-1]*a[5-1][4-1]*a[6-1][1-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[3-1][3-1]*a[5-1][5-1]*a[6-1][1-1]
            - 
            a[1-1][4-1]*a[2-1][6-1]*a[3-1][3-1]*a[5-1][5-1]*a[6-1][1-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][4-1]*a[5-1][5-1]*a[6-1][1-1]
            + a[1-1][3-1]*
            a[2-1][6-1]*a[3-1][4-1]*a[5-1][5-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][6-1]*a[5-1][5-1]*a[6-1][1-1]
            - a[1-1][3-1]*a[2-1][4-1]*
            a[3-1][6-1]*a[5-1][5-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][3-1]*a[5-1][6-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][3-1]*
            a[5-1][6-1]*a[6-1][1-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][4-1]*a[5-1][6-1]*a[6-1][1-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][4-1]*a[5-1][6-1]*
            a[6-1][1-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][5-1]*a[5-1][6-1]*a[6-1][1-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][5-1]*a[5-1][6-1]*a[6-1][1-1]
            - 
            a[1-1][6-1]*a[2-1][5-1]*a[3-1][4-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][4-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[1-1][6-1]*
            a[2-1][4-1]*a[3-1][5-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[3-1][5-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[1-1][5-1]*a[2-1][4-1]*
            a[3-1][6-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][6-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[1-1][6-1]*a[2-1][5-1]*a[3-1][1-1]*
            a[5-1][4-1]*a[6-1][3-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][1-1]*a[5-1][4-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][5-1]*a[5-1][4-1]*
            a[6-1][3-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][5-1]*a[5-1][4-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][6-1]*a[5-1][4-1]*a[6-1][3-1]
            - 
            a[1-1][1-1]*a[2-1][5-1]*a[3-1][6-1]*a[5-1][4-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[3-1][1-1]*a[5-1][5-1]*a[6-1][3-1]
            + a[1-1][4-1]*
            a[2-1][6-1]*a[3-1][1-1]*a[5-1][5-1]*a[6-1][3-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][4-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[1-1][1-1]*a[2-1][6-1]*
            a[3-1][4-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][6-1]*a[5-1][5-1]*a[6-1][3-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][6-1]*
            a[5-1][5-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[3-1][1-1]*a[5-1][6-1]*a[6-1][3-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][1-1]*a[5-1][6-1]*
            a[6-1][3-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][4-1]*a[5-1][6-1]*a[6-1][3-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][4-1]*a[5-1][6-1]*a[6-1][3-1]
            + 
            a[1-1][4-1]*a[2-1][1-1]*a[3-1][5-1]*a[5-1][6-1]*a[6-1][3-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][5-1]*a[5-1][6-1]*a[6-1][3-1]
            + a[1-1][6-1]*
            a[2-1][5-1]*a[3-1][3-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][3-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[2-1][3-1]*
            a[3-1][5-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][5-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][6-1]*
            a[5-1][1-1]*a[6-1][4-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][6-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[2-1][5-1]*a[3-1][1-1]*a[5-1][3-1]*
            a[6-1][4-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][1-1]*a[5-1][3-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][5-1]*a[5-1][3-1]*a[6-1][4-1]
            - 
            a[1-1][1-1]*a[2-1][6-1]*a[3-1][5-1]*a[5-1][3-1]*a[6-1][4-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][6-1]*a[5-1][3-1]*a[6-1][4-1]
            + a[1-1][1-1]*
            a[2-1][5-1]*a[3-1][6-1]*a[5-1][3-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][1-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[1-1][3-1]*a[2-1][6-1]*
            a[3-1][1-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][3-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][3-1]*
            a[5-1][5-1]*a[6-1][4-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][6-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][6-1]*a[5-1][5-1]*
            a[6-1][4-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][1-1]*a[5-1][6-1]*a[6-1][4-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][1-1]*a[5-1][6-1]*a[6-1][4-1]
            + 
            a[1-1][5-1]*a[2-1][1-1]*a[3-1][3-1]*a[5-1][6-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][3-1]*a[5-1][6-1]*a[6-1][4-1]
            - a[1-1][3-1]*
            a[2-1][1-1]*a[3-1][5-1]*a[5-1][6-1]*a[6-1][4-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][5-1]*a[5-1][6-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[2-1][4-1]*
            a[3-1][3-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][3-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][4-1]*
            a[5-1][1-1]*a[6-1][5-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][4-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][6-1]*a[5-1][1-1]*
            a[6-1][5-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][6-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[3-1][1-1]*a[5-1][3-1]*a[6-1][5-1]
            - 
            a[1-1][4-1]*a[2-1][6-1]*a[3-1][1-1]*a[5-1][3-1]*a[6-1][5-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][4-1]*a[5-1][3-1]*a[6-1][5-1]
            + a[1-1][1-1]*
            a[2-1][6-1]*a[3-1][4-1]*a[5-1][3-1]*a[6-1][5-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][6-1]*a[5-1][3-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[2-1][4-1]*
            a[3-1][6-1]*a[5-1][3-1]*a[6-1][5-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][1-1]*a[5-1][4-1]*a[6-1][5-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][1-1]*
            a[5-1][4-1]*a[6-1][5-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][3-1]*a[5-1][4-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][3-1]*a[5-1][4-1]*
            a[6-1][5-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][6-1]*a[5-1][4-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][6-1]*a[5-1][4-1]*a[6-1][5-1]
            + 
            a[1-1][4-1]*a[2-1][3-1]*a[3-1][1-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[3-1][1-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[1-1][4-1]*
            a[2-1][1-1]*a[3-1][3-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][3-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[1-1][3-1]*a[2-1][1-1]*
            a[3-1][4-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][4-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[3-1][3-1]*
            a[5-1][1-1]*a[6-1][6-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][3-1]*a[5-1][1-1]*a[6-1][6-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][4-1]*a[5-1][1-1]*
            a[6-1][6-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][4-1]*a[5-1][1-1]*a[6-1][6-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][5-1]*a[5-1][1-1]*a[6-1][6-1]
            - 
            a[1-1][3-1]*a[2-1][4-1]*a[3-1][5-1]*a[5-1][1-1]*a[6-1][6-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][1-1]*a[5-1][3-1]*a[6-1][6-1]
            + a[1-1][4-1]*
            a[2-1][5-1]*a[3-1][1-1]*a[5-1][3-1]*a[6-1][6-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][4-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[2-1][5-1]*
            a[3-1][4-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][5-1]*a[5-1][3-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][5-1]*
            a[5-1][3-1]*a[6-1][6-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][1-1]*a[5-1][4-1]*a[6-1][6-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][1-1]*a[5-1][4-1]*
            a[6-1][6-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][3-1]*a[5-1][4-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][3-1]*a[5-1][4-1]*a[6-1][6-1]
            + 
            a[1-1][3-1]*a[2-1][1-1]*a[3-1][5-1]*a[5-1][4-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][5-1]*a[5-1][4-1]*a[6-1][6-1]
            - a[1-1][4-1]*
            a[2-1][3-1]*a[3-1][1-1]*a[5-1][5-1]*a[6-1][6-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][1-1]*a[5-1][5-1]*a[6-1][6-1]
            + a[1-1][4-1]*a[2-1][1-1]*
            a[3-1][3-1]*a[5-1][5-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][3-1]*a[5-1][5-1]*a[6-1][6-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][4-1]*
            a[5-1][5-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][4-1]*a[5-1][5-1]*a[6-1][6-1];
    cofactor[10] = -a[1-1][6-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][3-1]*a[6-1][1-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][3-1]*a[6-1][1-1] 
            + a[1-1][6-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][3-1]*a[6-1][1-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][3-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][3-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][3-1]*a[6-1][1-1]
            + a[1-1][6-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][4-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][4-1]*a[6-1][1-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][4-1]*a[6-1][1-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][4-1]*a[6-1][1-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][4-1]*a[6-1][1-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][4-1]*a[6-1][1-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][5-1]*a[6-1][1-1] 
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][5-1]*a[6-1][1-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][5-1]*a[6-1][1-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][5-1]*a[6-1][1-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][5-1]*a[6-1][1-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][5-1]*a[6-1][1-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][6-1]*a[6-1][1-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][6-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][6-1]*a[6-1][1-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][6-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][6-1]*a[6-1][1-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][6-1]*a[6-1][1-1] 
            + a[1-1][6-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][1-1]*a[6-1][3-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][1-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][1-1]*a[6-1][3-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][1-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][1-1]*a[6-1][3-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][1-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][4-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][4-1]*a[6-1][3-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][4-1]*a[6-1][3-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][4-1]*a[6-1][3-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][4-1]*a[6-1][3-1] 
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][4-1]*a[6-1][3-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][5-1]*a[6-1][3-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][5-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][5-1]*a[6-1][3-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][5-1]*a[6-1][3-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][5-1]*a[6-1][3-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][5-1]*a[6-1][3-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][6-1]*a[6-1][3-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][6-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][6-1]*a[6-1][3-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][6-1]*a[6-1][3-1] 
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][6-1]*a[6-1][3-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][6-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][1-1]*a[6-1][4-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][1-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][1-1]*a[6-1][4-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][1-1]*a[6-1][4-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][1-1]*a[6-1][4-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][1-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][3-1]*a[6-1][4-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][3-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][3-1]*a[6-1][4-1] 
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][3-1]*a[6-1][4-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][3-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][3-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][5-1]*a[6-1][4-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][5-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][5-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][5-1]*a[6-1][4-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][5-1]*a[6-1][4-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][5-1]*a[6-1][4-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][6-1]*a[6-1][4-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][6-1]*a[6-1][4-1] 
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][6-1]*a[6-1][4-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][6-1]*a[6-1][4-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][6-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][6-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][1-1]*a[6-1][5-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][1-1]*a[6-1][5-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][1-1]*a[6-1][5-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][1-1]*a[6-1][5-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][1-1]*a[6-1][5-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][1-1]*a[6-1][5-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][3-1]*a[6-1][5-1] 
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][3-1]*a[6-1][5-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][3-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][3-1]*a[6-1][5-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][3-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][3-1]*a[6-1][5-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][4-1]*a[6-1][5-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][4-1]*a[6-1][5-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][4-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][4-1]*a[6-1][5-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][4-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][4-1]*a[6-1][5-1] 
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][6-1]*a[6-1][5-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][6-1]*a[6-1][5-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][6-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][6-1]*a[6-1][5-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][6-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][6-1]*a[6-1][5-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][1-1]*a[6-1][6-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][1-1]*a[6-1][6-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][1-1]*a[6-1][6-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][1-1]*a[6-1][6-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][1-1]*a[6-1][6-1] 
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][1-1]*a[6-1][6-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][3-1]*a[6-1][6-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][3-1]*a[6-1][6-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][3-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][3-1]*a[6-1][6-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][3-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][3-1]*a[6-1][6-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][4-1]*a[6-1][6-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][4-1]*a[6-1][6-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][4-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][4-1]*a[6-1][6-1] 
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][4-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][4-1]*a[6-1][6-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][5-1]*a[6-1][6-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][5-1]*a[6-1][6-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][5-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][5-1]*a[6-1][6-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][5-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][5-1]*a[6-1][6-1];
    cofactor[11] = a[1-1][6-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][1-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][1-1] 
            - a[1-1][6-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][1-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][1-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][1-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][1-1]
            - a[1-1][6-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][1-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][1-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][1-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][1-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][1-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][1-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][1-1] 
            - a[1-1][4-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][1-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][1-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][1-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][1-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][1-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][1-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][1-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][1-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][1-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][1-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][1-1] 
            - a[1-1][6-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][3-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][3-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][3-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][3-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][3-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][3-1]
            + a[1-1][6-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][3-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][3-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][3-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][3-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][3-1] 
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][3-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][3-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][3-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][3-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][3-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][3-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][3-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][3-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][3-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][3-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][3-1] 
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][3-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][3-1]
            + a[1-1][6-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][4-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][4-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][4-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][4-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][4-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][4-1]
            - a[1-1][6-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][4-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][4-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][4-1] 
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][4-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][4-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][4-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][4-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][4-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][4-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][4-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][4-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][4-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][4-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][4-1] 
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][4-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][4-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][4-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][4-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][5-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][5-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][5-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][5-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][5-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][5-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][5-1] 
            - a[1-1][4-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][5-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][5-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][5-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][5-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][5-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][5-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][5-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][5-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][5-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][5-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][5-1] 
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][5-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][5-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][5-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][5-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][5-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][5-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][6-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][6-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][6-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][6-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][6-1] 
            - a[1-1][3-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][6-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][6-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][6-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][6-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][6-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][6-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][6-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][6-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][6-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][6-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][6-1] 
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][6-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][6-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][6-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][6-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][6-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][6-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][6-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][6-1];
    cofactor[12] = a[2-1][6-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][1-1]
            - a[2-1][5-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][1-1] 
            - a[2-1][6-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][1-1]
            + a[2-1][4-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][1-1]
            + a[2-1][5-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][1-1]
            - a[2-1][4-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][1-1]
            - a[2-1][6-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][1-1]
            + a[2-1][5-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][1-1]
            + a[2-1][6-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][1-1]
            - a[2-1][2-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][1-1]
            - a[2-1][5-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][1-1]
            + a[2-1][2-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][1-1]
            + a[2-1][6-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][1-1] 
            - a[2-1][4-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][1-1]
            - a[2-1][6-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][1-1]
            + a[2-1][2-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][1-1]
            + a[2-1][4-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][1-1]
            - a[2-1][2-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][1-1]
            - a[2-1][5-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][1-1]
            + a[2-1][4-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][1-1]
            + a[2-1][5-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][1-1]
            - a[2-1][2-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][1-1]
            - a[2-1][4-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][1-1]
            + a[2-1][2-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][1-1] 
            - a[2-1][6-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[2-1][5-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[2-1][6-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[2-1][4-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[2-1][5-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[2-1][4-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[2-1][6-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[2-1][5-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[2-1][6-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[2-1][1-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[2-1][5-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][2-1] 
            - a[2-1][1-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[2-1][6-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[2-1][4-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[2-1][6-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[2-1][1-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[2-1][4-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[2-1][1-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[2-1][5-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][2-1]
            - a[2-1][4-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][2-1]
            - a[2-1][5-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][2-1]
            + a[2-1][1-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][2-1] 
            + a[2-1][4-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][2-1]
            - a[2-1][1-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][2-1]
            + a[2-1][6-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[2-1][5-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[2-1][6-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[2-1][2-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[2-1][5-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[2-1][2-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[2-1][6-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][4-1]
            + a[2-1][5-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][4-1]
            + a[2-1][6-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][4-1] 
            - a[2-1][1-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][4-1]
            - a[2-1][5-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][4-1]
            + a[2-1][1-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][4-1]
            + a[2-1][6-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[2-1][2-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[2-1][6-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[2-1][1-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[2-1][2-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[2-1][1-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[2-1][5-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][4-1]
            + a[2-1][2-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][4-1] 
            + a[2-1][5-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][4-1]
            - a[2-1][1-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][4-1]
            - a[2-1][2-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][4-1]
            + a[2-1][1-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][4-1]
            - a[2-1][6-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[2-1][4-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[2-1][6-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[2-1][2-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[2-1][4-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[2-1][2-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[2-1][6-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][5-1] 
            - a[2-1][4-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][5-1]
            - a[2-1][6-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][5-1]
            + a[2-1][1-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][5-1]
            + a[2-1][4-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][5-1]
            - a[2-1][1-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][5-1]
            - a[2-1][6-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][5-1]
            + a[2-1][2-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][5-1]
            + a[2-1][6-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][5-1]
            - a[2-1][1-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][5-1]
            - a[2-1][2-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][5-1]
            + a[2-1][1-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][5-1] 
            + a[2-1][4-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[2-1][2-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[2-1][4-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[2-1][1-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[2-1][2-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[2-1][1-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[2-1][5-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][6-1]
            - a[2-1][4-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][6-1]
            - a[2-1][5-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][6-1]
            + a[2-1][2-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][6-1]
            + a[2-1][4-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][6-1] 
            - a[2-1][2-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][6-1]
            - a[2-1][5-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[2-1][4-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[2-1][5-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[2-1][1-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[2-1][4-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[2-1][1-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[2-1][5-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][6-1]
            - a[2-1][2-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][6-1]
            - a[2-1][5-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][6-1]
            + a[2-1][1-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][6-1] 
            + a[2-1][2-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][6-1]
            - a[2-1][1-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][6-1]
            - a[2-1][4-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][6-1]
            + a[2-1][2-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][6-1]
            + a[2-1][4-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][6-1]
            - a[2-1][1-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][6-1]
            - a[2-1][2-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][6-1]
            + a[2-1][1-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][6-1];
    cofactor[13] = -a[1-1][6-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][1-1]
            + a[1-1][5-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][1-1] 
            + a[1-1][6-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][1-1]
            - a[1-1][4-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][1-1]
            + a[1-1][6-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][1-1]
            - a[1-1][6-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][1-1]
            + a[1-1][5-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][1-1]
            - a[1-1][6-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][1-1] 
            + a[1-1][4-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][1-1]
            + a[1-1][6-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][1-1]
            - a[1-1][4-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][1-1]
            + a[1-1][5-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][1-1]
            - a[1-1][4-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][1-1] 
            + a[1-1][6-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[1-1][4-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[1-1][1-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][2-1] 
            + a[1-1][1-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[1-1][4-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[1-1][1-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[1-1][1-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][2-1]
            - a[1-1][1-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][2-1] 
            - a[1-1][4-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][2-1]
            + a[1-1][1-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[1-1][5-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[1-1][5-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][4-1]
            - a[1-1][5-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][4-1] 
            + a[1-1][1-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][4-1]
            + a[1-1][5-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[1-1][1-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[1-1][5-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][4-1] 
            - a[1-1][5-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][4-1]
            + a[1-1][1-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[1-1][4-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[1-1][6-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[1-1][2-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[1-1][4-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[1-1][6-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][5-1] 
            + a[1-1][4-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][5-1]
            + a[1-1][6-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][5-1]
            - a[1-1][4-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][5-1]
            + a[1-1][6-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][5-1]
            - a[1-1][6-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][5-1]
            + a[1-1][2-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][5-1] 
            - a[1-1][4-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[1-1][2-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[1-1][4-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[1-1][5-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][6-1]
            + a[1-1][4-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][6-1]
            + a[1-1][5-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][6-1]
            - a[1-1][2-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][6-1]
            - a[1-1][4-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][6-1] 
            + a[1-1][2-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][6-1]
            + a[1-1][5-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[1-1][4-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[1-1][5-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[1-1][4-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[1-1][5-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][6-1]
            + a[1-1][2-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][6-1]
            + a[1-1][5-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][6-1] 
            - a[1-1][2-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][6-1]
            + a[1-1][4-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][6-1]
            - a[1-1][2-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][6-1]
            - a[1-1][4-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][6-1]
            + a[1-1][2-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][6-1];
    cofactor[14] = a[1-1][6-1]*a[2-1][5-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][1-1] 
            - a[1-1][6-1]*a[2-1][4-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][1-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][1-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][1-1]
            - a[1-1][6-1]*a[2-1][5-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][1-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][1-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][1-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][1-1] 
            - a[1-1][4-1]*a[2-1][6-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][1-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][1-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][1-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][1-1] 
            - a[1-1][6-1]*a[2-1][5-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[2-1][5-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][2-1] 
            - a[1-1][1-1]*a[2-1][5-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][2-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][2-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][2-1] 
            + a[1-1][4-1]*a[2-1][1-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][2-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[2-1][5-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[2-1][5-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][4-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][4-1] 
            - a[1-1][1-1]*a[2-1][6-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][4-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][4-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][4-1] 
            + a[1-1][5-1]*a[2-1][1-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][4-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][5-1] 
            - a[1-1][4-1]*a[2-1][6-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][5-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][5-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][5-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][5-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][5-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][5-1] 
            + a[1-1][4-1]*a[2-1][2-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][6-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][6-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][6-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][6-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][6-1] 
            - a[1-1][2-1]*a[2-1][4-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][6-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][6-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][6-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][6-1] 
            + a[1-1][2-1]*a[2-1][1-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][6-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][6-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][6-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][6-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][6-1];
    cofactor[15] = -a[1-1][6-1]*a[2-1][5-1]*a[3-1][4-1]*a[5-1][2-1]*a[6-1][1-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][4-1]*a[5-1][2-1]*a[6-1][1-1] 
            + a[1-1][6-1]*a[2-1][4-1]*a[3-1][5-1]*a[5-1][2-1]*a[6-1][1-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[3-1][5-1]*a[5-1][2-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][6-1]*a[5-1][2-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][6-1]*a[5-1][2-1]*a[6-1][1-1]
            + a[1-1][6-1]*a[2-1][5-1]*a[3-1][2-1]*a[5-1][4-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][2-1]*a[5-1][4-1]*a[6-1][1-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][5-1]*a[5-1][4-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][5-1]*a[5-1][4-1]*a[6-1][1-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][6-1]*a[5-1][4-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][6-1]*a[5-1][4-1]*a[6-1][1-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[3-1][2-1]*a[5-1][5-1]*a[6-1][1-1] 
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][2-1]*a[5-1][5-1]*a[6-1][1-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][4-1]*a[5-1][5-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][4-1]*a[5-1][5-1]*a[6-1][1-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][6-1]*a[5-1][5-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][6-1]*a[5-1][5-1]*a[6-1][1-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[3-1][2-1]*a[5-1][6-1]*a[6-1][1-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][2-1]*a[5-1][6-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][4-1]*a[5-1][6-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][4-1]*a[5-1][6-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][5-1]*a[5-1][6-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][5-1]*a[5-1][6-1]*a[6-1][1-1] 
            + a[1-1][6-1]*a[2-1][5-1]*a[3-1][4-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][4-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[3-1][5-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][5-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[3-1][6-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][6-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[2-1][5-1]*a[3-1][1-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][1-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][5-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][5-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][6-1]*a[5-1][4-1]*a[6-1][2-1] 
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][6-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[3-1][1-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[3-1][1-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][4-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][4-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][6-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][6-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][1-1]*a[5-1][6-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][1-1]*a[5-1][6-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][4-1]*a[5-1][6-1]*a[6-1][2-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][4-1]*a[5-1][6-1]*a[6-1][2-1] 
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][5-1]*a[5-1][6-1]*a[6-1][2-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][5-1]*a[5-1][6-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[2-1][5-1]*a[3-1][2-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][2-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][5-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][5-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][6-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][6-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[2-1][5-1]*a[3-1][1-1]*a[5-1][2-1]*a[6-1][4-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][1-1]*a[5-1][2-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][5-1]*a[5-1][2-1]*a[6-1][4-1] 
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][5-1]*a[5-1][2-1]*a[6-1][4-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][6-1]*a[5-1][2-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][6-1]*a[5-1][2-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][1-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][1-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][2-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][2-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][6-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][6-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][1-1]*a[5-1][6-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][1-1]*a[5-1][6-1]*a[6-1][4-1] 
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][2-1]*a[5-1][6-1]*a[6-1][4-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][2-1]*a[5-1][6-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][5-1]*a[5-1][6-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][5-1]*a[5-1][6-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[3-1][2-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[3-1][2-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][4-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][4-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][6-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][6-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[3-1][1-1]*a[5-1][2-1]*a[6-1][5-1] 
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][1-1]*a[5-1][2-1]*a[6-1][5-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][4-1]*a[5-1][2-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][4-1]*a[5-1][2-1]*a[6-1][5-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][6-1]*a[5-1][2-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][6-1]*a[5-1][2-1]*a[6-1][5-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][1-1]*a[5-1][4-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][1-1]*a[5-1][4-1]*a[6-1][5-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][2-1]*a[5-1][4-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][2-1]*a[5-1][4-1]*a[6-1][5-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][6-1]*a[5-1][4-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][6-1]*a[5-1][4-1]*a[6-1][5-1] 
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][1-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][1-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][2-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][2-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][4-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][4-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][2-1]*a[5-1][1-1]*a[6-1][6-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][2-1]*a[5-1][1-1]*a[6-1][6-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][4-1]*a[5-1][1-1]*a[6-1][6-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][4-1]*a[5-1][1-1]*a[6-1][6-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][5-1]*a[5-1][1-1]*a[6-1][6-1] 
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][5-1]*a[5-1][1-1]*a[6-1][6-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[3-1][1-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][1-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][4-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][4-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][5-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][5-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][1-1]*a[5-1][4-1]*a[6-1][6-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][1-1]*a[5-1][4-1]*a[6-1][6-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][2-1]*a[5-1][4-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][2-1]*a[5-1][4-1]*a[6-1][6-1] 
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][5-1]*a[5-1][4-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][5-1]*a[5-1][4-1]*a[6-1][6-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][1-1]*a[5-1][5-1]*a[6-1][6-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][1-1]*a[5-1][5-1]*a[6-1][6-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][2-1]*a[5-1][5-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][2-1]*a[5-1][5-1]*a[6-1][6-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][4-1]*a[5-1][5-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][4-1]*a[5-1][5-1]*a[6-1][6-1];
    cofactor[16] = a[1-1][6-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][2-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][2-1]*a[6-1][1-1] 
            - a[1-1][6-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][2-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][2-1]*a[6-1][1-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][2-1]*a[6-1][1-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][2-1]*a[6-1][1-1]
            - a[1-1][6-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][4-1]*a[6-1][1-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][4-1]*a[6-1][1-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][4-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][4-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][4-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][4-1]*a[6-1][1-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][5-1]*a[6-1][1-1] 
            - a[1-1][4-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][5-1]*a[6-1][1-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][5-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][5-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][5-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][5-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][6-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][6-1]*a[6-1][1-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][6-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][6-1]*a[6-1][1-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][6-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][6-1]*a[6-1][1-1] 
            - a[1-1][6-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][1-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][1-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][1-1]*a[6-1][2-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][1-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][1-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][1-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][4-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][4-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][4-1]*a[6-1][2-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][4-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][4-1]*a[6-1][2-1] 
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][4-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][5-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][5-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][5-1]*a[6-1][2-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][5-1]*a[6-1][2-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][5-1]*a[6-1][2-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][5-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][6-1]*a[6-1][2-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][6-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][6-1]*a[6-1][2-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][6-1]*a[6-1][2-1] 
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][6-1]*a[6-1][2-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][6-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][1-1]*a[6-1][4-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][1-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][1-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][1-1]*a[6-1][4-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][1-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][1-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][2-1]*a[6-1][4-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][2-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][2-1]*a[6-1][4-1] 
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][2-1]*a[6-1][4-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][2-1]*a[6-1][4-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][2-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][5-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][5-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][5-1]*a[6-1][4-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][5-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][5-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][5-1]*a[6-1][4-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][6-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][6-1]*a[6-1][4-1] 
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][6-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][6-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][6-1]*a[6-1][4-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][6-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][1-1]*a[6-1][5-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][1-1]*a[6-1][5-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][1-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][1-1]*a[6-1][5-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][1-1]*a[6-1][5-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][1-1]*a[6-1][5-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][2-1]*a[6-1][5-1] 
            - a[1-1][4-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][2-1]*a[6-1][5-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][2-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][2-1]*a[6-1][5-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][2-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][2-1]*a[6-1][5-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][4-1]*a[6-1][5-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][4-1]*a[6-1][5-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][4-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][4-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][4-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][4-1]*a[6-1][5-1] 
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][6-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][6-1]*a[6-1][5-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][6-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][6-1]*a[6-1][5-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][6-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][6-1]*a[6-1][5-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][1-1]*a[6-1][6-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][1-1]*a[6-1][6-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][1-1]*a[6-1][6-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][1-1]*a[6-1][6-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][1-1]*a[6-1][6-1] 
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][1-1]*a[6-1][6-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][2-1]*a[6-1][6-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][2-1]*a[6-1][6-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][2-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][2-1]*a[6-1][6-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][2-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][2-1]*a[6-1][6-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][4-1]*a[6-1][6-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][4-1]*a[6-1][6-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][4-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][4-1]*a[6-1][6-1] 
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][4-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][4-1]*a[6-1][6-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][5-1]*a[6-1][6-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][5-1]*a[6-1][6-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][5-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][5-1]*a[6-1][6-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][5-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][5-1]*a[6-1][6-1];
    cofactor[17] = -a[1-1][6-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][1-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][1-1] 
            + a[1-1][6-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][1-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][1-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][1-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][1-1]
            + a[1-1][6-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][1-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][1-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][1-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][1-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][1-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][1-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][1-1] 
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][1-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][1-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][1-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][1-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][1-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][1-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][1-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][1-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][1-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][1-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][1-1] 
            + a[1-1][6-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][2-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][2-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][2-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][2-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][2-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][2-1]
            - a[1-1][6-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][2-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][2-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][2-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][2-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][2-1] 
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][2-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][2-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][2-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][2-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][2-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][2-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][2-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][2-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][2-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][2-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][2-1] 
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][2-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][2-1]
            - a[1-1][6-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][4-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][4-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][4-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][4-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][4-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][4-1]
            + a[1-1][6-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][4-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][4-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][4-1] 
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][4-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][4-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][4-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][4-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][4-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][4-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][4-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][4-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][4-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][4-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][4-1] 
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][4-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][4-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][4-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][4-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][5-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][5-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][5-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][5-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][5-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][5-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][5-1] 
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][5-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][5-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][5-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][5-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][5-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][5-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][5-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][5-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][5-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][5-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][5-1] 
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][5-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][5-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][5-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][5-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][5-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][5-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][6-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][6-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][6-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][6-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][6-1] 
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][6-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][6-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][6-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][6-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][6-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][6-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][6-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][6-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][6-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][6-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][6-1] 
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][6-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][6-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][6-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][6-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][6-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][6-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][6-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][6-1];
    cofactor[18] = -a[2-1][6-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][1-1]
            + a[2-1][5-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][1-1] 
            + a[2-1][6-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][1-1]
            - a[2-1][3-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][1-1]
            - a[2-1][5-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][1-1]
            + a[2-1][3-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][1-1]
            + a[2-1][6-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[2-1][5-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[2-1][6-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[2-1][2-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[2-1][5-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[2-1][2-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[2-1][6-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][1-1] 
            + a[2-1][3-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][1-1]
            + a[2-1][6-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][1-1]
            - a[2-1][2-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][1-1]
            - a[2-1][3-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][1-1]
            + a[2-1][2-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][1-1]
            + a[2-1][5-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][1-1]
            - a[2-1][3-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][1-1]
            - a[2-1][5-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][1-1]
            + a[2-1][2-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][1-1]
            + a[2-1][3-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][1-1]
            - a[2-1][2-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][1-1] 
            + a[2-1][6-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[2-1][5-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[2-1][6-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[2-1][3-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[2-1][5-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[2-1][3-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[2-1][6-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][2-1]
            + a[2-1][5-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][2-1]
            + a[2-1][6-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][2-1]
            - a[2-1][1-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][2-1]
            - a[2-1][5-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][2-1] 
            + a[2-1][1-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][2-1]
            + a[2-1][6-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[2-1][3-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[2-1][6-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[2-1][1-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[2-1][3-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[2-1][1-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[2-1][5-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][2-1]
            + a[2-1][3-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][2-1]
            + a[2-1][5-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][2-1]
            - a[2-1][1-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][2-1] 
            - a[2-1][3-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][2-1]
            + a[2-1][1-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][2-1]
            - a[2-1][6-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[2-1][5-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[2-1][6-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[2-1][2-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[2-1][5-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[2-1][2-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[2-1][6-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][3-1]
            - a[2-1][5-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][3-1]
            - a[2-1][6-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][3-1] 
            + a[2-1][1-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][3-1]
            + a[2-1][5-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][3-1]
            - a[2-1][1-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][3-1]
            - a[2-1][6-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][3-1]
            + a[2-1][2-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][3-1]
            + a[2-1][6-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[2-1][1-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[2-1][2-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][3-1]
            + a[2-1][1-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][3-1]
            + a[2-1][5-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][3-1]
            - a[2-1][2-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][3-1] 
            - a[2-1][5-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][3-1]
            + a[2-1][1-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][3-1]
            + a[2-1][2-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][3-1]
            - a[2-1][1-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][3-1]
            + a[2-1][6-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[2-1][3-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[2-1][6-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[2-1][2-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[2-1][3-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[2-1][2-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[2-1][6-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][5-1] 
            + a[2-1][3-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][5-1]
            + a[2-1][6-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][5-1]
            - a[2-1][1-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][5-1]
            - a[2-1][3-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][5-1]
            + a[2-1][1-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][5-1]
            + a[2-1][6-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][5-1]
            - a[2-1][2-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][5-1]
            - a[2-1][6-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][5-1]
            + a[2-1][1-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][5-1]
            + a[2-1][2-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][5-1]
            - a[2-1][1-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][5-1] 
            - a[2-1][3-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[2-1][2-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[2-1][3-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[2-1][1-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[2-1][2-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[2-1][1-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[2-1][5-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][6-1]
            + a[2-1][3-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][6-1]
            + a[2-1][5-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][6-1]
            - a[2-1][2-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][6-1]
            - a[2-1][3-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][6-1] 
            + a[2-1][2-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][6-1]
            + a[2-1][5-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[2-1][3-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[2-1][5-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[2-1][1-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[2-1][3-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[2-1][1-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[2-1][5-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][6-1]
            + a[2-1][2-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][6-1]
            + a[2-1][5-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[2-1][1-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][6-1] 
            - a[2-1][2-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][6-1]
            + a[2-1][1-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][6-1]
            + a[2-1][3-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][6-1]
            - a[2-1][2-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][6-1]
            - a[2-1][3-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][6-1]
            + a[2-1][1-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][6-1]
            + a[2-1][2-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][6-1]
            - a[2-1][1-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][6-1];
    cofactor[19] = a[1-1][6-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][1-1] 
            - a[1-1][6-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][1-1]
            + a[1-1][3-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][1-1]
            + a[1-1][5-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][1-1]
            - a[1-1][3-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][1-1]
            - a[1-1][6-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[1-1][5-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[1-1][6-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[1-1][6-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][1-1] 
            - a[1-1][3-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][1-1]
            - a[1-1][6-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][1-1]
            + a[1-1][3-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][1-1]
            + a[1-1][3-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][1-1]
            + a[1-1][5-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][1-1]
            - a[1-1][3-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][1-1] 
            - a[1-1][6-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[1-1][3-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[1-1][3-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][2-1]
            + a[1-1][1-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][2-1] 
            - a[1-1][1-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[1-1][3-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[1-1][1-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[1-1][3-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[1-1][1-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][2-1]
            - a[1-1][3-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][2-1]
            + a[1-1][1-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][2-1] 
            + a[1-1][3-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][2-1]
            - a[1-1][1-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[1-1][5-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][3-1]
            + a[1-1][6-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][3-1] 
            - a[1-1][1-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][3-1]
            - a[1-1][5-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][3-1]
            + a[1-1][1-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][3-1]
            + a[1-1][6-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][3-1]
            + a[1-1][1-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[1-1][1-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[1-1][5-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][3-1] 
            + a[1-1][5-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][3-1]
            - a[1-1][1-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][3-1]
            + a[1-1][1-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[1-1][3-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[1-1][6-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[1-1][3-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[1-1][2-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[1-1][6-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][5-1] 
            - a[1-1][3-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][5-1]
            - a[1-1][6-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][5-1]
            + a[1-1][3-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][5-1]
            - a[1-1][6-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][5-1]
            + a[1-1][2-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][5-1]
            + a[1-1][6-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][5-1] 
            + a[1-1][3-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[1-1][3-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[1-1][2-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[1-1][5-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][6-1]
            - a[1-1][3-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][6-1]
            - a[1-1][5-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][6-1]
            + a[1-1][2-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][6-1]
            + a[1-1][3-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][6-1] 
            - a[1-1][2-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][6-1]
            - a[1-1][5-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[1-1][3-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[1-1][5-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[1-1][3-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[1-1][5-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[1-1][2-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[1-1][5-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][6-1] 
            + a[1-1][2-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[1-1][3-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][6-1]
            + a[1-1][2-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][6-1]
            + a[1-1][3-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][6-1]
            - a[1-1][2-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][6-1];
    cofactor[20] = -a[1-1][6-1]*a[2-1][5-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][1-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][1-1] 
            + a[1-1][6-1]*a[2-1][3-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][1-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][1-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][1-1]
            + a[1-1][6-1]*a[2-1][5-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][1-1] 
            + a[1-1][3-1]*a[2-1][6-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][1-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][1-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][1-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][1-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][1-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][1-1] 
            + a[1-1][6-1]*a[2-1][5-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[2-1][5-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][2-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][2-1] 
            + a[1-1][1-1]*a[2-1][5-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][2-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][2-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][2-1] 
            - a[1-1][3-1]*a[2-1][1-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][2-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[2-1][5-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[1-1][6-1]*a[2-1][5-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][3-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][3-1] 
            + a[1-1][1-1]*a[2-1][6-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][3-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][3-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][3-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[4-1][6-1]*a[5-1][5-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][3-1] 
            - a[1-1][5-1]*a[2-1][1-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][3-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][3-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[4-1][5-1]*a[5-1][6-1]*a[6-1][3-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][5-1] 
            + a[1-1][3-1]*a[2-1][6-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][5-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][5-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][5-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][5-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][5-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][5-1] 
            - a[1-1][3-1]*a[2-1][2-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][6-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][6-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][6-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][6-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][6-1] 
            + a[1-1][2-1]*a[2-1][3-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][6-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][6-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][6-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][6-1] 
            - a[1-1][2-1]*a[2-1][1-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][6-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][6-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][6-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][6-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][6-1];
    cofactor[21] = a[1-1][6-1]*a[2-1][5-1]*a[3-1][3-1]*a[5-1][2-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][3-1]*a[5-1][2-1]*a[6-1][1-1] 
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][5-1]*a[5-1][2-1]*a[6-1][1-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][5-1]*a[5-1][2-1]*a[6-1][1-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][6-1]*a[5-1][2-1]*a[6-1][1-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][6-1]*a[5-1][2-1]*a[6-1][1-1]
            - a[1-1][6-1]*a[2-1][5-1]*a[3-1][2-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][2-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][5-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][5-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][6-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][6-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][2-1]*a[5-1][5-1]*a[6-1][1-1] 
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][2-1]*a[5-1][5-1]*a[6-1][1-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][3-1]*a[5-1][5-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][3-1]*a[5-1][5-1]*a[6-1][1-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][6-1]*a[5-1][5-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][6-1]*a[5-1][5-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][2-1]*a[5-1][6-1]*a[6-1][1-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][2-1]*a[5-1][6-1]*a[6-1][1-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][3-1]*a[5-1][6-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][3-1]*a[5-1][6-1]*a[6-1][1-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][5-1]*a[5-1][6-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][5-1]*a[5-1][6-1]*a[6-1][1-1] 
            - a[1-1][6-1]*a[2-1][5-1]*a[3-1][3-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][3-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][5-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][5-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][6-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][6-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[2-1][5-1]*a[3-1][1-1]*a[5-1][3-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][1-1]*a[5-1][3-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][5-1]*a[5-1][3-1]*a[6-1][2-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][5-1]*a[5-1][3-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][6-1]*a[5-1][3-1]*a[6-1][2-1] 
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][6-1]*a[5-1][3-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][1-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][1-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][3-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][3-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][6-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][6-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][1-1]*a[5-1][6-1]*a[6-1][2-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][1-1]*a[5-1][6-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][3-1]*a[5-1][6-1]*a[6-1][2-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][3-1]*a[5-1][6-1]*a[6-1][2-1] 
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][5-1]*a[5-1][6-1]*a[6-1][2-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][5-1]*a[5-1][6-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[2-1][5-1]*a[3-1][2-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][2-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][5-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][5-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][6-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][6-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[2-1][5-1]*a[3-1][1-1]*a[5-1][2-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][1-1]*a[5-1][2-1]*a[6-1][3-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][5-1]*a[5-1][2-1]*a[6-1][3-1] 
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][5-1]*a[5-1][2-1]*a[6-1][3-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][6-1]*a[5-1][2-1]*a[6-1][3-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][6-1]*a[5-1][2-1]*a[6-1][3-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][1-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][1-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][2-1]*a[5-1][5-1]*a[6-1][3-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][2-1]*a[5-1][5-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][6-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][6-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][1-1]*a[5-1][6-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][1-1]*a[5-1][6-1]*a[6-1][3-1] 
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][2-1]*a[5-1][6-1]*a[6-1][3-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][2-1]*a[5-1][6-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][5-1]*a[5-1][6-1]*a[6-1][3-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][5-1]*a[5-1][6-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][2-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][2-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][3-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][3-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][6-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][6-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][1-1]*a[5-1][2-1]*a[6-1][5-1] 
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][1-1]*a[5-1][2-1]*a[6-1][5-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][3-1]*a[5-1][2-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][3-1]*a[5-1][2-1]*a[6-1][5-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][6-1]*a[5-1][2-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][6-1]*a[5-1][2-1]*a[6-1][5-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][1-1]*a[5-1][3-1]*a[6-1][5-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][1-1]*a[5-1][3-1]*a[6-1][5-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][2-1]*a[5-1][3-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][2-1]*a[5-1][3-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][6-1]*a[5-1][3-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][6-1]*a[5-1][3-1]*a[6-1][5-1] 
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][1-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][1-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][2-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][2-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][3-1]*a[5-1][6-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][3-1]*a[5-1][6-1]*a[6-1][5-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][2-1]*a[5-1][1-1]*a[6-1][6-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][2-1]*a[5-1][1-1]*a[6-1][6-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][3-1]*a[5-1][1-1]*a[6-1][6-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][3-1]*a[5-1][1-1]*a[6-1][6-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][5-1]*a[5-1][1-1]*a[6-1][6-1] 
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][5-1]*a[5-1][1-1]*a[6-1][6-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][1-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][1-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][3-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][3-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][5-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][5-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][1-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][1-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][2-1]*a[5-1][3-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][2-1]*a[5-1][3-1]*a[6-1][6-1] 
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][5-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][5-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][1-1]*a[5-1][5-1]*a[6-1][6-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][1-1]*a[5-1][5-1]*a[6-1][6-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][2-1]*a[5-1][5-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][2-1]*a[5-1][5-1]*a[6-1][6-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][3-1]*a[5-1][5-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][3-1]*a[5-1][5-1]*a[6-1][6-1];
    cofactor[22] = -a[1-1][6-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][2-1]*a[6-1][1-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][2-1]*a[6-1][1-1] 
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][2-1]*a[6-1][1-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][2-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][2-1]*a[6-1][1-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][2-1]*a[6-1][1-1]
            + a[1-1][6-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][3-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][3-1]*a[6-1][1-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][3-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][3-1]*a[6-1][1-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][3-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][3-1]*a[6-1][1-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][5-1]*a[6-1][1-1] 
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][5-1]*a[6-1][1-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][5-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][5-1]*a[6-1][1-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][5-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][5-1]*a[6-1][1-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][6-1]*a[6-1][1-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][6-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][6-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][6-1]*a[6-1][1-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][6-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][6-1]*a[6-1][1-1] 
            + a[1-1][6-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][1-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][1-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][1-1]*a[6-1][2-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][1-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][1-1]*a[6-1][2-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][1-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][3-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][3-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][3-1]*a[6-1][2-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][3-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][3-1]*a[6-1][2-1] 
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][3-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][5-1]*a[6-1][2-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][5-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][5-1]*a[6-1][2-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][5-1]*a[6-1][2-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][5-1]*a[6-1][2-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][5-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][6-1]*a[6-1][2-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][6-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][6-1]*a[6-1][2-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][6-1]*a[6-1][2-1] 
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][6-1]*a[6-1][2-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][6-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][1-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][1-1]*a[6-1][3-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][1-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][1-1]*a[6-1][3-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][1-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][1-1]*a[6-1][3-1]
            + a[1-1][6-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][2-1]*a[6-1][3-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][2-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][2-1]*a[6-1][3-1] 
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][2-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][2-1]*a[6-1][3-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][2-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][5-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][5-1]*a[6-1][3-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][5-1]*a[6-1][3-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][5-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][5-1]*a[6-1][3-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][5-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][6-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][6-1]*a[6-1][3-1] 
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][6-1]*a[6-1][3-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][6-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][6-1]*a[6-1][3-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][6-1]*a[6-1][3-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][1-1]*a[6-1][5-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][1-1]*a[6-1][5-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][1-1]*a[6-1][5-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][1-1]*a[6-1][5-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][1-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][1-1]*a[6-1][5-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][2-1]*a[6-1][5-1] 
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][2-1]*a[6-1][5-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][2-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][2-1]*a[6-1][5-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][2-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][2-1]*a[6-1][5-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][3-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][3-1]*a[6-1][5-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][3-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][3-1]*a[6-1][5-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][3-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][3-1]*a[6-1][5-1] 
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][6-1]*a[6-1][5-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][6-1]*a[6-1][5-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][6-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][6-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][6-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][6-1]*a[6-1][5-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][1-1]*a[6-1][6-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][1-1]*a[6-1][6-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][1-1]*a[6-1][6-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][1-1]*a[6-1][6-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][1-1]*a[6-1][6-1] 
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][1-1]*a[6-1][6-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][2-1]*a[6-1][6-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][2-1]*a[6-1][6-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][2-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][2-1]*a[6-1][6-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][2-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][2-1]*a[6-1][6-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][3-1]*a[6-1][6-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][3-1]*a[6-1][6-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][3-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][3-1]*a[6-1][6-1] 
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][3-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][3-1]*a[6-1][6-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][5-1]*a[6-1][6-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][5-1]*a[6-1][6-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][5-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][5-1]*a[6-1][6-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][5-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][5-1]*a[6-1][6-1];
    cofactor[23] = a[1-1][6-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][1-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][1-1] 
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][1-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][1-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][1-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][1-1]
            - a[1-1][6-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][1-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][1-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][1-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][1-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][1-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][1-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][1-1] 
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][1-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][1-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][1-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][1-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][1-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][1-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][1-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][1-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][1-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][1-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][1-1] 
            - a[1-1][6-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][2-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][2-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][2-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][2-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][2-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][2-1]
            + a[1-1][6-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][2-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][2-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][2-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][2-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][2-1] 
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][2-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][2-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][2-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][2-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][2-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][2-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][2-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][2-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][2-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][2-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][2-1] 
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][2-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][2-1]
            + a[1-1][6-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][3-1]
            - a[1-1][5-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][3-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][3-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][3-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][3-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][3-1]
            - a[1-1][6-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][3-1]
            + a[1-1][5-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][3-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][3-1] 
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][3-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][3-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][3-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][3-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][3-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][3-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][3-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][3-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][5-1]*a[5-1][3-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][3-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][3-1] 
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][3-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][3-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][3-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][6-1]*a[5-1][3-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][5-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][5-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][5-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][5-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][5-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][5-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][5-1] 
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][5-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][5-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][5-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][5-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][5-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][5-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][5-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][5-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][5-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][5-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][5-1] 
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][5-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][5-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][5-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][5-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][5-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][5-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][6-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][6-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][6-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][6-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][6-1] 
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][6-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][6-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][6-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][6-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][6-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][6-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][6-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][6-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][6-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][6-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][6-1] 
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][6-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][6-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][6-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][6-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][6-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][6-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][6-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][6-1];
    cofactor[24] = a[2-1][6-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][1-1]
            - a[2-1][4-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][1-1] 
            - a[2-1][6-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][1-1]
            + a[2-1][3-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][1-1]
            + a[2-1][4-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][1-1]
            - a[2-1][3-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][1-1]
            - a[2-1][6-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[2-1][4-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[2-1][6-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[2-1][2-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[2-1][4-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[2-1][2-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[2-1][6-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][1-1] 
            - a[2-1][3-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][1-1]
            - a[2-1][6-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][1-1]
            + a[2-1][2-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][1-1]
            + a[2-1][3-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][1-1]
            - a[2-1][2-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][1-1]
            - a[2-1][4-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][1-1]
            + a[2-1][3-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][1-1]
            + a[2-1][4-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][1-1]
            - a[2-1][2-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][1-1]
            - a[2-1][3-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][1-1]
            + a[2-1][2-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][1-1] 
            - a[2-1][6-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[2-1][4-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[2-1][6-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[2-1][3-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[2-1][4-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[2-1][3-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[2-1][6-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][2-1]
            - a[2-1][4-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][2-1]
            - a[2-1][6-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][2-1]
            + a[2-1][1-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][2-1]
            + a[2-1][4-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][2-1] 
            - a[2-1][1-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][2-1]
            - a[2-1][6-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[2-1][3-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[2-1][6-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[2-1][1-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[2-1][3-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[2-1][1-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[2-1][4-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][2-1]
            - a[2-1][3-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][2-1]
            - a[2-1][4-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][2-1]
            + a[2-1][1-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][2-1] 
            + a[2-1][3-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][2-1]
            - a[2-1][1-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][2-1]
            + a[2-1][6-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[2-1][4-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[2-1][6-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[2-1][2-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[2-1][4-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[2-1][2-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[2-1][6-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][3-1]
            + a[2-1][4-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][3-1]
            + a[2-1][6-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][3-1] 
            - a[2-1][1-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][3-1]
            - a[2-1][4-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][3-1]
            + a[2-1][1-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][3-1]
            + a[2-1][6-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][3-1]
            - a[2-1][2-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][3-1]
            - a[2-1][6-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][3-1]
            + a[2-1][1-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][3-1]
            + a[2-1][2-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][3-1]
            - a[2-1][1-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][3-1]
            - a[2-1][4-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][3-1]
            + a[2-1][2-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][3-1] 
            + a[2-1][4-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][3-1]
            - a[2-1][1-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][3-1]
            - a[2-1][2-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][3-1]
            + a[2-1][1-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][3-1]
            - a[2-1][6-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[2-1][3-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[2-1][6-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[2-1][2-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[2-1][3-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[2-1][2-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[2-1][6-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][4-1] 
            - a[2-1][3-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][4-1]
            - a[2-1][6-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][4-1]
            + a[2-1][1-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][4-1]
            + a[2-1][3-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][4-1]
            - a[2-1][1-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][4-1]
            - a[2-1][6-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][4-1]
            + a[2-1][2-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][4-1]
            + a[2-1][6-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][4-1]
            - a[2-1][1-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][4-1]
            - a[2-1][2-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][4-1]
            + a[2-1][1-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][4-1] 
            + a[2-1][3-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][4-1]
            - a[2-1][2-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][4-1]
            - a[2-1][3-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][4-1]
            + a[2-1][1-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][4-1]
            + a[2-1][2-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][4-1]
            - a[2-1][1-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][4-1]
            + a[2-1][4-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][6-1]
            - a[2-1][3-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][6-1]
            - a[2-1][4-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][6-1]
            + a[2-1][2-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][6-1]
            + a[2-1][3-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][6-1] 
            - a[2-1][2-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][6-1]
            - a[2-1][4-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[2-1][3-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[2-1][4-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[2-1][1-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[2-1][3-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[2-1][1-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[2-1][4-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[2-1][2-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[2-1][4-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][6-1]
            + a[2-1][1-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][6-1] 
            + a[2-1][2-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[2-1][1-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[2-1][3-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][6-1]
            + a[2-1][2-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][6-1]
            + a[2-1][3-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][6-1]
            - a[2-1][1-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][6-1]
            - a[2-1][2-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][6-1]
            + a[2-1][1-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][6-1];
    cofactor[25] = -a[1-1][6-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][1-1] 
            + a[1-1][6-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][1-1]
            - a[1-1][3-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][1-1]
            - a[1-1][4-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][1-1]
            + a[1-1][3-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][1-1]
            + a[1-1][6-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[1-1][4-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[1-1][6-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[1-1][6-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][1-1] 
            + a[1-1][3-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][1-1]
            + a[1-1][6-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][1-1]
            - a[1-1][3-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][1-1]
            - a[1-1][3-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][1-1]
            - a[1-1][4-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][1-1]
            + a[1-1][3-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][1-1] 
            + a[1-1][6-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[1-1][4-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[1-1][3-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[1-1][3-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][2-1]
            - a[1-1][1-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][2-1]
            - a[1-1][4-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][2-1] 
            + a[1-1][1-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[1-1][3-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[1-1][1-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[1-1][3-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[1-1][1-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[1-1][4-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][2-1]
            + a[1-1][3-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][2-1]
            - a[1-1][1-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][2-1] 
            - a[1-1][3-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][2-1]
            + a[1-1][1-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[1-1][4-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[1-1][6-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[1-1][4-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[1-1][6-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][3-1]
            - a[1-1][4-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][3-1] 
            + a[1-1][1-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][3-1]
            + a[1-1][4-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][3-1]
            - a[1-1][1-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][3-1]
            + a[1-1][6-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][3-1]
            - a[1-1][1-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][3-1]
            + a[1-1][1-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][3-1]
            + a[1-1][4-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][3-1] 
            - a[1-1][4-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][3-1]
            + a[1-1][1-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][3-1]
            - a[1-1][1-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][3-1]
            + a[1-1][6-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[1-1][3-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[1-1][3-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][4-1] 
            + a[1-1][3-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][4-1]
            - a[1-1][3-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][4-1]
            + a[1-1][1-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][4-1]
            + a[1-1][1-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][4-1] 
            - a[1-1][3-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][4-1]
            + a[1-1][3-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][4-1]
            + a[1-1][1-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][4-1]
            - a[1-1][4-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][6-1]
            + a[1-1][3-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][6-1]
            + a[1-1][4-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][6-1]
            - a[1-1][2-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][6-1]
            - a[1-1][3-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][6-1] 
            + a[1-1][2-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][6-1]
            + a[1-1][4-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[1-1][3-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[1-1][4-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[1-1][3-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[1-1][4-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][6-1]
            + a[1-1][2-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][6-1]
            + a[1-1][4-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][6-1] 
            - a[1-1][2-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][6-1]
            + a[1-1][3-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][6-1]
            - a[1-1][2-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][6-1]
            - a[1-1][3-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][6-1]
            + a[1-1][2-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][6-1];
    cofactor[26] = a[1-1][6-1]*a[2-1][4-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][1-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][1-1] 
            - a[1-1][6-1]*a[2-1][3-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][1-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][1-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][1-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][1-1] 
            - a[1-1][3-1]*a[2-1][6-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][1-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][1-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][1-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][1-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][1-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][1-1] 
            - a[1-1][6-1]*a[2-1][4-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][2-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][2-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][2-1] 
            - a[1-1][1-1]*a[2-1][4-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][2-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][2-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][2-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][2-1] 
            + a[1-1][3-1]*a[2-1][1-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][2-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][3-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][3-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][3-1] 
            - a[1-1][1-1]*a[2-1][6-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][3-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][3-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][3-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][3-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][3-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[4-1][6-1]*a[5-1][4-1]*a[6-1][3-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][3-1] 
            + a[1-1][4-1]*a[2-1][1-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][3-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][3-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[4-1][4-1]*a[5-1][6-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[4-1][6-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][4-1] 
            - a[1-1][3-1]*a[2-1][6-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][4-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][4-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[4-1][6-1]*a[5-1][2-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][4-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[4-1][6-1]*a[5-1][3-1]*a[6-1][4-1] 
            + a[1-1][3-1]*a[2-1][2-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[4-1][1-1]*a[5-1][6-1]*a[6-1][4-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][4-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[4-1][2-1]*a[5-1][6-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[4-1][3-1]*a[5-1][6-1]*a[6-1][4-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][6-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][6-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][6-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][6-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][6-1] 
            - a[1-1][2-1]*a[2-1][3-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][6-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][6-1] 
            + a[1-1][2-1]*a[2-1][1-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][6-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][6-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][6-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][6-1];
    cofactor[27] = -a[1-1][6-1]*a[2-1][4-1]*a[3-1][3-1]*a[5-1][2-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][3-1]*a[5-1][2-1]*a[6-1][1-1] 
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][4-1]*a[5-1][2-1]*a[6-1][1-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][4-1]*a[5-1][2-1]*a[6-1][1-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][6-1]*a[5-1][2-1]*a[6-1][1-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][6-1]*a[5-1][2-1]*a[6-1][1-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[3-1][2-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[3-1][2-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][4-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][4-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][6-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][6-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][2-1]*a[5-1][4-1]*a[6-1][1-1] 
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][2-1]*a[5-1][4-1]*a[6-1][1-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][3-1]*a[5-1][4-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][3-1]*a[5-1][4-1]*a[6-1][1-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][6-1]*a[5-1][4-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][6-1]*a[5-1][4-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][2-1]*a[5-1][6-1]*a[6-1][1-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[3-1][2-1]*a[5-1][6-1]*a[6-1][1-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][3-1]*a[5-1][6-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][3-1]*a[5-1][6-1]*a[6-1][1-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][4-1]*a[5-1][6-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][4-1]*a[5-1][6-1]*a[6-1][1-1] 
            + a[1-1][6-1]*a[2-1][4-1]*a[3-1][3-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[3-1][3-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][4-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][4-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][6-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[3-1][6-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[3-1][1-1]*a[5-1][3-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][1-1]*a[5-1][3-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][4-1]*a[5-1][3-1]*a[6-1][2-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][4-1]*a[5-1][3-1]*a[6-1][2-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][6-1]*a[5-1][3-1]*a[6-1][2-1] 
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][6-1]*a[5-1][3-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][1-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][1-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][3-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][3-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][6-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][6-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][1-1]*a[5-1][6-1]*a[6-1][2-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][1-1]*a[5-1][6-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][3-1]*a[5-1][6-1]*a[6-1][2-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][3-1]*a[5-1][6-1]*a[6-1][2-1] 
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][4-1]*a[5-1][6-1]*a[6-1][2-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][4-1]*a[5-1][6-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[3-1][2-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][2-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][4-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][4-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][6-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][6-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[3-1][1-1]*a[5-1][2-1]*a[6-1][3-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[3-1][1-1]*a[5-1][2-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][4-1]*a[5-1][2-1]*a[6-1][3-1] 
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][4-1]*a[5-1][2-1]*a[6-1][3-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][6-1]*a[5-1][2-1]*a[6-1][3-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][6-1]*a[5-1][2-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][1-1]*a[5-1][4-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][1-1]*a[5-1][4-1]*a[6-1][3-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][2-1]*a[5-1][4-1]*a[6-1][3-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][2-1]*a[5-1][4-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][6-1]*a[5-1][4-1]*a[6-1][3-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][6-1]*a[5-1][4-1]*a[6-1][3-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][1-1]*a[5-1][6-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][1-1]*a[5-1][6-1]*a[6-1][3-1] 
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][2-1]*a[5-1][6-1]*a[6-1][3-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][2-1]*a[5-1][6-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][4-1]*a[5-1][6-1]*a[6-1][3-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][4-1]*a[5-1][6-1]*a[6-1][3-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][2-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][2-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][3-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][3-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][6-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][6-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][1-1]*a[5-1][2-1]*a[6-1][4-1] 
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][1-1]*a[5-1][2-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][3-1]*a[5-1][2-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][3-1]*a[5-1][2-1]*a[6-1][4-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][6-1]*a[5-1][2-1]*a[6-1][4-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][6-1]*a[5-1][2-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][1-1]*a[5-1][3-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][1-1]*a[5-1][3-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][2-1]*a[5-1][3-1]*a[6-1][4-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][2-1]*a[5-1][3-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][6-1]*a[5-1][3-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][6-1]*a[5-1][3-1]*a[6-1][4-1] 
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][1-1]*a[5-1][6-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][1-1]*a[5-1][6-1]*a[6-1][4-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][2-1]*a[5-1][6-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][2-1]*a[5-1][6-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][3-1]*a[5-1][6-1]*a[6-1][4-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][3-1]*a[5-1][6-1]*a[6-1][4-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][2-1]*a[5-1][1-1]*a[6-1][6-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][2-1]*a[5-1][1-1]*a[6-1][6-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][3-1]*a[5-1][1-1]*a[6-1][6-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][3-1]*a[5-1][1-1]*a[6-1][6-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][4-1]*a[5-1][1-1]*a[6-1][6-1] 
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][4-1]*a[5-1][1-1]*a[6-1][6-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][1-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[3-1][1-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][3-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][3-1]*a[5-1][2-1]*a[6-1][6-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][4-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][4-1]*a[5-1][2-1]*a[6-1][6-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][1-1]*a[5-1][3-1]*a[6-1][6-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][1-1]*a[5-1][3-1]*a[6-1][6-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][2-1]*a[5-1][3-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][2-1]*a[5-1][3-1]*a[6-1][6-1] 
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][4-1]*a[5-1][3-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][4-1]*a[5-1][3-1]*a[6-1][6-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][1-1]*a[5-1][4-1]*a[6-1][6-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][1-1]*a[5-1][4-1]*a[6-1][6-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][2-1]*a[5-1][4-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][2-1]*a[5-1][4-1]*a[6-1][6-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][3-1]*a[5-1][4-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][3-1]*a[5-1][4-1]*a[6-1][6-1];
    cofactor[28] = a[1-1][6-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][2-1]*a[6-1][1-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][2-1]*a[6-1][1-1] 
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][2-1]*a[6-1][1-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][2-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][2-1]*a[6-1][1-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][2-1]*a[6-1][1-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][3-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][3-1]*a[6-1][1-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][3-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][3-1]*a[6-1][1-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][3-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][3-1]*a[6-1][1-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][4-1]*a[6-1][1-1] 
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][4-1]*a[6-1][1-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][4-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][4-1]*a[6-1][1-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][4-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][4-1]*a[6-1][1-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][6-1]*a[6-1][1-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][6-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][6-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][6-1]*a[6-1][1-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][6-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][6-1]*a[6-1][1-1] 
            - a[1-1][6-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][1-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][1-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][1-1]*a[6-1][2-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][1-1]*a[6-1][2-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][1-1]*a[6-1][2-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][1-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][3-1]*a[6-1][2-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][3-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][3-1]*a[6-1][2-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][3-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][3-1]*a[6-1][2-1] 
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][3-1]*a[6-1][2-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][4-1]*a[6-1][2-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][4-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][4-1]*a[6-1][2-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][4-1]*a[6-1][2-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][4-1]*a[6-1][2-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][4-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][6-1]*a[6-1][2-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][6-1]*a[6-1][2-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][6-1]*a[6-1][2-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][6-1]*a[6-1][2-1] 
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][6-1]*a[6-1][2-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][6-1]*a[6-1][2-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][1-1]*a[6-1][3-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][1-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][1-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][1-1]*a[6-1][3-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][1-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][1-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][2-1]*a[6-1][3-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][2-1]*a[6-1][3-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][2-1]*a[6-1][3-1] 
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][2-1]*a[6-1][3-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][2-1]*a[6-1][3-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][2-1]*a[6-1][3-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][4-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][4-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][4-1]*a[6-1][3-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][4-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][4-1]*a[6-1][3-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][4-1]*a[6-1][3-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][6-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][6-1]*a[6-1][3-1] 
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][6-1]*a[6-1][3-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][6-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][6-1]*a[6-1][3-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][6-1]*a[6-1][3-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][1-1]*a[6-1][4-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][1-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][1-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][1-1]*a[6-1][4-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][1-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][1-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][2-1]*a[6-1][4-1] 
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][2-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][2-1]*a[6-1][4-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][2-1]*a[6-1][4-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][2-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][2-1]*a[6-1][4-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][3-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][3-1]*a[6-1][4-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][3-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][3-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][3-1]*a[6-1][4-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][3-1]*a[6-1][4-1] 
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][6-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][6-1]*a[6-1][4-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][6-1]*a[6-1][4-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][6-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][6-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][6-1]*a[6-1][4-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][1-1]*a[6-1][6-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][1-1]*a[6-1][6-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][1-1]*a[6-1][6-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][1-1]*a[6-1][6-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][1-1]*a[6-1][6-1] 
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][1-1]*a[6-1][6-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][2-1]*a[6-1][6-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][2-1]*a[6-1][6-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][2-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][2-1]*a[6-1][6-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][2-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][2-1]*a[6-1][6-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][3-1]*a[6-1][6-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][3-1]*a[6-1][6-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][3-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][3-1]*a[6-1][6-1] 
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][3-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][3-1]*a[6-1][6-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][4-1]*a[6-1][6-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][4-1]*a[6-1][6-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][4-1]*a[6-1][6-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][4-1]*a[6-1][6-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][4-1]*a[6-1][6-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][4-1]*a[6-1][6-1];
    cofactor[29] = -a[1-1][6-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][1-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][1-1] 
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][1-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][1-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][1-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][1-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][1-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][1-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][1-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][1-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][1-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][1-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][1-1] 
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][1-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][1-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][1-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][1-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][1-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][1-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][1-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][1-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][1-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][1-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][1-1] 
            + a[1-1][6-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][2-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][2-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][2-1]
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][2-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][2-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][2-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][2-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][2-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][2-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][2-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][2-1] 
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][2-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][2-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][2-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][2-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][2-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][2-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][2-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][2-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][2-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][2-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][2-1] 
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][2-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][2-1]
            - a[1-1][6-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][3-1]
            + a[1-1][4-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][3-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][3-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][3-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][3-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][3-1]
            + a[1-1][6-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][3-1]
            - a[1-1][4-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][3-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][3-1] 
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][3-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][3-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][3-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][3-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][3-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][3-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][3-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][3-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][4-1]*a[5-1][3-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][3-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][3-1] 
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][3-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][3-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][3-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][6-1]*a[5-1][3-1]
            + a[1-1][6-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][4-1]
            - a[1-1][3-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][4-1]
            - a[1-1][6-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][4-1]
            + a[1-1][2-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][4-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][4-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][1-1]*a[5-1][4-1]
            - a[1-1][6-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][4-1] 
            + a[1-1][3-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][4-1]
            + a[1-1][6-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][4-1]
            - a[1-1][1-1]*a[2-1][6-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][4-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][4-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][6-1]*a[4-1][2-1]*a[5-1][4-1]
            + a[1-1][6-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][4-1]
            - a[1-1][2-1]*a[2-1][6-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][4-1]
            - a[1-1][6-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][4-1]
            + a[1-1][1-1]*a[2-1][6-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][4-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][4-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][6-1]*a[4-1][3-1]*a[5-1][4-1] 
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][4-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][6-1]*a[5-1][4-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][4-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][6-1]*a[5-1][4-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][4-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][6-1]*a[5-1][4-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][6-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][6-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][6-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][6-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][6-1] 
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][6-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][6-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][6-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][6-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][6-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][6-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][6-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][6-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][6-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][6-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][6-1] 
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][6-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][6-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][6-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][6-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][6-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][6-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][6-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][6-1];
    cofactor[30] = -a[2-1][5-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][1-1]
            + a[2-1][4-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][1-1] 
            + a[2-1][5-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][1-1]
            - a[2-1][3-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][1-1]
            - a[2-1][4-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][1-1]
            + a[2-1][3-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][1-1]
            + a[2-1][5-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[2-1][4-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[2-1][5-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[2-1][2-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[2-1][4-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[2-1][2-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[2-1][5-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][1-1] 
            + a[2-1][3-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][1-1]
            + a[2-1][5-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][1-1]
            - a[2-1][2-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][1-1]
            - a[2-1][3-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][1-1]
            + a[2-1][2-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][1-1]
            + a[2-1][4-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][1-1]
            - a[2-1][3-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][1-1]
            - a[2-1][4-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][1-1]
            + a[2-1][2-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][1-1]
            + a[2-1][3-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][1-1]
            - a[2-1][2-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][1-1] 
            + a[2-1][5-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[2-1][4-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[2-1][5-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[2-1][3-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[2-1][4-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[2-1][3-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[2-1][5-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][2-1]
            + a[2-1][4-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][2-1]
            + a[2-1][5-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][2-1]
            - a[2-1][1-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][2-1]
            - a[2-1][4-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][2-1] 
            + a[2-1][1-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][2-1]
            + a[2-1][5-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[2-1][3-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[2-1][5-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[2-1][1-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[2-1][3-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[2-1][1-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[2-1][4-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[2-1][3-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[2-1][4-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[2-1][1-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][2-1] 
            - a[2-1][3-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[2-1][1-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[2-1][5-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[2-1][4-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[2-1][5-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[2-1][2-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[2-1][4-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[2-1][2-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[2-1][5-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][3-1]
            - a[2-1][4-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][3-1]
            - a[2-1][5-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][3-1] 
            + a[2-1][1-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][3-1]
            + a[2-1][4-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][3-1]
            - a[2-1][1-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][3-1]
            - a[2-1][5-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][3-1]
            + a[2-1][2-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][3-1]
            + a[2-1][5-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][3-1]
            - a[2-1][1-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][3-1]
            - a[2-1][2-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][3-1]
            + a[2-1][1-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][3-1]
            + a[2-1][4-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[2-1][2-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][3-1] 
            - a[2-1][4-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][3-1]
            + a[2-1][1-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][3-1]
            + a[2-1][2-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[2-1][1-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][3-1]
            + a[2-1][5-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[2-1][3-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[2-1][5-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[2-1][2-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[2-1][3-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[2-1][2-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[2-1][5-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][4-1] 
            + a[2-1][3-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][4-1]
            + a[2-1][5-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][4-1]
            - a[2-1][1-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][4-1]
            - a[2-1][3-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][4-1]
            + a[2-1][1-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][4-1]
            + a[2-1][5-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][4-1]
            - a[2-1][2-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][4-1]
            - a[2-1][5-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][4-1]
            + a[2-1][1-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][4-1]
            + a[2-1][2-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][4-1]
            - a[2-1][1-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][4-1] 
            - a[2-1][3-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[2-1][2-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[2-1][3-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[2-1][1-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[2-1][2-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[2-1][1-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[2-1][4-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[2-1][3-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[2-1][4-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[2-1][2-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[2-1][3-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][5-1] 
            + a[2-1][2-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[2-1][4-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][5-1]
            - a[2-1][3-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][5-1]
            - a[2-1][4-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][5-1]
            + a[2-1][1-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][5-1]
            + a[2-1][3-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][5-1]
            - a[2-1][1-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][5-1]
            - a[2-1][4-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][5-1]
            + a[2-1][2-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][5-1]
            + a[2-1][4-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][5-1]
            - a[2-1][1-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][5-1] 
            - a[2-1][2-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][5-1]
            + a[2-1][1-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][5-1]
            + a[2-1][3-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][5-1]
            - a[2-1][2-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][5-1]
            - a[2-1][3-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][5-1]
            + a[2-1][1-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][5-1]
            + a[2-1][2-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][5-1]
            - a[2-1][1-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][5-1];
    cofactor[31] = a[1-1][5-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][1-1]
            - a[1-1][4-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][1-1] 
            - a[1-1][5-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][1-1]
            + a[1-1][3-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][1-1]
            - a[1-1][3-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[1-1][5-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[1-1][4-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[1-1][5-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][1-1] 
            - a[1-1][3-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][1-1]
            + a[1-1][3-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][1-1]
            - a[1-1][4-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][1-1]
            + a[1-1][3-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][1-1]
            - a[1-1][3-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][1-1] 
            - a[1-1][5-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[1-1][3-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[1-1][4-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[1-1][3-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][2-1]
            - a[1-1][4-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][2-1]
            + a[1-1][1-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][2-1] 
            - a[1-1][1-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[1-1][3-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[1-1][1-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[1-1][3-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[1-1][1-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[1-1][3-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[1-1][4-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[1-1][1-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][2-1] 
            + a[1-1][3-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[1-1][1-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[1-1][4-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[1-1][5-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[1-1][4-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[1-1][5-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][3-1]
            + a[1-1][4-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][3-1] 
            - a[1-1][1-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][3-1]
            - a[1-1][4-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][3-1]
            + a[1-1][1-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][3-1]
            - a[1-1][5-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][3-1]
            + a[1-1][1-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][3-1]
            - a[1-1][1-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][3-1]
            - a[1-1][4-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][3-1] 
            + a[1-1][4-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[1-1][1-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][3-1]
            + a[1-1][1-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[1-1][5-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[1-1][3-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[1-1][5-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[1-1][3-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[1-1][5-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][4-1] 
            - a[1-1][3-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][4-1]
            - a[1-1][5-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][4-1]
            + a[1-1][1-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][4-1]
            + a[1-1][3-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][4-1]
            - a[1-1][5-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][4-1]
            + a[1-1][5-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][4-1]
            + a[1-1][1-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][4-1] 
            + a[1-1][3-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[1-1][3-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[1-1][1-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[1-1][4-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[1-1][3-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[1-1][4-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[1-1][2-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[1-1][3-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][5-1] 
            - a[1-1][2-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[1-1][4-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][5-1]
            + a[1-1][3-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][5-1]
            + a[1-1][4-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][5-1]
            - a[1-1][3-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][5-1]
            + a[1-1][4-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][5-1]
            - a[1-1][4-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][5-1] 
            + a[1-1][2-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][5-1]
            - a[1-1][3-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][5-1]
            + a[1-1][2-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][5-1]
            + a[1-1][3-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][5-1];

    cofactor[32] = -a[1-1][5-1]*a[2-1][4-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][1-1] 
            + a[1-1][5-1]*a[2-1][3-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][1-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][1-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][1-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][1-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][1-1] 
            + a[1-1][3-1]*a[2-1][5-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][1-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][1-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][1-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][1-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][1-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][1-1] 
            + a[1-1][5-1]*a[2-1][4-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][2-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][2-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][2-1] 
            + a[1-1][1-1]*a[2-1][4-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][2-1] 
            - a[1-1][3-1]*a[2-1][1-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][3-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][3-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][3-1] 
            + a[1-1][1-1]*a[2-1][5-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][3-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][3-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][3-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][3-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][3-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[4-1][5-1]*a[5-1][4-1]*a[6-1][3-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][3-1] 
            - a[1-1][4-1]*a[2-1][1-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][3-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[4-1][4-1]*a[5-1][5-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[4-1][5-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][4-1] 
            + a[1-1][3-1]*a[2-1][5-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][4-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][4-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][4-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[4-1][5-1]*a[5-1][2-1]*a[6-1][4-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][4-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][4-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[4-1][5-1]*a[5-1][3-1]*a[6-1][4-1] 
            - a[1-1][3-1]*a[2-1][2-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[4-1][1-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[4-1][2-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[4-1][3-1]*a[5-1][5-1]*a[6-1][4-1]

            - a[1-1][4-1]*a[2-1][3-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[4-1][2-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[4-1][3-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][5-1] 
            + a[1-1][2-1]*a[2-1][3-1]*a[4-1][4-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][5-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[4-1][1-1]*a[5-1][2-1]*a[6-1][5-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[4-1][3-1]*a[5-1][2-1]*a[6-1][5-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[4-1][4-1]*a[5-1][2-1]*a[6-1][5-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][5-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[4-1][1-1]*a[5-1][3-1]*a[6-1][5-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[4-1][2-1]*a[5-1][3-1]*a[6-1][5-1] 
            - a[1-1][2-1]*a[2-1][1-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[4-1][4-1]*a[5-1][3-1]*a[6-1][5-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[4-1][1-1]*a[5-1][4-1]*a[6-1][5-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[4-1][2-1]*a[5-1][4-1]*a[6-1][5-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[4-1][3-1]*a[5-1][4-1]*a[6-1][5-1];
    cofactor[33] = a[1-1][5-1]*a[2-1][4-1]*a[3-1][3-1]*a[5-1][2-1]*a[6-1][1-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][3-1]*a[5-1][2-1]*a[6-1][1-1] 
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][4-1]*a[5-1][2-1]*a[6-1][1-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][4-1]*a[5-1][2-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][5-1]*a[5-1][2-1]*a[6-1][1-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[3-1][5-1]*a[5-1][2-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][2-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][2-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][4-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][4-1]*a[5-1][3-1]*a[6-1][1-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][5-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][5-1]*a[5-1][3-1]*a[6-1][1-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][2-1]*a[5-1][4-1]*a[6-1][1-1] 
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][2-1]*a[5-1][4-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][3-1]*a[5-1][4-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][3-1]*a[5-1][4-1]*a[6-1][1-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][5-1]*a[5-1][4-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][5-1]*a[5-1][4-1]*a[6-1][1-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][2-1]*a[5-1][5-1]*a[6-1][1-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][2-1]*a[5-1][5-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][3-1]*a[5-1][5-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][3-1]*a[5-1][5-1]*a[6-1][1-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][4-1]*a[5-1][5-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][4-1]*a[5-1][5-1]*a[6-1][1-1] 
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][3-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][3-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][4-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][4-1]*a[5-1][1-1]*a[6-1][2-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][5-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][5-1]*a[5-1][1-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[3-1][1-1]*a[5-1][3-1]*a[6-1][2-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][1-1]*a[5-1][3-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][4-1]*a[5-1][3-1]*a[6-1][2-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][4-1]*a[5-1][3-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][5-1]*a[5-1][3-1]*a[6-1][2-1] 
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][5-1]*a[5-1][3-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][1-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][1-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][3-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][3-1]*a[5-1][4-1]*a[6-1][2-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][5-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][5-1]*a[5-1][4-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][1-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[3-1][1-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][3-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][3-1]*a[5-1][5-1]*a[6-1][2-1] 
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][4-1]*a[5-1][5-1]*a[6-1][2-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][4-1]*a[5-1][5-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[3-1][2-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][2-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][4-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][4-1]*a[5-1][1-1]*a[6-1][3-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][5-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][5-1]*a[5-1][1-1]*a[6-1][3-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][1-1]*a[5-1][2-1]*a[6-1][3-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][1-1]*a[5-1][2-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][4-1]*a[5-1][2-1]*a[6-1][3-1] 
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][4-1]*a[5-1][2-1]*a[6-1][3-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][5-1]*a[5-1][2-1]*a[6-1][3-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][5-1]*a[5-1][2-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][1-1]*a[5-1][4-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][1-1]*a[5-1][4-1]*a[6-1][3-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][2-1]*a[5-1][4-1]*a[6-1][3-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][2-1]*a[5-1][4-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][5-1]*a[5-1][4-1]*a[6-1][3-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][5-1]*a[5-1][4-1]*a[6-1][3-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][1-1]*a[5-1][5-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][1-1]*a[5-1][5-1]*a[6-1][3-1] 
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][2-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][2-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][4-1]*a[5-1][5-1]*a[6-1][3-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][4-1]*a[5-1][5-1]*a[6-1][3-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][2-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][2-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][3-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][3-1]*a[5-1][1-1]*a[6-1][4-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][5-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][5-1]*a[5-1][1-1]*a[6-1][4-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][1-1]*a[5-1][2-1]*a[6-1][4-1] 
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][1-1]*a[5-1][2-1]*a[6-1][4-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][3-1]*a[5-1][2-1]*a[6-1][4-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][3-1]*a[5-1][2-1]*a[6-1][4-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][5-1]*a[5-1][2-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][5-1]*a[5-1][2-1]*a[6-1][4-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][1-1]*a[5-1][3-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][1-1]*a[5-1][3-1]*a[6-1][4-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][2-1]*a[5-1][3-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][2-1]*a[5-1][3-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][5-1]*a[5-1][3-1]*a[6-1][4-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][5-1]*a[5-1][3-1]*a[6-1][4-1] 
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][1-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][1-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][2-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][2-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][3-1]*a[5-1][5-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][3-1]*a[5-1][5-1]*a[6-1][4-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][2-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[3-1][2-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][3-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][3-1]*a[5-1][1-1]*a[6-1][5-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][4-1]*a[5-1][1-1]*a[6-1][5-1] 
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][4-1]*a[5-1][1-1]*a[6-1][5-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][1-1]*a[5-1][2-1]*a[6-1][5-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][1-1]*a[5-1][2-1]*a[6-1][5-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][3-1]*a[5-1][2-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][3-1]*a[5-1][2-1]*a[6-1][5-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][4-1]*a[5-1][2-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][4-1]*a[5-1][2-1]*a[6-1][5-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][1-1]*a[5-1][3-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][1-1]*a[5-1][3-1]*a[6-1][5-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][2-1]*a[5-1][3-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][2-1]*a[5-1][3-1]*a[6-1][5-1] 
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][4-1]*a[5-1][3-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][4-1]*a[5-1][3-1]*a[6-1][5-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][1-1]*a[5-1][4-1]*a[6-1][5-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][1-1]*a[5-1][4-1]*a[6-1][5-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][2-1]*a[5-1][4-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][2-1]*a[5-1][4-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][3-1]*a[5-1][4-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][3-1]*a[5-1][4-1]*a[6-1][5-1];
    cofactor[34] = -a[1-1][5-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][2-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][2-1]*a[6-1][1-1] 
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][2-1]*a[6-1][1-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][2-1]*a[6-1][1-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][2-1]*a[6-1][1-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][2-1]*a[6-1][1-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][3-1]*a[6-1][1-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][3-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][3-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][3-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][3-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][3-1]*a[6-1][1-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][4-1]*a[6-1][1-1] 
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][4-1]*a[6-1][1-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][4-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][4-1]*a[6-1][1-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][4-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][4-1]*a[6-1][1-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][5-1]*a[6-1][1-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][5-1]*a[6-1][1-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][5-1]*a[6-1][1-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][5-1]*a[6-1][1-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][5-1]*a[6-1][1-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][5-1]*a[6-1][1-1] 
            + a[1-1][5-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][1-1]*a[6-1][2-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][1-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][1-1]*a[6-1][2-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][1-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][1-1]*a[6-1][2-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][1-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][3-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][3-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][3-1]*a[6-1][2-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][3-1]*a[6-1][2-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][3-1]*a[6-1][2-1] 
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][3-1]*a[6-1][2-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][4-1]*a[6-1][2-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][4-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][4-1]*a[6-1][2-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][4-1]*a[6-1][2-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][4-1]*a[6-1][2-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][4-1]*a[6-1][2-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][5-1]*a[6-1][2-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][5-1]*a[6-1][2-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][5-1]*a[6-1][2-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][5-1]*a[6-1][2-1] 
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][5-1]*a[6-1][2-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][5-1]*a[6-1][2-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][1-1]*a[6-1][3-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][1-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][1-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][1-1]*a[6-1][3-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][1-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][1-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][2-1]*a[6-1][3-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][2-1]*a[6-1][3-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][2-1]*a[6-1][3-1] 
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][2-1]*a[6-1][3-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][2-1]*a[6-1][3-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][2-1]*a[6-1][3-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][4-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][4-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][4-1]*a[6-1][3-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][4-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][4-1]*a[6-1][3-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][4-1]*a[6-1][3-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][5-1]*a[6-1][3-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][5-1]*a[6-1][3-1] 
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][5-1]*a[6-1][3-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][5-1]*a[6-1][3-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][5-1]*a[6-1][3-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][5-1]*a[6-1][3-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][1-1]*a[6-1][4-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][1-1]*a[6-1][4-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][1-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][1-1]*a[6-1][4-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][1-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][1-1]*a[6-1][4-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][2-1]*a[6-1][4-1] 
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][2-1]*a[6-1][4-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][2-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][2-1]*a[6-1][4-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][2-1]*a[6-1][4-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][2-1]*a[6-1][4-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][3-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][3-1]*a[6-1][4-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][3-1]*a[6-1][4-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][3-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][3-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][3-1]*a[6-1][4-1] 
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][5-1]*a[6-1][4-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][5-1]*a[6-1][4-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][5-1]*a[6-1][4-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][5-1]*a[6-1][4-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][5-1]*a[6-1][4-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][5-1]*a[6-1][4-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][1-1]*a[6-1][5-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][1-1]*a[6-1][5-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][1-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][1-1]*a[6-1][5-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][1-1]*a[6-1][5-1] 
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][1-1]*a[6-1][5-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][2-1]*a[6-1][5-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][2-1]*a[6-1][5-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][2-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][2-1]*a[6-1][5-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][2-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][2-1]*a[6-1][5-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][3-1]*a[6-1][5-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][3-1]*a[6-1][5-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][3-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][3-1]*a[6-1][5-1] 
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][3-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][3-1]*a[6-1][5-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][4-1]*a[6-1][5-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][4-1]*a[6-1][5-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][4-1]*a[6-1][5-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][4-1]*a[6-1][5-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][4-1]*a[6-1][5-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][4-1]*a[6-1][5-1];
    cofactor[35] = a[1-1][5-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][1-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][1-1] 
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][1-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][1-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][1-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][1-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][1-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][1-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][1-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][1-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][1-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][1-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][1-1] 
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][1-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][1-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][1-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][1-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][1-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][1-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][1-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][1-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][1-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][1-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][1-1] 
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][2-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][2-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][2-1]
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][2-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][2-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][2-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][2-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][2-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][2-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][2-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][2-1] 
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][2-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][2-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][2-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][2-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][2-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][2-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][2-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][2-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][2-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][2-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][2-1] 
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][2-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][2-1]
            + a[1-1][5-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][3-1]
            - a[1-1][4-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][3-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][3-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][3-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][3-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][3-1]
            - a[1-1][5-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][3-1]
            + a[1-1][4-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][3-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][3-1] 
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][3-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][3-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][3-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][3-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][3-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][3-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][3-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][3-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][4-1]*a[5-1][3-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][3-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][3-1] 
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][3-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][3-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][3-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][5-1]*a[5-1][3-1]
            - a[1-1][5-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][4-1]
            + a[1-1][3-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][4-1]
            + a[1-1][5-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][4-1]
            - a[1-1][2-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][4-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][4-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][1-1]*a[5-1][4-1]
            + a[1-1][5-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][4-1] 
            - a[1-1][3-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][4-1]
            - a[1-1][5-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][4-1]
            + a[1-1][1-1]*a[2-1][5-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][4-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][4-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][5-1]*a[4-1][2-1]*a[5-1][4-1]
            - a[1-1][5-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][4-1]
            + a[1-1][2-1]*a[2-1][5-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][4-1]
            + a[1-1][5-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][4-1]
            - a[1-1][1-1]*a[2-1][5-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][4-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][4-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][5-1]*a[4-1][3-1]*a[5-1][4-1] 
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][4-1]
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][5-1]*a[5-1][4-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][4-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][5-1]*a[5-1][4-1]
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][4-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][5-1]*a[5-1][4-1]
            + a[1-1][4-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][5-1]
            - a[1-1][3-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][1-1]*a[5-1][5-1]
            - a[1-1][4-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][5-1]
            + a[1-1][2-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][1-1]*a[5-1][5-1]
            + a[1-1][3-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][5-1] 
            - a[1-1][2-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][1-1]*a[5-1][5-1]
            - a[1-1][4-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][5-1]
            + a[1-1][3-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][2-1]*a[5-1][5-1]
            + a[1-1][4-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][5-1]
            - a[1-1][1-1]*a[2-1][4-1]*a[3-1][3-1]*a[4-1][2-1]*a[5-1][5-1]
            - a[1-1][3-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][5-1]
            + a[1-1][1-1]*a[2-1][3-1]*a[3-1][4-1]*a[4-1][2-1]*a[5-1][5-1]
            + a[1-1][4-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][5-1]
            - a[1-1][2-1]*a[2-1][4-1]*a[3-1][1-1]*a[4-1][3-1]*a[5-1][5-1]
            - a[1-1][4-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][5-1]
            + a[1-1][1-1]*a[2-1][4-1]*a[3-1][2-1]*a[4-1][3-1]*a[5-1][5-1] 
            + a[1-1][2-1]*a[2-1][1-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][5-1]
            - a[1-1][1-1]*a[2-1][2-1]*a[3-1][4-1]*a[4-1][3-1]*a[5-1][5-1]
            - a[1-1][3-1]*a[2-1][2-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][5-1]
            + a[1-1][2-1]*a[2-1][3-1]*a[3-1][1-1]*a[4-1][4-1]*a[5-1][5-1]
            + a[1-1][3-1]*a[2-1][1-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][5-1]
            - a[1-1][1-1]*a[2-1][3-1]*a[3-1][2-1]*a[4-1][4-1]*a[5-1][5-1]
            - a[1-1][2-1]*a[2-1][1-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][5-1]
            + a[1-1][1-1]*a[2-1][2-1]*a[3-1][3-1]*a[4-1][4-1]*a[5-1][5-1];

    const double jinv = 1/det;

    for (int i = 1; i <= 6; ++i) {
        for (int j = 1; j <= 6; ++j) {
            ainv[j + i*6] = cofactor[i + j*6 - 7] *jinv;
        }
    }
    *ok_flag__ = 0;
    return 0;
}
#endif

#define a11  a[ 0]
#define a12  a[6]
#define a13  a[12]
#define a14  a[18]
#define a15  a[24]
#define a16  a[30]
#define a21  a[ 1]
#define a22  a[7]
#define a23  a[13]
#define a24  a[19]
#define a25  a[25]
#define a26  a[31]
#define a31  a[ 2]
#define a32  a[8]
#define a33  a[14]
#define a34  a[20]
#define a35  a[26]
#define a36  a[32]
#define a41  a[3]
#define a42  a[9]
#define a43  a[15]
#define a44  a[21]
#define a45  a[27]
#define a46  a[33]
#define a51  a[4]
#define a52  a[10]
#define a53  a[16]
#define a54  a[22]
#define a55  a[28]
#define a56  a[34]
#define a61  a[5]
#define a62  a[11]
#define a63  a[17]
#define a64  a[23]
#define a65  a[29]
#define a66  a[35]

int cmx_inv6(const double a[36], double *ainv, int*ok_flag__)
{
    double cofactor[36];

    /* Parameter adjustments */
//  ainv -= 7;
//  a -= 7;

    /* Function Body */
    const double eps = 1e-10;
    const double
    det = - ( a16*a25*a34*a43*a52
            - a15*a26*a34*a43*a52
            - a16*a24*a35*a43*a52
            + a14*a26*a35*a43*a52
            + a15*a24*a36*a43*a52
            - a14*a25*a36*a43*a52
            - a16*a25*a33*a44*a52
            + a15*a26*a33*a44*a52
            + a16*a23*a35*a44*a52
            - a13*a26*a35*a44*a52
            - a15*a23*a36*a44*a52
            + a13*a25*a36*a44*a52
            + a16*a24*a33*a45*a52
            - a14*a26*a33*a45*a52
            - a16*a23*a34*a45*a52
            + a13*a26*a34*a45*a52
            + a14*a23*a36*a45*a52
            - a13*a24*a36*a45*a52
            - a15*a24*a33*a46*a52
            + a14*a25*a33*a46*a52
            + a15*a23*a34*a46*a52
            - a13*a25*a34*a46*a52
            - a14*a23*a35*a46*a52
            + a13*a24*a35*a46*a52
            - a16*a25*a34*a42*a53
            + a15*a26*a34*a42*a53
            + a16*a24*a35*a42*a53
            - a14*a26*a35*a42*a53
            - a15*a24*a36*a42*a53
            + a14*a25*a36*a42*a53
            + a16*a25*a32*a44*a53
            - a15*a26*a32*a44*a53
            - a16*a22*a35*a44*a53
            + 
            a12*a26*a35*a44*a53
            + a15*a22*a36*a44*a53
            - a12*a25*a36*a44*a53
            - a16*a24*a32*a45*a53
            + a14*a26*a32*a45*a53
            + a16*a22*a34*a45*a53
            - a12*a26*a34*a45*a53
            - a14*a22*a36*a45*a53
            + a12*a24*a36*a45*a53
            + a15*a24*a32*a46*a53
            - a14*a25*a32*a46*a53
            - 
            a15*a22*a34*a46*a53
            + a12*a25*a34*a46*a53
            + a14*a22*a35*a46*a53
            - a12*a24*a35*a46*a53
            + a16*a25*a33*a42*a54
            - a15*a26*a33*a42*a54
            - a16*a23*a35*a42*a54
            + a13*a26*a35*a42*a54
            + a15*a23*a36*a42*a54
            - a13*a25*a36*a42*a54
            - a16*a25*a32*a43*a54
            + 
            a15*a26*a32*a43*a54
            + a16*a22*a35*a43*a54
            - a12*a26*a35*a43*a54
            - a15*a22*a36*a43*a54
            + a12*a25*a36*a43*a54
            + a16*a23*a32*a45*a54
            - a13*a26*a32*a45*a54
            - a16*a22*a33*a45*a54
            + a12*a26*a33*a45*a54
            + a13*a22*a36*a45*a54
            - a12*a23*a36*a45*a54
            - 
            a15*a23*a32*a46*a54
            + a13*a25*a32*a46*a54
            + a15*a22*a33*a46*a54
            - a12*a25*a33*a46*a54
            - a13*a22*a35*a46*a54
            + a12*a23*a35*a46*a54
            - a16*a24*a33*a42*a55
            + a14*a26*a33*a42*a55
            + a16*a23*a34*a42*a55
            - a13*a26*a34*a42*a55
            - a14*a23*a36*a42*a55
            + a13*a24*a36*a42*a55
            + a16*a24*a32*a43*a55
            - a14*a26*a32*a43*a55
            - a16*a22*a34*a43*a55
            + a12*a26*a34*a43*a55
            + a14*a22*a36*a43*a55
            - a12*a24*a36*a43*a55
            - a16*a23*a32*a44*a55
            + a13*a26*a32*a44*a55
            + a16*a22*a33*a44*a55
            - a12*a26*a33*a44*a55
            - a13*a22*a36*a44*a55
            + a12*a23*a36*a44*a55
            + a14*a23*a32*a46*a55
            - a13*a24*a32*a46*a55
            - a14*a22*a33*a46*a55
            + a12*a24*a33*a46*a55
            + a13*a22*a34*a46*a55
            - a12*a23*a34*a46*a55
            + a15*a24*a33*a42*a56
            - a14*a25*a33*a42*a56
            - a15*a23*a34*a42*a56
            + a13*a25*a34*a42*a56
            + a14*a23*a35*a42*a56
            - a13*a24*a35*a42*a56
            - a15*a24*a32*a43*a56
            + a14*a25*a32*a43*a56
            + a15*a22*a34*a43*a56
            - a12*a25*a34*a43*a56
            - a14*a22*a35*a43*a56
            + a12*a24*a35*a43*a56
            + a15*a23*a32*a44*a56
            - a13*a25*a32*a44*a56
            - a15*a22*a33*a44*a56
            + a12*a25*a33*a44*a56
            + a13*a22*a35*a44*a56
            - a12*a23*a35*a44*a56
            - a14*a23*a32*a45*a56
            + a13*a24*a32*a45*a56
            + a14*a22*a33*a45*a56
            - a12*a24*a33*a45*a56
            - a13*a22*a34*a45*a56
            + a12*a23*a34*a45*a56)*a61

            + (a16*a25*a34*a43*a51
            - a15*a26*a34*a43*a51
            - a16*a24*a35*a43*a51 
            + a14*a26*a35*a43*a51
            + a15*a24*a36*a43*a51
            - a14*a25*a36*a43*a51
            - a16*a25*a33*a44*a51
            + a15*a26*a33*a44*a51
            + a16*a23*a35*a44*a51
            - a13*a26*a35*a44*a51
            - a15*a23*a36*a44*a51
            + a13*a25*a36*a44*a51
            + a16*a24*a33*a45*a51
            - a14*a26*a33*a45*a51 
            - a16*a23*a34*a45*a51
            + a13*a26*a34*a45*a51
            + a14*a23*a36*a45*a51
            - a13*a24*a36*a45*a51
            - a15*a24*a33*a46*a51
            + a14*a25*a33*a46*a51
            + a15*a23*a34*a46*a51
            - a13*a25*a34*a46*a51
            - a14*a23*a35*a46*a51
            + a13*a24*a35*a46*a51
            - a16*a25*a34*a41*a53 
            + a15*a26*a34*a41*a53
            + a16*a24*a35*a41*a53
            - a14*a26*a35*a41*a53
            - a15*a24*a36*a41*a53
            + a14*a25*a36*a41*a53
            + a16*a25*a31*a44*a53
            - a15*a26*a31*a44*a53
            - a16*a21*a35*a44*a53
            + a11*a26*a35*a44*a53
            + a15*a21*a36*a44*a53
            - a11*a25*a36*a44*a53 
            - a16*a24*a31*a45*a53
            + a14*a26*a31*a45*a53
            + a16*a21*a34*a45*a53
            - a11*a26*a34*a45*a53
            - a14*a21*a36*a45*a53
            + a11*a24*a36*a45*a53
            + a15*a24*a31*a46*a53
            - a14*a25*a31*a46*a53
            - a15*a21*a34*a46*a53
            + a11*a25*a34*a46*a53
            + a14*a21*a35*a46*a53 
            - a11*a24*a35*a46*a53
            + a16*a25*a33*a41*a54
            - a15*a26*a33*a41*a54
            - a16*a23*a35*a41*a54
            + a13*a26*a35*a41*a54
            + a15*a23*a36*a41*a54
            - a13*a25*a36*a41*a54
            - a16*a25*a31*a43*a54
            + a15*a26*a31*a43*a54
            + a16*a21*a35*a43*a54
            - a11*a26*a35*a43*a54 
            - a15*a21*a36*a43*a54
            + a11*a25*a36*a43*a54
            + a16*a23*a31*a45*a54
            - a13*a26*a31*a45*a54
            - a16*a21*a33*a45*a54
            + a11*a26*a33*a45*a54
            + a13*a21*a36*a45*a54
            - a11*a23*a36*a45*a54
            - a15*a23*a31*a46*a54
            + a13*a25*a31*a46*a54
            + a15*a21*a33*a46*a54 
            - a11*a25*a33*a46*a54
            - a13*a21*a35*a46*a54
            + a11*a23*a35*a46*a54
            - a16*a24*a33*a41*a55
            + a14*a26*a33*a41*a55
            + a16*a23*a34*a41*a55
            - a13*a26*a34*a41*a55
            - a14*a23*a36*a41*a55
            + a13*a24*a36*a41*a55
            + a16*a24*a31*a43*a55
            - a14*a26*a31*a43*a55 
            - a16*a21*a34*a43*a55
            + a11*a26*a34*a43*a55
            + a14*a21*a36*a43*a55
            - a11*a24*a36*a43*a55
            - a16*a23*a31*a44*a55
            + a13*a26*a31*a44*a55
            + a16*a21*a33*a44*a55
            - a11*a26*a33*a44*a55
            - a13*a21*a36*a44*a55
            + a11*a23*a36*a44*a55
            + a14*a23*a31*a46*a55 
            - a13*a24*a31*a46*a55
            - a14*a21*a33*a46*a55
            + a11*a24*a33*a46*a55
            + a13*a21*a34*a46*a55
            - a11*a23*a34*a46*a55
            + a15*a24*a33*a41*a56
            - a14*a25*a33*a41*a56
            - a15*a23*a34*a41*a56
            + a13*a25*a34*a41*a56
            + a14*a23*a35*a41*a56
            - a13*a24*a35*a41*a56 
            - a15*a24*a31*a43*a56
            + a14*a25*a31*a43*a56
            + a15*a21*a34*a43*a56
            - a11*a25*a34*a43*a56
            - a14*a21*a35*a43*a56
            + a11*a24*a35*a43*a56
            + a15*a23*a31*a44*a56
            - a13*a25*a31*a44*a56
            - a15*a21*a33*a44*a56
            + a11*a25*a33*a44*a56
            + a13*a21*a35*a44*a56 
            - a11*a23*a35*a44*a56
            - a14*a23*a31*a45*a56
            + a13*a24*a31*a45*a56
            + a14*a21*a33*a45*a56
            - a11*a24*a33*a45*a56
            - a13*a21*a34*a45*a56
            + a11*a23*a34*a45*a56)*a62
            - (a16*a25*a34*a42*a51
            - a15*a26*a34*a42*a51
            - a16*a24*a35*a42*a51
            + a14*a26*a35*a42*a51
            + a15*a24*a36*a42*a51
            - a14*a25*a36*a42*a51
            - a16*a25*a32*a44*a51
            + a15*a26*a32*a44*a51
            + 
            a16*a22*a35*a44*a51
            - a12*a26*a35*a44*a51
            - a15*a22*a36*a44*a51
            + a12*a25*a36*a44*a51
            + a16*a24*a32*a45*a51
            - a14*a26*a32*a45*a51
            - a16*a22*a34*a45*a51
            + a12*a26*a34*a45*a51
            + a14*a22*a36*a45*a51
            - a12*a24*a36*a45*a51
            - a15*a24*a32*a46*a51
            + 
            a14*a25*a32*a46*a51
            + a15*a22*a34*a46*a51
            - a12*a25*a34*a46*a51
            - a14*a22*a35*a46*a51
            + a12*a24*a35*a46*a51
            - a16*a25*a34*a41*a52
            + a15*a26*a34*a41*a52
            + a16*a24*a35*a41*a52
            - a14*a26*a35*a41*a52
            - a15*a24*a36*a41*a52
            + a14*a25*a36*a41*a52
            + 
            a16*a25*a31*a44*a52
            - a15*a26*a31*a44*a52
            - a16*a21*a35*a44*a52
            + a11*a26*a35*a44*a52
            + a15*a21*a36*a44*a52
            - a11*a25*a36*a44*a52
            - a16*a24*a31*a45*a52
            + a14*a26*a31*a45*a52
            + a16*a21*a34*a45*a52
            - a11*a26*a34*a45*a52
            - a14*a21*a36*a45*a52
            + 
            a11*a24*a36*a45*a52
            + a15*a24*a31*a46*a52
            - a14*a25*a31*a46*a52
            - a15*a21*a34*a46*a52
            + a11*a25*a34*a46*a52
            + a14*a21*a35*a46*a52
            - a11*a24*a35*a46*a52
            + a16*a25*a32*a41*a54
            - a15*a26*a32*a41*a54
            - a16*a22*a35*a41*a54
            + a12*a26*a35*a41*a54
            + 
            a15*a22*a36*a41*a54
            - a12*a25*a36*a41*a54
            - a16*a25*a31*a42*a54
            + a15*a26*a31*a42*a54
            + a16*a21*a35*a42*a54
            - a11*a26*a35*a42*a54
            - a15*a21*a36*a42*a54
            + a11*a25*a36*a42*a54
            + a16*a22*a31*a45*a54
            - a12*a26*a31*a45*a54
            - a16*a21*a32*a45*a54
            + 
            a11*a26*a32*a45*a54
            + a12*a21*a36*a45*a54
            - a11*a22*a36*a45*a54
            - a15*a22*a31*a46*a54
            + a12*a25*a31*a46*a54
            + a15*a21*a32*a46*a54
            - a11*a25*a32*a46*a54
            - a12*a21*a35*a46*a54
            + a11*a22*a35*a46*a54
            - a16*a24*a32*a41*a55
            + a14*a26*a32*a41*a55
            + 
            a16*a22*a34*a41*a55
            - a12*a26*a34*a41*a55
            - a14*a22*a36*a41*a55
            + a12*a24*a36*a41*a55
            + a16*a24*a31*a42*a55
            - a14*a26*a31*a42*a55
            - a16*a21*a34*a42*a55
            + a11*a26*a34*a42*a55
            + a14*a21*a36*a42*a55
            - a11*a24*a36*a42*a55
            - a16*a22*a31*a44*a55
            + 
            a12*a26*a31*a44*a55
            + a16*a21*a32*a44*a55
            - a11*a26*a32*a44*a55
            - a12*a21*a36*a44*a55
            + a11*a22*a36*a44*a55
            + a14*a22*a31*a46*a55
            - a12*a24*a31*a46*a55
            - a14*a21*a32*a46*a55
            + a11*a24*a32*a46*a55
            + a12*a21*a34*a46*a55
            - a11*a22*a34*a46*a55
            + 
            a15*a24*a32*a41*a56
            - a14*a25*a32*a41*a56
            - a15*a22*a34*a41*a56
            + a12*a25*a34*a41*a56
            + a14*a22*a35*a41*a56
            - a12*a24*a35*a41*a56
            - a15*a24*a31*a42*a56
            + a14*a25*a31*a42*a56
            + a15*a21*a34*a42*a56
            - a11*a25*a34*a42*a56
            - a14*a21*a35*a42*a56
            + 
            a11*a24*a35*a42*a56
            + a15*a22*a31*a44*a56
            - a12*a25*a31*a44*a56
            - a15*a21*a32*a44*a56
            + a11*a25*a32*a44*a56
            + a12*a21*a35*a44*a56
            - a11*a22*a35*a44*a56
            - a14*a22*a31*a45*a56
            + a12*a24*a31*a45*a56
            + a14*a21*a32*a45*a56
            - a11*a24*a32*a45*a56
            - 
            a12*a21*a34*a45*a56
            + a11*a22*a34*a45*a56)*a63 
            + (a16*a25*a33*a42*a51
            - a15*a26*a33*a42*a51
            - 
            a16*a23*a35*a42*a51
            + a13*a26*a35*a42*a51
            + a15*a23*a36*a42*a51
            - a13*a25*a36*a42*a51
            - a16*a25*a32*a43*a51
            + a15*a26*a32*a43*a51
            + a16*a22*a35*a43*a51
            - a12*a26*a35*a43*a51
            - a15*a22*a36*a43*a51
            + a12*a25*a36*a43*a51
            + a16*a23*a32*a45*a51
            - 
            a13*a26*a32*a45*a51
            - a16*a22*a33*a45*a51
            + a12*a26*a33*a45*a51
            + a13*a22*a36*a45*a51
            - a12*a23*a36*a45*a51
            - a15*a23*a32*a46*a51
            + a13*a25*a32*a46*a51
            + a15*a22*a33*a46*a51
            - a12*a25*a33*a46*a51
            - a13*a22*a35*a46*a51
            + a12*a23*a35*a46*a51
            - 
            a16*a25*a33*a41*a52
            + a15*a26*a33*a41*a52
            + a16*a23*a35*a41*a52
            - a13*a26*a35*a41*a52
            - a15*a23*a36*a41*a52
            + a13*a25*a36*a41*a52
            + a16*a25*a31*a43*a52
            - a15*a26*a31*a43*a52
            - a16*a21*a35*a43*a52
            + a11*a26*a35*a43*a52
            + a15*a21*a36*a43*a52
            - a11*a25*a36*a43*a52
            - a16*a23*a31*a45*a52
            + a13*a26*a31*a45*a52
            + a16*a21*a33*a45*a52
            - a11*a26*a33*a45*a52
            - a13*a21*a36*a45*a52
            + a11*a23*a36*a45*a52
            + a15*a23*a31*a46*a52
            - a13*a25*a31*a46*a52
            - a15*a21*a33*a46*a52
            + a11*a25*a33*a46*a52
            + a13*a21*a35*a46*a52
            - a11*a23*a35*a46*a52
            + a16*a25*a32*a41*a53
            - a15*a26*a32*a41*a53
            - a16*a22*a35*a41*a53
            + a12*a26*a35*a41*a53
            + a15*a22*a36*a41*a53
            - a12*a25*a36*a41*a53
            - a16*a25*a31*a42*a53
            + a15*a26*a31*a42*a53
            + a16*a21*a35*a42*a53
            - a11*a26*a35*a42*a53
            - a15*a21*a36*a42*a53
            + a11*a25*a36*a42*a53
            + a16*a22*a31*a45*a53
            - a12*a26*a31*a45*a53
            - a16*a21*a32*a45*a53
            + a11*a26*a32*a45*a53
            + a12*a21*a36*a45*a53
            - a11*a22*a36*a45*a53
            - a15*a22*a31*a46*a53
            + a12*a25*a31*a46*a53
            + a15*a21*a32*a46*a53
            - a11*a25*a32*a46*a53
            - a12*a21*a35*a46*a53
            + a11*a22*a35*a46*a53
            - a16*a23*a32*a41*a55
            + a13*a26*a32*a41*a55
            + a16*a22*a33*a41*a55
            - a12*a26*a33*a41*a55
            - a13*a22*a36*a41*a55
            + a12*a23*a36*a41*a55
            + a16*a23*a31*a42*a55
            - a13*a26*a31*a42*a55
            - a16*a21*a33*a42*a55
            + a11*a26*a33*a42*a55
            + a13*a21*a36*a42*a55
            - a11*a23*a36*a42*a55
            - a16*a22*a31*a43*a55
            + a12*a26*a31*a43*a55
            + a16*a21*a32*a43*a55
            - a11*a26*a32*a43*a55
            - a12*a21*a36*a43*a55
            + a11*a22*a36*a43*a55
            + a13*a22*a31*a46*a55
            - a12*a23*a31*a46*a55
            - a13*a21*a32*a46*a55
            + a11*a23*a32*a46*a55
            + a12*a21*a33*a46*a55
            - a11*a22*a33*a46*a55
            + a15*a23*a32*a41*a56
            - a13*a25*a32*a41*a56
            - a15*a22*a33*a41*a56
            + a12*a25*a33*a41*a56
            + a13*a22*a35*a41*a56
            - a12*a23*a35*a41*a56
            - a15*a23*a31*a42*a56
            + a13*a25*a31*a42*a56
            + a15*a21*a33*a42*a56
            - a11*a25*a33*a42*a56
            - a13*a21*a35*a42*a56
            + a11*a23*a35*a42*a56
            + a15*a22*a31*a43*a56
            - a12*a25*a31*a43*a56
            - a15*a21*a32*a43*a56
            + a11*a25*a32*a43*a56
            + a12*a21*a35*a43*a56
            - a11*a22*a35*a43*a56
            - a13*a22*a31*a45*a56
            + a12*a23*a31*a45*a56
            + a13*a21*a32*a45*a56
            - a11*a23*a32*a45*a56
            - a12*a21*a33*a45*a56
            + a11*a22*a33*a45*a56)*a64

            - (a16*a24*a33*a42*a51
            - a14*a26*a33*a42*a51
            - a16*a23*a34*a42*a51
            + a13*a26*a34*a42*a51
            + a14*a23*a36*a42*a51 
            - a13*a24*a36*a42*a51
            - a16*a24*a32*a43*a51
            + a14*a26*a32*a43*a51
            + a16*a22*a34*a43*a51
            - a12*a26*a34*a43*a51
            - a14*a22*a36*a43*a51
            + a12*a24*a36*a43*a51
            + a16*a23*a32*a44*a51
            - a13*a26*a32*a44*a51
            - a16*a22*a33*a44*a51
            + a12*a26*a33*a44*a51 
            + a13*a22*a36*a44*a51
            - a12*a23*a36*a44*a51
            - a14*a23*a32*a46*a51
            + a13*a24*a32*a46*a51
            + a14*a22*a33*a46*a51
            - a12*a24*a33*a46*a51
            - a13*a22*a34*a46*a51
            + a12*a23*a34*a46*a51
            - a16*a24*a33*a41*a52
            + a14*a26*a33*a41*a52
            + a16*a23*a34*a41*a52 
            - a13*a26*a34*a41*a52
            - a14*a23*a36*a41*a52
            + a13*a24*a36*a41*a52
            + a16*a24*a31*a43*a52
            - a14*a26*a31*a43*a52
            - a16*a21*a34*a43*a52
            + a11*a26*a34*a43*a52
            + a14*a21*a36*a43*a52
            - a11*a24*a36*a43*a52
            - a16*a23*a31*a44*a52
            + a13*a26*a31*a44*a52 
            + a16*a21*a33*a44*a52
            - a11*a26*a33*a44*a52
            - a13*a21*a36*a44*a52
            + a11*a23*a36*a44*a52
            + a14*a23*a31*a46*a52
            - a13*a24*a31*a46*a52
            - a14*a21*a33*a46*a52
            + a11*a24*a33*a46*a52
            + a13*a21*a34*a46*a52
            - a11*a23*a34*a46*a52
            + a16*a24*a32*a41*a53 
            - a14*a26*a32*a41*a53
            - a16*a22*a34*a41*a53
            + a12*a26*a34*a41*a53
            + a14*a22*a36*a41*a53
            - a12*a24*a36*a41*a53
            - a16*a24*a31*a42*a53
            + a14*a26*a31*a42*a53
            + a16*a21*a34*a42*a53
            - a11*a26*a34*a42*a53
            - a14*a21*a36*a42*a53
            + a11*a24*a36*a42*a53 
            + a16*a22*a31*a44*a53
            - a12*a26*a31*a44*a53
            - a16*a21*a32*a44*a53
            + a11*a26*a32*a44*a53
            + a12*a21*a36*a44*a53
            - a11*a22*a36*a44*a53
            - a14*a22*a31*a46*a53
            + a12*a24*a31*a46*a53
            + a14*a21*a32*a46*a53
            - a11*a24*a32*a46*a53
            - a12*a21*a34*a46*a53 
            + a11*a22*a34*a46*a53
            - a16*a23*a32*a41*a54
            + a13*a26*a32*a41*a54
            + a16*a22*a33*a41*a54
            - a12*a26*a33*a41*a54
            - a13*a22*a36*a41*a54
            + a12*a23*a36*a41*a54
            + a16*a23*a31*a42*a54
            - a13*a26*a31*a42*a54
            - a16*a21*a33*a42*a54
            + a11*a26*a33*a42*a54 
            + a13*a21*a36*a42*a54
            - a11*a23*a36*a42*a54
            - a16*a22*a31*a43*a54
            + a12*a26*a31*a43*a54
            + a16*a21*a32*a43*a54
            - a11*a26*a32*a43*a54
            - a12*a21*a36*a43*a54
            + a11*a22*a36*a43*a54
            + a13*a22*a31*a46*a54
            - a12*a23*a31*a46*a54
            - a13*a21*a32*a46*a54 
            + a11*a23*a32*a46*a54
            + a12*a21*a33*a46*a54
            - a11*a22*a33*a46*a54
            + a14*a23*a32*a41*a56
            - a13*a24*a32*a41*a56
            - a14*a22*a33*a41*a56
            + a12*a24*a33*a41*a56
            + a13*a22*a34*a41*a56
            - a12*a23*a34*a41*a56
            - a14*a23*a31*a42*a56
            + a13*a24*a31*a42*a56 
            + a14*a21*a33*a42*a56
            - a11*a24*a33*a42*a56
            - a13*a21*a34*a42*a56
            + a11*a23*a34*a42*a56
            + a14*a22*a31*a43*a56
            - a12*a24*a31*a43*a56
            - a14*a21*a32*a43*a56
            + a11*a24*a32*a43*a56
            + a12*a21*a34*a43*a56
            - a11*a22*a34*a43*a56
            - a13*a22*a31*a44*a56 
            + a12*a23*a31*a44*a56
            + a13*a21*a32*a44*a56
            - a11*a23*a32*a44*a56
            - a12*a21*a33*a44*a56
            + a11*a22*a33*a44*a56)*a65
          + (a15*a24*a33*a42*a51
            - a14*a25*a33*a42*a51
            - a15*a23*a34*a42*a51
            + a13*a25*a34*a42*a51
            + a14*a23*a35*a42*a51
            - a13*a24*a35*a42*a51
            - a15*a24*a32*a43*a51
            + a14*a25*a32*a43*a51
            + a15*a22*a34*a43*a51
            - a12*a25*a34*a43*a51
            - a14*a22*a35*a43*a51
            + a12*a24*a35*a43*a51
            + a15*a23*a32*a44*a51
            - a13*a25*a32*a44*a51
            - a15*a22*a33*a44*a51
            + a12*a25*a33*a44*a51
            + a13*a22*a35*a44*a51
            - a12*a23*a35*a44*a51
            - a14*a23*a32*a45*a51
            + a13*a24*a32*a45*a51
            + a14*a22*a33*a45*a51
            - 
            a12*a24*a33*a45*a51
            - a13*a22*a34*a45*a51
            + a12*a23*a34*a45*a51
            - a15*a24*a33*a41*a52
            + a14*a25*a33*a41*a52
            + a15*a23*a34*a41*a52
            - a13*a25*a34*a41*a52
            - a14*a23*a35*a41*a52
            + a13*a24*a35*a41*a52
            + a15*a24*a31*a43*a52
            - a14*a25*a31*a43*a52
            - 
            a15*a21*a34*a43*a52
            + a11*a25*a34*a43*a52
            + a14*a21*a35*a43*a52
            - a11*a24*a35*a43*a52
            - a15*a23*a31*a44*a52
            + a13*a25*a31*a44*a52
            + a15*a21*a33*a44*a52
            - a11*a25*a33*a44*a52
            - a13*a21*a35*a44*a52
            + a11*a23*a35*a44*a52
            + a14*a23*a31*a45*a52
            - 
            a13*a24*a31*a45*a52
            - a14*a21*a33*a45*a52
            + a11*a24*a33*a45*a52
            + a13*a21*a34*a45*a52
            - a11*a23*a34*a45*a52
            + a15*a24*a32*a41*a53
            - a14*a25*a32*a41*a53
            - a15*a22*a34*a41*a53
            + a12*a25*a34*a41*a53
            + a14*a22*a35*a41*a53
            - a12*a24*a35*a41*a53
            - 
            a15*a24*a31*a42*a53
            + a14*a25*a31*a42*a53
            + a15*a21*a34*a42*a53
            - a11*a25*a34*a42*a53
            - a14*a21*a35*a42*a53
            + a11*a24*a35*a42*a53
            + a15*a22*a31*a44*a53
            - a12*a25*a31*a44*a53
            - a15*a21*a32*a44*a53
            + a11*a25*a32*a44*a53
            + a12*a21*a35*a44*a53
            - 
            a11*a22*a35*a44*a53
            - a14*a22*a31*a45*a53
            + a12*a24*a31*a45*a53
            + a14*a21*a32*a45*a53
            - a11*a24*a32*a45*a53
            - a12*a21*a34*a45*a53
            + a11*a22*a34*a45*a53
            - a15*a23*a32*a41*a54
            + a13*a25*a32*a41*a54
            + a15*a22*a33*a41*a54
            - a12*a25*a33*a41*a54
            - 
            a13*a22*a35*a41*a54
            + a12*a23*a35*a41*a54
            + a15*a23*a31*a42*a54
            - a13*a25*a31*a42*a54
            - a15*a21*a33*a42*a54
            + a11*a25*a33*a42*a54
            + a13*a21*a35*a42*a54
            - a11*a23*a35*a42*a54
            - a15*a22*a31*a43*a54
            + a12*a25*a31*a43*a54
            + a15*a21*a32*a43*a54
            - 
            a11*a25*a32*a43*a54
            - a12*a21*a35*a43*a54
            + a11*a22*a35*a43*a54
            + a13*a22*a31*a45*a54
            - a12*a23*a31*a45*a54
            - a13*a21*a32*a45*a54
            + a11*a23*a32*a45*a54
            + a12*a21*a33*a45*a54
            - a11*a22*a33*a45*a54
            + a14*a23*a32*a41*a55
            - a13*a24*a32*a41*a55
            - 
            a14*a22*a33*a41*a55
            + a12*a24*a33*a41*a55
            + a13*a22*a34*a41*a55
            - a12*a23*a34*a41*a55
            - a14*a23*a31*a42*a55
            + a13*a24*a31*a42*a55
            + a14*a21*a33*a42*a55
            - a11*a24*a33*a42*a55
            - a13*a21*a34*a42*a55
            + a11*a23*a34*a42*a55
            + a14*a22*a31*a43*a55
            - a12*a24*a31*a43*a55
            - a14*a21*a32*a43*a55
            + a11*a24*a32*a43*a55
            + a12*a21*a34*a43*a55
            - a11*a22*a34*a43*a55
            - a13*a22*a31*a44*a55
            + a12*a23*a31*a44*a55
            + a13*a21*a32*a44*a55
            - a11*a23*a32*a44*a55
            - a12*a21*a33*a44*a55
            + a11*a22*a33*a44*a55)*a66;

    if (fabs(det) <= eps) {
      // printf("inv6: det = %lf\n", det);
      *ok_flag__ = -1;
      // return -1;
    }
    cofactor[0] = a26*a35*a44*a53*a62
            - a25*a36*a44*a53*a62
            - 
            a26*a34*a45*a53*a62
            + a24*a36*a45*a53*a62
            + a25*
            a34*a46*a53*a62
            - a24*a35*a46*a53*a62
            - a26*a35*
            a43*a54*a62
            + a25*a36*a43*a54*a62
            + a26*a33*a45*
            a54*a62
            - a23*a36*a45*a54*a62
            - a25*a33*a46*a54*
            a62
            + a23*a35*a46*a54*a62
            + a26*a34*a43*a55*a62
            - 
            a24*a36*a43*a55*a62
            - a26*a33*a44*a55*a62
            + a23*
            a36*a44*a55*a62
            + a24*a33*a46*a55*a62
            - a23*a34*
            a46*a55*a62
            - a25*a34*a43*a56*a62
            + a24*a35*a43*
            a56*a62
            + a25*a33*a44*a56*a62
            - a23*a35*a44*a56*
            a62
            - a24*a33*a45*a56*a62
            + a23*a34*a45*a56*a62
            - 
            a26*a35*a44*a52*a63
            + a25*a36*a44*a52*a63
            + a26*
            a34*a45*a52*a63
            - a24*a36*a45*a52*a63
            - a25*a34*
            a46*a52*a63
            + a24*a35*a46*a52*a63
            + a26*a35*a42*
            a54*a63
            - a25*a36*a42*a54*a63
            - a26*a32*a45*a54*
            a63
            + a22*a36*a45*a54*a63
            + a25*a32*a46*a54*a63
            - 
            a22*a35*a46*a54*a63
            - a26*a34*a42*a55*a63
            + a24*
            a36*a42*a55*a63
            + a26*a32*a44*a55*a63
            - a22*a36*
            a44*a55*a63
            - a24*a32*a46*a55*a63
            + a22*a34*a46*
            a55*a63
            + a25*a34*a42*a56*a63
            - a24*a35*a42*a56*
            a63
            - a25*a32*a44*a56*a63
            + a22*a35*a44*a56*a63
            + 
            a24*a32*a45*a56*a63
            - a22*a34*a45*a56*a63
            + a26*
            a35*a43*a52*a64
            - a25*a36*a43*a52*a64
            - a26*a33*
            a45*a52*a64
            + a23*a36*a45*a52*a64
            + a25*a33*a46*
            a52*a64
            - a23*a35*a46*a52*a64
            - a26*a35*a42*a53*
            a64
            + a25*a36*a42*a53*a64
            + a26*a32*a45*a53*a64
            - 
            a22*a36*a45*a53*a64
            - a25*a32*a46*a53*a64
            + a22*
            a35*a46*a53*a64
            + a26*a33*a42*a55*a64
            - a23*a36*
            a42*a55*a64
            - a26*a32*a43*a55*a64
            + a22*a36*a43*
            a55*a64
            + a23*a32*a46*a55*a64
            - a22*a33*a46*a55*
            a64
            - a25*a33*a42*a56*a64
            + a23*a35*a42*a56*a64
            + 
            a25*a32*a43*a56*a64
            - a22*a35*a43*a56*a64
            - a23*
            a32*a45*a56*a64
            + a22*a33*a45*a56*a64
            - a26*a34*
            a43*a52*a65
            + a24*a36*a43*a52*a65
            + a26*a33*a44*
            a52*a65
            - a23*a36*a44*a52*a65
            - a24*a33*a46*a52*
            a65
            + a23*a34*a46*a52*a65
            + a26*a34*a42*a53*a65
            - 
            a24*a36*a42*a53*a65
            - a26*a32*a44*a53*a65
            + a22*
            a36*a44*a53*a65
            + a24*a32*a46*a53*a65
            - a22*a34*
            a46*a53*a65
            - a26*a33*a42*a54*a65
            + a23*a36*a42*
            a54*a65
            + a26*a32*a43*a54*a65
            - a22*a36*a43*a54*
            a65
            - a23*a32*a46*a54*a65
            + a22*a33*a46*a54*a65
            + 
            a24*a33*a42*a56*a65
            - a23*a34*a42*a56*a65
            - a24*
            a32*a43*a56*a65
            + a22*a34*a43*a56*a65
            + a23*a32*
            a44*a56*a65
            - a22*a33*a44*a56*a65
            + a25*a34*a43*
            a52*a66
            - a24*a35*a43*a52*a66
            - a25*a33*a44*a52*
            a66
            + a23*a35*a44*a52*a66
            + a24*a33*a45*a52*a66
            - 
            a23*a34*a45*a52*a66
            - a25*a34*a42*a53*a66
            + a24*
            a35*a42*a53*a66
            + a25*a32*a44*a53*a66
            - a22*a35*
            a44*a53*a66
            - a24*a32*a45*a53*a66
            + a22*a34*a45*
            a53*a66
            + a25*a33*a42*a54*a66
            - a23*a35*a42*a54*
            a66
            - a25*a32*a43*a54*a66
            + a22*a35*a43*a54*a66
            + 
            a23*a32*a45*a54*a66
            - a22*a33*a45*a54*a66
            - a24*
            a33*a42*a55*a66
            + a23*a34*a42*a55*a66
            + a24*a32*
            a43*a55*a66
            - a22*a34*a43*a55*a66
            - a23*a32*a44*
            a55*a66
            + a22*a33*a44*a55*a66;
    cofactor[1] = -a16*a35*a44*a53*a62
            + a15*a36*a44*a53*a62 
            + a16*a34*a45*a53*a62
            - a14*a36*a45*a53*a62
            - a15*a34*a46*a53*a62
            + a14*a35*a46*a53*a62
            + a16*a35*a43*a54*a62
            - a15*a36*a43*a54*a62
            - a16*a33*a45*a54*a62
            + a13*a36*a45*a54*a62
            + a15*a33*a46*a54*a62
            - a13*a35*a46*a54*a62
            - a16*a34*a43*a55*a62 
            + a14*a36*a43*a55*a62
            + a16*a33*a44*a55*a62
            - a13*a36*a44*a55*a62
            - a14*a33*a46*a55*a62
            + a13*a34*a46*a55*a62
            + a15*a34*a43*a56*a62
            - a14*a35*a43*a56*a62
            - a15*a33*a44*a56*a62
            + a13*a35*a44*a56*a62
            + a14*a33*a45*a56*a62
            - a13*a34*a45*a56*a62 
            + a16*a35*a44*a52*a63
            - a15*a36*a44*a52*a63
            - a16*a34*a45*a52*a63
            + a14*a36*a45*a52*a63
            + a15*a34*a46*a52*a63
            - a14*a35*a46*a52*a63
            - a16*a35*a42*a54*a63
            + a15*a36*a42*a54*a63
            + a16*a32*a45*a54*a63
            - a12*a36*a45*a54*a63
            - a15*a32*a46*a54*a63 
            + a12*a35*a46*a54*a63
            + a16*a34*a42*a55*a63
            - a14*a36*a42*a55*a63
            - a16*a32*a44*a55*a63
            + a12*a36*a44*a55*a63
            + a14*a32*a46*a55*a63
            - a12*a34*a46*a55*a63
            - a15*a34*a42*a56*a63
            + a14*a35*a42*a56*a63
            + a15*a32*a44*a56*a63
            - a12*a35*a44*a56*a63 
            - a14*a32*a45*a56*a63
            + a12*a34*a45*a56*a63
            - a16*a35*a43*a52*a64
            + a15*a36*a43*a52*a64
            + a16*a33*a45*a52*a64
            - a13*a36*a45*a52*a64
            - a15*a33*a46*a52*a64
            + a13*a35*a46*a52*a64
            + a16*a35*a42*a53*a64
            - a15*a36*a42*a53*a64
            - a16*a32*a45*a53*a64 
            + a12*a36*a45*a53*a64
            + a15*a32*a46*a53*a64
            - a12*a35*a46*a53*a64
            - a16*a33*a42*a55*a64
            + a13*a36*a42*a55*a64
            + a16*a32*a43*a55*a64
            - a12*a36*a43*a55*a64
            - a13*a32*a46*a55*a64
            + a12*a33*a46*a55*a64
            + a15*a33*a42*a56*a64
            - a13*a35*a42*a56*a64 
            - a15*a32*a43*a56*a64
            + a12*a35*a43*a56*a64
            + a13*a32*a45*a56*a64
            - a12*a33*a45*a56*a64
            + a16*a34*a43*a52*a65
            - a14*a36*a43*a52*a65
            - a16*a33*a44*a52*a65
            + a13*a36*a44*a52*a65
            + a14*a33*a46*a52*a65
            - a13*a34*a46*a52*a65
            - a16*a34*a42*a53*a65 
            + a14*a36*a42*a53*a65
            + a16*a32*a44*a53*a65
            - a12*a36*a44*a53*a65
            - a14*a32*a46*a53*a65
            + a12*a34*a46*a53*a65
            + a16*a33*a42*a54*a65
            - a13*a36*a42*a54*a65
            - a16*a32*a43*a54*a65
            + a12*a36*a43*a54*a65
            + a13*a32*a46*a54*a65
            - a12*a33*a46*a54*a65 
            - a14*a33*a42*a56*a65
            + a13*a34*a42*a56*a65
            + a14*a32*a43*a56*a65
            - a12*a34*a43*a56*a65
            - a13*a32*a44*a56*a65
            + a12*a33*a44*a56*a65
            - a15*a34*a43*a52*a66
            + a14*a35*a43*a52*a66
            + a15*a33*a44*a52*a66
            - a13*a35*a44*a52*a66
            - a14*a33*a45*a52*a66 
            + a13*a34*a45*a52*a66
            + a15*a34*a42*a53*a66
            - a14*a35*a42*a53*a66
            - a15*a32*a44*a53*a66
            + a12*a35*a44*a53*a66
            + a14*a32*a45*a53*a66
            - a12*a34*a45*a53*a66
            - a15*a33*a42*a54*a66
            + a13*a35*a42*a54*a66
            + a15*a32*a43*a54*a66
            - a12*a35*a43*a54*a66 
            - a13*a32*a45*a54*a66
            + a12*a33*a45*a54*a66
            + a14*a33*a42*a55*a66
            - a13*a34*a42*a55*a66
            - a14*a32*a43*a55*a66
            + a12*a34*a43*a55*a66
            + a13*a32*a44*a55*a66
            - a12*a33*a44*a55*a66;
    cofactor[2] = a16*a25*a44*a53*a62
            - a15*a26*a44*a53*a62
            - 
            a16*a24*a45*a53*a62
            + a14*a26*a45*a53*a62
            + a15*
            a24*a46*a53*a62
            - a14*a25*a46*a53*a62
            - a16*a25*
            a43*a54*a62
            + a15*a26*a43*a54*a62
            + a16*a23*a45*
            a54*a62
            - a13*a26*a45*a54*a62
            - a15*a23*a46*a54*
            a62
            + a13*a25*a46*a54*a62
            + a16*a24*a43*a55*a62
            - 
            a14*a26*a43*a55*a62
            - a16*a23*a44*a55*a62
            + a13*
            a26*a44*a55*a62
            + a14*a23*a46*a55*a62
            - a13*a24*
            a46*a55*a62
            - a15*a24*a43*a56*a62
            + a14*a25*a43*
            a56*a62
            + a15*a23*a44*a56*a62
            - a13*a25*a44*a56*
            a62
            - a14*a23*a45*a56*a62
            + a13*a24*a45*a56*a62
            - 
            a16*a25*a44*a52*a63
            + a15*a26*a44*a52*a63
            + a16*
            a24*a45*a52*a63
            - a14*a26*a45*a52*a63
            - a15*a24*
            a46*a52*a63
            + a14*a25*a46*a52*a63
            + a16*a25*a42*
            a54*a63
            - a15*a26*a42*a54*a63
            - a16*a22*a45*a54*
            a63
            + a12*a26*a45*a54*a63
            + a15*a22*a46*a54*a63
            - 
            a12*a25*a46*a54*a63
            - a16*a24*a42*a55*a63
            + a14*
            a26*a42*a55*a63
            + a16*a22*a44*a55*a63
            - a12*a26*
            a44*a55*a63
            - a14*a22*a46*a55*a63
            + a12*a24*a46*
            a55*a63
            + a15*a24*a42*a56*a63
            - a14*a25*a42*a56*
            a63
            - a15*a22*a44*a56*a63
            + a12*a25*a44*a56*a63
            + 
            a14*a22*a45*a56*a63
            - a12*a24*a45*a56*a63
            + a16*
            a25*a43*a52*a64
            - a15*a26*a43*a52*a64
            - a16*a23*
            a45*a52*a64
            + a13*a26*a45*a52*a64
            + a15*a23*a46*
            a52*a64
            - a13*a25*a46*a52*a64
            - a16*a25*a42*a53*
            a64
            + a15*a26*a42*a53*a64
            + a16*a22*a45*a53*a64
            - 
            a12*a26*a45*a53*a64
            - a15*a22*a46*a53*a64
            + a12*
            a25*a46*a53*a64
            + a16*a23*a42*a55*a64
            - a13*a26*
            a42*a55*a64
            - a16*a22*a43*a55*a64
            + a12*a26*a43*
            a55*a64
            + a13*a22*a46*a55*a64
            - a12*a23*a46*a55*
            a64
            - a15*a23*a42*a56*a64
            + a13*a25*a42*a56*a64
            + 
            a15*a22*a43*a56*a64
            - a12*a25*a43*a56*a64
            - a13*
            a22*a45*a56*a64
            + a12*a23*a45*a56*a64
            - a16*a24*
            a43*a52*a65
            + a14*a26*a43*a52*a65
            + a16*a23*a44*
            a52*a65
            - a13*a26*a44*a52*a65
            - a14*a23*a46*a52*
            a65
            + a13*a24*a46*a52*a65
            + a16*a24*a42*a53*a65
            - 
            a14*a26*a42*a53*a65
            - a16*a22*a44*a53*a65
            + a12*
            a26*a44*a53*a65
            + a14*a22*a46*a53*a65
            - a12*a24*
            a46*a53*a65
            - a16*a23*a42*a54*a65
            + a13*a26*a42*
            a54*a65
            + a16*a22*a43*a54*a65
            - a12*a26*a43*a54*
            a65
            - a13*a22*a46*a54*a65
            + a12*a23*a46*a54*a65
            + 
            a14*a23*a42*a56*a65
            - a13*a24*a42*a56*a65
            - a14*
            a22*a43*a56*a65
            + a12*a24*a43*a56*a65
            + a13*a22*
            a44*a56*a65
            - a12*a23*a44*a56*a65
            + a15*a24*a43*
            a52*a66
            - a14*a25*a43*a52*a66
            - a15*a23*a44*a52*
            a66
            + a13*a25*a44*a52*a66
            + a14*a23*a45*a52*a66
            - 
            a13*a24*a45*a52*a66
            - a15*a24*a42*a53*a66
            + a14*
            a25*a42*a53*a66
            + a15*a22*a44*a53*a66
            - a12*a25*
            a44*a53*a66
            - a14*a22*a45*a53*a66
            + a12*a24*a45*
            a53*a66
            + a15*a23*a42*a54*a66
            - a13*a25*a42*a54*
            a66
            - a15*a22*a43*a54*a66
            + a12*a25*a43*a54*a66
            + 
            a13*a22*a45*a54*a66
            - a12*a23*a45*a54*a66
            - a14*
            a23*a42*a55*a66
            + a13*a24*a42*a55*a66
            + a14*a22*
            a43*a55*a66
            - a12*a24*a43*a55*a66
            - a13*a22*a44*
            a55*a66
            + a12*a23*a44*a55*a66;
    cofactor[3] = -a16*a25*a34*a53*a62
            + a15*a26*a34*a53*a62 
            + a16*a24*a35*a53*a62
            - a14*a26*a35*a53*a62
            - a15*a24*a36*a53*a62
            + a14*a25*a36*a53*a62
            + a16*a25*a33*a54*a62
            - a15*a26*a33*a54*a62
            - a16*a23*a35*a54*a62
            + a13*a26*a35*a54*a62
            + a15*a23*a36*a54*a62
            - a13*a25*a36*a54*a62
            - a16*a24*a33*a55*a62 
            + a14*a26*a33*a55*a62
            + a16*a23*a34*a55*a62
            - a13*a26*a34*a55*a62
            - a14*a23*a36*a55*a62
            + a13*a24*a36*a55*a62
            + a15*a24*a33*a56*a62
            - a14*a25*a33*a56*a62
            - a15*a23*a34*a56*a62
            + a13*a25*a34*a56*a62
            + a14*a23*a35*a56*a62
            - a13*a24*a35*a56*a62 
            + a16*a25*a34*a52*a63
            - a15*a26*a34*a52*a63
            - a16*a24*a35*a52*a63
            + a14*a26*a35*a52*a63
            + a15*a24*a36*a52*a63
            - a14*a25*a36*a52*a63
            - a16*a25*a32*a54*a63
            + a15*a26*a32*a54*a63
            + a16*a22*a35*a54*a63
            - a12*a26*a35*a54*a63
            - a15*a22*a36*a54*a63 
            + a12*a25*a36*a54*a63
            + a16*a24*a32*a55*a63
            - a14*a26*a32*a55*a63
            - a16*a22*a34*a55*a63
            + a12*a26*a34*a55*a63
            + a14*a22*a36*a55*a63
            - a12*a24*a36*a55*a63
            - a15*a24*a32*a56*a63
            + a14*a25*a32*a56*a63
            + a15*a22*a34*a56*a63
            - a12*a25*a34*a56*a63 
            - a14*a22*a35*a56*a63
            + a12*a24*a35*a56*a63
            - a16*a25*a33*a52*a64
            + a15*a26*a33*a52*a64
            + a16*a23*a35*a52*a64
            - a13*a26*a35*a52*a64
            - a15*a23*a36*a52*a64
            + a13*a25*a36*a52*a64
            + a16*a25*a32*a53*a64
            - a15*a26*a32*a53*a64
            - a16*a22*a35*a53*a64 
            + a12*a26*a35*a53*a64
            + a15*a22*a36*a53*a64
            - a12*a25*a36*a53*a64
            - a16*a23*a32*a55*a64
            + a13*a26*a32*a55*a64
            + a16*a22*a33*a55*a64
            - a12*a26*a33*a55*a64
            - a13*a22*a36*a55*a64
            + a12*a23*a36*a55*a64
            + a15*a23*a32*a56*a64
            - a13*a25*a32*a56*a64 
            - a15*a22*a33*a56*a64
            + a12*a25*a33*a56*a64
            + a13*a22*a35*a56*a64
            - a12*a23*a35*a56*a64
            + a16*a24*a33*a52*a65
            - a14*a26*a33*a52*a65
            - a16*a23*a34*a52*a65
            + a13*a26*a34*a52*a65
            + a14*a23*a36*a52*a65
            - a13*a24*a36*a52*a65
            - a16*a24*a32*a53*a65 
            + a14*a26*a32*a53*a65
            + a16*a22*a34*a53*a65
            - a12*a26*a34*a53*a65
            - a14*a22*a36*a53*a65
            + a12*a24*a36*a53*a65
            + a16*a23*a32*a54*a65
            - a13*a26*a32*a54*a65
            - a16*a22*a33*a54*a65
            + a12*a26*a33*a54*a65
            + a13*a22*a36*a54*a65
            - a12*a23*a36*a54*a65 
            - a14*a23*a32*a56*a65
            + a13*a24*a32*a56*a65
            + a14*a22*a33*a56*a65
            - a12*a24*a33*a56*a65
            - a13*a22*a34*a56*a65
            + a12*a23*a34*a56*a65
            - a15*a24*a33*a52*a66
            + a14*a25*a33*a52*a66
            + a15*a23*a34*a52*a66
            - a13*a25*a34*a52*a66
            - a14*a23*a35*a52*a66 
            + a13*a24*a35*a52*a66
            + a15*a24*a32*a53*a66
            - a14*a25*a32*a53*a66
            - a15*a22*a34*a53*a66
            + a12*a25*a34*a53*a66
            + a14*a22*a35*a53*a66
            - a12*a24*a35*a53*a66
            - a15*a23*a32*a54*a66
            + a13*a25*a32*a54*a66
            + a15*a22*a33*a54*a66
            - a12*a25*a33*a54*a66 
            - a13*a22*a35*a54*a66
            + a12*a23*a35*a54*a66
            + a14*a23*a32*a55*a66
            - a13*a24*a32*a55*a66
            - a14*a22*a33*a55*a66
            + a12*a24*a33*a55*a66
            + a13*a22*a34*a55*a66
            - a12*a23*a34*a55*a66;
    cofactor[4] = a16*a25*a34*a43*a62
            - a15*a26*a34*a43*a62
            - 
            a16*a24*a35*a43*a62
            + a14*a26*a35*a43*a62
            + a15*
            a24*a36*a43*a62
            - a14*a25*a36*a43*a62
            - a16*a25*
            a33*a44*a62
            + a15*a26*a33*a44*a62
            + a16*a23*a35*
            a44*a62
            - a13*a26*a35*a44*a62
            - a15*a23*a36*a44*
            a62
            + a13*a25*a36*a44*a62
            + a16*a24*a33*a45*a62
            - 
            a14*a26*a33*a45*a62
            - a16*a23*a34*a45*a62
            + a13*
            a26*a34*a45*a62
            + a14*a23*a36*a45*a62
            - a13*a24*
            a36*a45*a62
            - a15*a24*a33*a46*a62
            + a14*a25*a33*
            a46*a62
            + a15*a23*a34*a46*a62
            - a13*a25*a34*a46*
            a62
            - a14*a23*a35*a46*a62
            + a13*a24*a35*a46*a62
            - 
            a16*a25*a34*a42*a63
            + a15*a26*a34*a42*a63
            + a16*
            a24*a35*a42*a63
            - a14*a26*a35*a42*a63
            - a15*a24*
            a36*a42*a63
            + a14*a25*a36*a42*a63
            + a16*a25*a32*
            a44*a63
            - a15*a26*a32*a44*a63
            - a16*a22*a35*a44*
            a63
            + a12*a26*a35*a44*a63
            + a15*a22*a36*a44*a63
            - 
            a12*a25*a36*a44*a63
            - a16*a24*a32*a45*a63
            + a14*
            a26*a32*a45*a63
            + a16*a22*a34*a45*a63
            - a12*a26*
            a34*a45*a63
            - a14*a22*a36*a45*a63
            + a12*a24*a36*
            a45*a63
            + a15*a24*a32*a46*a63
            - a14*a25*a32*a46*
            a63
            - a15*a22*a34*a46*a63
            + a12*a25*a34*a46*a63
            + 
            a14*a22*a35*a46*a63
            - a12*a24*a35*a46*a63
            + a16*
            a25*a33*a42*a64
            - a15*a26*a33*a42*a64
            - a16*a23*
            a35*a42*a64
            + a13*a26*a35*a42*a64
            + a15*a23*a36*
            a42*a64
            - a13*a25*a36*a42*a64
            - a16*a25*a32*a43*
            a64
            + a15*a26*a32*a43*a64
            + a16*a22*a35*a43*a64
            - 
            a12*a26*a35*a43*a64
            - a15*a22*a36*a43*a64
            + a12*
            a25*a36*a43*a64
            + a16*a23*a32*a45*a64
            - a13*a26*
            a32*a45*a64
            - a16*a22*a33*a45*a64
            + a12*a26*a33*
            a45*a64
            + a13*a22*a36*a45*a64
            - a12*a23*a36*a45*
            a64
            - a15*a23*a32*a46*a64
            + a13*a25*a32*a46*a64
            + 
            a15*a22*a33*a46*a64
            - a12*a25*a33*a46*a64
            - a13*
            a22*a35*a46*a64
            + a12*a23*a35*a46*a64
            - a16*a24*
            a33*a42*a65
            + a14*a26*a33*a42*a65
            + a16*a23*a34*
            a42*a65
            - a13*a26*a34*a42*a65
            - a14*a23*a36*a42*
            a65
            + a13*a24*a36*a42*a65
            + a16*a24*a32*a43*a65
            - 
            a14*a26*a32*a43*a65
            - a16*a22*a34*a43*a65
            + a12*
            a26*a34*a43*a65
            + a14*a22*a36*a43*a65
            - a12*a24*
            a36*a43*a65
            - a16*a23*a32*a44*a65
            + a13*a26*a32*
            a44*a65
            + a16*a22*a33*a44*a65
            - a12*a26*a33*a44*
            a65
            - a13*a22*a36*a44*a65
            + a12*a23*a36*a44*a65
            + 
            a14*a23*a32*a46*a65
            - a13*a24*a32*a46*a65
            - a14*
            a22*a33*a46*a65
            + a12*a24*a33*a46*a65
            + a13*a22*
            a34*a46*a65
            - a12*a23*a34*a46*a65
            + a15*a24*a33*
            a42*a66
            - a14*a25*a33*a42*a66
            - a15*a23*a34*a42*
            a66
            + a13*a25*a34*a42*a66
            + a14*a23*a35*a42*a66
            - 
            a13*a24*a35*a42*a66
            - a15*a24*a32*a43*a66
            + a14*
            a25*a32*a43*a66
            + a15*a22*a34*a43*a66
            - a12*a25*
            a34*a43*a66
            - a14*a22*a35*a43*a66
            + a12*a24*a35*
            a43*a66
            + a15*a23*a32*a44*a66
            - a13*a25*a32*a44*
            a66
            - a15*a22*a33*a44*a66
            + a12*a25*a33*a44*a66
            + 
            a13*a22*a35*a44*a66
            - a12*a23*a35*a44*a66
            - a14*
            a23*a32*a45*a66
            + a13*a24*a32*a45*a66
            + a14*a22*
            a33*a45*a66
            - a12*a24*a33*a45*a66
            - a13*a22*a34*
            a45*a66
            + a12*a23*a34*a45*a66;
    cofactor[5] = -a16*a25*a34*a43*a52
            + a15*a26*a34*a43*a52 
            + a16*a24*a35*a43*a52
            - a14*a26*a35*a43*a52
            - a15*a24*a36*a43*a52
            + a14*a25*a36*a43*a52
            + a16*a25*a33*a44*a52
            - a15*a26*a33*a44*a52
            - a16*a23*a35*a44*a52
            + a13*a26*a35*a44*a52
            + a15*a23*a36*a44*a52
            - a13*a25*a36*a44*a52
            - a16*a24*a33*a45*a52 
            + a14*a26*a33*a45*a52
            + a16*a23*a34*a45*a52
            - a13*a26*a34*a45*a52
            - a14*a23*a36*a45*a52
            + a13*a24*a36*a45*a52
            + a15*a24*a33*a46*a52
            - a14*a25*a33*a46*a52
            - a15*a23*a34*a46*a52
            + a13*a25*a34*a46*a52
            + a14*a23*a35*a46*a52
            - a13*a24*a35*a46*a52 
            + a16*a25*a34*a42*a53
            - a15*a26*a34*a42*a53
            - a16*a24*a35*a42*a53
            + a14*a26*a35*a42*a53
            + a15*a24*a36*a42*a53
            - a14*a25*a36*a42*a53
            - a16*a25*a32*a44*a53
            + a15*a26*a32*a44*a53
            + a16*a22*a35*a44*a53
            - a12*a26*a35*a44*a53
            - a15*a22*a36*a44*a53 
            + a12*a25*a36*a44*a53
            + a16*a24*a32*a45*a53
            - a14*a26*a32*a45*a53
            - a16*a22*a34*a45*a53
            + a12*a26*a34*a45*a53
            + a14*a22*a36*a45*a53
            - a12*a24*a36*a45*a53
            - a15*a24*a32*a46*a53
            + a14*a25*a32*a46*a53
            + a15*a22*a34*a46*a53
            - a12*a25*a34*a46*a53 
            - a14*a22*a35*a46*a53
            + a12*a24*a35*a46*a53
            - a16*a25*a33*a42*a54
            + a15*a26*a33*a42*a54
            + a16*a23*a35*a42*a54
            - a13*a26*a35*a42*a54
            - a15*a23*a36*a42*a54
            + a13*a25*a36*a42*a54
            + a16*a25*a32*a43*a54
            - a15*a26*a32*a43*a54
            - a16*a22*a35*a43*a54 
            + a12*a26*a35*a43*a54
            + a15*a22*a36*a43*a54
            - a12*a25*a36*a43*a54
            - a16*a23*a32*a45*a54
            + a13*a26*a32*a45*a54
            + a16*a22*a33*a45*a54
            - a12*a26*a33*a45*a54
            - a13*a22*a36*a45*a54
            + a12*a23*a36*a45*a54
            + a15*a23*a32*a46*a54
            - a13*a25*a32*a46*a54 
            - a15*a22*a33*a46*a54
            + a12*a25*a33*a46*a54
            + a13*a22*a35*a46*a54
            - a12*a23*a35*a46*a54
            + a16*a24*a33*a42*a55
            - a14*a26*a33*a42*a55
            - a16*a23*a34*a42*a55
            + a13*a26*a34*a42*a55
            + a14*a23*a36*a42*a55
            - a13*a24*a36*a42*a55
            - a16*a24*a32*a43*a55 
            + a14*a26*a32*a43*a55
            + a16*a22*a34*a43*a55
            - a12*a26*a34*a43*a55
            - a14*a22*a36*a43*a55
            + a12*a24*a36*a43*a55
            + a16*a23*a32*a44*a55
            - a13*a26*a32*a44*a55
            - a16*a22*a33*a44*a55
            + a12*a26*a33*a44*a55
            + a13*a22*a36*a44*a55
            - a12*a23*a36*a44*a55 
            - a14*a23*a32*a46*a55
            + a13*a24*a32*a46*a55
            + a14*a22*a33*a46*a55
            - a12*a24*a33*a46*a55
            - a13*a22*a34*a46*a55
            + a12*a23*a34*a46*a55
            - a15*a24*a33*a42*a56
            + a14*a25*a33*a42*a56
            + a15*a23*a34*a42*a56
            - a13*a25*a34*a42*a56
            - a14*a23*a35*a42*a56 
            + a13*a24*a35*a42*a56
            + a15*a24*a32*a43*a56
            - a14*a25*a32*a43*a56
            - a15*a22*a34*a43*a56
            + a12*a25*a34*a43*a56
            + a14*a22*a35*a43*a56
            - a12*a24*a35*a43*a56
            - a15*a23*a32*a44*a56
            + a13*a25*a32*a44*a56
            + a15*a22*a33*a44*a56
            - a12*a25*a33*a44*a56 
            - a13*a22*a35*a44*a56
            + a12*a23*a35*a44*a56
            + a14*a23*a32*a45*a56
            - a13*a24*a32*a45*a56
            - a14*a22*a33*a45*a56
            + a12*a24*a33*a45*a56
            + a13*a22*a34*a45*a56
            - a12*a23*a34*a45*a56;
    cofactor[6] = -a26*a35*a44*a53*a61
            + a25*a36*a44*a53*a61 
            + a26*a34*a45*a53*a61
            - a24*a36*a45*a53*a61
            - a25*a34*a46*a53*a61
            + a24*a35*a46*a53*a61
            + a26*a35*a43*a54*a61
            - a25*a36*a43*a54*a61
            - a26*a33*a45*a54*a61
            + a23*a36*a45*a54*a61
            + a25*a33*a46*a54*a61
            - a23*a35*a46*a54*a61
            - a26*a34*a43*a55*a61 
            + a24*a36*a43*a55*a61
            + a26*a33*a44*a55*a61
            - a23*a36*a44*a55*a61
            - a24*a33*a46*a55*a61
            + a23*a34*a46*a55*a61
            + a25*a34*a43*a56*a61
            - a24*a35*a43*a56*a61
            - a25*a33*a44*a56*a61
            + a23*a35*a44*a56*a61
            + a24*a33*a45*a56*a61
            - a23*a34*a45*a56*a61 
            + a26*a35*a44*a51*a63
            - a25*a36*a44*a51*a63
            - a26*a34*a45*a51*a63
            + a24*a36*a45*a51*a63
            + a25*a34*a46*a51*a63
            - a24*a35*a46*a51*a63
            - a26*a35*a41*a54*a63
            + a25*a36*a41*a54*a63
            + a26*a31*a45*a54*a63
            - a21*a36*a45*a54*a63
            - a25*a31*a46*a54*a63 
            + a21*a35*a46*a54*a63
            + a26*a34*a41*a55*a63
            - a24*a36*a41*a55*a63
            - a26*a31*a44*a55*a63
            + a21*a36*a44*a55*a63
            + a24*a31*a46*a55*a63
            - a21*a34*a46*a55*a63
            - a25*a34*a41*a56*a63
            + a24*a35*a41*a56*a63
            + a25*a31*a44*a56*a63
            - a21*a35*a44*a56*a63 
            - a24*a31*a45*a56*a63
            + a21*a34*a45*a56*a63
            - a26*a35*a43*a51*a64
            + a25*a36*a43*a51*a64
            + a26*a33*a45*a51*a64
            - a23*a36*a45*a51*a64
            - a25*a33*a46*a51*a64
            + a23*a35*a46*a51*a64
            + a26*a35*a41*a53*a64
            - a25*a36*a41*a53*a64
            - a26*a31*a45*a53*a64 
            + a21*a36*a45*a53*a64
            + a25*a31*a46*a53*a64
            - a21*a35*a46*a53*a64
            - a26*a33*a41*a55*a64
            + a23*a36*a41*a55*a64
            + a26*a31*a43*a55*a64
            - a21*a36*a43*a55*a64
            - a23*a31*a46*a55*a64
            + a21*a33*a46*a55*a64
            + a25*a33*a41*a56*a64
            - a23*a35*a41*a56*a64 
            - a25*a31*a43*a56*a64
            + a21*a35*a43*a56*a64
            + a23*a31*a45*a56*a64
            - a21*a33*a45*a56*a64
            + a26*a34*a43*a51*a65
            - a24*a36*a43*a51*a65
            - a26*a33*a44*a51*a65
            + a23*a36*a44*a51*a65
            + a24*a33*a46*a51*a65
            - a23*a34*a46*a51*a65
            - a26*a34*a41*a53*a65 
            + a24*a36*a41*a53*a65
            + a26*a31*a44*a53*a65
            - a21*a36*a44*a53*a65
            - a24*a31*a46*a53*a65
            + a21*a34*a46*a53*a65
            + a26*a33*a41*a54*a65
            - a23*a36*a41*a54*a65
            - a26*a31*a43*a54*a65
            + a21*a36*a43*a54*a65
            + a23*a31*a46*a54*a65
            - a21*a33*a46*a54*a65 
            - a24*a33*a41*a56*a65
            + a23*a34*a41*a56*a65
            + a24*a31*a43*a56*a65
            - a21*a34*a43*a56*a65
            - a23*a31*a44*a56*a65
            + a21*a33*a44*a56*a65
            - a25*a34*a43*a51*a66
            + a24*a35*a43*a51*a66
            + a25*a33*a44*a51*a66
            - a23*a35*a44*a51*a66
            - a24*a33*a45*a51*a66 
            + a23*a34*a45*a51*a66
            + a25*a34*a41*a53*a66
            - a24*a35*a41*a53*a66
            - a25*a31*a44*a53*a66
            + a21*a35*a44*a53*a66
            + a24*a31*a45*a53*a66
            - a21*a34*a45*a53*a66
            - a25*a33*a41*a54*a66
            + a23*a35*a41*a54*a66
            + a25*a31*a43*a54*a66
            - a21*a35*a43*a54*a66 
            - a23*a31*a45*a54*a66
            + a21*a33*a45*a54*a66
            + a24*a33*a41*a55*a66
            - a23*a34*a41*a55*a66
            - a24*a31*a43*a55*a66
            + a21*a34*a43*a55*a66
            + a23*a31*a44*a55*a66
            - a21*a33*a44*a55*a66;
    cofactor[7] = a16*a35*a44*a53*a61
            - a15*a36*a44*a53*a61
            - 
            a16*a34*a45*a53*a61
            + a14*a36*a45*a53*a61
            + a15*
            a34*a46*a53*a61
            - a14*a35*a46*a53*a61
            - a16*a35*
            a43*a54*a61
            + a15*a36*a43*a54*a61
            + a16*a33*a45*
            a54*a61
            - a13*a36*a45*a54*a61
            - a15*a33*a46*a54*
            a61
            + a13*a35*a46*a54*a61
            + a16*a34*a43*a55*a61
            - 
            a14*a36*a43*a55*a61
            - a16*a33*a44*a55*a61
            + a13*
            a36*a44*a55*a61
            + a14*a33*a46*a55*a61
            - a13*a34*
            a46*a55*a61
            - a15*a34*a43*a56*a61
            + a14*a35*a43*
            a56*a61
            + a15*a33*a44*a56*a61
            - a13*a35*a44*a56*
            a61
            - a14*a33*a45*a56*a61
            + a13*a34*a45*a56*a61
            - 
            a16*a35*a44*a51*a63
            + a15*a36*a44*a51*a63
            + a16*
            a34*a45*a51*a63
            - a14*a36*a45*a51*a63
            - a15*a34*
            a46*a51*a63
            + a14*a35*a46*a51*a63
            + a16*a35*a41*
            a54*a63
            - a15*a36*a41*a54*a63
            - a16*a31*a45*a54*
            a63
            + a11*a36*a45*a54*a63
            + a15*a31*a46*a54*a63
            - 
            a11*a35*a46*a54*a63
            - a16*a34*a41*a55*a63
            + a14*
            a36*a41*a55*a63
            + a16*a31*a44*a55*a63
            - a11*a36*
            a44*a55*a63
            - a14*a31*a46*a55*a63
            + a11*a34*a46*
            a55*a63
            + a15*a34*a41*a56*a63
            - a14*a35*a41*a56*
            a63
            - a15*a31*a44*a56*a63
            + a11*a35*a44*a56*a63
            + 
            a14*a31*a45*a56*a63
            - a11*a34*a45*a56*a63
            + a16*
            a35*a43*a51*a64
            - a15*a36*a43*a51*a64
            - a16*a33*
            a45*a51*a64
            + a13*a36*a45*a51*a64
            + a15*a33*a46*
            a51*a64
            - a13*a35*a46*a51*a64
            - a16*a35*a41*a53*
            a64
            + a15*a36*a41*a53*a64
            + a16*a31*a45*a53*a64
            - 
            a11*a36*a45*a53*a64
            - a15*a31*a46*a53*a64
            + a11*
            a35*a46*a53*a64
            + a16*a33*a41*a55*a64
            - a13*a36*
            a41*a55*a64
            - a16*a31*a43*a55*a64
            + a11*a36*a43*
            a55*a64
            + a13*a31*a46*a55*a64
            - a11*a33*a46*a55*
            a64
            - a15*a33*a41*a56*a64
            + a13*a35*a41*a56*a64
            + 
            a15*a31*a43*a56*a64
            - a11*a35*a43*a56*a64
            - a13*
            a31*a45*a56*a64
            + a11*a33*a45*a56*a64
            - a16*a34*
            a43*a51*a65
            + a14*a36*a43*a51*a65
            + a16*a33*a44*
            a51*a65
            - a13*a36*a44*a51*a65
            - a14*a33*a46*a51*
            a65
            + a13*a34*a46*a51*a65
            + a16*a34*a41*a53*a65
            - 
            a14*a36*a41*a53*a65
            - a16*a31*a44*a53*a65
            + a11*
            a36*a44*a53*a65
            + a14*a31*a46*a53*a65
            - a11*a34*
            a46*a53*a65
            - a16*a33*a41*a54*a65
            + a13*a36*a41*
            a54*a65
            + a16*a31*a43*a54*a65
            - a11*a36*a43*a54*
            a65
            - a13*a31*a46*a54*a65
            + a11*a33*a46*a54*a65
            + 
            a14*a33*a41*a56*a65
            - a13*a34*a41*a56*a65
            - a14*
            a31*a43*a56*a65
            + a11*a34*a43*a56*a65
            + a13*a31*
            a44*a56*a65
            - a11*a33*a44*a56*a65
            + a15*a34*a43*
            a51*a66
            - a14*a35*a43*a51*a66
            - a15*a33*a44*a51*
            a66
            + a13*a35*a44*a51*a66
            + a14*a33*a45*a51*a66
            - 
            a13*a34*a45*a51*a66
            - a15*a34*a41*a53*a66
            + a14*
            a35*a41*a53*a66
            + a15*a31*a44*a53*a66
            - a11*a35*
            a44*a53*a66
            - a14*a31*a45*a53*a66
            + a11*a34*a45*
            a53*a66
            + a15*a33*a41*a54*a66
            - a13*a35*a41*a54*
            a66
            - a15*a31*a43*a54*a66
            + a11*a35*a43*a54*a66
            + 
            a13*a31*a45*a54*a66
            - a11*a33*a45*a54*a66
            - a14*
            a33*a41*a55*a66
            + a13*a34*a41*a55*a66
            + a14*a31*
            a43*a55*a66
            - a11*a34*a43*a55*a66
            - a13*a31*a44*
            a55*a66
            + a11*a33*a44*a55*a66;
    cofactor[8] = -a16*a25*a44*a53*a61
            + a15*a26*a44*a53*a61 
            + a16*a24*a45*a53*a61
            - a14*a26*a45*a53*a61
            - a15*a24*a46*a53*a61
            + a14*a25*a46*a53*a61
            + a16*a25*a43*a54*a61
            - a15*a26*a43*a54*a61
            - a16*a23*a45*a54*a61
            + a13*a26*a45*a54*a61
            + a15*a23*a46*a54*a61
            - a13*a25*a46*a54*a61
            - a16*a24*a43*a55*a61 
            + a14*a26*a43*a55*a61
            + a16*a23*a44*a55*a61
            - a13*a26*a44*a55*a61
            - a14*a23*a46*a55*a61
            + a13*a24*a46*a55*a61
            + a15*a24*a43*a56*a61
            - a14*a25*a43*a56*a61
            - a15*a23*a44*a56*a61
            + a13*a25*a44*a56*a61
            + a14*a23*a45*a56*a61
            - a13*a24*a45*a56*a61 
            + a16*a25*a44*a51*a63
            - a15*a26*a44*a51*a63
            - a16*a24*a45*a51*a63
            + a14*a26*a45*a51*a63
            + a15*a24*a46*a51*a63
            - a14*a25*a46*a51*a63
            - a16*a25*a41*a54*a63
            + a15*a26*a41*a54*a63
            + a16*a21*a45*a54*a63
            - a11*a26*a45*a54*a63
            - a15*a21*a46*a54*a63 
            + a11*a25*a46*a54*a63
            + a16*a24*a41*a55*a63
            - a14*a26*a41*a55*a63
            - a16*a21*a44*a55*a63
            + a11*a26*a44*a55*a63
            + a14*a21*a46*a55*a63
            - a11*a24*a46*a55*a63
            - a15*a24*a41*a56*a63
            + a14*a25*a41*a56*a63
            + a15*a21*a44*a56*a63
            - a11*a25*a44*a56*a63 
            - a14*a21*a45*a56*a63
            + a11*a24*a45*a56*a63
            - a16*a25*a43*a51*a64
            + a15*a26*a43*a51*a64
            + a16*a23*a45*a51*a64
            - a13*a26*a45*a51*a64
            - a15*a23*a46*a51*a64
            + a13*a25*a46*a51*a64
            + a16*a25*a41*a53*a64
            - a15*a26*a41*a53*a64
            - a16*a21*a45*a53*a64 
            + a11*a26*a45*a53*a64
            + a15*a21*a46*a53*a64
            - a11*a25*a46*a53*a64
            - a16*a23*a41*a55*a64
            + a13*a26*a41*a55*a64
            + a16*a21*a43*a55*a64
            - a11*a26*a43*a55*a64
            - a13*a21*a46*a55*a64
            + a11*a23*a46*a55*a64
            + a15*a23*a41*a56*a64
            - a13*a25*a41*a56*a64 
            - a15*a21*a43*a56*a64
            + a11*a25*a43*a56*a64
            + a13*a21*a45*a56*a64
            - a11*a23*a45*a56*a64
            + a16*a24*a43*a51*a65
            - a14*a26*a43*a51*a65
            - a16*a23*a44*a51*a65
            + a13*a26*a44*a51*a65
            + a14*a23*a46*a51*a65
            - a13*a24*a46*a51*a65
            - a16*a24*a41*a53*a65 
            + a14*a26*a41*a53*a65
            + a16*a21*a44*a53*a65
            - a11*a26*a44*a53*a65
            - a14*a21*a46*a53*a65
            + a11*a24*a46*a53*a65
            + a16*a23*a41*a54*a65
            - a13*a26*a41*a54*a65
            - a16*a21*a43*a54*a65
            + a11*a26*a43*a54*a65
            + a13*a21*a46*a54*a65
            - a11*a23*a46*a54*a65 
            - a14*a23*a41*a56*a65
            + a13*a24*a41*a56*a65
            + a14*a21*a43*a56*a65
            - a11*a24*a43*a56*a65
            - a13*a21*a44*a56*a65
            + a11*a23*a44*a56*a65
            - a15*a24*a43*a51*a66
            + a14*a25*a43*a51*a66
            + a15*a23*a44*a51*a66
            - a13*a25*a44*a51*a66
            - a14*a23*a45*a51*a66 
            + a13*a24*a45*a51*a66
            + a15*a24*a41*a53*a66
            - a14*a25*a41*a53*a66
            - a15*a21*a44*a53*a66
            + a11*a25*a44*a53*a66
            + a14*a21*a45*a53*a66
            - a11*a24*a45*a53*a66
            - a15*a23*a41*a54*a66
            + a13*a25*a41*a54*a66
            + a15*a21*a43*a54*a66
            - a11*a25*a43*a54*a66 
            - a13*a21*a45*a54*a66
            + a11*a23*a45*a54*a66
            + a14*a23*a41*a55*a66
            - a13*a24*a41*a55*a66
            - a14*a21*a43*a55*a66
            + a11*a24*a43*a55*a66
            + a13*a21*a44*a55*a66
            - a11*a23*a44*a55*a66;
    cofactor[9] = a16*a25*a34*a53*a61
            - a15*a26*a34*a53*a61
            - 
            a16*a24*a35*a53*a61
            + a14*a26*a35*a53*a61
            + a15*
            a24*a36*a53*a61
            - a14*a25*a36*a53*a61
            - a16*a25*
            a33*a54*a61
            + a15*a26*a33*a54*a61
            + a16*a23*a35*
            a54*a61
            - a13*a26*a35*a54*a61
            - a15*a23*a36*a54*
            a61
            + a13*a25*a36*a54*a61
            + a16*a24*a33*a55*a61
            - 
            a14*a26*a33*a55*a61
            - a16*a23*a34*a55*a61
            + a13*
            a26*a34*a55*a61
            + a14*a23*a36*a55*a61
            - a13*a24*
            a36*a55*a61
            - a15*a24*a33*a56*a61
            + a14*a25*a33*
            a56*a61
            + a15*a23*a34*a56*a61
            - a13*a25*a34*a56*
            a61
            - a14*a23*a35*a56*a61
            + a13*a24*a35*a56*a61
            - 
            a16*a25*a34*a51*a63
            + a15*a26*a34*a51*a63
            + a16*
            a24*a35*a51*a63
            - a14*a26*a35*a51*a63
            - a15*a24*
            a36*a51*a63
            + a14*a25*a36*a51*a63
            + a16*a25*a31*
            a54*a63
            - a15*a26*a31*a54*a63
            - a16*a21*a35*a54*
            a63
            + a11*a26*a35*a54*a63
            + a15*a21*a36*a54*a63
            - 
            a11*a25*a36*a54*a63
            - a16*a24*a31*a55*a63
            + a14*
            a26*a31*a55*a63
            + a16*a21*a34*a55*a63
            - a11*a26*
            a34*a55*a63
            - a14*a21*a36*a55*a63
            + a11*a24*a36*
            a55*a63
            + a15*a24*a31*a56*a63
            - a14*a25*a31*a56*
            a63
            - a15*a21*a34*a56*a63
            + a11*a25*a34*a56*a63
            + 
            a14*a21*a35*a56*a63
            - a11*a24*a35*a56*a63
            + a16*
            a25*a33*a51*a64
            - a15*a26*a33*a51*a64
            - a16*a23*
            a35*a51*a64
            + a13*a26*a35*a51*a64
            + a15*a23*a36*
            a51*a64
            - a13*a25*a36*a51*a64
            - a16*a25*a31*a53*
            a64
            + a15*a26*a31*a53*a64
            + a16*a21*a35*a53*a64
            - 
            a11*a26*a35*a53*a64
            - a15*a21*a36*a53*a64
            + a11*
            a25*a36*a53*a64
            + a16*a23*a31*a55*a64
            - a13*a26*
            a31*a55*a64
            - a16*a21*a33*a55*a64
            + a11*a26*a33*
            a55*a64
            + a13*a21*a36*a55*a64
            - a11*a23*a36*a55*
            a64
            - a15*a23*a31*a56*a64
            + a13*a25*a31*a56*a64
            + 
            a15*a21*a33*a56*a64
            - a11*a25*a33*a56*a64
            - a13*
            a21*a35*a56*a64
            + a11*a23*a35*a56*a64
            - a16*a24*
            a33*a51*a65
            + a14*a26*a33*a51*a65
            + a16*a23*a34*
            a51*a65
            - a13*a26*a34*a51*a65
            - a14*a23*a36*a51*
            a65
            + a13*a24*a36*a51*a65
            + a16*a24*a31*a53*a65
            - 
            a14*a26*a31*a53*a65
            - a16*a21*a34*a53*a65
            + a11*
            a26*a34*a53*a65
            + a14*a21*a36*a53*a65
            - a11*a24*
            a36*a53*a65
            - a16*a23*a31*a54*a65
            + a13*a26*a31*
            a54*a65
            + a16*a21*a33*a54*a65
            - a11*a26*a33*a54*
            a65
            - a13*a21*a36*a54*a65
            + a11*a23*a36*a54*a65
            + 
            a14*a23*a31*a56*a65
            - a13*a24*a31*a56*a65
            - a14*
            a21*a33*a56*a65
            + a11*a24*a33*a56*a65
            + a13*a21*
            a34*a56*a65
            - a11*a23*a34*a56*a65
            + a15*a24*a33*
            a51*a66
            - a14*a25*a33*a51*a66
            - a15*a23*a34*a51*
            a66
            + a13*a25*a34*a51*a66
            + a14*a23*a35*a51*a66
            - 
            a13*a24*a35*a51*a66
            - a15*a24*a31*a53*a66
            + a14*
            a25*a31*a53*a66
            + a15*a21*a34*a53*a66
            - a11*a25*
            a34*a53*a66
            - a14*a21*a35*a53*a66
            + a11*a24*a35*
            a53*a66
            + a15*a23*a31*a54*a66
            - a13*a25*a31*a54*
            a66
            - a15*a21*a33*a54*a66
            + a11*a25*a33*a54*a66
            + 
            a13*a21*a35*a54*a66
            - a11*a23*a35*a54*a66
            - a14*
            a23*a31*a55*a66
            + a13*a24*a31*a55*a66
            + a14*a21*
            a33*a55*a66
            - a11*a24*a33*a55*a66
            - a13*a21*a34*
            a55*a66
            + a11*a23*a34*a55*a66;
    cofactor[10] = -a16*a25*a34*a43*a61
            + a15*a26*a34*a43*a61 
            + a16*a24*a35*a43*a61
            - a14*a26*a35*a43*a61
            - a15*a24*a36*a43*a61
            + a14*a25*a36*a43*a61
            + a16*a25*a33*a44*a61
            - a15*a26*a33*a44*a61
            - a16*a23*a35*a44*a61
            + a13*a26*a35*a44*a61
            + a15*a23*a36*a44*a61
            - a13*a25*a36*a44*a61
            - a16*a24*a33*a45*a61 
            + a14*a26*a33*a45*a61
            + a16*a23*a34*a45*a61
            - a13*a26*a34*a45*a61
            - a14*a23*a36*a45*a61
            + a13*a24*a36*a45*a61
            + a15*a24*a33*a46*a61
            - a14*a25*a33*a46*a61
            - a15*a23*a34*a46*a61
            + a13*a25*a34*a46*a61
            + a14*a23*a35*a46*a61
            - a13*a24*a35*a46*a61 
            + a16*a25*a34*a41*a63
            - a15*a26*a34*a41*a63
            - a16*a24*a35*a41*a63
            + a14*a26*a35*a41*a63
            + a15*a24*a36*a41*a63
            - a14*a25*a36*a41*a63
            - a16*a25*a31*a44*a63
            + a15*a26*a31*a44*a63
            + a16*a21*a35*a44*a63
            - a11*a26*a35*a44*a63
            - a15*a21*a36*a44*a63 
            + a11*a25*a36*a44*a63
            + a16*a24*a31*a45*a63
            - a14*a26*a31*a45*a63
            - a16*a21*a34*a45*a63
            + a11*a26*a34*a45*a63
            + a14*a21*a36*a45*a63
            - a11*a24*a36*a45*a63
            - a15*a24*a31*a46*a63
            + a14*a25*a31*a46*a63
            + a15*a21*a34*a46*a63
            - a11*a25*a34*a46*a63 
            - a14*a21*a35*a46*a63
            + a11*a24*a35*a46*a63
            - a16*a25*a33*a41*a64
            + a15*a26*a33*a41*a64
            + a16*a23*a35*a41*a64
            - a13*a26*a35*a41*a64
            - a15*a23*a36*a41*a64
            + a13*a25*a36*a41*a64
            + a16*a25*a31*a43*a64
            - a15*a26*a31*a43*a64
            - a16*a21*a35*a43*a64 
            + a11*a26*a35*a43*a64
            + a15*a21*a36*a43*a64
            - a11*a25*a36*a43*a64
            - a16*a23*a31*a45*a64
            + a13*a26*a31*a45*a64
            + a16*a21*a33*a45*a64
            - a11*a26*a33*a45*a64
            - a13*a21*a36*a45*a64
            + a11*a23*a36*a45*a64
            + a15*a23*a31*a46*a64
            - a13*a25*a31*a46*a64 
            - a15*a21*a33*a46*a64
            + a11*a25*a33*a46*a64
            + a13*a21*a35*a46*a64
            - a11*a23*a35*a46*a64
            + a16*a24*a33*a41*a65
            - a14*a26*a33*a41*a65
            - a16*a23*a34*a41*a65
            + a13*a26*a34*a41*a65
            + a14*a23*a36*a41*a65
            - a13*a24*a36*a41*a65
            - a16*a24*a31*a43*a65 
            + a14*a26*a31*a43*a65
            + a16*a21*a34*a43*a65
            - a11*a26*a34*a43*a65
            - a14*a21*a36*a43*a65
            + a11*a24*a36*a43*a65
            + a16*a23*a31*a44*a65
            - a13*a26*a31*a44*a65
            - a16*a21*a33*a44*a65
            + a11*a26*a33*a44*a65
            + a13*a21*a36*a44*a65
            - a11*a23*a36*a44*a65 
            - a14*a23*a31*a46*a65
            + a13*a24*a31*a46*a65
            + a14*a21*a33*a46*a65
            - a11*a24*a33*a46*a65
            - a13*a21*a34*a46*a65
            + a11*a23*a34*a46*a65
            - a15*a24*a33*a41*a66
            + a14*a25*a33*a41*a66
            + a15*a23*a34*a41*a66
            - a13*a25*a34*a41*a66
            - a14*a23*a35*a41*a66 
            + a13*a24*a35*a41*a66
            + a15*a24*a31*a43*a66
            - a14*a25*a31*a43*a66
            - a15*a21*a34*a43*a66
            + a11*a25*a34*a43*a66
            + a14*a21*a35*a43*a66
            - a11*a24*a35*a43*a66
            - a15*a23*a31*a44*a66
            + a13*a25*a31*a44*a66
            + a15*a21*a33*a44*a66
            - a11*a25*a33*a44*a66 
            - a13*a21*a35*a44*a66
            + a11*a23*a35*a44*a66
            + a14*a23*a31*a45*a66
            - a13*a24*a31*a45*a66
            - a14*a21*a33*a45*a66
            + a11*a24*a33*a45*a66
            + a13*a21*a34*a45*a66
            - a11*a23*a34*a45*a66;
    cofactor[11] = a16*a25*a34*a43*a51
            - a15*a26*a34*a43*a51 
            - a16*a24*a35*a43*a51
            + a14*a26*a35*a43*a51
            + a15*a24*a36*a43*a51
            - a14*a25*a36*a43*a51
            - a16*a25*a33*a44*a51
            + a15*a26*a33*a44*a51
            + a16*a23*a35*a44*a51
            - a13*a26*a35*a44*a51
            - a15*a23*a36*a44*a51
            + a13*a25*a36*a44*a51
            + a16*a24*a33*a45*a51 
            - a14*a26*a33*a45*a51
            - a16*a23*a34*a45*a51
            + a13*a26*a34*a45*a51
            + a14*a23*a36*a45*a51
            - a13*a24*a36*a45*a51
            - a15*a24*a33*a46*a51
            + a14*a25*a33*a46*a51
            + a15*a23*a34*a46*a51
            - a13*a25*a34*a46*a51
            - a14*a23*a35*a46*a51
            + a13*a24*a35*a46*a51 
            - a16*a25*a34*a41*a53
            + a15*a26*a34*a41*a53
            + a16*a24*a35*a41*a53
            - a14*a26*a35*a41*a53
            - a15*a24*a36*a41*a53
            + a14*a25*a36*a41*a53
            + a16*a25*a31*a44*a53
            - a15*a26*a31*a44*a53
            - a16*a21*a35*a44*a53
            + a11*a26*a35*a44*a53
            + a15*a21*a36*a44*a53 
            - a11*a25*a36*a44*a53
            - a16*a24*a31*a45*a53
            + a14*a26*a31*a45*a53
            + a16*a21*a34*a45*a53
            - a11*a26*a34*a45*a53
            - a14*a21*a36*a45*a53
            + a11*a24*a36*a45*a53
            + a15*a24*a31*a46*a53
            - a14*a25*a31*a46*a53
            - a15*a21*a34*a46*a53
            + a11*a25*a34*a46*a53 
            + a14*a21*a35*a46*a53
            - a11*a24*a35*a46*a53
            + a16*a25*a33*a41*a54
            - a15*a26*a33*a41*a54
            - a16*a23*a35*a41*a54
            + a13*a26*a35*a41*a54
            + a15*a23*a36*a41*a54
            - a13*a25*a36*a41*a54
            - a16*a25*a31*a43*a54
            + a15*a26*a31*a43*a54
            + a16*a21*a35*a43*a54 
            - a11*a26*a35*a43*a54
            - a15*a21*a36*a43*a54
            + a11*a25*a36*a43*a54
            + a16*a23*a31*a45*a54
            - a13*a26*a31*a45*a54
            - a16*a21*a33*a45*a54
            + a11*a26*a33*a45*a54
            + a13*a21*a36*a45*a54
            - a11*a23*a36*a45*a54
            - a15*a23*a31*a46*a54
            + a13*a25*a31*a46*a54 
            + a15*a21*a33*a46*a54
            - a11*a25*a33*a46*a54
            - a13*a21*a35*a46*a54
            + a11*a23*a35*a46*a54
            - a16*a24*a33*a41*a55
            + a14*a26*a33*a41*a55
            + a16*a23*a34*a41*a55
            - a13*a26*a34*a41*a55
            - a14*a23*a36*a41*a55
            + a13*a24*a36*a41*a55
            + a16*a24*a31*a43*a55 
            - a14*a26*a31*a43*a55
            - a16*a21*a34*a43*a55
            + a11*a26*a34*a43*a55
            + a14*a21*a36*a43*a55
            - a11*a24*a36*a43*a55
            - a16*a23*a31*a44*a55
            + a13*a26*a31*a44*a55
            + a16*a21*a33*a44*a55
            - a11*a26*a33*a44*a55
            - a13*a21*a36*a44*a55
            + a11*a23*a36*a44*a55 
            + a14*a23*a31*a46*a55
            - a13*a24*a31*a46*a55
            - a14*a21*a33*a46*a55
            + a11*a24*a33*a46*a55
            + a13*a21*a34*a46*a55
            - a11*a23*a34*a46*a55
            + a15*a24*a33*a41*a56
            - a14*a25*a33*a41*a56
            - a15*a23*a34*a41*a56
            + a13*a25*a34*a41*a56
            + a14*a23*a35*a41*a56 
            - a13*a24*a35*a41*a56
            - a15*a24*a31*a43*a56
            + a14*a25*a31*a43*a56
            + a15*a21*a34*a43*a56
            - a11*a25*a34*a43*a56
            - a14*a21*a35*a43*a56
            + a11*a24*a35*a43*a56
            + a15*a23*a31*a44*a56
            - a13*a25*a31*a44*a56
            - a15*a21*a33*a44*a56
            + a11*a25*a33*a44*a56 
            + a13*a21*a35*a44*a56
            - a11*a23*a35*a44*a56
            - a14*a23*a31*a45*a56
            + a13*a24*a31*a45*a56
            + a14*a21*a33*a45*a56
            - a11*a24*a33*a45*a56
            - a13*a21*a34*a45*a56
            + a11*a23*a34*a45*a56;
    cofactor[12] = a26*a35*a44*a52*a61
            - a25*a36*a44*a52*a61 
            - a26*a34*a45*a52*a61
            + a24*a36*a45*a52*a61
            + a25*a34*a46*a52*a61
            - a24*a35*a46*a52*a61
            - a26*a35*a42*a54*a61
            + a25*a36*a42*a54*a61
            + a26*a32*a45*a54*a61
            - a22*a36*a45*a54*a61
            - a25*a32*a46*a54*a61
            + a22*a35*a46*a54*a61
            + a26*a34*a42*a55*a61 
            - a24*a36*a42*a55*a61
            - a26*a32*a44*a55*a61
            + a22*a36*a44*a55*a61
            + a24*a32*a46*a55*a61
            - a22*a34*a46*a55*a61
            - a25*a34*a42*a56*a61
            + a24*a35*a42*a56*a61
            + a25*a32*a44*a56*a61
            - a22*a35*a44*a56*a61
            - a24*a32*a45*a56*a61
            + a22*a34*a45*a56*a61 
            - a26*a35*a44*a51*a62
            + a25*a36*a44*a51*a62
            + a26*a34*a45*a51*a62
            - a24*a36*a45*a51*a62
            - a25*a34*a46*a51*a62
            + a24*a35*a46*a51*a62
            + a26*a35*a41*a54*a62
            - a25*a36*a41*a54*a62
            - a26*a31*a45*a54*a62
            + a21*a36*a45*a54*a62
            + a25*a31*a46*a54*a62 
            - a21*a35*a46*a54*a62
            - a26*a34*a41*a55*a62
            + a24*a36*a41*a55*a62
            + a26*a31*a44*a55*a62
            - a21*a36*a44*a55*a62
            - a24*a31*a46*a55*a62
            + a21*a34*a46*a55*a62
            + a25*a34*a41*a56*a62
            - a24*a35*a41*a56*a62
            - a25*a31*a44*a56*a62
            + a21*a35*a44*a56*a62 
            + a24*a31*a45*a56*a62
            - a21*a34*a45*a56*a62
            + a26*a35*a42*a51*a64
            - a25*a36*a42*a51*a64
            - a26*a32*a45*a51*a64
            + a22*a36*a45*a51*a64
            + a25*a32*a46*a51*a64
            - a22*a35*a46*a51*a64
            - a26*a35*a41*a52*a64
            + a25*a36*a41*a52*a64
            + a26*a31*a45*a52*a64 
            - a21*a36*a45*a52*a64
            - a25*a31*a46*a52*a64
            + a21*a35*a46*a52*a64
            + a26*a32*a41*a55*a64
            - a22*a36*a41*a55*a64
            - a26*a31*a42*a55*a64
            + a21*a36*a42*a55*a64
            + a22*a31*a46*a55*a64
            - a21*a32*a46*a55*a64
            - a25*a32*a41*a56*a64
            + a22*a35*a41*a56*a64 
            + a25*a31*a42*a56*a64
            - a21*a35*a42*a56*a64
            - a22*a31*a45*a56*a64
            + a21*a32*a45*a56*a64
            - a26*a34*a42*a51*a65
            + a24*a36*a42*a51*a65
            + a26*a32*a44*a51*a65
            - a22*a36*a44*a51*a65
            - a24*a32*a46*a51*a65
            + a22*a34*a46*a51*a65
            + a26*a34*a41*a52*a65 
            - a24*a36*a41*a52*a65
            - a26*a31*a44*a52*a65
            + a21*a36*a44*a52*a65
            + a24*a31*a46*a52*a65
            - a21*a34*a46*a52*a65
            - a26*a32*a41*a54*a65
            + a22*a36*a41*a54*a65
            + a26*a31*a42*a54*a65
            - a21*a36*a42*a54*a65
            - a22*a31*a46*a54*a65
            + a21*a32*a46*a54*a65 
            + a24*a32*a41*a56*a65
            - a22*a34*a41*a56*a65
            - a24*a31*a42*a56*a65
            + a21*a34*a42*a56*a65
            + a22*a31*a44*a56*a65
            - a21*a32*a44*a56*a65
            + a25*a34*a42*a51*a66
            - a24*a35*a42*a51*a66
            - a25*a32*a44*a51*a66
            + a22*a35*a44*a51*a66
            + a24*a32*a45*a51*a66 
            - a22*a34*a45*a51*a66
            - a25*a34*a41*a52*a66
            + a24*a35*a41*a52*a66
            + a25*a31*a44*a52*a66
            - a21*a35*a44*a52*a66
            - a24*a31*a45*a52*a66
            + a21*a34*a45*a52*a66
            + a25*a32*a41*a54*a66
            - a22*a35*a41*a54*a66
            - a25*a31*a42*a54*a66
            + a21*a35*a42*a54*a66 
            + a22*a31*a45*a54*a66
            - a21*a32*a45*a54*a66
            - a24*a32*a41*a55*a66
            + a22*a34*a41*a55*a66
            + a24*a31*a42*a55*a66
            - a21*a34*a42*a55*a66
            - a22*a31*a44*a55*a66
            + a21*a32*a44*a55*a66;
    cofactor[13] = -a16*a35*a44*a52*a61
            + a15*a36*a44*a52*a61 
            + a16*a34*a45*a52*a61
            - a14*a36*a45*a52*a61
            - a15*a34*a46*a52*a61
            + a14*a35*a46*a52*a61
            + a16*a35*a42*a54*a61
            - a15*a36*a42*a54*a61
            - a16*a32*a45*a54*a61
            + a12*a36*a45*a54*a61
            + a15*a32*a46*a54*a61
            - a12*a35*a46*a54*a61
            - a16*a34*a42*a55*a61 
            + a14*a36*a42*a55*a61
            + a16*a32*a44*a55*a61
            - a12*a36*a44*a55*a61
            - a14*a32*a46*a55*a61
            + a12*a34*a46*a55*a61
            + a15*a34*a42*a56*a61
            - a14*a35*a42*a56*a61
            - a15*a32*a44*a56*a61
            + a12*a35*a44*a56*a61
            + a14*a32*a45*a56*a61
            - a12*a34*a45*a56*a61 
            + a16*a35*a44*a51*a62
            - a15*a36*a44*a51*a62
            - a16*a34*a45*a51*a62
            + a14*a36*a45*a51*a62
            + a15*a34*a46*a51*a62
            - a14*a35*a46*a51*a62
            - a16*a35*a41*a54*a62
            + a15*a36*a41*a54*a62
            + a16*a31*a45*a54*a62
            - a11*a36*a45*a54*a62
            - a15*a31*a46*a54*a62 
            + a11*a35*a46*a54*a62
            + a16*a34*a41*a55*a62
            - a14*a36*a41*a55*a62
            - a16*a31*a44*a55*a62
            + a11*a36*a44*a55*a62
            + a14*a31*a46*a55*a62
            - a11*a34*a46*a55*a62
            - a15*a34*a41*a56*a62
            + a14*a35*a41*a56*a62
            + a15*a31*a44*a56*a62
            - a11*a35*a44*a56*a62 
            - a14*a31*a45*a56*a62
            + a11*a34*a45*a56*a62
            - a16*a35*a42*a51*a64
            + a15*a36*a42*a51*a64
            + a16*a32*a45*a51*a64
            - a12*a36*a45*a51*a64
            - a15*a32*a46*a51*a64
            + a12*a35*a46*a51*a64
            + a16*a35*a41*a52*a64
            - a15*a36*a41*a52*a64
            - a16*a31*a45*a52*a64 
            + a11*a36*a45*a52*a64
            + a15*a31*a46*a52*a64
            - a11*a35*a46*a52*a64
            - a16*a32*a41*a55*a64
            + a12*a36*a41*a55*a64
            + a16*a31*a42*a55*a64
            - a11*a36*a42*a55*a64
            - a12*a31*a46*a55*a64
            + a11*a32*a46*a55*a64
            + a15*a32*a41*a56*a64
            - a12*a35*a41*a56*a64 
            - a15*a31*a42*a56*a64
            + a11*a35*a42*a56*a64
            + a12*a31*a45*a56*a64
            - a11*a32*a45*a56*a64
            + a16*a34*a42*a51*a65
            - a14*a36*a42*a51*a65
            - a16*a32*a44*a51*a65
            + a12*a36*a44*a51*a65
            + a14*a32*a46*a51*a65
            - a12*a34*a46*a51*a65
            - a16*a34*a41*a52*a65 
            + a14*a36*a41*a52*a65
            + a16*a31*a44*a52*a65
            - a11*a36*a44*a52*a65
            - a14*a31*a46*a52*a65
            + a11*a34*a46*a52*a65
            + a16*a32*a41*a54*a65
            - a12*a36*a41*a54*a65
            - a16*a31*a42*a54*a65
            + a11*a36*a42*a54*a65
            + a12*a31*a46*a54*a65
            - a11*a32*a46*a54*a65 
            - a14*a32*a41*a56*a65
            + a12*a34*a41*a56*a65
            + a14*a31*a42*a56*a65
            - a11*a34*a42*a56*a65
            - a12*a31*a44*a56*a65
            + a11*a32*a44*a56*a65
            - a15*a34*a42*a51*a66
            + a14*a35*a42*a51*a66
            + a15*a32*a44*a51*a66
            - a12*a35*a44*a51*a66
            - a14*a32*a45*a51*a66 
            + a12*a34*a45*a51*a66
            + a15*a34*a41*a52*a66
            - a14*a35*a41*a52*a66
            - a15*a31*a44*a52*a66
            + a11*a35*a44*a52*a66
            + a14*a31*a45*a52*a66
            - a11*a34*a45*a52*a66
            - a15*a32*a41*a54*a66
            + a12*a35*a41*a54*a66
            + a15*a31*a42*a54*a66
            - a11*a35*a42*a54*a66 
            - a12*a31*a45*a54*a66
            + a11*a32*a45*a54*a66
            + a14*a32*a41*a55*a66
            - a12*a34*a41*a55*a66
            - a14*a31*a42*a55*a66
            + a11*a34*a42*a55*a66
            + a12*a31*a44*a55*a66
            - a11*a32*a44*a55*a66;
    cofactor[14] = a16*a25*a44*a52*a61
            - a15*a26*a44*a52*a61 
            - a16*a24*a45*a52*a61
            + a14*a26*a45*a52*a61
            + a15*a24*a46*a52*a61
            - a14*a25*a46*a52*a61
            - a16*a25*a42*a54*a61
            + a15*a26*a42*a54*a61
            + a16*a22*a45*a54*a61
            - a12*a26*a45*a54*a61
            - a15*a22*a46*a54*a61
            + a12*a25*a46*a54*a61
            + a16*a24*a42*a55*a61 
            - a14*a26*a42*a55*a61
            - a16*a22*a44*a55*a61
            + a12*a26*a44*a55*a61
            + a14*a22*a46*a55*a61
            - a12*a24*a46*a55*a61
            - a15*a24*a42*a56*a61
            + a14*a25*a42*a56*a61
            + a15*a22*a44*a56*a61
            - a12*a25*a44*a56*a61
            - a14*a22*a45*a56*a61
            + a12*a24*a45*a56*a61 
            - a16*a25*a44*a51*a62
            + a15*a26*a44*a51*a62
            + a16*a24*a45*a51*a62
            - a14*a26*a45*a51*a62
            - a15*a24*a46*a51*a62
            + a14*a25*a46*a51*a62
            + a16*a25*a41*a54*a62
            - a15*a26*a41*a54*a62
            - a16*a21*a45*a54*a62
            + a11*a26*a45*a54*a62
            + a15*a21*a46*a54*a62 
            - a11*a25*a46*a54*a62
            - a16*a24*a41*a55*a62
            + a14*a26*a41*a55*a62
            + a16*a21*a44*a55*a62
            - a11*a26*a44*a55*a62
            - a14*a21*a46*a55*a62
            + a11*a24*a46*a55*a62
            + a15*a24*a41*a56*a62
            - a14*a25*a41*a56*a62
            - a15*a21*a44*a56*a62
            + a11*a25*a44*a56*a62 
            + a14*a21*a45*a56*a62
            - a11*a24*a45*a56*a62
            + a16*a25*a42*a51*a64
            - a15*a26*a42*a51*a64
            - a16*a22*a45*a51*a64
            + a12*a26*a45*a51*a64
            + a15*a22*a46*a51*a64
            - a12*a25*a46*a51*a64
            - a16*a25*a41*a52*a64
            + a15*a26*a41*a52*a64
            + a16*a21*a45*a52*a64 
            - a11*a26*a45*a52*a64
            - a15*a21*a46*a52*a64
            + a11*a25*a46*a52*a64
            + a16*a22*a41*a55*a64
            - a12*a26*a41*a55*a64
            - a16*a21*a42*a55*a64
            + a11*a26*a42*a55*a64
            + a12*a21*a46*a55*a64
            - a11*a22*a46*a55*a64
            - a15*a22*a41*a56*a64
            + a12*a25*a41*a56*a64 
            + a15*a21*a42*a56*a64
            - a11*a25*a42*a56*a64
            - a12*a21*a45*a56*a64
            + a11*a22*a45*a56*a64
            - a16*a24*a42*a51*a65
            + a14*a26*a42*a51*a65
            + a16*a22*a44*a51*a65
            - a12*a26*a44*a51*a65
            - a14*a22*a46*a51*a65
            + a12*a24*a46*a51*a65
            + a16*a24*a41*a52*a65 
            - a14*a26*a41*a52*a65
            - a16*a21*a44*a52*a65
            + a11*a26*a44*a52*a65
            + a14*a21*a46*a52*a65
            - a11*a24*a46*a52*a65
            - a16*a22*a41*a54*a65
            + a12*a26*a41*a54*a65
            + a16*a21*a42*a54*a65
            - a11*a26*a42*a54*a65
            - a12*a21*a46*a54*a65
            + a11*a22*a46*a54*a65 
            + a14*a22*a41*a56*a65
            - a12*a24*a41*a56*a65
            - a14*a21*a42*a56*a65
            + a11*a24*a42*a56*a65
            + a12*a21*a44*a56*a65
            - a11*a22*a44*a56*a65
            + a15*a24*a42*a51*a66
            - a14*a25*a42*a51*a66
            - a15*a22*a44*a51*a66
            + a12*a25*a44*a51*a66
            + a14*a22*a45*a51*a66 
            - a12*a24*a45*a51*a66
            - a15*a24*a41*a52*a66
            + a14*a25*a41*a52*a66
            + a15*a21*a44*a52*a66
            - a11*a25*a44*a52*a66
            - a14*a21*a45*a52*a66
            + a11*a24*a45*a52*a66
            + a15*a22*a41*a54*a66
            - a12*a25*a41*a54*a66
            - a15*a21*a42*a54*a66
            + a11*a25*a42*a54*a66 
            + a12*a21*a45*a54*a66
            - a11*a22*a45*a54*a66
            - a14*a22*a41*a55*a66
            + a12*a24*a41*a55*a66
            + a14*a21*a42*a55*a66
            - a11*a24*a42*a55*a66
            - a12*a21*a44*a55*a66
            + a11*a22*a44*a55*a66;
    cofactor[15] = -a16*a25*a34*a52*a61
            + a15*a26*a34*a52*a61 
            + a16*a24*a35*a52*a61
            - a14*a26*a35*a52*a61
            - a15*a24*a36*a52*a61
            + a14*a25*a36*a52*a61
            + a16*a25*a32*a54*a61
            - a15*a26*a32*a54*a61
            - a16*a22*a35*a54*a61
            + a12*a26*a35*a54*a61
            + a15*a22*a36*a54*a61
            - a12*a25*a36*a54*a61
            - a16*a24*a32*a55*a61 
            + a14*a26*a32*a55*a61
            + a16*a22*a34*a55*a61
            - a12*a26*a34*a55*a61
            - a14*a22*a36*a55*a61
            + a12*a24*a36*a55*a61
            + a15*a24*a32*a56*a61
            - a14*a25*a32*a56*a61
            - a15*a22*a34*a56*a61
            + a12*a25*a34*a56*a61
            + a14*a22*a35*a56*a61
            - a12*a24*a35*a56*a61 
            + a16*a25*a34*a51*a62
            - a15*a26*a34*a51*a62
            - a16*a24*a35*a51*a62
            + a14*a26*a35*a51*a62
            + a15*a24*a36*a51*a62
            - a14*a25*a36*a51*a62
            - a16*a25*a31*a54*a62
            + a15*a26*a31*a54*a62
            + a16*a21*a35*a54*a62
            - a11*a26*a35*a54*a62
            - a15*a21*a36*a54*a62 
            + a11*a25*a36*a54*a62
            + a16*a24*a31*a55*a62
            - a14*a26*a31*a55*a62
            - a16*a21*a34*a55*a62
            + a11*a26*a34*a55*a62
            + a14*a21*a36*a55*a62
            - a11*a24*a36*a55*a62
            - a15*a24*a31*a56*a62
            + a14*a25*a31*a56*a62
            + a15*a21*a34*a56*a62
            - a11*a25*a34*a56*a62 
            - a14*a21*a35*a56*a62
            + a11*a24*a35*a56*a62
            - a16*a25*a32*a51*a64
            + a15*a26*a32*a51*a64
            + a16*a22*a35*a51*a64
            - a12*a26*a35*a51*a64
            - a15*a22*a36*a51*a64
            + a12*a25*a36*a51*a64
            + a16*a25*a31*a52*a64
            - a15*a26*a31*a52*a64
            - a16*a21*a35*a52*a64 
            + a11*a26*a35*a52*a64
            + a15*a21*a36*a52*a64
            - a11*a25*a36*a52*a64
            - a16*a22*a31*a55*a64
            + a12*a26*a31*a55*a64
            + a16*a21*a32*a55*a64
            - a11*a26*a32*a55*a64
            - a12*a21*a36*a55*a64
            + a11*a22*a36*a55*a64
            + a15*a22*a31*a56*a64
            - a12*a25*a31*a56*a64 
            - a15*a21*a32*a56*a64
            + a11*a25*a32*a56*a64
            + a12*a21*a35*a56*a64
            - a11*a22*a35*a56*a64
            + a16*a24*a32*a51*a65
            - a14*a26*a32*a51*a65
            - a16*a22*a34*a51*a65
            + a12*a26*a34*a51*a65
            + a14*a22*a36*a51*a65
            - a12*a24*a36*a51*a65
            - a16*a24*a31*a52*a65 
            + a14*a26*a31*a52*a65
            + a16*a21*a34*a52*a65
            - a11*a26*a34*a52*a65
            - a14*a21*a36*a52*a65
            + a11*a24*a36*a52*a65
            + a16*a22*a31*a54*a65
            - a12*a26*a31*a54*a65
            - a16*a21*a32*a54*a65
            + a11*a26*a32*a54*a65
            + a12*a21*a36*a54*a65
            - a11*a22*a36*a54*a65 
            - a14*a22*a31*a56*a65
            + a12*a24*a31*a56*a65
            + a14*a21*a32*a56*a65
            - a11*a24*a32*a56*a65
            - a12*a21*a34*a56*a65
            + a11*a22*a34*a56*a65
            - a15*a24*a32*a51*a66
            + a14*a25*a32*a51*a66
            + a15*a22*a34*a51*a66
            - a12*a25*a34*a51*a66
            - a14*a22*a35*a51*a66 
            + a12*a24*a35*a51*a66
            + a15*a24*a31*a52*a66
            - a14*a25*a31*a52*a66
            - a15*a21*a34*a52*a66
            + a11*a25*a34*a52*a66
            + a14*a21*a35*a52*a66
            - a11*a24*a35*a52*a66
            - a15*a22*a31*a54*a66
            + a12*a25*a31*a54*a66
            + a15*a21*a32*a54*a66
            - a11*a25*a32*a54*a66 
            - a12*a21*a35*a54*a66
            + a11*a22*a35*a54*a66
            + a14*a22*a31*a55*a66
            - a12*a24*a31*a55*a66
            - a14*a21*a32*a55*a66
            + a11*a24*a32*a55*a66
            + a12*a21*a34*a55*a66
            - a11*a22*a34*a55*a66;
    cofactor[16] = a16*a25*a34*a42*a61
            - a15*a26*a34*a42*a61 
            - a16*a24*a35*a42*a61
            + a14*a26*a35*a42*a61
            + a15*a24*a36*a42*a61
            - a14*a25*a36*a42*a61
            - a16*a25*a32*a44*a61
            + a15*a26*a32*a44*a61
            + a16*a22*a35*a44*a61
            - a12*a26*a35*a44*a61
            - a15*a22*a36*a44*a61
            + a12*a25*a36*a44*a61
            + a16*a24*a32*a45*a61 
            - a14*a26*a32*a45*a61
            - a16*a22*a34*a45*a61
            + a12*a26*a34*a45*a61
            + a14*a22*a36*a45*a61
            - a12*a24*a36*a45*a61
            - a15*a24*a32*a46*a61
            + a14*a25*a32*a46*a61
            + a15*a22*a34*a46*a61
            - a12*a25*a34*a46*a61
            - a14*a22*a35*a46*a61
            + a12*a24*a35*a46*a61 
            - a16*a25*a34*a41*a62
            + a15*a26*a34*a41*a62
            + a16*a24*a35*a41*a62
            - a14*a26*a35*a41*a62
            - a15*a24*a36*a41*a62
            + a14*a25*a36*a41*a62
            + a16*a25*a31*a44*a62
            - a15*a26*a31*a44*a62
            - a16*a21*a35*a44*a62
            + a11*a26*a35*a44*a62
            + a15*a21*a36*a44*a62 
            - a11*a25*a36*a44*a62
            - a16*a24*a31*a45*a62
            + a14*a26*a31*a45*a62
            + a16*a21*a34*a45*a62
            - a11*a26*a34*a45*a62
            - a14*a21*a36*a45*a62
            + a11*a24*a36*a45*a62
            + a15*a24*a31*a46*a62
            - a14*a25*a31*a46*a62
            - a15*a21*a34*a46*a62
            + a11*a25*a34*a46*a62 
            + a14*a21*a35*a46*a62
            - a11*a24*a35*a46*a62
            + a16*a25*a32*a41*a64
            - a15*a26*a32*a41*a64
            - a16*a22*a35*a41*a64
            + a12*a26*a35*a41*a64
            + a15*a22*a36*a41*a64
            - a12*a25*a36*a41*a64
            - a16*a25*a31*a42*a64
            + a15*a26*a31*a42*a64
            + a16*a21*a35*a42*a64 
            - a11*a26*a35*a42*a64
            - a15*a21*a36*a42*a64
            + a11*a25*a36*a42*a64
            + a16*a22*a31*a45*a64
            - a12*a26*a31*a45*a64
            - a16*a21*a32*a45*a64
            + a11*a26*a32*a45*a64
            + a12*a21*a36*a45*a64
            - a11*a22*a36*a45*a64
            - a15*a22*a31*a46*a64
            + a12*a25*a31*a46*a64 
            + a15*a21*a32*a46*a64
            - a11*a25*a32*a46*a64
            - a12*a21*a35*a46*a64
            + a11*a22*a35*a46*a64
            - a16*a24*a32*a41*a65
            + a14*a26*a32*a41*a65
            + a16*a22*a34*a41*a65
            - a12*a26*a34*a41*a65
            - a14*a22*a36*a41*a65
            + a12*a24*a36*a41*a65
            + a16*a24*a31*a42*a65 
            - a14*a26*a31*a42*a65
            - a16*a21*a34*a42*a65
            + a11*a26*a34*a42*a65
            + a14*a21*a36*a42*a65
            - a11*a24*a36*a42*a65
            - a16*a22*a31*a44*a65
            + a12*a26*a31*a44*a65
            + a16*a21*a32*a44*a65
            - a11*a26*a32*a44*a65
            - a12*a21*a36*a44*a65
            + a11*a22*a36*a44*a65 
            + a14*a22*a31*a46*a65
            - a12*a24*a31*a46*a65
            - a14*a21*a32*a46*a65
            + a11*a24*a32*a46*a65
            + a12*a21*a34*a46*a65
            - a11*a22*a34*a46*a65
            + a15*a24*a32*a41*a66
            - a14*a25*a32*a41*a66
            - a15*a22*a34*a41*a66
            + a12*a25*a34*a41*a66
            + a14*a22*a35*a41*a66 
            - a12*a24*a35*a41*a66
            - a15*a24*a31*a42*a66
            + a14*a25*a31*a42*a66
            + a15*a21*a34*a42*a66
            - a11*a25*a34*a42*a66
            - a14*a21*a35*a42*a66
            + a11*a24*a35*a42*a66
            + a15*a22*a31*a44*a66
            - a12*a25*a31*a44*a66
            - a15*a21*a32*a44*a66
            + a11*a25*a32*a44*a66 
            + a12*a21*a35*a44*a66
            - a11*a22*a35*a44*a66
            - a14*a22*a31*a45*a66
            + a12*a24*a31*a45*a66
            + a14*a21*a32*a45*a66
            - a11*a24*a32*a45*a66
            - a12*a21*a34*a45*a66
            + a11*a22*a34*a45*a66;
    cofactor[17] = -a16*a25*a34*a42*a51
            + a15*a26*a34*a42*a51 
            + a16*a24*a35*a42*a51
            - a14*a26*a35*a42*a51
            - a15*a24*a36*a42*a51
            + a14*a25*a36*a42*a51
            + a16*a25*a32*a44*a51
            - a15*a26*a32*a44*a51
            - a16*a22*a35*a44*a51
            + a12*a26*a35*a44*a51
            + a15*a22*a36*a44*a51
            - a12*a25*a36*a44*a51
            - a16*a24*a32*a45*a51 
            + a14*a26*a32*a45*a51
            + a16*a22*a34*a45*a51
            - a12*a26*a34*a45*a51
            - a14*a22*a36*a45*a51
            + a12*a24*a36*a45*a51
            + a15*a24*a32*a46*a51
            - a14*a25*a32*a46*a51
            - a15*a22*a34*a46*a51
            + a12*a25*a34*a46*a51
            + a14*a22*a35*a46*a51
            - a12*a24*a35*a46*a51 
            + a16*a25*a34*a41*a52
            - a15*a26*a34*a41*a52
            - a16*a24*a35*a41*a52
            + a14*a26*a35*a41*a52
            + a15*a24*a36*a41*a52
            - a14*a25*a36*a41*a52
            - a16*a25*a31*a44*a52
            + a15*a26*a31*a44*a52
            + a16*a21*a35*a44*a52
            - a11*a26*a35*a44*a52
            - a15*a21*a36*a44*a52 
            + a11*a25*a36*a44*a52
            + a16*a24*a31*a45*a52
            - a14*a26*a31*a45*a52
            - a16*a21*a34*a45*a52
            + a11*a26*a34*a45*a52
            + a14*a21*a36*a45*a52
            - a11*a24*a36*a45*a52
            - a15*a24*a31*a46*a52
            + a14*a25*a31*a46*a52
            + a15*a21*a34*a46*a52
            - a11*a25*a34*a46*a52 
            - a14*a21*a35*a46*a52
            + a11*a24*a35*a46*a52
            - a16*a25*a32*a41*a54
            + a15*a26*a32*a41*a54
            + a16*a22*a35*a41*a54
            - a12*a26*a35*a41*a54
            - a15*a22*a36*a41*a54
            + a12*a25*a36*a41*a54
            + a16*a25*a31*a42*a54
            - a15*a26*a31*a42*a54
            - a16*a21*a35*a42*a54 
            + a11*a26*a35*a42*a54
            + a15*a21*a36*a42*a54
            - a11*a25*a36*a42*a54
            - a16*a22*a31*a45*a54
            + a12*a26*a31*a45*a54
            + a16*a21*a32*a45*a54
            - a11*a26*a32*a45*a54
            - a12*a21*a36*a45*a54
            + a11*a22*a36*a45*a54
            + a15*a22*a31*a46*a54
            - a12*a25*a31*a46*a54 
            - a15*a21*a32*a46*a54
            + a11*a25*a32*a46*a54
            + a12*a21*a35*a46*a54
            - a11*a22*a35*a46*a54
            + a16*a24*a32*a41*a55
            - a14*a26*a32*a41*a55
            - a16*a22*a34*a41*a55
            + a12*a26*a34*a41*a55
            + a14*a22*a36*a41*a55
            - a12*a24*a36*a41*a55
            - a16*a24*a31*a42*a55 
            + a14*a26*a31*a42*a55
            + a16*a21*a34*a42*a55
            - a11*a26*a34*a42*a55
            - a14*a21*a36*a42*a55
            + a11*a24*a36*a42*a55
            + a16*a22*a31*a44*a55
            - a12*a26*a31*a44*a55
            - a16*a21*a32*a44*a55
            + a11*a26*a32*a44*a55
            + a12*a21*a36*a44*a55
            - a11*a22*a36*a44*a55 
            - a14*a22*a31*a46*a55
            + a12*a24*a31*a46*a55
            + a14*a21*a32*a46*a55
            - a11*a24*a32*a46*a55
            - a12*a21*a34*a46*a55
            + a11*a22*a34*a46*a55
            - a15*a24*a32*a41*a56
            + a14*a25*a32*a41*a56
            + a15*a22*a34*a41*a56
            - a12*a25*a34*a41*a56
            - a14*a22*a35*a41*a56 
            + a12*a24*a35*a41*a56
            + a15*a24*a31*a42*a56
            - a14*a25*a31*a42*a56
            - a15*a21*a34*a42*a56
            + a11*a25*a34*a42*a56
            + a14*a21*a35*a42*a56
            - a11*a24*a35*a42*a56
            - a15*a22*a31*a44*a56
            + a12*a25*a31*a44*a56
            + a15*a21*a32*a44*a56
            - a11*a25*a32*a44*a56 
            - a12*a21*a35*a44*a56
            + a11*a22*a35*a44*a56
            + a14*a22*a31*a45*a56
            - a12*a24*a31*a45*a56
            - a14*a21*a32*a45*a56
            + a11*a24*a32*a45*a56
            + a12*a21*a34*a45*a56
            - a11*a22*a34*a45*a56;
    cofactor[18] = -a26*a35*a43*a52*a61
            + a25*a36*a43*a52*a61 
            + a26*a33*a45*a52*a61
            - a23*a36*a45*a52*a61
            - a25*a33*a46*a52*a61
            + a23*a35*a46*a52*a61
            + a26*a35*a42*a53*a61
            - a25*a36*a42*a53*a61
            - a26*a32*a45*a53*a61
            + a22*a36*a45*a53*a61
            + a25*a32*a46*a53*a61
            - a22*a35*a46*a53*a61
            - a26*a33*a42*a55*a61 
            + a23*a36*a42*a55*a61
            + a26*a32*a43*a55*a61
            - a22*a36*a43*a55*a61
            - a23*a32*a46*a55*a61
            + a22*a33*a46*a55*a61
            + a25*a33*a42*a56*a61
            - a23*a35*a42*a56*a61
            - a25*a32*a43*a56*a61
            + a22*a35*a43*a56*a61
            + a23*a32*a45*a56*a61
            - a22*a33*a45*a56*a61 
            + a26*a35*a43*a51*a62
            - a25*a36*a43*a51*a62
            - a26*a33*a45*a51*a62
            + a23*a36*a45*a51*a62
            + a25*a33*a46*a51*a62
            - a23*a35*a46*a51*a62
            - a26*a35*a41*a53*a62
            + a25*a36*a41*a53*a62
            + a26*a31*a45*a53*a62
            - a21*a36*a45*a53*a62
            - a25*a31*a46*a53*a62 
            + a21*a35*a46*a53*a62
            + a26*a33*a41*a55*a62
            - a23*a36*a41*a55*a62
            - a26*a31*a43*a55*a62
            + a21*a36*a43*a55*a62
            + a23*a31*a46*a55*a62
            - a21*a33*a46*a55*a62
            - a25*a33*a41*a56*a62
            + a23*a35*a41*a56*a62
            + a25*a31*a43*a56*a62
            - a21*a35*a43*a56*a62 
            - a23*a31*a45*a56*a62
            + a21*a33*a45*a56*a62
            - a26*a35*a42*a51*a63
            + a25*a36*a42*a51*a63
            + a26*a32*a45*a51*a63
            - a22*a36*a45*a51*a63
            - a25*a32*a46*a51*a63
            + a22*a35*a46*a51*a63
            + a26*a35*a41*a52*a63
            - a25*a36*a41*a52*a63
            - a26*a31*a45*a52*a63 
            + a21*a36*a45*a52*a63
            + a25*a31*a46*a52*a63
            - a21*a35*a46*a52*a63
            - a26*a32*a41*a55*a63
            + a22*a36*a41*a55*a63
            + a26*a31*a42*a55*a63
            - a21*a36*a42*a55*a63
            - a22*a31*a46*a55*a63
            + a21*a32*a46*a55*a63
            + a25*a32*a41*a56*a63
            - a22*a35*a41*a56*a63 
            - a25*a31*a42*a56*a63
            + a21*a35*a42*a56*a63
            + a22*a31*a45*a56*a63
            - a21*a32*a45*a56*a63
            + a26*a33*a42*a51*a65
            - a23*a36*a42*a51*a65
            - a26*a32*a43*a51*a65
            + a22*a36*a43*a51*a65
            + a23*a32*a46*a51*a65
            - a22*a33*a46*a51*a65
            - a26*a33*a41*a52*a65 
            + a23*a36*a41*a52*a65
            + a26*a31*a43*a52*a65
            - a21*a36*a43*a52*a65
            - a23*a31*a46*a52*a65
            + a21*a33*a46*a52*a65
            + a26*a32*a41*a53*a65
            - a22*a36*a41*a53*a65
            - a26*a31*a42*a53*a65
            + a21*a36*a42*a53*a65
            + a22*a31*a46*a53*a65
            - a21*a32*a46*a53*a65 
            - a23*a32*a41*a56*a65
            + a22*a33*a41*a56*a65
            + a23*a31*a42*a56*a65
            - a21*a33*a42*a56*a65
            - a22*a31*a43*a56*a65
            + a21*a32*a43*a56*a65
            - a25*a33*a42*a51*a66
            + a23*a35*a42*a51*a66
            + a25*a32*a43*a51*a66
            - a22*a35*a43*a51*a66
            - a23*a32*a45*a51*a66 
            + a22*a33*a45*a51*a66
            + a25*a33*a41*a52*a66
            - a23*a35*a41*a52*a66
            - a25*a31*a43*a52*a66
            + a21*a35*a43*a52*a66
            + a23*a31*a45*a52*a66
            - a21*a33*a45*a52*a66
            - a25*a32*a41*a53*a66
            + a22*a35*a41*a53*a66
            + a25*a31*a42*a53*a66
            - a21*a35*a42*a53*a66 
            - a22*a31*a45*a53*a66
            + a21*a32*a45*a53*a66
            + a23*a32*a41*a55*a66
            - a22*a33*a41*a55*a66
            - a23*a31*a42*a55*a66
            + a21*a33*a42*a55*a66
            + a22*a31*a43*a55*a66
            - a21*a32*a43*a55*a66;
    cofactor[19] = a16*a35*a43*a52*a61
            - a15*a36*a43*a52*a61 
            - a16*a33*a45*a52*a61
            + a13*a36*a45*a52*a61
            + a15*a33*a46*a52*a61
            - a13*a35*a46*a52*a61
            - a16*a35*a42*a53*a61
            + a15*a36*a42*a53*a61
            + a16*a32*a45*a53*a61
            - a12*a36*a45*a53*a61
            - a15*a32*a46*a53*a61
            + a12*a35*a46*a53*a61
            + a16*a33*a42*a55*a61 
            - a13*a36*a42*a55*a61
            - a16*a32*a43*a55*a61
            + a12*a36*a43*a55*a61
            + a13*a32*a46*a55*a61
            - a12*a33*a46*a55*a61
            - a15*a33*a42*a56*a61
            + a13*a35*a42*a56*a61
            + a15*a32*a43*a56*a61
            - a12*a35*a43*a56*a61
            - a13*a32*a45*a56*a61
            + a12*a33*a45*a56*a61 
            - a16*a35*a43*a51*a62
            + a15*a36*a43*a51*a62
            + a16*a33*a45*a51*a62
            - a13*a36*a45*a51*a62
            - a15*a33*a46*a51*a62
            + a13*a35*a46*a51*a62
            + a16*a35*a41*a53*a62
            - a15*a36*a41*a53*a62
            - a16*a31*a45*a53*a62
            + a11*a36*a45*a53*a62
            + a15*a31*a46*a53*a62 
            - a11*a35*a46*a53*a62
            - a16*a33*a41*a55*a62
            + a13*a36*a41*a55*a62
            + a16*a31*a43*a55*a62
            - a11*a36*a43*a55*a62
            - a13*a31*a46*a55*a62
            + a11*a33*a46*a55*a62
            + a15*a33*a41*a56*a62
            - a13*a35*a41*a56*a62
            - a15*a31*a43*a56*a62
            + a11*a35*a43*a56*a62 
            + a13*a31*a45*a56*a62
            - a11*a33*a45*a56*a62
            + a16*a35*a42*a51*a63
            - a15*a36*a42*a51*a63
            - a16*a32*a45*a51*a63
            + a12*a36*a45*a51*a63
            + a15*a32*a46*a51*a63
            - a12*a35*a46*a51*a63
            - a16*a35*a41*a52*a63
            + a15*a36*a41*a52*a63
            + a16*a31*a45*a52*a63 
            - a11*a36*a45*a52*a63
            - a15*a31*a46*a52*a63
            + a11*a35*a46*a52*a63
            + a16*a32*a41*a55*a63
            - a12*a36*a41*a55*a63
            - a16*a31*a42*a55*a63
            + a11*a36*a42*a55*a63
            + a12*a31*a46*a55*a63
            - a11*a32*a46*a55*a63
            - a15*a32*a41*a56*a63
            + a12*a35*a41*a56*a63 
            + a15*a31*a42*a56*a63
            - a11*a35*a42*a56*a63
            - a12*a31*a45*a56*a63
            + a11*a32*a45*a56*a63
            - a16*a33*a42*a51*a65
            + a13*a36*a42*a51*a65
            + a16*a32*a43*a51*a65
            - a12*a36*a43*a51*a65
            - a13*a32*a46*a51*a65
            + a12*a33*a46*a51*a65
            + a16*a33*a41*a52*a65 
            - a13*a36*a41*a52*a65
            - a16*a31*a43*a52*a65
            + a11*a36*a43*a52*a65
            + a13*a31*a46*a52*a65
            - a11*a33*a46*a52*a65
            - a16*a32*a41*a53*a65
            + a12*a36*a41*a53*a65
            + a16*a31*a42*a53*a65
            - a11*a36*a42*a53*a65
            - a12*a31*a46*a53*a65
            + a11*a32*a46*a53*a65 
            + a13*a32*a41*a56*a65
            - a12*a33*a41*a56*a65
            - a13*a31*a42*a56*a65
            + a11*a33*a42*a56*a65
            + a12*a31*a43*a56*a65
            - a11*a32*a43*a56*a65
            + a15*a33*a42*a51*a66
            - a13*a35*a42*a51*a66
            - a15*a32*a43*a51*a66
            + a12*a35*a43*a51*a66
            + a13*a32*a45*a51*a66 
            - a12*a33*a45*a51*a66
            - a15*a33*a41*a52*a66
            + a13*a35*a41*a52*a66
            + a15*a31*a43*a52*a66
            - a11*a35*a43*a52*a66
            - a13*a31*a45*a52*a66
            + a11*a33*a45*a52*a66
            + a15*a32*a41*a53*a66
            - a12*a35*a41*a53*a66
            - a15*a31*a42*a53*a66
            + a11*a35*a42*a53*a66 
            + a12*a31*a45*a53*a66
            - a11*a32*a45*a53*a66
            - a13*a32*a41*a55*a66
            + a12*a33*a41*a55*a66
            + a13*a31*a42*a55*a66
            - a11*a33*a42*a55*a66
            - a12*a31*a43*a55*a66
            + a11*a32*a43*a55*a66;
    cofactor[20] = -a16*a25*a43*a52*a61
            + a15*a26*a43*a52*a61 
            + a16*a23*a45*a52*a61
            - a13*a26*a45*a52*a61
            - a15*a23*a46*a52*a61
            + a13*a25*a46*a52*a61
            + a16*a25*a42*a53*a61
            - a15*a26*a42*a53*a61
            - a16*a22*a45*a53*a61
            + a12*a26*a45*a53*a61
            + a15*a22*a46*a53*a61
            - a12*a25*a46*a53*a61
            - a16*a23*a42*a55*a61 
            + a13*a26*a42*a55*a61
            + a16*a22*a43*a55*a61
            - a12*a26*a43*a55*a61
            - a13*a22*a46*a55*a61
            + a12*a23*a46*a55*a61
            + a15*a23*a42*a56*a61
            - a13*a25*a42*a56*a61
            - a15*a22*a43*a56*a61
            + a12*a25*a43*a56*a61
            + a13*a22*a45*a56*a61
            - a12*a23*a45*a56*a61 
            + a16*a25*a43*a51*a62
            - a15*a26*a43*a51*a62
            - a16*a23*a45*a51*a62
            + a13*a26*a45*a51*a62
            + a15*a23*a46*a51*a62
            - a13*a25*a46*a51*a62
            - a16*a25*a41*a53*a62
            + a15*a26*a41*a53*a62
            + a16*a21*a45*a53*a62
            - a11*a26*a45*a53*a62
            - a15*a21*a46*a53*a62 
            + a11*a25*a46*a53*a62
            + a16*a23*a41*a55*a62
            - a13*a26*a41*a55*a62
            - a16*a21*a43*a55*a62
            + a11*a26*a43*a55*a62
            + a13*a21*a46*a55*a62
            - a11*a23*a46*a55*a62
            - a15*a23*a41*a56*a62
            + a13*a25*a41*a56*a62
            + a15*a21*a43*a56*a62
            - a11*a25*a43*a56*a62 
            - a13*a21*a45*a56*a62
            + a11*a23*a45*a56*a62
            - a16*a25*a42*a51*a63
            + a15*a26*a42*a51*a63
            + a16*a22*a45*a51*a63
            - a12*a26*a45*a51*a63
            - a15*a22*a46*a51*a63
            + a12*a25*a46*a51*a63
            + a16*a25*a41*a52*a63
            - a15*a26*a41*a52*a63
            - a16*a21*a45*a52*a63 
            + a11*a26*a45*a52*a63
            + a15*a21*a46*a52*a63
            - a11*a25*a46*a52*a63
            - a16*a22*a41*a55*a63
            + a12*a26*a41*a55*a63
            + a16*a21*a42*a55*a63
            - a11*a26*a42*a55*a63
            - a12*a21*a46*a55*a63
            + a11*a22*a46*a55*a63
            + a15*a22*a41*a56*a63
            - a12*a25*a41*a56*a63 
            - a15*a21*a42*a56*a63
            + a11*a25*a42*a56*a63
            + a12*a21*a45*a56*a63
            - a11*a22*a45*a56*a63
            + a16*a23*a42*a51*a65
            - a13*a26*a42*a51*a65
            - a16*a22*a43*a51*a65
            + a12*a26*a43*a51*a65
            + a13*a22*a46*a51*a65
            - a12*a23*a46*a51*a65
            - a16*a23*a41*a52*a65 
            + a13*a26*a41*a52*a65
            + a16*a21*a43*a52*a65
            - a11*a26*a43*a52*a65
            - a13*a21*a46*a52*a65
            + a11*a23*a46*a52*a65
            + a16*a22*a41*a53*a65
            - a12*a26*a41*a53*a65
            - a16*a21*a42*a53*a65
            + a11*a26*a42*a53*a65
            + a12*a21*a46*a53*a65
            - a11*a22*a46*a53*a65 
            - a13*a22*a41*a56*a65
            + a12*a23*a41*a56*a65
            + a13*a21*a42*a56*a65
            - a11*a23*a42*a56*a65
            - a12*a21*a43*a56*a65
            + a11*a22*a43*a56*a65
            - a15*a23*a42*a51*a66
            + a13*a25*a42*a51*a66
            + a15*a22*a43*a51*a66
            - a12*a25*a43*a51*a66
            - a13*a22*a45*a51*a66 
            + a12*a23*a45*a51*a66
            + a15*a23*a41*a52*a66
            - a13*a25*a41*a52*a66
            - a15*a21*a43*a52*a66
            + a11*a25*a43*a52*a66
            + a13*a21*a45*a52*a66
            - a11*a23*a45*a52*a66
            - a15*a22*a41*a53*a66
            + a12*a25*a41*a53*a66
            + a15*a21*a42*a53*a66
            - a11*a25*a42*a53*a66 
            - a12*a21*a45*a53*a66
            + a11*a22*a45*a53*a66
            + a13*a22*a41*a55*a66
            - a12*a23*a41*a55*a66
            - a13*a21*a42*a55*a66
            + a11*a23*a42*a55*a66
            + a12*a21*a43*a55*a66
            - a11*a22*a43*a55*a66;
    cofactor[21] = a16*a25*a33*a52*a61
            - a15*a26*a33*a52*a61 
            - a16*a23*a35*a52*a61
            + a13*a26*a35*a52*a61
            + a15*a23*a36*a52*a61
            - a13*a25*a36*a52*a61
            - a16*a25*a32*a53*a61
            + a15*a26*a32*a53*a61
            + a16*a22*a35*a53*a61
            - a12*a26*a35*a53*a61
            - a15*a22*a36*a53*a61
            + a12*a25*a36*a53*a61
            + a16*a23*a32*a55*a61 
            - a13*a26*a32*a55*a61
            - a16*a22*a33*a55*a61
            + a12*a26*a33*a55*a61
            + a13*a22*a36*a55*a61
            - a12*a23*a36*a55*a61
            - a15*a23*a32*a56*a61
            + a13*a25*a32*a56*a61
            + a15*a22*a33*a56*a61
            - a12*a25*a33*a56*a61
            - a13*a22*a35*a56*a61
            + a12*a23*a35*a56*a61 
            - a16*a25*a33*a51*a62
            + a15*a26*a33*a51*a62
            + a16*a23*a35*a51*a62
            - a13*a26*a35*a51*a62
            - a15*a23*a36*a51*a62
            + a13*a25*a36*a51*a62
            + a16*a25*a31*a53*a62
            - a15*a26*a31*a53*a62
            - a16*a21*a35*a53*a62
            + a11*a26*a35*a53*a62
            + a15*a21*a36*a53*a62 
            - a11*a25*a36*a53*a62
            - a16*a23*a31*a55*a62
            + a13*a26*a31*a55*a62
            + a16*a21*a33*a55*a62
            - a11*a26*a33*a55*a62
            - a13*a21*a36*a55*a62
            + a11*a23*a36*a55*a62
            + a15*a23*a31*a56*a62
            - a13*a25*a31*a56*a62
            - a15*a21*a33*a56*a62
            + a11*a25*a33*a56*a62 
            + a13*a21*a35*a56*a62
            - a11*a23*a35*a56*a62
            + a16*a25*a32*a51*a63
            - a15*a26*a32*a51*a63
            - a16*a22*a35*a51*a63
            + a12*a26*a35*a51*a63
            + a15*a22*a36*a51*a63
            - a12*a25*a36*a51*a63
            - a16*a25*a31*a52*a63
            + a15*a26*a31*a52*a63
            + a16*a21*a35*a52*a63 
            - a11*a26*a35*a52*a63
            - a15*a21*a36*a52*a63
            + a11*a25*a36*a52*a63
            + a16*a22*a31*a55*a63
            - a12*a26*a31*a55*a63
            - a16*a21*a32*a55*a63
            + a11*a26*a32*a55*a63
            + a12*a21*a36*a55*a63
            - a11*a22*a36*a55*a63
            - a15*a22*a31*a56*a63
            + a12*a25*a31*a56*a63 
            + a15*a21*a32*a56*a63
            - a11*a25*a32*a56*a63
            - a12*a21*a35*a56*a63
            + a11*a22*a35*a56*a63
            - a16*a23*a32*a51*a65
            + a13*a26*a32*a51*a65
            + a16*a22*a33*a51*a65
            - a12*a26*a33*a51*a65
            - a13*a22*a36*a51*a65
            + a12*a23*a36*a51*a65
            + a16*a23*a31*a52*a65 
            - a13*a26*a31*a52*a65
            - a16*a21*a33*a52*a65
            + a11*a26*a33*a52*a65
            + a13*a21*a36*a52*a65
            - a11*a23*a36*a52*a65
            - a16*a22*a31*a53*a65
            + a12*a26*a31*a53*a65
            + a16*a21*a32*a53*a65
            - a11*a26*a32*a53*a65
            - a12*a21*a36*a53*a65
            + a11*a22*a36*a53*a65 
            + a13*a22*a31*a56*a65
            - a12*a23*a31*a56*a65
            - a13*a21*a32*a56*a65
            + a11*a23*a32*a56*a65
            + a12*a21*a33*a56*a65
            - a11*a22*a33*a56*a65
            + a15*a23*a32*a51*a66
            - a13*a25*a32*a51*a66
            - a15*a22*a33*a51*a66
            + a12*a25*a33*a51*a66
            + a13*a22*a35*a51*a66 
            - a12*a23*a35*a51*a66
            - a15*a23*a31*a52*a66
            + a13*a25*a31*a52*a66
            + a15*a21*a33*a52*a66
            - a11*a25*a33*a52*a66
            - a13*a21*a35*a52*a66
            + a11*a23*a35*a52*a66
            + a15*a22*a31*a53*a66
            - a12*a25*a31*a53*a66
            - a15*a21*a32*a53*a66
            + a11*a25*a32*a53*a66 
            + a12*a21*a35*a53*a66
            - a11*a22*a35*a53*a66
            - a13*a22*a31*a55*a66
            + a12*a23*a31*a55*a66
            + a13*a21*a32*a55*a66
            - a11*a23*a32*a55*a66
            - a12*a21*a33*a55*a66
            + a11*a22*a33*a55*a66;
    cofactor[22] = -a16*a25*a33*a42*a61
            + a15*a26*a33*a42*a61 
            + a16*a23*a35*a42*a61
            - a13*a26*a35*a42*a61
            - a15*a23*a36*a42*a61
            + a13*a25*a36*a42*a61
            + a16*a25*a32*a43*a61
            - a15*a26*a32*a43*a61
            - a16*a22*a35*a43*a61
            + a12*a26*a35*a43*a61
            + a15*a22*a36*a43*a61
            - a12*a25*a36*a43*a61
            - a16*a23*a32*a45*a61 
            + a13*a26*a32*a45*a61
            + a16*a22*a33*a45*a61
            - a12*a26*a33*a45*a61
            - a13*a22*a36*a45*a61
            + a12*a23*a36*a45*a61
            + a15*a23*a32*a46*a61
            - a13*a25*a32*a46*a61
            - a15*a22*a33*a46*a61
            + a12*a25*a33*a46*a61
            + a13*a22*a35*a46*a61
            - a12*a23*a35*a46*a61 
            + a16*a25*a33*a41*a62
            - a15*a26*a33*a41*a62
            - a16*a23*a35*a41*a62
            + a13*a26*a35*a41*a62
            + a15*a23*a36*a41*a62
            - a13*a25*a36*a41*a62
            - a16*a25*a31*a43*a62
            + a15*a26*a31*a43*a62
            + a16*a21*a35*a43*a62
            - a11*a26*a35*a43*a62
            - a15*a21*a36*a43*a62 
            + a11*a25*a36*a43*a62
            + a16*a23*a31*a45*a62
            - a13*a26*a31*a45*a62
            - a16*a21*a33*a45*a62
            + a11*a26*a33*a45*a62
            + a13*a21*a36*a45*a62
            - a11*a23*a36*a45*a62
            - a15*a23*a31*a46*a62
            + a13*a25*a31*a46*a62
            + a15*a21*a33*a46*a62
            - a11*a25*a33*a46*a62 
            - a13*a21*a35*a46*a62
            + a11*a23*a35*a46*a62
            - a16*a25*a32*a41*a63
            + a15*a26*a32*a41*a63
            + a16*a22*a35*a41*a63
            - a12*a26*a35*a41*a63
            - a15*a22*a36*a41*a63
            + a12*a25*a36*a41*a63
            + a16*a25*a31*a42*a63
            - a15*a26*a31*a42*a63
            - a16*a21*a35*a42*a63 
            + a11*a26*a35*a42*a63
            + a15*a21*a36*a42*a63
            - a11*a25*a36*a42*a63
            - a16*a22*a31*a45*a63
            + a12*a26*a31*a45*a63
            + a16*a21*a32*a45*a63
            - a11*a26*a32*a45*a63
            - a12*a21*a36*a45*a63
            + a11*a22*a36*a45*a63
            + a15*a22*a31*a46*a63
            - a12*a25*a31*a46*a63 
            - a15*a21*a32*a46*a63
            + a11*a25*a32*a46*a63
            + a12*a21*a35*a46*a63
            - a11*a22*a35*a46*a63
            + a16*a23*a32*a41*a65
            - a13*a26*a32*a41*a65
            - a16*a22*a33*a41*a65
            + a12*a26*a33*a41*a65
            + a13*a22*a36*a41*a65
            - a12*a23*a36*a41*a65
            - a16*a23*a31*a42*a65 
            + a13*a26*a31*a42*a65
            + a16*a21*a33*a42*a65
            - a11*a26*a33*a42*a65
            - a13*a21*a36*a42*a65
            + a11*a23*a36*a42*a65
            + a16*a22*a31*a43*a65
            - a12*a26*a31*a43*a65
            - a16*a21*a32*a43*a65
            + a11*a26*a32*a43*a65
            + a12*a21*a36*a43*a65
            - a11*a22*a36*a43*a65 
            - a13*a22*a31*a46*a65
            + a12*a23*a31*a46*a65
            + a13*a21*a32*a46*a65
            - a11*a23*a32*a46*a65
            - a12*a21*a33*a46*a65
            + a11*a22*a33*a46*a65
            - a15*a23*a32*a41*a66
            + a13*a25*a32*a41*a66
            + a15*a22*a33*a41*a66
            - a12*a25*a33*a41*a66
            - a13*a22*a35*a41*a66 
            + a12*a23*a35*a41*a66
            + a15*a23*a31*a42*a66
            - a13*a25*a31*a42*a66
            - a15*a21*a33*a42*a66
            + a11*a25*a33*a42*a66
            + a13*a21*a35*a42*a66
            - a11*a23*a35*a42*a66
            - a15*a22*a31*a43*a66
            + a12*a25*a31*a43*a66
            + a15*a21*a32*a43*a66
            - a11*a25*a32*a43*a66 
            - a12*a21*a35*a43*a66
            + a11*a22*a35*a43*a66
            + a13*a22*a31*a45*a66
            - a12*a23*a31*a45*a66
            - a13*a21*a32*a45*a66
            + a11*a23*a32*a45*a66
            + a12*a21*a33*a45*a66
            - a11*a22*a33*a45*a66;
    cofactor[23] = a16*a25*a33*a42*a51
            - a15*a26*a33*a42*a51 
            - a16*a23*a35*a42*a51
            + a13*a26*a35*a42*a51
            + a15*a23*a36*a42*a51
            - a13*a25*a36*a42*a51
            - a16*a25*a32*a43*a51
            + a15*a26*a32*a43*a51
            + a16*a22*a35*a43*a51
            - a12*a26*a35*a43*a51
            - a15*a22*a36*a43*a51
            + a12*a25*a36*a43*a51
            + a16*a23*a32*a45*a51 
            - a13*a26*a32*a45*a51
            - a16*a22*a33*a45*a51
            + a12*a26*a33*a45*a51
            + a13*a22*a36*a45*a51
            - a12*a23*a36*a45*a51
            - a15*a23*a32*a46*a51
            + a13*a25*a32*a46*a51
            + a15*a22*a33*a46*a51
            - a12*a25*a33*a46*a51
            - a13*a22*a35*a46*a51
            + a12*a23*a35*a46*a51 
            - a16*a25*a33*a41*a52
            + a15*a26*a33*a41*a52
            + a16*a23*a35*a41*a52
            - a13*a26*a35*a41*a52
            - a15*a23*a36*a41*a52
            + a13*a25*a36*a41*a52
            + a16*a25*a31*a43*a52
            - a15*a26*a31*a43*a52
            - a16*a21*a35*a43*a52
            + a11*a26*a35*a43*a52
            + a15*a21*a36*a43*a52 
            - a11*a25*a36*a43*a52
            - a16*a23*a31*a45*a52
            + a13*a26*a31*a45*a52
            + a16*a21*a33*a45*a52
            - a11*a26*a33*a45*a52
            - a13*a21*a36*a45*a52
            + a11*a23*a36*a45*a52
            + a15*a23*a31*a46*a52
            - a13*a25*a31*a46*a52
            - a15*a21*a33*a46*a52
            + a11*a25*a33*a46*a52 
            + a13*a21*a35*a46*a52
            - a11*a23*a35*a46*a52
            + a16*a25*a32*a41*a53
            - a15*a26*a32*a41*a53
            - a16*a22*a35*a41*a53
            + a12*a26*a35*a41*a53
            + a15*a22*a36*a41*a53
            - a12*a25*a36*a41*a53
            - a16*a25*a31*a42*a53
            + a15*a26*a31*a42*a53
            + a16*a21*a35*a42*a53 
            - a11*a26*a35*a42*a53
            - a15*a21*a36*a42*a53
            + a11*a25*a36*a42*a53
            + a16*a22*a31*a45*a53
            - a12*a26*a31*a45*a53
            - a16*a21*a32*a45*a53
            + a11*a26*a32*a45*a53
            + a12*a21*a36*a45*a53
            - a11*a22*a36*a45*a53
            - a15*a22*a31*a46*a53
            + a12*a25*a31*a46*a53 
            + a15*a21*a32*a46*a53
            - a11*a25*a32*a46*a53
            - a12*a21*a35*a46*a53
            + a11*a22*a35*a46*a53
            - a16*a23*a32*a41*a55
            + a13*a26*a32*a41*a55
            + a16*a22*a33*a41*a55
            - a12*a26*a33*a41*a55
            - a13*a22*a36*a41*a55
            + a12*a23*a36*a41*a55
            + a16*a23*a31*a42*a55 
            - a13*a26*a31*a42*a55
            - a16*a21*a33*a42*a55
            + a11*a26*a33*a42*a55
            + a13*a21*a36*a42*a55
            - a11*a23*a36*a42*a55
            - a16*a22*a31*a43*a55
            + a12*a26*a31*a43*a55
            + a16*a21*a32*a43*a55
            - a11*a26*a32*a43*a55
            - a12*a21*a36*a43*a55
            + a11*a22*a36*a43*a55 
            + a13*a22*a31*a46*a55
            - a12*a23*a31*a46*a55
            - a13*a21*a32*a46*a55
            + a11*a23*a32*a46*a55
            + a12*a21*a33*a46*a55
            - a11*a22*a33*a46*a55
            + a15*a23*a32*a41*a56
            - a13*a25*a32*a41*a56
            - a15*a22*a33*a41*a56
            + a12*a25*a33*a41*a56
            + a13*a22*a35*a41*a56 
            - a12*a23*a35*a41*a56
            - a15*a23*a31*a42*a56
            + a13*a25*a31*a42*a56
            + a15*a21*a33*a42*a56
            - a11*a25*a33*a42*a56
            - a13*a21*a35*a42*a56
            + a11*a23*a35*a42*a56
            + a15*a22*a31*a43*a56
            - a12*a25*a31*a43*a56
            - a15*a21*a32*a43*a56
            + a11*a25*a32*a43*a56 
            + a12*a21*a35*a43*a56
            - a11*a22*a35*a43*a56
            - a13*a22*a31*a45*a56
            + a12*a23*a31*a45*a56
            + a13*a21*a32*a45*a56
            - a11*a23*a32*a45*a56
            - a12*a21*a33*a45*a56
            + a11*a22*a33*a45*a56;
    cofactor[24] = a26*a34*a43*a52*a61
            - a24*a36*a43*a52*a61 
            - a26*a33*a44*a52*a61
            + a23*a36*a44*a52*a61
            + a24*a33*a46*a52*a61
            - a23*a34*a46*a52*a61
            - a26*a34*a42*a53*a61
            + a24*a36*a42*a53*a61
            + a26*a32*a44*a53*a61
            - a22*a36*a44*a53*a61
            - a24*a32*a46*a53*a61
            + a22*a34*a46*a53*a61
            + a26*a33*a42*a54*a61 
            - a23*a36*a42*a54*a61
            - a26*a32*a43*a54*a61
            + a22*a36*a43*a54*a61
            + a23*a32*a46*a54*a61
            - a22*a33*a46*a54*a61
            - a24*a33*a42*a56*a61
            + a23*a34*a42*a56*a61
            + a24*a32*a43*a56*a61
            - a22*a34*a43*a56*a61
            - a23*a32*a44*a56*a61
            + a22*a33*a44*a56*a61 
            - a26*a34*a43*a51*a62
            + a24*a36*a43*a51*a62
            + a26*a33*a44*a51*a62
            - a23*a36*a44*a51*a62
            - a24*a33*a46*a51*a62
            + a23*a34*a46*a51*a62
            + a26*a34*a41*a53*a62
            - a24*a36*a41*a53*a62
            - a26*a31*a44*a53*a62
            + a21*a36*a44*a53*a62
            + a24*a31*a46*a53*a62 
            - a21*a34*a46*a53*a62
            - a26*a33*a41*a54*a62
            + a23*a36*a41*a54*a62
            + a26*a31*a43*a54*a62
            - a21*a36*a43*a54*a62
            - a23*a31*a46*a54*a62
            + a21*a33*a46*a54*a62
            + a24*a33*a41*a56*a62
            - a23*a34*a41*a56*a62
            - a24*a31*a43*a56*a62
            + a21*a34*a43*a56*a62 
            + a23*a31*a44*a56*a62
            - a21*a33*a44*a56*a62
            + a26*a34*a42*a51*a63
            - a24*a36*a42*a51*a63
            - a26*a32*a44*a51*a63
            + a22*a36*a44*a51*a63
            + a24*a32*a46*a51*a63
            - a22*a34*a46*a51*a63
            - a26*a34*a41*a52*a63
            + a24*a36*a41*a52*a63
            + a26*a31*a44*a52*a63 
            - a21*a36*a44*a52*a63
            - a24*a31*a46*a52*a63
            + a21*a34*a46*a52*a63
            + a26*a32*a41*a54*a63
            - a22*a36*a41*a54*a63
            - a26*a31*a42*a54*a63
            + a21*a36*a42*a54*a63
            + a22*a31*a46*a54*a63
            - a21*a32*a46*a54*a63
            - a24*a32*a41*a56*a63
            + a22*a34*a41*a56*a63 
            + a24*a31*a42*a56*a63
            - a21*a34*a42*a56*a63
            - a22*a31*a44*a56*a63
            + a21*a32*a44*a56*a63
            - a26*a33*a42*a51*a64
            + a23*a36*a42*a51*a64
            + a26*a32*a43*a51*a64
            - a22*a36*a43*a51*a64
            - a23*a32*a46*a51*a64
            + a22*a33*a46*a51*a64
            + a26*a33*a41*a52*a64 
            - a23*a36*a41*a52*a64
            - a26*a31*a43*a52*a64
            + a21*a36*a43*a52*a64
            + a23*a31*a46*a52*a64
            - a21*a33*a46*a52*a64
            - a26*a32*a41*a53*a64
            + a22*a36*a41*a53*a64
            + a26*a31*a42*a53*a64
            - a21*a36*a42*a53*a64
            - a22*a31*a46*a53*a64
            + a21*a32*a46*a53*a64 
            + a23*a32*a41*a56*a64
            - a22*a33*a41*a56*a64
            - a23*a31*a42*a56*a64
            + a21*a33*a42*a56*a64
            + a22*a31*a43*a56*a64
            - a21*a32*a43*a56*a64
            + a24*a33*a42*a51*a66
            - a23*a34*a42*a51*a66
            - a24*a32*a43*a51*a66
            + a22*a34*a43*a51*a66
            + a23*a32*a44*a51*a66 
            - a22*a33*a44*a51*a66
            - a24*a33*a41*a52*a66
            + a23*a34*a41*a52*a66
            + a24*a31*a43*a52*a66
            - a21*a34*a43*a52*a66
            - a23*a31*a44*a52*a66
            + a21*a33*a44*a52*a66
            + a24*a32*a41*a53*a66
            - a22*a34*a41*a53*a66
            - a24*a31*a42*a53*a66
            + a21*a34*a42*a53*a66 
            + a22*a31*a44*a53*a66
            - a21*a32*a44*a53*a66
            - a23*a32*a41*a54*a66
            + a22*a33*a41*a54*a66
            + a23*a31*a42*a54*a66
            - a21*a33*a42*a54*a66
            - a22*a31*a43*a54*a66
            + a21*a32*a43*a54*a66;
    cofactor[25] = -a16*a34*a43*a52*a61
            + a14*a36*a43*a52*a61 
            + a16*a33*a44*a52*a61
            - a13*a36*a44*a52*a61
            - a14*a33*a46*a52*a61
            + a13*a34*a46*a52*a61
            + a16*a34*a42*a53*a61
            - a14*a36*a42*a53*a61
            - a16*a32*a44*a53*a61
            + a12*a36*a44*a53*a61
            + a14*a32*a46*a53*a61
            - a12*a34*a46*a53*a61
            - a16*a33*a42*a54*a61 
            + a13*a36*a42*a54*a61
            + a16*a32*a43*a54*a61
            - a12*a36*a43*a54*a61
            - a13*a32*a46*a54*a61
            + a12*a33*a46*a54*a61
            + a14*a33*a42*a56*a61
            - a13*a34*a42*a56*a61
            - a14*a32*a43*a56*a61
            + a12*a34*a43*a56*a61
            + a13*a32*a44*a56*a61
            - a12*a33*a44*a56*a61 
            + a16*a34*a43*a51*a62
            - a14*a36*a43*a51*a62
            - a16*a33*a44*a51*a62
            + a13*a36*a44*a51*a62
            + a14*a33*a46*a51*a62
            - a13*a34*a46*a51*a62
            - a16*a34*a41*a53*a62
            + a14*a36*a41*a53*a62
            + a16*a31*a44*a53*a62
            - a11*a36*a44*a53*a62
            - a14*a31*a46*a53*a62 
            + a11*a34*a46*a53*a62
            + a16*a33*a41*a54*a62
            - a13*a36*a41*a54*a62
            - a16*a31*a43*a54*a62
            + a11*a36*a43*a54*a62
            + a13*a31*a46*a54*a62
            - a11*a33*a46*a54*a62
            - a14*a33*a41*a56*a62
            + a13*a34*a41*a56*a62
            + a14*a31*a43*a56*a62
            - a11*a34*a43*a56*a62 
            - a13*a31*a44*a56*a62
            + a11*a33*a44*a56*a62
            - a16*a34*a42*a51*a63
            + a14*a36*a42*a51*a63
            + a16*a32*a44*a51*a63
            - a12*a36*a44*a51*a63
            - a14*a32*a46*a51*a63
            + a12*a34*a46*a51*a63
            + a16*a34*a41*a52*a63
            - a14*a36*a41*a52*a63
            - a16*a31*a44*a52*a63 
            + a11*a36*a44*a52*a63
            + a14*a31*a46*a52*a63
            - a11*a34*a46*a52*a63
            - a16*a32*a41*a54*a63
            + a12*a36*a41*a54*a63
            + a16*a31*a42*a54*a63
            - a11*a36*a42*a54*a63
            - a12*a31*a46*a54*a63
            + a11*a32*a46*a54*a63
            + a14*a32*a41*a56*a63
            - a12*a34*a41*a56*a63 
            - a14*a31*a42*a56*a63
            + a11*a34*a42*a56*a63
            + a12*a31*a44*a56*a63
            - a11*a32*a44*a56*a63
            + a16*a33*a42*a51*a64
            - a13*a36*a42*a51*a64
            - a16*a32*a43*a51*a64
            + a12*a36*a43*a51*a64
            + a13*a32*a46*a51*a64
            - a12*a33*a46*a51*a64
            - a16*a33*a41*a52*a64 
            + a13*a36*a41*a52*a64
            + a16*a31*a43*a52*a64
            - a11*a36*a43*a52*a64
            - a13*a31*a46*a52*a64
            + a11*a33*a46*a52*a64
            + a16*a32*a41*a53*a64
            - a12*a36*a41*a53*a64
            - a16*a31*a42*a53*a64
            + a11*a36*a42*a53*a64
            + a12*a31*a46*a53*a64
            - a11*a32*a46*a53*a64 
            - a13*a32*a41*a56*a64
            + a12*a33*a41*a56*a64
            + a13*a31*a42*a56*a64
            - a11*a33*a42*a56*a64
            - a12*a31*a43*a56*a64
            + a11*a32*a43*a56*a64
            - a14*a33*a42*a51*a66
            + a13*a34*a42*a51*a66
            + a14*a32*a43*a51*a66
            - a12*a34*a43*a51*a66
            - a13*a32*a44*a51*a66 
            + a12*a33*a44*a51*a66
            + a14*a33*a41*a52*a66
            - a13*a34*a41*a52*a66
            - a14*a31*a43*a52*a66
            + a11*a34*a43*a52*a66
            + a13*a31*a44*a52*a66
            - a11*a33*a44*a52*a66
            - a14*a32*a41*a53*a66
            + a12*a34*a41*a53*a66
            + a14*a31*a42*a53*a66
            - a11*a34*a42*a53*a66 
            - a12*a31*a44*a53*a66
            + a11*a32*a44*a53*a66
            + a13*a32*a41*a54*a66
            - a12*a33*a41*a54*a66
            - a13*a31*a42*a54*a66
            + a11*a33*a42*a54*a66
            + a12*a31*a43*a54*a66
            - a11*a32*a43*a54*a66;
    cofactor[26] = a16*a24*a43*a52*a61
            - a14*a26*a43*a52*a61 
            - a16*a23*a44*a52*a61
            + a13*a26*a44*a52*a61
            + a14*a23*a46*a52*a61
            - a13*a24*a46*a52*a61
            - a16*a24*a42*a53*a61
            + a14*a26*a42*a53*a61
            + a16*a22*a44*a53*a61
            - a12*a26*a44*a53*a61
            - a14*a22*a46*a53*a61
            + a12*a24*a46*a53*a61
            + a16*a23*a42*a54*a61 
            - a13*a26*a42*a54*a61
            - a16*a22*a43*a54*a61
            + a12*a26*a43*a54*a61
            + a13*a22*a46*a54*a61
            - a12*a23*a46*a54*a61
            - a14*a23*a42*a56*a61
            + a13*a24*a42*a56*a61
            + a14*a22*a43*a56*a61
            - a12*a24*a43*a56*a61
            - a13*a22*a44*a56*a61
            + a12*a23*a44*a56*a61 
            - a16*a24*a43*a51*a62
            + a14*a26*a43*a51*a62
            + a16*a23*a44*a51*a62
            - a13*a26*a44*a51*a62
            - a14*a23*a46*a51*a62
            + a13*a24*a46*a51*a62
            + a16*a24*a41*a53*a62
            - a14*a26*a41*a53*a62
            - a16*a21*a44*a53*a62
            + a11*a26*a44*a53*a62
            + a14*a21*a46*a53*a62 
            - a11*a24*a46*a53*a62
            - a16*a23*a41*a54*a62
            + a13*a26*a41*a54*a62
            + a16*a21*a43*a54*a62
            - a11*a26*a43*a54*a62
            - a13*a21*a46*a54*a62
            + a11*a23*a46*a54*a62
            + a14*a23*a41*a56*a62
            - a13*a24*a41*a56*a62
            - a14*a21*a43*a56*a62
            + a11*a24*a43*a56*a62 
            + a13*a21*a44*a56*a62
            - a11*a23*a44*a56*a62
            + a16*a24*a42*a51*a63
            - a14*a26*a42*a51*a63
            - a16*a22*a44*a51*a63
            + a12*a26*a44*a51*a63
            + a14*a22*a46*a51*a63
            - a12*a24*a46*a51*a63
            - a16*a24*a41*a52*a63
            + a14*a26*a41*a52*a63
            + a16*a21*a44*a52*a63 
            - a11*a26*a44*a52*a63
            - a14*a21*a46*a52*a63
            + a11*a24*a46*a52*a63
            + a16*a22*a41*a54*a63
            - a12*a26*a41*a54*a63
            - a16*a21*a42*a54*a63
            + a11*a26*a42*a54*a63
            + a12*a21*a46*a54*a63
            - a11*a22*a46*a54*a63
            - a14*a22*a41*a56*a63
            + a12*a24*a41*a56*a63 
            + a14*a21*a42*a56*a63
            - a11*a24*a42*a56*a63
            - a12*a21*a44*a56*a63
            + a11*a22*a44*a56*a63
            - a16*a23*a42*a51*a64
            + a13*a26*a42*a51*a64
            + a16*a22*a43*a51*a64
            - a12*a26*a43*a51*a64
            - a13*a22*a46*a51*a64
            + a12*a23*a46*a51*a64
            + a16*a23*a41*a52*a64 
            - a13*a26*a41*a52*a64
            - a16*a21*a43*a52*a64
            + a11*a26*a43*a52*a64
            + a13*a21*a46*a52*a64
            - a11*a23*a46*a52*a64
            - a16*a22*a41*a53*a64
            + a12*a26*a41*a53*a64
            + a16*a21*a42*a53*a64
            - a11*a26*a42*a53*a64
            - a12*a21*a46*a53*a64
            + a11*a22*a46*a53*a64 
            + a13*a22*a41*a56*a64
            - a12*a23*a41*a56*a64
            - a13*a21*a42*a56*a64
            + a11*a23*a42*a56*a64
            + a12*a21*a43*a56*a64
            - a11*a22*a43*a56*a64
            + a14*a23*a42*a51*a66
            - a13*a24*a42*a51*a66
            - a14*a22*a43*a51*a66
            + a12*a24*a43*a51*a66
            + a13*a22*a44*a51*a66 
            - a12*a23*a44*a51*a66
            - a14*a23*a41*a52*a66
            + a13*a24*a41*a52*a66
            + a14*a21*a43*a52*a66
            - a11*a24*a43*a52*a66
            - a13*a21*a44*a52*a66
            + a11*a23*a44*a52*a66
            + a14*a22*a41*a53*a66
            - a12*a24*a41*a53*a66
            - a14*a21*a42*a53*a66
            + a11*a24*a42*a53*a66 
            + a12*a21*a44*a53*a66
            - a11*a22*a44*a53*a66
            - a13*a22*a41*a54*a66
            + a12*a23*a41*a54*a66
            + a13*a21*a42*a54*a66
            - a11*a23*a42*a54*a66
            - a12*a21*a43*a54*a66
            + a11*a22*a43*a54*a66;
    cofactor[27] = -a16*a24*a33*a52*a61
            + a14*a26*a33*a52*a61 
            + a16*a23*a34*a52*a61
            - a13*a26*a34*a52*a61
            - a14*a23*a36*a52*a61
            + a13*a24*a36*a52*a61
            + a16*a24*a32*a53*a61
            - a14*a26*a32*a53*a61
            - a16*a22*a34*a53*a61
            + a12*a26*a34*a53*a61
            + a14*a22*a36*a53*a61
            - a12*a24*a36*a53*a61
            - a16*a23*a32*a54*a61 
            + a13*a26*a32*a54*a61
            + a16*a22*a33*a54*a61
            - a12*a26*a33*a54*a61
            - a13*a22*a36*a54*a61
            + a12*a23*a36*a54*a61
            + a14*a23*a32*a56*a61
            - a13*a24*a32*a56*a61
            - a14*a22*a33*a56*a61
            + a12*a24*a33*a56*a61
            + a13*a22*a34*a56*a61
            - a12*a23*a34*a56*a61 
            + a16*a24*a33*a51*a62
            - a14*a26*a33*a51*a62
            - a16*a23*a34*a51*a62
            + a13*a26*a34*a51*a62
            + a14*a23*a36*a51*a62
            - a13*a24*a36*a51*a62
            - a16*a24*a31*a53*a62
            + a14*a26*a31*a53*a62
            + a16*a21*a34*a53*a62
            - a11*a26*a34*a53*a62
            - a14*a21*a36*a53*a62 
            + a11*a24*a36*a53*a62
            + a16*a23*a31*a54*a62
            - a13*a26*a31*a54*a62
            - a16*a21*a33*a54*a62
            + a11*a26*a33*a54*a62
            + a13*a21*a36*a54*a62
            - a11*a23*a36*a54*a62
            - a14*a23*a31*a56*a62
            + a13*a24*a31*a56*a62
            + a14*a21*a33*a56*a62
            - a11*a24*a33*a56*a62 
            - a13*a21*a34*a56*a62
            + a11*a23*a34*a56*a62
            - a16*a24*a32*a51*a63
            + a14*a26*a32*a51*a63
            + a16*a22*a34*a51*a63
            - a12*a26*a34*a51*a63
            - a14*a22*a36*a51*a63
            + a12*a24*a36*a51*a63
            + a16*a24*a31*a52*a63
            - a14*a26*a31*a52*a63
            - a16*a21*a34*a52*a63 
            + a11*a26*a34*a52*a63
            + a14*a21*a36*a52*a63
            - a11*a24*a36*a52*a63
            - a16*a22*a31*a54*a63
            + a12*a26*a31*a54*a63
            + a16*a21*a32*a54*a63
            - a11*a26*a32*a54*a63
            - a12*a21*a36*a54*a63
            + a11*a22*a36*a54*a63
            + a14*a22*a31*a56*a63
            - a12*a24*a31*a56*a63 
            - a14*a21*a32*a56*a63
            + a11*a24*a32*a56*a63
            + a12*a21*a34*a56*a63
            - a11*a22*a34*a56*a63
            + a16*a23*a32*a51*a64
            - a13*a26*a32*a51*a64
            - a16*a22*a33*a51*a64
            + a12*a26*a33*a51*a64
            + a13*a22*a36*a51*a64
            - a12*a23*a36*a51*a64
            - a16*a23*a31*a52*a64 
            + a13*a26*a31*a52*a64
            + a16*a21*a33*a52*a64
            - a11*a26*a33*a52*a64
            - a13*a21*a36*a52*a64
            + a11*a23*a36*a52*a64
            + a16*a22*a31*a53*a64
            - a12*a26*a31*a53*a64
            - a16*a21*a32*a53*a64
            + a11*a26*a32*a53*a64
            + a12*a21*a36*a53*a64
            - a11*a22*a36*a53*a64 
            - a13*a22*a31*a56*a64
            + a12*a23*a31*a56*a64
            + a13*a21*a32*a56*a64
            - a11*a23*a32*a56*a64
            - a12*a21*a33*a56*a64
            + a11*a22*a33*a56*a64
            - a14*a23*a32*a51*a66
            + a13*a24*a32*a51*a66
            + a14*a22*a33*a51*a66
            - a12*a24*a33*a51*a66
            - a13*a22*a34*a51*a66 
            + a12*a23*a34*a51*a66
            + a14*a23*a31*a52*a66
            - a13*a24*a31*a52*a66
            - a14*a21*a33*a52*a66
            + a11*a24*a33*a52*a66
            + a13*a21*a34*a52*a66
            - a11*a23*a34*a52*a66
            - a14*a22*a31*a53*a66
            + a12*a24*a31*a53*a66
            + a14*a21*a32*a53*a66
            - a11*a24*a32*a53*a66 
            - a12*a21*a34*a53*a66
            + a11*a22*a34*a53*a66
            + a13*a22*a31*a54*a66
            - a12*a23*a31*a54*a66
            - a13*a21*a32*a54*a66
            + a11*a23*a32*a54*a66
            + a12*a21*a33*a54*a66
            - a11*a22*a33*a54*a66;
    cofactor[28] = a16*a24*a33*a42*a61
            - a14*a26*a33*a42*a61 
            - a16*a23*a34*a42*a61
            + a13*a26*a34*a42*a61
            + a14*a23*a36*a42*a61
            - a13*a24*a36*a42*a61
            - a16*a24*a32*a43*a61
            + a14*a26*a32*a43*a61
            + a16*a22*a34*a43*a61
            - a12*a26*a34*a43*a61
            - a14*a22*a36*a43*a61
            + a12*a24*a36*a43*a61
            + a16*a23*a32*a44*a61 
            - a13*a26*a32*a44*a61
            - a16*a22*a33*a44*a61
            + a12*a26*a33*a44*a61
            + a13*a22*a36*a44*a61
            - a12*a23*a36*a44*a61
            - a14*a23*a32*a46*a61
            + a13*a24*a32*a46*a61
            + a14*a22*a33*a46*a61
            - a12*a24*a33*a46*a61
            - a13*a22*a34*a46*a61
            + a12*a23*a34*a46*a61 
            - a16*a24*a33*a41*a62
            + a14*a26*a33*a41*a62
            + a16*a23*a34*a41*a62
            - a13*a26*a34*a41*a62
            - a14*a23*a36*a41*a62
            + a13*a24*a36*a41*a62
            + a16*a24*a31*a43*a62
            - a14*a26*a31*a43*a62
            - a16*a21*a34*a43*a62
            + a11*a26*a34*a43*a62
            + a14*a21*a36*a43*a62 
            - a11*a24*a36*a43*a62
            - a16*a23*a31*a44*a62
            + a13*a26*a31*a44*a62
            + a16*a21*a33*a44*a62
            - a11*a26*a33*a44*a62
            - a13*a21*a36*a44*a62
            + a11*a23*a36*a44*a62
            + a14*a23*a31*a46*a62
            - a13*a24*a31*a46*a62
            - a14*a21*a33*a46*a62
            + a11*a24*a33*a46*a62 
            + a13*a21*a34*a46*a62
            - a11*a23*a34*a46*a62
            + a16*a24*a32*a41*a63
            - a14*a26*a32*a41*a63
            - a16*a22*a34*a41*a63
            + a12*a26*a34*a41*a63
            + a14*a22*a36*a41*a63
            - a12*a24*a36*a41*a63
            - a16*a24*a31*a42*a63
            + a14*a26*a31*a42*a63
            + a16*a21*a34*a42*a63 
            - a11*a26*a34*a42*a63
            - a14*a21*a36*a42*a63
            + a11*a24*a36*a42*a63
            + a16*a22*a31*a44*a63
            - a12*a26*a31*a44*a63
            - a16*a21*a32*a44*a63
            + a11*a26*a32*a44*a63
            + a12*a21*a36*a44*a63
            - a11*a22*a36*a44*a63
            - a14*a22*a31*a46*a63
            + a12*a24*a31*a46*a63 
            + a14*a21*a32*a46*a63
            - a11*a24*a32*a46*a63
            - a12*a21*a34*a46*a63
            + a11*a22*a34*a46*a63
            - a16*a23*a32*a41*a64
            + a13*a26*a32*a41*a64
            + a16*a22*a33*a41*a64
            - a12*a26*a33*a41*a64
            - a13*a22*a36*a41*a64
            + a12*a23*a36*a41*a64
            + a16*a23*a31*a42*a64 
            - a13*a26*a31*a42*a64
            - a16*a21*a33*a42*a64
            + a11*a26*a33*a42*a64
            + a13*a21*a36*a42*a64
            - a11*a23*a36*a42*a64
            - a16*a22*a31*a43*a64
            + a12*a26*a31*a43*a64
            + a16*a21*a32*a43*a64
            - a11*a26*a32*a43*a64
            - a12*a21*a36*a43*a64
            + a11*a22*a36*a43*a64 
            + a13*a22*a31*a46*a64
            - a12*a23*a31*a46*a64
            - a13*a21*a32*a46*a64
            + a11*a23*a32*a46*a64
            + a12*a21*a33*a46*a64
            - a11*a22*a33*a46*a64
            + a14*a23*a32*a41*a66
            - a13*a24*a32*a41*a66
            - a14*a22*a33*a41*a66
            + a12*a24*a33*a41*a66
            + a13*a22*a34*a41*a66 
            - a12*a23*a34*a41*a66
            - a14*a23*a31*a42*a66
            + a13*a24*a31*a42*a66
            + a14*a21*a33*a42*a66
            - a11*a24*a33*a42*a66
            - a13*a21*a34*a42*a66
            + a11*a23*a34*a42*a66
            + a14*a22*a31*a43*a66
            - a12*a24*a31*a43*a66
            - a14*a21*a32*a43*a66
            + a11*a24*a32*a43*a66 
            + a12*a21*a34*a43*a66
            - a11*a22*a34*a43*a66
            - a13*a22*a31*a44*a66
            + a12*a23*a31*a44*a66
            + a13*a21*a32*a44*a66
            - a11*a23*a32*a44*a66
            - a12*a21*a33*a44*a66
            + a11*a22*a33*a44*a66;
    cofactor[29] = -a16*a24*a33*a42*a51
            + a14*a26*a33*a42*a51 
            + a16*a23*a34*a42*a51
            - a13*a26*a34*a42*a51
            - a14*a23*a36*a42*a51
            + a13*a24*a36*a42*a51
            + a16*a24*a32*a43*a51
            - a14*a26*a32*a43*a51
            - a16*a22*a34*a43*a51
            + a12*a26*a34*a43*a51
            + a14*a22*a36*a43*a51
            - a12*a24*a36*a43*a51
            - a16*a23*a32*a44*a51 
            + a13*a26*a32*a44*a51
            + a16*a22*a33*a44*a51
            - a12*a26*a33*a44*a51
            - a13*a22*a36*a44*a51
            + a12*a23*a36*a44*a51
            + a14*a23*a32*a46*a51
            - a13*a24*a32*a46*a51
            - a14*a22*a33*a46*a51
            + a12*a24*a33*a46*a51
            + a13*a22*a34*a46*a51
            - a12*a23*a34*a46*a51 
            + a16*a24*a33*a41*a52
            - a14*a26*a33*a41*a52
            - a16*a23*a34*a41*a52
            + a13*a26*a34*a41*a52
            + a14*a23*a36*a41*a52
            - a13*a24*a36*a41*a52
            - a16*a24*a31*a43*a52
            + a14*a26*a31*a43*a52
            + a16*a21*a34*a43*a52
            - a11*a26*a34*a43*a52
            - a14*a21*a36*a43*a52 
            + a11*a24*a36*a43*a52
            + a16*a23*a31*a44*a52
            - a13*a26*a31*a44*a52
            - a16*a21*a33*a44*a52
            + a11*a26*a33*a44*a52
            + a13*a21*a36*a44*a52
            - a11*a23*a36*a44*a52
            - a14*a23*a31*a46*a52
            + a13*a24*a31*a46*a52
            + a14*a21*a33*a46*a52
            - a11*a24*a33*a46*a52 
            - a13*a21*a34*a46*a52
            + a11*a23*a34*a46*a52
            - a16*a24*a32*a41*a53
            + a14*a26*a32*a41*a53
            + a16*a22*a34*a41*a53
            - a12*a26*a34*a41*a53
            - a14*a22*a36*a41*a53
            + a12*a24*a36*a41*a53
            + a16*a24*a31*a42*a53
            - a14*a26*a31*a42*a53
            - a16*a21*a34*a42*a53 
            + a11*a26*a34*a42*a53
            + a14*a21*a36*a42*a53
            - a11*a24*a36*a42*a53
            - a16*a22*a31*a44*a53
            + a12*a26*a31*a44*a53
            + a16*a21*a32*a44*a53
            - a11*a26*a32*a44*a53
            - a12*a21*a36*a44*a53
            + a11*a22*a36*a44*a53
            + a14*a22*a31*a46*a53
            - a12*a24*a31*a46*a53 
            - a14*a21*a32*a46*a53
            + a11*a24*a32*a46*a53
            + a12*a21*a34*a46*a53
            - a11*a22*a34*a46*a53
            + a16*a23*a32*a41*a54
            - a13*a26*a32*a41*a54
            - a16*a22*a33*a41*a54
            + a12*a26*a33*a41*a54
            + a13*a22*a36*a41*a54
            - a12*a23*a36*a41*a54
            - a16*a23*a31*a42*a54 
            + a13*a26*a31*a42*a54
            + a16*a21*a33*a42*a54
            - a11*a26*a33*a42*a54
            - a13*a21*a36*a42*a54
            + a11*a23*a36*a42*a54
            + a16*a22*a31*a43*a54
            - a12*a26*a31*a43*a54
            - a16*a21*a32*a43*a54
            + a11*a26*a32*a43*a54
            + a12*a21*a36*a43*a54
            - a11*a22*a36*a43*a54 
            - a13*a22*a31*a46*a54
            + a12*a23*a31*a46*a54
            + a13*a21*a32*a46*a54
            - a11*a23*a32*a46*a54
            - a12*a21*a33*a46*a54
            + a11*a22*a33*a46*a54
            - a14*a23*a32*a41*a56
            + a13*a24*a32*a41*a56
            + a14*a22*a33*a41*a56
            - a12*a24*a33*a41*a56
            - a13*a22*a34*a41*a56 
            + a12*a23*a34*a41*a56
            + a14*a23*a31*a42*a56
            - a13*a24*a31*a42*a56
            - a14*a21*a33*a42*a56
            + a11*a24*a33*a42*a56
            + a13*a21*a34*a42*a56
            - a11*a23*a34*a42*a56
            - a14*a22*a31*a43*a56
            + a12*a24*a31*a43*a56
            + a14*a21*a32*a43*a56
            - a11*a24*a32*a43*a56 
            - a12*a21*a34*a43*a56
            + a11*a22*a34*a43*a56
            + a13*a22*a31*a44*a56
            - a12*a23*a31*a44*a56
            - a13*a21*a32*a44*a56
            + a11*a23*a32*a44*a56
            + a12*a21*a33*a44*a56
            - a11*a22*a33*a44*a56;
    cofactor[30] = -a25*a34*a43*a52*a61
            + a24*a35*a43*a52*a61 
            + a25*a33*a44*a52*a61
            - a23*a35*a44*a52*a61
            - a24*a33*a45*a52*a61
            + a23*a34*a45*a52*a61
            + a25*a34*a42*a53*a61
            - a24*a35*a42*a53*a61
            - a25*a32*a44*a53*a61
            + a22*a35*a44*a53*a61
            + a24*a32*a45*a53*a61
            - a22*a34*a45*a53*a61
            - a25*a33*a42*a54*a61 
            + a23*a35*a42*a54*a61
            + a25*a32*a43*a54*a61
            - a22*a35*a43*a54*a61
            - a23*a32*a45*a54*a61
            + a22*a33*a45*a54*a61
            + a24*a33*a42*a55*a61
            - a23*a34*a42*a55*a61
            - a24*a32*a43*a55*a61
            + a22*a34*a43*a55*a61
            + a23*a32*a44*a55*a61
            - a22*a33*a44*a55*a61 
            + a25*a34*a43*a51*a62
            - a24*a35*a43*a51*a62
            - a25*a33*a44*a51*a62
            + a23*a35*a44*a51*a62
            + a24*a33*a45*a51*a62
            - a23*a34*a45*a51*a62
            - a25*a34*a41*a53*a62
            + a24*a35*a41*a53*a62
            + a25*a31*a44*a53*a62
            - a21*a35*a44*a53*a62
            - a24*a31*a45*a53*a62 
            + a21*a34*a45*a53*a62
            + a25*a33*a41*a54*a62
            - a23*a35*a41*a54*a62
            - a25*a31*a43*a54*a62
            + a21*a35*a43*a54*a62
            + a23*a31*a45*a54*a62
            - a21*a33*a45*a54*a62
            - a24*a33*a41*a55*a62
            + a23*a34*a41*a55*a62
            + a24*a31*a43*a55*a62
            - a21*a34*a43*a55*a62 
            - a23*a31*a44*a55*a62
            + a21*a33*a44*a55*a62
            - a25*a34*a42*a51*a63
            + a24*a35*a42*a51*a63
            + a25*a32*a44*a51*a63
            - a22*a35*a44*a51*a63
            - a24*a32*a45*a51*a63
            + a22*a34*a45*a51*a63
            + a25*a34*a41*a52*a63
            - a24*a35*a41*a52*a63
            - a25*a31*a44*a52*a63 
            + a21*a35*a44*a52*a63
            + a24*a31*a45*a52*a63
            - a21*a34*a45*a52*a63
            - a25*a32*a41*a54*a63
            + a22*a35*a41*a54*a63
            + a25*a31*a42*a54*a63
            - a21*a35*a42*a54*a63
            - a22*a31*a45*a54*a63
            + a21*a32*a45*a54*a63
            + a24*a32*a41*a55*a63
            - a22*a34*a41*a55*a63 
            - a24*a31*a42*a55*a63
            + a21*a34*a42*a55*a63
            + a22*a31*a44*a55*a63
            - a21*a32*a44*a55*a63
            + a25*a33*a42*a51*a64
            - a23*a35*a42*a51*a64
            - a25*a32*a43*a51*a64
            + a22*a35*a43*a51*a64
            + a23*a32*a45*a51*a64
            - a22*a33*a45*a51*a64
            - a25*a33*a41*a52*a64 
            + a23*a35*a41*a52*a64
            + a25*a31*a43*a52*a64
            - a21*a35*a43*a52*a64
            - a23*a31*a45*a52*a64
            + a21*a33*a45*a52*a64
            + a25*a32*a41*a53*a64
            - a22*a35*a41*a53*a64
            - a25*a31*a42*a53*a64
            + a21*a35*a42*a53*a64
            + a22*a31*a45*a53*a64
            - a21*a32*a45*a53*a64 
            - a23*a32*a41*a55*a64
            + a22*a33*a41*a55*a64
            + a23*a31*a42*a55*a64
            - a21*a33*a42*a55*a64
            - a22*a31*a43*a55*a64
            + a21*a32*a43*a55*a64
            - a24*a33*a42*a51*a65
            + a23*a34*a42*a51*a65
            + a24*a32*a43*a51*a65
            - a22*a34*a43*a51*a65
            - a23*a32*a44*a51*a65 
            + a22*a33*a44*a51*a65
            + a24*a33*a41*a52*a65
            - a23*a34*a41*a52*a65
            - a24*a31*a43*a52*a65
            + a21*a34*a43*a52*a65
            + a23*a31*a44*a52*a65
            - a21*a33*a44*a52*a65
            - a24*a32*a41*a53*a65
            + a22*a34*a41*a53*a65
            + a24*a31*a42*a53*a65
            - a21*a34*a42*a53*a65 
            - a22*a31*a44*a53*a65
            + a21*a32*a44*a53*a65
            + a23*a32*a41*a54*a65
            - a22*a33*a41*a54*a65
            - a23*a31*a42*a54*a65
            + a21*a33*a42*a54*a65
            + a22*a31*a43*a54*a65
            - a21*a32*a43*a54*a65;
    cofactor[31] = a15*a34*a43*a52*a61
            - a14*a35*a43*a52*a61 
            - a15*a33*a44*a52*a61
            + a13*a35*a44*a52*a61
            + a14*a33*a45*a52*a61
            - a13*a34*a45*a52*a61
            - a15*a34*a42*a53*a61
            + a14*a35*a42*a53*a61
            + a15*a32*a44*a53*a61
            - a12*a35*a44*a53*a61
            - a14*a32*a45*a53*a61
            + a12*a34*a45*a53*a61
            + a15*a33*a42*a54*a61 
            - a13*a35*a42*a54*a61
            - a15*a32*a43*a54*a61
            + a12*a35*a43*a54*a61
            + a13*a32*a45*a54*a61
            - a12*a33*a45*a54*a61
            - a14*a33*a42*a55*a61
            + a13*a34*a42*a55*a61
            + a14*a32*a43*a55*a61
            - a12*a34*a43*a55*a61
            - a13*a32*a44*a55*a61
            + a12*a33*a44*a55*a61 
            - a15*a34*a43*a51*a62
            + a14*a35*a43*a51*a62
            + a15*a33*a44*a51*a62
            - a13*a35*a44*a51*a62
            - a14*a33*a45*a51*a62
            + a13*a34*a45*a51*a62
            + a15*a34*a41*a53*a62
            - a14*a35*a41*a53*a62
            - a15*a31*a44*a53*a62
            + a11*a35*a44*a53*a62
            + a14*a31*a45*a53*a62 
            - a11*a34*a45*a53*a62
            - a15*a33*a41*a54*a62
            + a13*a35*a41*a54*a62
            + a15*a31*a43*a54*a62
            - a11*a35*a43*a54*a62
            - a13*a31*a45*a54*a62
            + a11*a33*a45*a54*a62
            + a14*a33*a41*a55*a62
            - a13*a34*a41*a55*a62
            - a14*a31*a43*a55*a62
            + a11*a34*a43*a55*a62 
            + a13*a31*a44*a55*a62
            - a11*a33*a44*a55*a62
            + a15*a34*a42*a51*a63
            - a14*a35*a42*a51*a63
            - a15*a32*a44*a51*a63
            + a12*a35*a44*a51*a63
            + a14*a32*a45*a51*a63
            - a12*a34*a45*a51*a63
            - a15*a34*a41*a52*a63
            + a14*a35*a41*a52*a63
            + a15*a31*a44*a52*a63 
            - a11*a35*a44*a52*a63
            - a14*a31*a45*a52*a63
            + a11*a34*a45*a52*a63
            + a15*a32*a41*a54*a63
            - a12*a35*a41*a54*a63
            - a15*a31*a42*a54*a63
            + a11*a35*a42*a54*a63
            + a12*a31*a45*a54*a63
            - a11*a32*a45*a54*a63
            - a14*a32*a41*a55*a63
            + a12*a34*a41*a55*a63 
            + a14*a31*a42*a55*a63
            - a11*a34*a42*a55*a63
            - a12*a31*a44*a55*a63
            + a11*a32*a44*a55*a63
            - a15*a33*a42*a51*a64
            + a13*a35*a42*a51*a64
            + a15*a32*a43*a51*a64
            - a12*a35*a43*a51*a64
            - a13*a32*a45*a51*a64
            + a12*a33*a45*a51*a64
            + a15*a33*a41*a52*a64 
            - a13*a35*a41*a52*a64
            - a15*a31*a43*a52*a64
            + a11*a35*a43*a52*a64
            + a13*a31*a45*a52*a64
            - a11*a33*a45*a52*a64
            - a15*a32*a41*a53*a64
            + a12*a35*a41*a53*a64
            + a15*a31*a42*a53*a64
            - a11*a35*a42*a53*a64
            - a12*a31*a45*a53*a64
            + a11*a32*a45*a53*a64 
            + a13*a32*a41*a55*a64
            - a12*a33*a41*a55*a64
            - a13*a31*a42*a55*a64
            + a11*a33*a42*a55*a64
            + a12*a31*a43*a55*a64
            - a11*a32*a43*a55*a64
            + a14*a33*a42*a51*a65
            - a13*a34*a42*a51*a65
            - a14*a32*a43*a51*a65
            + a12*a34*a43*a51*a65
            + a13*a32*a44*a51*a65 
            - a12*a33*a44*a51*a65
            - a14*a33*a41*a52*a65
            + a13*a34*a41*a52*a65
            + a14*a31*a43*a52*a65
            - a11*a34*a43*a52*a65
            - a13*a31*a44*a52*a65
            + a11*a33*a44*a52*a65
            + a14*a32*a41*a53*a65
            - a12*a34*a41*a53*a65
            - a14*a31*a42*a53*a65
            + a11*a34*a42*a53*a65 
            + a12*a31*a44*a53*a65
            - a11*a32*a44*a53*a65
            - a13*a32*a41*a54*a65
            + a12*a33*a41*a54*a65
            + a13*a31*a42*a54*a65
            - a11*a33*a42*a54*a65
            - a12*a31*a43*a54*a65
            + a11*a32*a43*a54*a65;

    cofactor[32] = -a15*a24*a43*a52*a61
            + a14*a25*a43*a52*a61 
            + a15*a23*a44*a52*a61
            - a13*a25*a44*a52*a61
            - a14*a23*a45*a52*a61
            + a13*a24*a45*a52*a61
            + a15*a24*a42*a53*a61
            - a14*a25*a42*a53*a61
            - a15*a22*a44*a53*a61
            + a12*a25*a44*a53*a61
            + a14*a22*a45*a53*a61
            - a12*a24*a45*a53*a61
            - a15*a23*a42*a54*a61 
            + a13*a25*a42*a54*a61
            + a15*a22*a43*a54*a61
            - a12*a25*a43*a54*a61
            - a13*a22*a45*a54*a61
            + a12*a23*a45*a54*a61
            + a14*a23*a42*a55*a61
            - a13*a24*a42*a55*a61
            - a14*a22*a43*a55*a61
            + a12*a24*a43*a55*a61
            + a13*a22*a44*a55*a61
            - a12*a23*a44*a55*a61 
            + a15*a24*a43*a51*a62
            - a14*a25*a43*a51*a62
            - a15*a23*a44*a51*a62
            + a13*a25*a44*a51*a62
            + a14*a23*a45*a51*a62
            - a13*a24*a45*a51*a62
            - a15*a24*a41*a53*a62
            + a14*a25*a41*a53*a62
            + a15*a21*a44*a53*a62
            - a11*a25*a44*a53*a62
            - a14*a21*a45*a53*a62 
            + a11*a24*a45*a53*a62
            + a15*a23*a41*a54*a62
            - a13*a25*a41*a54*a62
            - a15*a21*a43*a54*a62
            + a11*a25*a43*a54*a62
            + a13*a21*a45*a54*a62
            - a11*a23*a45*a54*a62
            - a14*a23*a41*a55*a62
            + a13*a24*a41*a55*a62
            + a14*a21*a43*a55*a62
            - a11*a24*a43*a55*a62 
            - a13*a21*a44*a55*a62
            + a11*a23*a44*a55*a62
            - a15*a24*a42*a51*a63
            + a14*a25*a42*a51*a63
            + a15*a22*a44*a51*a63
            - a12*a25*a44*a51*a63
            - a14*a22*a45*a51*a63
            + a12*a24*a45*a51*a63
            + a15*a24*a41*a52*a63
            - a14*a25*a41*a52*a63
            - a15*a21*a44*a52*a63 
            + a11*a25*a44*a52*a63
            + a14*a21*a45*a52*a63
            - a11*a24*a45*a52*a63
            - a15*a22*a41*a54*a63
            + a12*a25*a41*a54*a63
            + a15*a21*a42*a54*a63
            - a11*a25*a42*a54*a63
            - a12*a21*a45*a54*a63
            + a11*a22*a45*a54*a63
            + a14*a22*a41*a55*a63
            - a12*a24*a41*a55*a63 
            - a14*a21*a42*a55*a63
            + a11*a24*a42*a55*a63
            + a12*a21*a44*a55*a63
            - a11*a22*a44*a55*a63
            + a15*a23*a42*a51*a64
            - a13*a25*a42*a51*a64
            - a15*a22*a43*a51*a64
            + a12*a25*a43*a51*a64
            + a13*a22*a45*a51*a64
            - a12*a23*a45*a51*a64
            - a15*a23*a41*a52*a64 
            + a13*a25*a41*a52*a64
            + a15*a21*a43*a52*a64
            - a11*a25*a43*a52*a64
            - a13*a21*a45*a52*a64
            + a11*a23*a45*a52*a64
            + a15*a22*a41*a53*a64
            - a12*a25*a41*a53*a64
            - a15*a21*a42*a53*a64
            + a11*a25*a42*a53*a64
            + a12*a21*a45*a53*a64
            - a11*a22*a45*a53*a64 
            - a13*a22*a41*a55*a64
            + a12*a23*a41*a55*a64
            + a13*a21*a42*a55*a64
            - a11*a23*a42*a55*a64
            - a12*a21*a43*a55*a64
            + a11*a22*a43*a55*a64

            - a14*a23*a42*a51*a65
            + a13*a24*a42*a51*a65
            + a14*a22*a43*a51*a65
            - a12*a24*a43*a51*a65
            - a13*a22*a44*a51*a65 
            + a12*a23*a44*a51*a65
            + a14*a23*a41*a52*a65
            - a13*a24*a41*a52*a65
            - a14*a21*a43*a52*a65
            + a11*a24*a43*a52*a65
            + a13*a21*a44*a52*a65
            - a11*a23*a44*a52*a65
            - a14*a22*a41*a53*a65
            + a12*a24*a41*a53*a65
            + a14*a21*a42*a53*a65
            - a11*a24*a42*a53*a65 
            - a12*a21*a44*a53*a65
            + a11*a22*a44*a53*a65
            + a13*a22*a41*a54*a65
            - a12*a23*a41*a54*a65
            - a13*a21*a42*a54*a65
            + a11*a23*a42*a54*a65
            + a12*a21*a43*a54*a65
            - a11*a22*a43*a54*a65;
    cofactor[33] = a15*a24*a33*a52*a61
            - a14*a25*a33*a52*a61 
            - a15*a23*a34*a52*a61
            + a13*a25*a34*a52*a61
            + a14*a23*a35*a52*a61
            - a13*a24*a35*a52*a61
            - a15*a24*a32*a53*a61
            + a14*a25*a32*a53*a61
            + a15*a22*a34*a53*a61
            - a12*a25*a34*a53*a61
            - a14*a22*a35*a53*a61
            + a12*a24*a35*a53*a61
            + a15*a23*a32*a54*a61 
            - a13*a25*a32*a54*a61
            - a15*a22*a33*a54*a61
            + a12*a25*a33*a54*a61
            + a13*a22*a35*a54*a61
            - a12*a23*a35*a54*a61
            - a14*a23*a32*a55*a61
            + a13*a24*a32*a55*a61
            + a14*a22*a33*a55*a61
            - a12*a24*a33*a55*a61
            - a13*a22*a34*a55*a61
            + a12*a23*a34*a55*a61 
            - a15*a24*a33*a51*a62
            + a14*a25*a33*a51*a62
            + a15*a23*a34*a51*a62
            - a13*a25*a34*a51*a62
            - a14*a23*a35*a51*a62
            + a13*a24*a35*a51*a62
            + a15*a24*a31*a53*a62
            - a14*a25*a31*a53*a62
            - a15*a21*a34*a53*a62
            + a11*a25*a34*a53*a62
            + a14*a21*a35*a53*a62 
            - a11*a24*a35*a53*a62
            - a15*a23*a31*a54*a62
            + a13*a25*a31*a54*a62
            + a15*a21*a33*a54*a62
            - a11*a25*a33*a54*a62
            - a13*a21*a35*a54*a62
            + a11*a23*a35*a54*a62
            + a14*a23*a31*a55*a62
            - a13*a24*a31*a55*a62
            - a14*a21*a33*a55*a62
            + a11*a24*a33*a55*a62 
            + a13*a21*a34*a55*a62
            - a11*a23*a34*a55*a62
            + a15*a24*a32*a51*a63
            - a14*a25*a32*a51*a63
            - a15*a22*a34*a51*a63
            + a12*a25*a34*a51*a63
            + a14*a22*a35*a51*a63
            - a12*a24*a35*a51*a63
            - a15*a24*a31*a52*a63
            + a14*a25*a31*a52*a63
            + a15*a21*a34*a52*a63 
            - a11*a25*a34*a52*a63
            - a14*a21*a35*a52*a63
            + a11*a24*a35*a52*a63
            + a15*a22*a31*a54*a63
            - a12*a25*a31*a54*a63
            - a15*a21*a32*a54*a63
            + a11*a25*a32*a54*a63
            + a12*a21*a35*a54*a63
            - a11*a22*a35*a54*a63
            - a14*a22*a31*a55*a63
            + a12*a24*a31*a55*a63 
            + a14*a21*a32*a55*a63
            - a11*a24*a32*a55*a63
            - a12*a21*a34*a55*a63
            + a11*a22*a34*a55*a63
            - a15*a23*a32*a51*a64
            + a13*a25*a32*a51*a64
            + a15*a22*a33*a51*a64
            - a12*a25*a33*a51*a64
            - a13*a22*a35*a51*a64
            + a12*a23*a35*a51*a64
            + a15*a23*a31*a52*a64 
            - a13*a25*a31*a52*a64
            - a15*a21*a33*a52*a64
            + a11*a25*a33*a52*a64
            + a13*a21*a35*a52*a64
            - a11*a23*a35*a52*a64
            - a15*a22*a31*a53*a64
            + a12*a25*a31*a53*a64
            + a15*a21*a32*a53*a64
            - a11*a25*a32*a53*a64
            - a12*a21*a35*a53*a64
            + a11*a22*a35*a53*a64 
            + a13*a22*a31*a55*a64
            - a12*a23*a31*a55*a64
            - a13*a21*a32*a55*a64
            + a11*a23*a32*a55*a64
            + a12*a21*a33*a55*a64
            - a11*a22*a33*a55*a64
            + a14*a23*a32*a51*a65
            - a13*a24*a32*a51*a65
            - a14*a22*a33*a51*a65
            + a12*a24*a33*a51*a65
            + a13*a22*a34*a51*a65 
            - a12*a23*a34*a51*a65
            - a14*a23*a31*a52*a65
            + a13*a24*a31*a52*a65
            + a14*a21*a33*a52*a65
            - a11*a24*a33*a52*a65
            - a13*a21*a34*a52*a65
            + a11*a23*a34*a52*a65
            + a14*a22*a31*a53*a65
            - a12*a24*a31*a53*a65
            - a14*a21*a32*a53*a65
            + a11*a24*a32*a53*a65 
            + a12*a21*a34*a53*a65
            - a11*a22*a34*a53*a65
            - a13*a22*a31*a54*a65
            + a12*a23*a31*a54*a65
            + a13*a21*a32*a54*a65
            - a11*a23*a32*a54*a65
            - a12*a21*a33*a54*a65
            + a11*a22*a33*a54*a65;
    cofactor[34] = -a15*a24*a33*a42*a61
            + a14*a25*a33*a42*a61 
            + a15*a23*a34*a42*a61
            - a13*a25*a34*a42*a61
            - a14*a23*a35*a42*a61
            + a13*a24*a35*a42*a61
            + a15*a24*a32*a43*a61
            - a14*a25*a32*a43*a61
            - a15*a22*a34*a43*a61
            + a12*a25*a34*a43*a61
            + a14*a22*a35*a43*a61
            - a12*a24*a35*a43*a61
            - a15*a23*a32*a44*a61 
            + a13*a25*a32*a44*a61
            + a15*a22*a33*a44*a61
            - a12*a25*a33*a44*a61
            - a13*a22*a35*a44*a61
            + a12*a23*a35*a44*a61
            + a14*a23*a32*a45*a61
            - a13*a24*a32*a45*a61
            - a14*a22*a33*a45*a61
            + a12*a24*a33*a45*a61
            + a13*a22*a34*a45*a61
            - a12*a23*a34*a45*a61 
            + a15*a24*a33*a41*a62
            - a14*a25*a33*a41*a62
            - a15*a23*a34*a41*a62
            + a13*a25*a34*a41*a62
            + a14*a23*a35*a41*a62
            - a13*a24*a35*a41*a62
            - a15*a24*a31*a43*a62
            + a14*a25*a31*a43*a62
            + a15*a21*a34*a43*a62
            - a11*a25*a34*a43*a62
            - a14*a21*a35*a43*a62 
            + a11*a24*a35*a43*a62
            + a15*a23*a31*a44*a62
            - a13*a25*a31*a44*a62
            - a15*a21*a33*a44*a62
            + a11*a25*a33*a44*a62
            + a13*a21*a35*a44*a62
            - a11*a23*a35*a44*a62
            - a14*a23*a31*a45*a62
            + a13*a24*a31*a45*a62
            + a14*a21*a33*a45*a62
            - a11*a24*a33*a45*a62 
            - a13*a21*a34*a45*a62
            + a11*a23*a34*a45*a62
            - a15*a24*a32*a41*a63
            + a14*a25*a32*a41*a63
            + a15*a22*a34*a41*a63
            - a12*a25*a34*a41*a63
            - a14*a22*a35*a41*a63
            + a12*a24*a35*a41*a63
            + a15*a24*a31*a42*a63
            - a14*a25*a31*a42*a63
            - a15*a21*a34*a42*a63 
            + a11*a25*a34*a42*a63
            + a14*a21*a35*a42*a63
            - a11*a24*a35*a42*a63
            - a15*a22*a31*a44*a63
            + a12*a25*a31*a44*a63
            + a15*a21*a32*a44*a63
            - a11*a25*a32*a44*a63
            - a12*a21*a35*a44*a63
            + a11*a22*a35*a44*a63
            + a14*a22*a31*a45*a63
            - a12*a24*a31*a45*a63 
            - a14*a21*a32*a45*a63
            + a11*a24*a32*a45*a63
            + a12*a21*a34*a45*a63
            - a11*a22*a34*a45*a63
            + a15*a23*a32*a41*a64
            - a13*a25*a32*a41*a64
            - a15*a22*a33*a41*a64
            + a12*a25*a33*a41*a64
            + a13*a22*a35*a41*a64
            - a12*a23*a35*a41*a64
            - a15*a23*a31*a42*a64 
            + a13*a25*a31*a42*a64
            + a15*a21*a33*a42*a64
            - a11*a25*a33*a42*a64
            - a13*a21*a35*a42*a64
            + a11*a23*a35*a42*a64
            + a15*a22*a31*a43*a64
            - a12*a25*a31*a43*a64
            - a15*a21*a32*a43*a64
            + a11*a25*a32*a43*a64
            + a12*a21*a35*a43*a64
            - a11*a22*a35*a43*a64 
            - a13*a22*a31*a45*a64
            + a12*a23*a31*a45*a64
            + a13*a21*a32*a45*a64
            - a11*a23*a32*a45*a64
            - a12*a21*a33*a45*a64
            + a11*a22*a33*a45*a64
            - a14*a23*a32*a41*a65
            + a13*a24*a32*a41*a65
            + a14*a22*a33*a41*a65
            - a12*a24*a33*a41*a65
            - a13*a22*a34*a41*a65 
            + a12*a23*a34*a41*a65
            + a14*a23*a31*a42*a65
            - a13*a24*a31*a42*a65
            - a14*a21*a33*a42*a65
            + a11*a24*a33*a42*a65
            + a13*a21*a34*a42*a65
            - a11*a23*a34*a42*a65
            - a14*a22*a31*a43*a65
            + a12*a24*a31*a43*a65
            + a14*a21*a32*a43*a65
            - a11*a24*a32*a43*a65 
            - a12*a21*a34*a43*a65
            + a11*a22*a34*a43*a65
            + a13*a22*a31*a44*a65
            - a12*a23*a31*a44*a65
            - a13*a21*a32*a44*a65
            + a11*a23*a32*a44*a65
            + a12*a21*a33*a44*a65
            - a11*a22*a33*a44*a65;
    cofactor[35] = a15*a24*a33*a42*a51
            - a14*a25*a33*a42*a51 
            - a15*a23*a34*a42*a51
            + a13*a25*a34*a42*a51
            + a14*a23*a35*a42*a51
            - a13*a24*a35*a42*a51
            - a15*a24*a32*a43*a51
            + a14*a25*a32*a43*a51
            + a15*a22*a34*a43*a51
            - a12*a25*a34*a43*a51
            - a14*a22*a35*a43*a51
            + a12*a24*a35*a43*a51
            + a15*a23*a32*a44*a51 
            - a13*a25*a32*a44*a51
            - a15*a22*a33*a44*a51
            + a12*a25*a33*a44*a51
            + a13*a22*a35*a44*a51
            - a12*a23*a35*a44*a51
            - a14*a23*a32*a45*a51
            + a13*a24*a32*a45*a51
            + a14*a22*a33*a45*a51
            - a12*a24*a33*a45*a51
            - a13*a22*a34*a45*a51
            + a12*a23*a34*a45*a51 
            - a15*a24*a33*a41*a52
            + a14*a25*a33*a41*a52
            + a15*a23*a34*a41*a52
            - a13*a25*a34*a41*a52
            - a14*a23*a35*a41*a52
            + a13*a24*a35*a41*a52
            + a15*a24*a31*a43*a52
            - a14*a25*a31*a43*a52
            - a15*a21*a34*a43*a52
            + a11*a25*a34*a43*a52
            + a14*a21*a35*a43*a52 
            - a11*a24*a35*a43*a52
            - a15*a23*a31*a44*a52
            + a13*a25*a31*a44*a52
            + a15*a21*a33*a44*a52
            - a11*a25*a33*a44*a52
            - a13*a21*a35*a44*a52
            + a11*a23*a35*a44*a52
            + a14*a23*a31*a45*a52
            - a13*a24*a31*a45*a52
            - a14*a21*a33*a45*a52
            + a11*a24*a33*a45*a52 
            + a13*a21*a34*a45*a52
            - a11*a23*a34*a45*a52
            + a15*a24*a32*a41*a53
            - a14*a25*a32*a41*a53
            - a15*a22*a34*a41*a53
            + a12*a25*a34*a41*a53
            + a14*a22*a35*a41*a53
            - a12*a24*a35*a41*a53
            - a15*a24*a31*a42*a53
            + a14*a25*a31*a42*a53
            + a15*a21*a34*a42*a53 
            - a11*a25*a34*a42*a53
            - a14*a21*a35*a42*a53
            + a11*a24*a35*a42*a53
            + a15*a22*a31*a44*a53
            - a12*a25*a31*a44*a53
            - a15*a21*a32*a44*a53
            + a11*a25*a32*a44*a53
            + a12*a21*a35*a44*a53
            - a11*a22*a35*a44*a53
            - a14*a22*a31*a45*a53
            + a12*a24*a31*a45*a53 
            + a14*a21*a32*a45*a53
            - a11*a24*a32*a45*a53
            - a12*a21*a34*a45*a53
            + a11*a22*a34*a45*a53
            - a15*a23*a32*a41*a54
            + a13*a25*a32*a41*a54
            + a15*a22*a33*a41*a54
            - a12*a25*a33*a41*a54
            - a13*a22*a35*a41*a54
            + a12*a23*a35*a41*a54
            + a15*a23*a31*a42*a54 
            - a13*a25*a31*a42*a54
            - a15*a21*a33*a42*a54
            + a11*a25*a33*a42*a54
            + a13*a21*a35*a42*a54
            - a11*a23*a35*a42*a54
            - a15*a22*a31*a43*a54
            + a12*a25*a31*a43*a54
            + a15*a21*a32*a43*a54
            - a11*a25*a32*a43*a54
            - a12*a21*a35*a43*a54
            + a11*a22*a35*a43*a54 
            + a13*a22*a31*a45*a54
            - a12*a23*a31*a45*a54
            - a13*a21*a32*a45*a54
            + a11*a23*a32*a45*a54
            + a12*a21*a33*a45*a54
            - a11*a22*a33*a45*a54
            + a14*a23*a32*a41*a55
            - a13*a24*a32*a41*a55
            - a14*a22*a33*a41*a55
            + a12*a24*a33*a41*a55
            + a13*a22*a34*a41*a55 
            - a12*a23*a34*a41*a55
            - a14*a23*a31*a42*a55
            + a13*a24*a31*a42*a55
            + a14*a21*a33*a42*a55
            - a11*a24*a33*a42*a55
            - a13*a21*a34*a42*a55
            + a11*a23*a34*a42*a55
            + a14*a22*a31*a43*a55
            - a12*a24*a31*a43*a55
            - a14*a21*a32*a43*a55
            + a11*a24*a32*a43*a55 
            + a12*a21*a34*a43*a55
            - a11*a22*a34*a43*a55
            - a13*a22*a31*a44*a55
            + a12*a23*a31*a44*a55
            + a13*a21*a32*a44*a55
            - a11*a23*a32*a44*a55
            - a12*a21*a33*a44*a55
            + a11*a22*a33*a44*a55;

/*     ainv = transpose(cofactor) ! / det */
    const double jinv = 1/det;
    ainv[0] = cofactor[0]*jinv;
    ainv[1] = cofactor[6]*jinv;
    ainv[2] = cofactor[12]*jinv;
    ainv[3] = cofactor[18]*jinv;
    ainv[4] = cofactor[24]*jinv;
    ainv[5] = cofactor[30]*jinv;
    ainv[6] = cofactor[1]*jinv;
    ainv[7] = cofactor[7]*jinv;
    ainv[8] = cofactor[13]*jinv;
    ainv[9] = cofactor[19]*jinv;
    ainv[10] = cofactor[25]*jinv;
    ainv[11] = cofactor[31]*jinv;
    ainv[12] = cofactor[2]*jinv;
    ainv[13] = cofactor[8]*jinv;
    ainv[14] = cofactor[14]*jinv;
    ainv[15] = cofactor[20]*jinv;
    ainv[16] = cofactor[26]*jinv;
    ainv[17] = cofactor[32]*jinv;
    ainv[18] = cofactor[3]*jinv;
    ainv[19] = cofactor[9]*jinv;
    ainv[20] = cofactor[15]*jinv;
    ainv[21] = cofactor[21]*jinv;
    ainv[22] = cofactor[27]*jinv;
    ainv[23] = cofactor[33]*jinv;
    ainv[24] = cofactor[4]*jinv;
    ainv[25] = cofactor[10]*jinv;
    ainv[26] = cofactor[16]*jinv;
    ainv[27] = cofactor[22]*jinv;
    ainv[28] = cofactor[28]*jinv;
    ainv[29] = cofactor[34]*jinv;
    ainv[30] = cofactor[5]*jinv;
    ainv[31] = cofactor[11]*jinv;
    ainv[32] = cofactor[17]*jinv;
    ainv[33] = cofactor[23]*jinv;
    ainv[34] = cofactor[29]*jinv;
    ainv[35] = cofactor[35]*jinv;

    *ok_flag__ = 0;
    return 0;
}
